Package: twoddpcr
Title: Classify 2-d Droplet Digital PCR (ddPCR) data and quantify the
        number of starting molecules
Version: 1.37.0
Authors@R: person("Anthony", "Chiu",
    email="anthony@achiu.me",
    role=c("aut", "cre"))
Author: Anthony Chiu [aut, cre]
Maintainer: Anthony Chiu <anthony@achiu.me>
URL: http://github.com/CRUKMI-ComputationalBiology/twoddpcr/
BugReports: http://github.com/CRUKMI-ComputationalBiology/twoddpcr/issues/
Description: The twoddpcr package takes Droplet Digital PCR (ddPCR)
    droplet amplitude data from Bio-Rad's QuantaSoft and can classify the
    droplets. A summary of the positive/negative droplet counts can be
    generated, which can then be used to estimate the number of molecules
    using the Poisson distribution. This is the first open source package
    that facilitates the automatic classification of general two channel
    ddPCR data. Previous work includes 'definetherain' (Jones et al., 2014)
    and 'ddpcRquant' (Trypsteen et al., 2015) which both handle one channel
    ddPCR experiments only. The 'ddpcr' package available on CRAN
    (Attali et al., 2016) supports automatic gating of a specific class of
    two channel ddPCR experiments only.
Depends: R (>= 3.4)
Imports: class, ggplot2, hexbin, methods, scales, shiny, stats, utils,
        RColorBrewer, S4Vectors
License: GPL-3
LazyData: true
RoxygenNote: 7.1.1
Collate: 'KRAScounts.R' 'KRASdata.R' 'global.R' 'ddpcrWell.R'
        'ddpcrPlate.R' 'clusterCentres.R' 'clusterStats.R' 'themes.R'
        'dropletPlot.R' 'exportTable.R' 'facetPlot.R' 'flatPlot.R'
        'ggplot.R' 'gridClassify.R' 'heatPlot.R' 'isTwoDimDataFrame.R'
        'kmeansClassify.R' 'knnClassify.R' 'mahRain.R' 'normalise.R'
        'numDroplets.R' 'parseCounts.R' 'plateSummary.R'
        'readCSVDataFrame.R' 'relabelClasses.R'
        'removeDropletClasses.R' 'sdRain.R' 'shinyVisApp.R'
        'shinyVisGlobal.R' 'shinyVisServer.R' 'shinyVisUI.R'
        'summaries.R' 'twoddpcr.R' 'wellNameSort.R'
Suggests: devtools, knitr, reshape2, rmarkdown, testthat, BiocStyle
VignetteBuilder: knitr
biocViews: ddPCR, Software, Classification
git_url: https://git.bioconductor.org/packages/twoddpcr
git_branch: devel
git_last_commit: 4aca120
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:43:25 UTC; biocbuild

# twoddpcr

[twoddpcr](https://bioconductor.org/packages/twoddpcr/) is an R/Bioconductor 
package for Droplet Digital PCR (ddPCR) analysis. The package is named for its 
ability to classify two channel ddPCR data (the amalgamation of "2-d" and 
"ddPCR").
                
Example usage of the package with a sample dataset is included in the package's 
[vignette](https://bioconductor.org/packages/release/bioc/vignettes/twoddpcr/inst/doc/twoddpcr.html), 
where the Appendix also explains how to extract raw droplet data from Bio-Rad's 
QuantaSoft.


## Installing the `twoddpcr` package

The package can be installed from Bioconductor using:

```
install.packages("BiocManager")
BiocManager::install("twoddpcr")
```

Alternatively, it can be installed from GitHub using:

```
library(devtools)
install_github("CRUKMI-ComputationalBiology/twoddpcr")
```

Another alternative is to install the package from source:

```
install.packages("</path/to/twoddpcr/>", repos=NULL, type="source")
```


## Loading the `twoddpcr` package

Once the package has been installed, it can be loaded in the usual way:

```
library(twoddpcr)
```


## `ddpcrPlate` objects

The package revolves around the use of `ddpcrPlate` objects, which stores 
droplet amplitude data for the wells in the plate. The `ddpcrPlate` object also 
keeps track of the various classifications of the droplets.

To use your own droplet data and store it in a variable named `plate`, use:

```
plate <- ddpcrPlate("amplitudes/")
```

Here, we have assumed that your droplet amplitude CSVs are stored in the 
`amplitudes` directory inside the working directory.


## Classifying using the k-means clustering

If your data has four distinct clusters, the k-means clustering algorithm can 
be used:

```
plate <- kmeansClassify(plate)
```

This method can also take the `centres` parameter as a matrix to adjust the 
approximate centres of each cluster. This parameter can also be the number of 
clusters instead of a matrix. See `?kmeansClassify` for more details.


## Plotting classifications

Once the droplets have been classified, they can be plotted using the 
`dropletPlot` method. To use this, the names of the available classification 
methods can be obtained by:

```
getCommonClassMethod(plate)
```

There should be a `kmeans` entry for k-means clustering. To plot this, use:

```
dropletPlot(plate, cMethod="kmeans")
```


## Adding "rain"

Droplets between the main clusters of droplets will possibly have ambiguous 
classifications. These droplets are colloquially known as "rain". To do this, 
use:

```
plate <- mahalanobisRain(plate, maxDistances=list(NN=35, NP=30, PN=30, PP=30))
```

Some trial-and-error is required for setting the `maxDistances` parameter.


## Summaries

Since ddPCR samples are partitioned into droplets, the molecules are assumed to 
be Poisson distributed. With this, the actual number of starting fragments can 
be estimated:

```
plateSummary(plate, cMethod="kmeansMahRain")
```


## Shiny-based GUI for non-R users

A Shiny app is included in the package, which provides a GUI that allows 
interactive use of the package for ddPCR analysis. This can be run from an 
interactive R session using:

```
shinyVisApp()
```

It can also be accessed at 
[http://shiny.cruk.manchester.ac.uk/twoddpcr/](http://shiny.cruk.manchester.ac.uk/twoddpcr/).

If you wish to run the app from your own server, instructions are given in the 
[vignette](https://bioconductor.org/packages/devel/bioc/vignettes/twoddpcr/inst/doc/twoddpcr.html#shiny-based-gui-for-non-r-users).


# Citing `twoddpcr`

If you use the `twoddpcr` package in your work, please cite the [Bioinformatics 
paper](http://dx.doi.org/10.1093/bioinformatics/btx308). The citation can be 
obtained within R using:

```
citation("twoddpcr")
```

#' @import methods
NULL

#' @title Use a 'grid' to create training data for classification algorithms.
#'
#' @description Classify droplets as "NN", "NP", "PN" or "PP". The
#' classification is based on upper bounds for negative readings and lower
#' bounds for positive readings; see the details and parameters for more
#' detail. If required (see the \code{trainingData} parameter), droplets that
#' are not classified will be given the label "N/A".
#'
#' @param droplets A \code{\link{ddpcrWell}} object or a data frame of droplet
#' amplitudes with columns \code{Ch1.Amplitude} and \code{Ch2.Amplitude}.
#' @param ch1NNThreshold The channel 1 upper bound for the NN class. Defaults
#' to 6500.
#' @param ch2NNThreshold The channel 2 upper bound for the NN class. Defaults
#' to 1900.
#' @param ch1NPThreshold The channel 1 upper bound for the NP class. Defaults
#' to 6500.
#' @param ch2NPThreshold The channel 2 lower bound for the NP class. Defaults
#' to 5000.
#' @param ch1PNThreshold The channel 1 lower bound for the PN class. Defaults
#' to 10000.
#' @param ch2PNThreshold The channel 2 upper bound for the PN class. Defaults
#' to 2900.
#' @param ch1PPThreshold The channel 1 lower bound for the PP class. Defaults
#' to 7500.
#' @param ch2PPThreshold The channel 2 lower bound for the PP class. Defaults
#' to 5000.
#' @param ... Other options depending on the type of \code{droplets}.
#'
#' @details The \code{threshold} parameters correspond to those in the
#' following diagram:
#' \preformatted{Ch1 ^        |  |
#'     |        |  |
#'     |   PN   |  |
#'     |        |  |   PP
#'    e|________|  |
#'    g|........:..|_________
#'     |        :  :
#'    c|.............._______
#'    a|______  :  : |
#'     |      | :  : |  NP
#'     |  NN  | :  : |
#'     |      | :  : |
#'     --------------------->
#'            b f  h d    Ch2}
#' Specifically:
#' \describe{
#'   \item{a:}{\code{ch1NNThreshold},}
#'   \item{b:}{\code{ch2NNThreshold},}
#'   \item{c:}{\code{ch1PNThreshold},}
#'   \item{d:}{\code{ch2PNThreshold},}
#'   \item{e:}{\code{ch1NPThreshold},}
#'   \item{f:}{\code{ch2NPThreshold},}
#'   \item{g:}{\code{ch1PPThreshold},}
#'   \item{h:}{\code{ch2PPThreshold}.}
#' }
#'
#' @name gridClassify
#'
#' @seealso \code{\link{thresholdClassify}} is a special case of this
#' function.
#' @seealso \code{\link{removeDropletClasses}} retrieves a data frame with the
#' "N/A" (and "Rain") droplets removed. This can used for transforming
#' a grid-like classification into usable training data.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Use a grid to set training data for a data frame.
#' sgCl <- gridClassify(KRASdata[["E03"]],
#'                      ch1NNThreshold=5700, ch2NNThreshold=1700,
#'                      ch1NPThreshold=5400, ch2NPThreshold=5700,
#'                      ch1PNThreshold=9700, ch2PNThreshold=2050,
#'                      ch1PPThreshold=7200, ch2PPThreshold=4800)
#' str(sgCl)
#'
#' ## For data frame only, we can set the trainingData flag to FALSE so that
#' ## the unclassified droplets are retained but labelled as "N/A"
#' sgCl <- gridClassify(KRASdata[["E03"]],
#'                      ch1NNThreshold=5700, ch2NNThreshold=1700,
#'                      ch1NPThreshold=5400, ch2NPThreshold=5700,
#'                      ch1PNThreshold=9700, ch2PNThreshold=2050,
#'                      ch1PPThreshold=7200, ch2PPThreshold=4800,
#'                      trainingData=FALSE)
#' dropletPlot(sgCl, cMethod="class")
#'
#' ## The same works for ddpcrWell objects.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' aWell <- gridClassify(aWell,
#'                       ch1NNThreshold=5700, ch2NNThreshold=1700,
#'                       ch1NPThreshold=5400, ch2NPThreshold=5700,
#'                       ch1PNThreshold=9700, ch2PNThreshold=2050,
#'                       ch1PPThreshold=7200, ch2PPThreshold=4800)
#' str(aWell)
#'
#' ## ddpcrPlate objects work in exactly the same way.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' krasPlate <- gridClassify(krasPlate)
#' lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)
#'
#' ## The default classification method (column name) is 'gridClassify',
#' ## which may be a bit long. It can be changed.
#' krasPlate <- gridClassify(krasPlate, classMethodLabel="training")
#' lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)
#'
#' @export

setGeneric(
  "gridClassify",
  function(droplets,
           ch1NNThreshold=6500, ch2NNThreshold=1900,
           ch1NPThreshold=6500, ch2NPThreshold=5000,
           ch1PNThreshold=10000, ch2PNThreshold=2900,
           ch1PPThreshold=7500, ch2PPThreshold=5000,
           ...) {
    standardGeneric("gridClassify")
  }
)

#' @rdname gridClassify
#'
#' @param trainingData Whether to use the output as training data. If
#' \code{TRUE}, returns the _full table_ with the "N/A" entries removed; if
#' \code{FALSE}, the "N/A" entries are retained. Taken to be \code{FALSE} if
#' \code{fullTable} is set to \code{FALSE}. Defaults to \code{TRUE}. Ignored
#' if \code{droplets} is not a data frame.
#' @param fullTable Whether to return a data frame including amplitude
#' figures. If \code{TRUE}, a data frame with columns \code{Ch1.Amplitude},
#' \code{Ch1.Amplitude} and \code{class} is returned. If \code{FALSE}, a factor
#' with levels in \code{ddpcr$classesRain} is returned, where each entry
#' corresponds to each row in \code{droplets} (and \code{trainingData} is
#' automatically set to \code{FALSE}). Defaults to \code{TRUE}. Ignored if
#' \code{droplets} is not a data frame.
#' @param naLabel The label to use for unclassified droplets. Should be either
#' ddpcr$na ("N/A") or ddpcr$rain ("Rain"). Defaults to ddpcr$rain.
#'
#' @return If \code{droplets} is a data frame, return a data frame or factor
#' (depending on the \code{trainingData} and \code{fullTable} parameters) with
#' a classification for droplets in the chosen regions.
#'
#' @exportMethod gridClassify

setMethod(
  "gridClassify", "data.frame",
  function(droplets,
           ch1NNThreshold=6500, ch2NNThreshold=1900,
           ch1NPThreshold=6500, ch2NPThreshold=5000,
           ch1PNThreshold=10000, ch2PNThreshold=2900,
           ch1PPThreshold=7500, ch2PPThreshold=5000,
           trainingData=TRUE, fullTable=TRUE,
           naLabel=ddpcr$rain) {
    # Check that the thresholds are sensible.
    thresholds <- c(ch1NNThreshold, ch2NNThreshold,
                    ch1NPThreshold, ch2NPThreshold,
                    ch1PNThreshold, ch2PNThreshold,
                    ch1PPThreshold, ch2PPThreshold)
    if(!is.numeric(thresholds) || any(thresholds < 0)) {
      stop("Thresholds should be nonnegative.")
    }
    if(ch1NNThreshold > ch1PNThreshold || ch2NNThreshold > ch2NPThreshold ||
       (ch1NNThreshold > ch1PPThreshold && ch2NNThreshold > ch2PPThreshold) ||
       (ch1NPThreshold > ch1PNThreshold && ch2NPThreshold < ch2PNThreshold) ||
       ch1NPThreshold > ch1PPThreshold ||
       ch2PNThreshold > ch2PPThreshold) {
      stop("The thresholds overlap.")
    }

    # Set the classification of droplets that lie above or below the given
    # thresholds.
    df <- droplets[, c("Ch1.Amplitude", "Ch2.Amplitude")]
    df$class <- ifelse(
      df$Ch1.Amplitude < ch1NNThreshold & df$Ch2.Amplitude < ch2NNThreshold,
      ddpcr$nn,
      ifelse(
        df$Ch1.Amplitude > ch1PNThreshold & df$Ch2.Amplitude < ch2PNThreshold,
        ddpcr$pn,
        ifelse(
          df$Ch1.Amplitude < ch1NPThreshold & df$Ch2.Amplitude > ch2NPThreshold,
          ddpcr$np,
          ifelse(
            df$Ch1.Amplitude > ch1PPThreshold & df$Ch2.Amplitude > ch2PPThreshold,
            ddpcr$pp,
            naLabel))))

    # If we are setting training data, remove all rows not in the grid.
    if(!fullTable) {
      return(factor(df$class, levels=ddpcr$classesRain))
    } else if(trainingData) {
      df <- df[df$class != ddpcr$na, ]
    }

    df$class <- factor(df$class, levels=ddpcr$classesRain)
    df
  }
)


#' @rdname gridClassify
#'
#' @param classMethodLabel A name (as a character string) of the classification
#' method. Defaults to "grid".
#'
#' @return If \code{droplets} is a \code{ddpcrWell} object, return
#' a \code{ddpcrWell} object with the appropriate classification.
#'
#' @exportMethod gridClassify

setMethod("gridClassify", "ddpcrWell",
  function(droplets,
           ch1NNThreshold=6500, ch2NNThreshold=1900,
           ch1NPThreshold=6500, ch2NPThreshold=5000,
           ch1PNThreshold=10000, ch2PNThreshold=2900,
           ch1PPThreshold=7500, ch2PPThreshold=5000,
           classMethodLabel="grid",
           naLabel=ddpcr$rain) {
    df <- gridClassify(amplitudes(droplets),
                       ch1NNThreshold=ch1NNThreshold,
                       ch2NNThreshold=ch2NNThreshold,
                       ch1NPThreshold=ch1NPThreshold,
                       ch2NPThreshold=ch2NPThreshold,
                       ch1PNThreshold=ch1PNThreshold,
                       ch2PNThreshold=ch2PNThreshold,
                       ch1PPThreshold=ch1PPThreshold,
                       ch2PPThreshold=ch2PPThreshold,
                       trainingData=FALSE,
                       fullTable=TRUE,
                       naLabel=naLabel)

    wellClassification(droplets, classMethodLabel) <- df$class
    droplets
  }
)


#' @rdname gridClassify
#'
#' @return If \code{droplets} is a \code{ddpcrPlate} object, return
#' a \code{ddpcrPlate} object with the appropriate classification.
#'
#' @exportMethod gridClassify

setMethod(
  "gridClassify", "ddpcrPlate",
  function(droplets,
           ch1NNThreshold=6500, ch2NNThreshold=1900,
           ch1NPThreshold=6500, ch2NPThreshold=5000,
           ch1PNThreshold=10000, ch2PNThreshold=2900,
           ch1PPThreshold=7500, ch2PPThreshold=5000,
           classMethodLabel="grid",
           naLabel=ddpcr$rain) {
    df <- gridClassify(do.call(rbind, amplitudes(droplets)),
                       ch1NNThreshold=ch1NNThreshold,
                       ch2NNThreshold=ch2NNThreshold,
                       ch1NPThreshold=ch1NPThreshold,
                       ch2NPThreshold=ch2NPThreshold,
                       ch1PNThreshold=ch1PNThreshold,
                       ch2PNThreshold=ch2PNThreshold,
                       ch1PPThreshold=ch1PPThreshold,
                       ch2PPThreshold=ch2PPThreshold,
                       trainingData=FALSE,
                       fullTable=TRUE,
                       naLabel=naLabel)

    plateClassification(droplets, cMethod=classMethodLabel) <- df$class
    droplets
  }
)


#' @title Set thresholds to classify droplets.
#'
#' @description Classify droplets as "NN", "NP", "PN" or "PP" depending on
#' whether they lie above or below given thresholds. This is illustrated in the
#' details and parameters for more detail.
#'
#' @param droplets A \code{\link{ddpcrWell}} object or a data frame of droplet
#' amplitudes with columns \code{Ch1.Amplitude} and \code{Ch2.Amplitude}.
#' @param ch1Threshold The channel 1 upper bound for the NN and NP classes.
#' Defaults to 8000
#' @param ch2Threshold The channel 2 upper bound for the NN and PN classes.
#' Defaults to 3000.
#' @param ... Other options depending on the type of \code{droplets}.
#'
#' @details The \code{threshold} parameters correspond to those in the
#' following diagram:
#' \preformatted{Ch1 ^          |
#'     |          |
#'     |          |
#'     |    PN    |    PP
#'     |          |
#'     |          |
#'    a|__________|__________
#'     |          |
#'     |          |
#'     |    NN    |    NP
#'     |          |
#'     |          |
#'     --------------------->
#'                b      Ch2}
#' Specifically:
#' \describe{
#'   \item{a:}{\code{ch1Threshold},}
#'   \item{b:}{\code{ch2Threshold}.}
#' }
#'
#' @seealso This function is a special case of \code{\link{gridClassify}}.
#'
#' @name thresholdClassify
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Use thresholds to set a classification for a data frame.
#' gCl <- thresholdClassify(KRASdata[["E03"]],
#'                          ch1Threshold=6789, ch2Threshold=3000)
#' str(gCl)
#'
#' ## The same works for ddpcrWell objects.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' aWell <- thresholdClassify(aWell, ch1Threshold=6789, ch2Threshold=3000)
#' str(aWell)
#'
#' ## ddpcrPlate objects work in exactly the same way.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' krasPlate <- thresholdClassify(krasPlate,
#'                                ch1Threshold=6789, ch2Threshold=3000)
#' lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)
#'
#' ## The default classification method (column name) is 'threshold'. It can be
#' ## changed by providing a label.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' krasPlate <- thresholdClassify(krasPlate,
#'                                ch1Threshold=6789, ch2Threshold=3000,
#'                                classMethodLabel="manual")
#' lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)
#'
#' @export

setGeneric(
  "thresholdClassify",
  function(droplets, ch1Threshold=6500, ch2Threshold=2900, ...) {
    standardGeneric("thresholdClassify")
  }
)


#' @rdname thresholdClassify
#'
#' @param fullTable Whether to return a data frame including amplitude figures.
#' If \code{TRUE}, a data frame with columns \code{Ch1.Amplitude},
#' \code{Ch1.Amplitude} and \code{class} is returned. If \code{FALSE}, a factor
#' with levels in \code{ddpcr$classesRain} is returned, where each entry
#' corresponds to each row in \code{droplets} (and \code{trainingData} is
#' automatically set to \code{FALSE}). Defaults to \code{TRUE}.
#'
#' @return If \code{droplets} is a data frame, return a data frame or factor
#' (depending on the \code{trainingData} and \code{fullTable} parameters) with
#' a classification for droplets in the chosen regions.
#'
#' @exportMethod thresholdClassify

setMethod(
  "thresholdClassify", "data.frame",
  function(droplets, ch1Threshold=6500, ch2Threshold=2900, fullTable=TRUE) {
    gridClassify(droplets,
                 ch1NNThreshold=ch1Threshold,
                 ch2NNThreshold=ch2Threshold,
                 ch1NPThreshold=ch1Threshold,
                 ch2NPThreshold=ch2Threshold,
                 ch1PNThreshold=ch1Threshold,
                 ch2PNThreshold=ch2Threshold,
                 ch1PPThreshold=ch1Threshold,
                 ch2PPThreshold=ch2Threshold,
                 trainingData=TRUE,
                 fullTable=fullTable)
  }
)


#' @rdname thresholdClassify
#'
#' @param classMethodLabel A name (as a character string) of the classification
#' method. Defaults to "thresholds".
#'
#' @return If \code{droplets} is a \code{ddpcrWell} object, return
#' a \code{ddpcrWell} object with the appropriate classification.
#'
#' @exportMethod thresholdClassify

setMethod("thresholdClassify", "ddpcrWell",
  function(droplets, ch1Threshold=6500, ch2Threshold=2900,
           classMethodLabel="thresholds") {
    gridClassify(droplets,
                 ch1NNThreshold=ch1Threshold,
                 ch2NNThreshold=ch2Threshold,
                 ch1NPThreshold=ch1Threshold,
                 ch2NPThreshold=ch2Threshold,
                 ch1PNThreshold=ch1Threshold,
                 ch2PNThreshold=ch2Threshold,
                 ch1PPThreshold=ch1Threshold,
                 ch2PPThreshold=ch2Threshold,
                 classMethodLabel=classMethodLabel)
  }
)


#' @rdname thresholdClassify
#'
#' @return If \code{droplets} is a \code{ddpcrPlate} object, return
#' a \code{ddpcrPlate} object with the appropriate classification.
#'
#' @exportMethod thresholdClassify

setMethod("thresholdClassify",
  "ddpcrPlate",
  function(droplets, ch1Threshold=6500, ch2Threshold=2900,
           classMethodLabel="thresholds") {
    gridClassify(droplets,
                 ch1NNThreshold=ch1Threshold,
                 ch2NNThreshold=ch2Threshold,
                 ch1NPThreshold=ch1Threshold,
                 ch2NPThreshold=ch2Threshold,
                 ch1PNThreshold=ch1Threshold,
                 ch2PNThreshold=ch2Threshold,
                 ch1PPThreshold=ch1Threshold,
                 ch2PPThreshold=ch2Threshold,
                 classMethodLabel=classMethodLabel)
  }
)

#' @import methods
NULL

#' Find the standard deviation of droplets (in a given class) multipied by
#' a given constant.
#'
#' For a specified class, take a data frame of droplet amplitudes and compute
#' the standard deviation multiplied by a level of accuracy.
#'
#' @param droplets A data frame of droplets with "Ch1.Amplitude" and
#' "Ch2.Amplitude" columns, as well as a class column (see classCol).
#' @param cl The class to focus on. Typically one of "NN", "PN", "NP" and "PP".
#' @param level A constant by which we will multiply the standard deviation.
#' Defaults to 5.
#' @param classCol The column (name or number) from 'droplets' representing the
#' class.
#'
#' @return A list with named elements 'ch1' and 'ch2', each giving the error
#' bound for the corresponding channel. If the number of droplets is either
#' 0 or 1, return list(ch1=0, ch2=0) to avoid any errors. Otherwise, return
#' level * (sd of the droplets in each channel).
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

getCutOff <- function(droplets, cl, level=3, classCol="class") {
  # We want a class with just one droplet to be in a non-rainy class.
  if(length(droplets) <= 1) {
    list(ch1=0, ch2=0)
  } else {
    ch1Error <-
      level * stats::sd(droplets[droplets[, classCol]==cl, "Ch1.Amplitude"])
    ch2Error <-
      level * stats::sd(droplets[droplets[, classCol]==cl, "Ch2.Amplitude"])
    list("Ch1.Amplitude"=ch1Error, "Ch2.Amplitude"=ch2Error)
  }
}


#' @title Add rain to a classification by using a chosen multiple of standard
#' deviation.
#'
#' @description Although we can use various algorithms to classify all droplets
#' in a ddPCR experiment, there will be some variation between the
#' classifications. We can perhaps have a relatively high confidence that
#' droplets near the centres of clusters do indeed belong to that cluster,
#' whereas we probably have a lower confidence in the classification of those
#' further away, say, near the 'boundary' of two clusters. We may view these
#' droplets (or a subset of them) as having an ambiguous class. This function
#' allows us to only consider droplets classified within a certain distance of
#' the means of each cluster and label the rest as "Rain".
#'
#' @param droplets A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
#' object, or a droplet data frame including a classification column.
#' @param cMethod The name or column number of the classification for which we
#' want to add rain to.
#' @param errorLevel How many multiples of standard deviation from the mean of
#' each cluster to retain. Can be a list where each item corresponds to a class
#' name and the multiple for that class. Can also be a numeric vector of length
#' 1, which is equivalent to a list with all the same entries. Defaults to 5.
#' @param ... Other options depending on the type of \code{droplets}.
#'
#' @name sdRain
#'
#' @references This approach was described in {Jones, M., Williams, J.,
#' Gaertner, K., Phillips, R., Hurst, J., & Frater, J. (2014). Low copy target
#' detection by Droplet Digital PCR through application of a novel open access
#' bioinformatic pipeline, "definetherain." Journal of Virological Methods,
#' 202(100), 46--53. \url{http://doi.org/10.1016/j.jviromet.2014.02.020}}
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Compare the types of droplets in a single well for the "Cluster" class
#' ## and then with rain.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' aWell <- sdRain(aWell, cMethod="Cluster")
#' cl <- wellClassification(aWell)
#' table(cl$Cluster)
#' table(cl$ClusterSdRain)
#'
#' ## Compare the types of droplets in multiple wells for the "Cluster" class
#' ## and then with rain.
#' krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
#' krasPlate <- sdRain(krasPlate, cMethod="Cluster")
#' plateSummary(krasPlate, cMethod="Cluster")[, c(1:5)]
#' plateSummary(krasPlate, cMethod="ClusterSdRain")[, c(1:5)]
#'
#' ## The 'errorLevel' parameter can changed.
#' krasPlate <- sdRain(krasPlate, cMethod="Cluster", errorLevel=4)
#' plateSummary(krasPlate, cMethod="ClusterSdRain")[, c(1:5)]
#'
#' ## The 'errorLevel' parameter can also be changed for each cluster.
#' krasPlate <- sdRain(krasPlate, cMethod="Cluster",
#'                     errorLevel=list(NN=5, NP=5, PN=4, PP=3))
#' plateSummary(krasPlate, cMethod="ClusterSdRain")[, c(1:5)]
#'
#' @export

setGeneric("sdRain", function(droplets, cMethod, errorLevel=5, ...) {
  standardGeneric("sdRain")
})


#' @rdname sdRain
#'
#' @param fullTable If \code{TRUE}, returns a full data frame of droplets with
#' an extra column of rainy data; if \code{FALSE}, simply returns a factor
#' where each entry corresponds to an entry in the original classification
#' column with added rain. Defaults to \code{FALSE}.
#'
#' @return If \code{droplets} is a data frame, return a data frame or factor
#' (depending on \code{fullTable}) where droplets with ambiguous
#' classifications are labelled as "Rain".
#'
#' @exportMethod sdRain

setMethod(
  "sdRain", "data.frame",
  function(droplets, cMethod, errorLevel=5, fullTable=TRUE) {
    # Only one number supplied for the error level: make it into a list.
    if(is.numeric(errorLevel) && length(errorLevel) == 1) {
      errorLevel <- rep(errorLevel, length(ddpcr$classes))
      names(errorLevel) <- ddpcr$classes
    }

    means <- classMeans(droplets, classCol=cMethod)
    dfWithRain <- droplets[, cMethod]

    # Only add rain to the main classes that exist in the plot; ignore "Rain"
    # and "N/A".
    classes <- intersect(unique(dfWithRain), ddpcr$classes)
    for(cl in classes) {
      m1 <- means[cl, "Ch1.Amplitude"]
      m2 <- means[cl, "Ch2.Amplitude"]
      sds <- getCutOff(droplets, cl, level=errorLevel[[cl]],
                           classCol=cMethod)

      # We use different inequalities depending on whether the class in each
      # channel is "N" or "P".
      ch1 <- substr(cl, 1, 1)
      ch2 <- substr(cl, 2, 2)

      # Set rain droplets.
      dfWithRain <- ifelse(
        droplets[, cMethod] == cl & (
          (ch1 == "N" & droplets$Ch1.Amplitude > (m1 + sds$Ch1.Amplitude)) |
          (ch1 == "P" & droplets$Ch1.Amplitude < (m1 - sds$Ch1.Amplitude)) |
          (ch2 == "N" & droplets$Ch2.Amplitude > (m2 + sds$Ch2.Amplitude)) |
          (ch2 == "P" & droplets$Ch2.Amplitude < (m2 - sds$Ch2.Amplitude))
        ),
        ddpcr$rain,
        as.character(dfWithRain)
      )
    }

    dfWithRain <- factor(dfWithRain, levels=ddpcr$classesRain)
    if(fullTable) {
      data.frame(droplets, rainy=dfWithRain)
    } else {
      dfWithRain
    }
  }
)


#' @rdname sdRain
#'
#' @return If \code{droplets} is a \code{ddpcrWell} object, return
#' a \code{ddpcrWell} object with a rainy classification.
#'
#' @exportMethod sdRain

setMethod("sdRain", "ddpcrWell", function(droplets, cMethod, errorLevel=5) {
  cl <- wellClassification(droplets, cMethod=cMethod, withAmplitudes=TRUE)
  rainy <- sdRain(cl, cMethod=cMethod, errorLevel=errorLevel, fullTable=FALSE)
  wellClassification(droplets, paste0(cMethod, "SdRain")) <- rainy
  droplets
})


#' @rdname sdRain
#'
#' @return If \code{droplets} is a \code{ddpcrPlate} object, return
#' a \code{ddpcrPlate} object with a rainy classifications.
#'
#' @exportMethod sdRain

setMethod("sdRain", "ddpcrPlate", function(droplets, cMethod, errorLevel=5) {
  cl <- plateClassification(droplets, cMethod=cMethod, withAmplitudes=TRUE)
  cl <- do.call(rbind, cl)
  rainy <- sdRain(cl,
                  cMethod=cMethod, errorLevel=errorLevel, fullTable=FALSE)
  plateClassification(droplets, paste0(cMethod, "SdRain")) <- rainy
  droplets
})

#' @include dropletPlot.R
#' @import methods
NULL

#' @title Plot droplet amplitudes with all droplets classified as "N/A" (or
#' a chosen class).
#'
#' @description There are occasions where classification algorithms fail for
#' various reasons (such as poor choice/number of centres in k-means
#' clustering). In these cases, it may be helpful to the user if an app draws
#' a 'flat' plot with just one colour rather than nothing at all.
#'
#' @param droplets A data frame of droplet amplitudes, or
#' a \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}} object.
#' @param ch1Label The label for the channel 1 target. Defaults to "Ch1
#' Amplitude".
#' @param ch2Label The label for the channel 2 target. Defaults to "Ch2
#' Amplitude".
#' @param classString The class that all droplets should be classified as.
#' Defaults to the \code{ddpcr$na} ("N/A") character string.
#' @param initialCentres A data frame of initial centres to plot (e.g. initial
#' cluster centres used in the k-means). This is _not_ restricted to the class
#' \code{classString} only. If \code{NULL}, nothing is plotted. Defaults to
#' \code{NULL}.
#' @param selectedCentre An initial centre to highlight. This should be either
#' "NN", "PN", "NP" or "PP", but is _not_ restricted to the class 'classString'
#' only. If \code{NULL}, nothing is highlighted. Defaults to \code{NULL}.
#' @param plotLimits A list of 2-element vectors with names \code{x} and
#' \code{y}. These are used to fix the x and y limits of the plot, which is
#' especially useful for comparing plots. Defaults to
#' \code{list(x=c(1000, 9000), y=c(3000, 13500))}.
#'
#' @return A ggplot object in just one colour corresponding to
#' \code{classString}.
#'
#' @name flatPlot
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Plot the data frame with no classification.
#' aWell <- KRASdata[["E03"]]
#' flatPlot(aWell)
#'
#' ## Take a ddpcrWell object that is mostly classified as "NN" and colour it
#' ## as such.
#' aWell <- KRASdata[["H04"]]
#' emptiedWell <- aWell[aWell$Cluster == 1, ]
#' emptiedWell <- ddpcrWell(well=emptiedWell)
#' flatPlot(emptiedWell, classString="NN")
#'
#' ## Plotting all of a ddpcrPlate object works the same way.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' flatPlot(krasPlate)
#'
#' @export

flatPlot <- function(droplets,
                     ch1Label="Ch1 Amplitude",
                     ch2Label="Ch2 Amplitude",
                     classString=ddpcr$na,
                     initialCentres=NULL, selectedCentre=NULL,
                     plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)))
  UseMethod("flatPlot")


#' @export

setGeneric("flatPlot")


#' @rdname flatPlot
#'
#' @exportMethod flatPlot

setMethod("flatPlot", "data.frame",
  function(droplets,
           ch1Label="Ch1 Amplitude",
           ch2Label="Ch2 Amplitude",
           classString=ddpcr$na,
           initialCentres=NULL, selectedCentre=NULL,
           plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
    if(nrow(droplets) > 0) {
      droplets <- data.frame(droplets[, c("Ch1.Amplitude", "Ch2.Amplitude")],
                             "class"=classString)
    }
    dropletPlot(droplets, cMethod="class", initialCentres=initialCentres,
                selectedCentre=selectedCentre, plotLimits=plotLimits)
  }
)


#' @rdname flatPlot
#'
#' @description If a \code{ddpcrWell} object is given as a parameter, plot the
#' droplets in the well and colour them according to a given class.
#'
#' @exportMethod flatPlot

setMethod("flatPlot", "ddpcrWell",
  function(droplets,
           ch1Label="Ch1 Amplitude",
           ch2Label="Ch2 Amplitude",
           classString=ddpcr$na,
           initialCentres=NULL, selectedCentre=NULL,
           plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
    if(!isEmpty(droplets)) {
      droplets <- data.frame(amplitudes(droplets), class=classString)
    }
    dropletPlot(droplets, cMethod="class", initialCentres=initialCentres,
                selectedCentre=selectedCentre, plotLimits=plotLimits)
  }
)


#' @rdname flatPlot
#'
#' @description If a \code{ddpcrPlate} object is given as a parameter,
#' plot the droplets in all wells and colour them according to a given class.
#'
#' @exportMethod flatPlot

setMethod("flatPlot", "ddpcrPlate",
  function(droplets,
           ch1Label="Ch1 Amplitude",
           ch2Label="Ch2 Amplitude",
           classString=ddpcr$na,
           initialCentres=NULL, selectedCentre=NULL,
           plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
    if(!isEmpty(droplets)) {
      droplets <- do.call(rbind, amplitudes(droplets))
      droplets <- data.frame(droplets, class=classString)
    }
    dropletPlot(droplets, cMethod="class", initialCentres=initialCentres,
                selectedCentre=selectedCentre, plotLimits=plotLimits)
  }
)

#' @import stats
NULL

#' Re-label clusters.
#'
#' An attempt to label clusters with "NN", "NP", "PN" or "PP" automatically.
#' (This will not generalise to amplitudes in only a single channel.)
#'
#' @param droplets A data frame of droplet amplitudes with a classification.
#' @param classCol The column (name or number) from 'droplets' representing
#' the class.
#' @param presentClasses A vector of classes that we want to label. Must be
#' a subset of c("NN", "NP", "PN", "PP") and must have the same number of
#' classes as the number of unique classes in the class column.
#'
#' @return The classification column relabelled with "NN", "NP", "PN" and "PP".
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Look at the "Cluster" column that was created by Bio-Rad's QuantaSoft.
#' aWell <- KRASdata[["E03"]]
#' str(aWell$Cluster)
#'
#' ## Relabel the classes to see the difference.
#' relabelled <- relabelClasses(aWell, classCol="Cluster")
#' str(relabelled)
#' levels(relabelled)
#'
#' ## We choose a sample with 3 clusters.
#' unique(KRASdata[["H04"]]$Cluster)
#'
#' ## We can check that there is no "PP" class, so specify the others only.
#' relabelled <- relabelClasses(KRASdata[["H04"]], classCol="Cluster",
#'                              presentClasses=c("NN", "PN", "NP"))
#' table(relabelled)
#'
#' @export

relabelClasses <- function(droplets, classCol="class",
                          presentClasses=ddpcr$classes) {
  # Everything is easier if we use the column name instead of number.
  if(is.numeric(classCol)) {
    classCol <- colnames(droplets)[classCol]
  }

  # Only one class: label everything as given by presentClasses.
  if(length(unique(droplets[, classCol])) == 1) {
    newClassification <- rep(presentClasses[1], length(droplets[, classCol]))
    return(factor(newClassification, levels=ddpcr$classesRain))
  }

  # Bottom-left of each cluster with a shift-factor to the origin.
  bl <- stats::aggregate(
    droplets[!droplets[, classCol] %in% c(ddpcr$rain, ddpcr$na),
             c("Ch1.Amplitude", "Ch2.Amplitude")],
    by=list("class"=droplets[!droplets[, classCol] %in%
            c(ddpcr$rain, ddpcr$na), classCol]),
    FUN=min
  )
  ch1ShiftFactor <- min(bl$Ch1.Amplitude)
  ch2ShiftFactor <- min(bl$Ch2.Amplitude)

  # Top-right of each cluster with a scaling factor.
  tr <- stats::aggregate(
    droplets[!droplets[, classCol] %in% c(ddpcr$rain, ddpcr$na),
    c("Ch1.Amplitude", "Ch2.Amplitude")],
    by=list("class"=droplets[!droplets[, classCol] %in%
            c(ddpcr$rain, ddpcr$na), classCol]),
    FUN=max
  )
  ch1NormFactor <- max(tr$Ch1.Amplitude) - ch1ShiftFactor
  ch2NormFactor <- max(tr$Ch2.Amplitude) - ch2ShiftFactor

  # Normalise everything.
  tr$Ch1.Amplitude <- (tr$Ch1.Amplitude - ch1ShiftFactor) / ch1NormFactor
  tr$Ch2.Amplitude <- (tr$Ch2.Amplitude - ch2ShiftFactor) / ch2NormFactor
  bl$Ch1.Amplitude <- (bl$Ch1.Amplitude - ch1ShiftFactor) / ch1NormFactor
  bl$Ch2.Amplitude <- (bl$Ch2.Amplitude - ch2ShiftFactor) / ch2NormFactor

  # Bottom-right and top-left.
  br <- data.frame("Ch1.Amplitude"=bl$Ch1.Amplitude,
                   "Ch2.Amplitude"=tr$Ch2.Amplitude,
                   "class"=bl$class)
  tl <- data.frame("Ch1.Amplitude"=tr$Ch1.Amplitude,
                   "Ch2.Amplitude"=bl$Ch2.Amplitude,
                   "class"=bl$class)

  # Score the clusters according to their location. Basic idea here: transform
  # the candidate cluster to the bottom left so that they are the closest to
  # the origin; the cluster with the smallest sup.dist from the origin is the
  # best candidate.
  tr$sup.dist <- mapply(max, 1 - tr$Ch1.Amplitude, 1 - tr$Ch2.Amplitude)
  tl$sup.dist <- mapply(max, 1 - tl$Ch1.Amplitude, tl$Ch2.Amplitude)
  br$sup.dist <- mapply(max, br$Ch1.Amplitude, 1 - br$Ch2.Amplitude)
  bl$sup.dist <- mapply(max, bl$Ch1.Amplitude, bl$Ch2.Amplitude)
  distances <- data.frame("class"=tr$class, "NN"=bl$sup.dist, "NP"=br$sup.dist,
                          "PN"=tl$sup.dist, "PP"=tr$sup.dist)
  colnames(distances)[2:5] <- ddpcr$classes
  distances <- distances[, c("class", presentClasses)]

  # Labelling process.
  # Repeat the following for the original number of clusters:
  #   Find the smallest number in each column of 'distances'; choose the (row,
  #   column) with the smallest such min.
  #   Assign this column's label to the class corresponding to this row.
  #   Remove the entire row and column from 'distances'.
  labels <- setNames(vector("list", ncol(distances) + 2),
                     c(presentClasses, ddpcr$rain, ddpcr$na))
  for(n in seq_len(nrow(distances))) {
    min.row <- which.min(apply(distances, MARGIN=1, min))
    min.col <- which.min(apply(distances, MARGIN=2, min))
    labels[[as.character(distances[min.row, "class"])]] <-
      colnames(distances)[min.col]
    distances <- distances[-min.row, -min.col]
  }
  labels[[ddpcr$rain]] <- ddpcr$rain
  labels[[ddpcr$na]] <- ddpcr$na

  # Rename the original classes to the new class names.
  renamed <- factor(unlist(labels[as.character(droplets[, classCol])]),
                    levels=ddpcr$classesRain)
  setNames(renamed, NULL)
}

#' @import methods
NULL

#' Retrieve a data frame of droplet amplitudes with droplets of a given class
#' removed.
#'
#' By default, all droplets classified as "N/A" or "Rain" will be removed.
#' Including these droplets is useful for visualisation purposes, but they
#' could be a problem in some scenarios, e.g. if we wish to use the
#' classification as a training data set.
#'
#' @param droplets A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
#' object, or a data frame with columns \code{Ch1.Amplitude},
#' \code{Ch2.Amplitude} and a classification column.
#' @param ... Other parameters depending on the type of \code{droplets}.
#' @param classesToRemove A vector of character strings corresponding to the
#' classes that should be removed. Defaults to \code{NULL}, i.e. remove
#' nothing.
#' @param keepUnclassified A logical flag determining whether unclassified
#' droplets (i.e. "Rain" or "N/A") should be kept. Defaults to \code{FALSE},
#' i.e. remove them.
#'
#' @return If a \code{ddpcrWell} object is given, return a data frame
#' corresponding to \code{droplets} with the given droplet classes removed.
#' If a \code{ddpcrPlate} object is given, return a list of data frames
#' instead.
#'
#' @name removeDropletClasses
#'
#' @seealso This function can remove "N/A" droplets from classifications
#' produced by \code{\link{gridClassify}}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Take a data frame and transform it into the right format.
#' aWell <- KRASdata[["E03"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#'
#' ## Add rain using the Mahalanobis distance.
#' aWell$ClusterMahRain <-
#'     mahalanobisRain(aWell, cMethod="Cluster", fullTable=FALSE)
#' table(aWell$ClusterMahRain)
#'
#' ## Suppose we want to use this for training. Remove the "Rain" droplets.
#' aWellCleaned <- removeDropletClasses(aWell, cMethod="ClusterMahRain")
#' table(aWellCleaned$ClusterMahRain)
#'
#' ## All of the above works with ddpcrWell objects.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' aWell <- mahalanobisRain(aWell, cMethod="Cluster")
#' trainingData <- removeDropletClasses(aWell, cMethod="ClusterMahRain")
#' table(wellClassification(aWell, "ClusterMahRain"))
#' table(trainingData$ClusterMahRain)
#'
#' ## Likewise for ddpcrPlate objects we can create the training data.
#' krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "F03", "G03")])
#' krasPlate <- mahalanobisRain(krasPlate, cMethod="Cluster")
#' trainingData <- removeDropletClasses(krasPlate, cMethod="ClusterMahRain")
#' cl <- plateClassification(krasPlate, cMethod="ClusterMahRain")
#' cl <- unlist(cl)
#' table(cl)
#' td <- do.call(rbind, trainingData)
#' table(td$ClusterMahRain)
#'
#' ## We could also remove other droplet classes, such as the "PN" and "PP"
#' ## clusters.
#' noPNPP <- removeDropletClasses(krasPlate, cMethod="ClusterMahRain",
#'                                classesToRemove=c("PN", "PP"))
#' td <- do.call(rbind, noPNPP)
#' table(td$ClusterMahRain)
#'
#' ## The same could be done, but with the "Rain" retained.
#' noPNPPWithRain <- removeDropletClasses(krasPlate, cMethod="ClusterMahRain",
#'                                        classesToRemove=c("PN", "PP"),
#'                                        keepUnclassified=TRUE)
#' td <- do.call(rbind, noPNPPWithRain)
#' table(td$ClusterMahRain)
#'
#'
#' @export

setGeneric(
  "removeDropletClasses",
  function(droplets, ..., classesToRemove=NULL, keepUnclassified=FALSE) {
    standardGeneric("removeDropletClasses")
  }
)


#' @rdname removeDropletClasses
#'
#' @param cMethod This is the name or column number corresponding to the
#' classification in \code{droplets}. This column should only have entries in
#' "NN", "PN", "NP, "PP", "Rain" and "N/A". Defaults to "class".
#'
#' @exportMethod removeDropletClasses

setMethod(
  "removeDropletClasses", "data.frame",
  function(droplets, cMethod="class", classesToRemove=NULL,
           keepUnclassified=FALSE) {
    df <- droplets[, c("Ch1.Amplitude", "Ch2.Amplitude", cMethod)]
    df <- df[!df[, cMethod] %in% classesToRemove, ]
    if(!keepUnclassified) {
      df <- df[!df[, cMethod] %in% c(ddpcr$na, ddpcr$rain), ]
    }
    df
  }
)


#' @rdname removeDropletClasses
#'
#' @exportMethod removeDropletClasses

setMethod(
  "removeDropletClasses", "ddpcrWell",
  function(droplets, cMethod, classesToRemove=NULL, keepUnclassified=FALSE) {
    df <- wellClassification(droplets, withAmplitudes=TRUE)
    removeDropletClasses(df, cMethod=cMethod,
                         classesToRemove=classesToRemove,
                         keepUnclassified=keepUnclassified)
  }
)


#' @rdname removeDropletClasses
#'
#' @exportMethod removeDropletClasses

setMethod(
  "removeDropletClasses", "ddpcrPlate",
  function(droplets, cMethod, classesToRemove=NULL, keepUnclassified=FALSE) {
    lapply(plateClassification(droplets, withAmplitudes=TRUE),
           removeDropletClasses, cMethod=cMethod,
           classesToRemove=classesToRemove,
           keepUnclassified=keepUnclassified)

  }
)

#' @include global.R
#' @include themes.R
#' @include dropletPlot.R
#' @import methods
#' @import ggplot2
NULL

#' @title Draw a heat plot of the droplets.
#'
#' @description Using alpha transparency only, it is generally difficult to see
#' where droplets are truly distributed and concentrated. A heat (density) plot
#' gives a better illustration of this.
#'
#' @param droplets A data frame of droplet amplitudes, a \code{ggplot},
#' \code{ddpcrWell} or \code{ddpcrPlate} object.
#' @param ch1Label The label for the channel 1 target. Defaults to "Ch1
#' Amplitude".
#' @param ch2Label The label for the channel 2 target. Defaults to "Ch2
#' Amplitude".
#' @param binwidth The width of each hexagonal bin in the 2d heat (density)
#' plot. Defaults to 100.
#' @param plotLimits A list of 2-element vectors with names \code{x} and
#' \code{y}. These are used to fix the x and y limits of the plot, which is
#' especially useful for comparing plots. Defaults to \code{list(x=c(1000,
#' 9000), y=c(3000, 13500))}.
#'
#' @return A heat plot as a \code{\link[ggplot2]{ggplot}} object.
#'
#' @aliases densityPlot
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @references The nice log-scaled palette was achieved using
#' \url{http://www.everydayanalytics.ca/2014/09/5-ways-to-do-2d-histograms-in-r.html}
#'
#' @examples
#' ## Density plot of a data frame.
#' heatPlot(KRASdata[["E03"]])
#'
#' ## Density plot of a ddpcrWell object.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' heatPlot(aWell)
#'
#' ## Density plot of a ddpcrPlate object with an adjusted bin size.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' heatPlot(krasPlate, binwidth=50)
#'
#' @export

heatPlot <- function(droplets,
                     ch1Label="Ch1 Amplitude",
                     ch2Label="Ch2 Amplitude",
                     binwidth=100,
                     plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
  UseMethod("heatPlot")
}


#' @rdname heatPlot
#'
#' @exportMethod heatPlot

setGeneric("heatPlot")


#' @import hexbin
#' @importFrom RColorBrewer brewer.pal
#' @importFrom scales trans_format
#' @exportMethod heatPlot

heatPlot.gg <- function(droplets,
                        ch1Label="Ch1 Amplitude",
                        ch2Label="Ch2 Amplitude",
                        binwidth=100,
                        plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
  # Use a nice palette.
  rf <- grDevices::colorRampPalette(rev(brewer.pal(11, 'Spectral')))
  r <- rf(32)

  # Draw the heat plot with the colours on a log scale.
  p <-
    droplets + stat_binhex(binwidth=c(binwidth,binwidth)) +
    scale_fill_gradientn(name="# droplets", colours=r, trans="log",
      labels=trans_format("identity", function(x) round(x, 0)))

  # Label the axes.
  p <- p + ylab(ch1Label)
  p <- p + xlab(ch2Label)

  p + expand_limits(x=plotLimits$x, y=plotLimits$y) +
    whiteTheme(legendPosition=c(1, 1), legendJustification=c(1, 1))
}


#' @rdname heatPlot
#'
#' @exportMethod heatPlot

setMethod(
  "heatPlot", "data.frame",
  function(droplets, ch1Label="Ch1 Amplitude", ch2Label="Ch2 Amplitude",
           binwidth=100, plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
    # Something to plot.
    if(nrow(droplets) > 0) {
      heatPlot(ggplot(droplets,
                      aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude")),
               ch1Label=ch1Label, ch2Label=ch2Label,
               binwidth=binwidth, plotLimits=plotLimits)
    } else {
      # Nothing to plot.
      dropletPlot(droplets,
                  ch1Label=ch1Label, ch2Label=ch2Label,
                  plotLimits=plotLimits)
    }
  }
)


#' @rdname heatPlot
#'
#' @exportMethod heatPlot

setMethod("heatPlot", "ddpcrWell",
  function(droplets, ch1Label="Ch1 Amplitude", ch2Label="Ch2 Amplitude",
           binwidth=100, plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
    # Something to plot.
    if(numDroplets(droplets) > 0) {
      heatPlot(ggplot.well(droplets,
                           aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude")),
               ch1Label=ch1Label, ch2Label=ch2Label,
               binwidth=binwidth, plotLimits=plotLimits)
    } else {
      # Nothing to plot.
      dropletPlot(droplets,
                  ch1Label=ch1Label, ch2Label=ch2Label,
                  plotLimits=plotLimits)
    }
  }
)


#' @rdname heatPlot
#'
#' @exportMethod heatPlot

setMethod("heatPlot", "ddpcrPlate",
  function(droplets, ch1Label="Ch1 Amplitude", ch2Label="Ch2 Amplitude",
           binwidth=100, plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))) {
    # Something to plot.
    if(sum(numDroplets(droplets)) > 0) {
      heatPlot(ggplot.plate(droplets,
                            aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude")),
               ch1Label=ch1Label, ch2Label=ch2Label,
               binwidth=binwidth, plotLimits=plotLimits)
    } else {
      # Nothing to plot.
      dropletPlot(droplets,
                  ch1Label=ch1Label, ch2Label=ch2Label,
                  plotLimits=plotLimits)
    }
  }
)

#' @include global.R
#' @include themes.R
#' @import ggplot2
#' @import methods
NULL

#' Plot nothing.
#'
#' We may sometimes request that the \code{\link{dropletPlot}} method takes an
#' empty data frame as its argument, e.g. an empty CSV file is loaded. This
#' normally presents an error, which is not the desired output. This function
#' plots nothing to show that there was no data to plot.
#'
#' @seealso \code{\link{ggplot.well}} and
#' \code{\link[=ggplot.well]{ggplot.plate}} are wrappers for plotting
#' \code{\link{ddpcrWell}} and \code{\link{ddpcrPlate}} objects.
#' @seealso If there is at least one droplet, the \code{\link{dropletPlot}}
#' method plots droplet amplitude classifications.
#'
#' @return A blank \code{ggplot} object.
#'

drawBlank <- function() {
  ggplot() + geom_blank() +
    whiteTheme(legendPosition=c(1, 1), legendJustification=c(1, 1))
}


# Use an S3 generic because the default class for 'droplets' is a 'gg' object,
# which is not an S4 class.

#' @title Plot a droplet classification with a colour-blind palette, optional
#' cluster centres and fixed axes.
#'
#' @description Plot an object comprising droplet amplitudes and their
#' classification. If specified, centres of clusters can be marked, e.g.
#' k-means clustering can take a set of centres as the initial centres of the
#' algorithm, and the algorithm also outputs the final cluster centres. Limits
#' to the axes can also be set for ease of comparison and consistency.
#'
#' If a \code{ggplot} object is given as a parameter, this method will simply
#' plot it with the pretty colours, centres and restrictions on the axes.
#'
#' @param droplets An object corresponding to droplet amplitudes and their
#' classifications. This can be in the form of:
#' \itemize{
#'   \item A data frame with columns \code{Ch1.Amplitude}, \code{Ch2.Amplitude}
#'   and a classification column (see the parameter \code{cMethod}).
#'   \item A \code{\link{ddpcrWell}} object.
#'   \item A \code{\link{ddpcrPlate}} object.
#'   \item A \code{\link[ggplot2]{ggplot}} (\code{gg}) object. For example,
#'   this could be the output of \code{\link[twoddpcr]{ggplot.well}} or
#'   \code{\link[=ggplot.well]{ggplot.plate}}. We should not need to use this
#'   unless we are writing new methods to plot new data types.
#' }
#' @param ch1Label The label for the channel 1 target. Defaults to "Ch1
#' Amplitude".
#' @param ch2Label The label for the channel 2 target. Defaults to "Ch2
#' Amplitude".
#' @param ... Other plotting parameters that depend on the object type of
#' \code{droplets}.
#' @param cMethod This should be the name or column number of \code{droplets}
#' corresponding to the classification. This column should only have entries in
#' "NN", "PN", "NP, "PP", "Rain" and "N/A". If "None", plots the droplets with
#' all of them classified as \code{N/A}. Defaults to "None".
#' @param mapping A list of aesthetic mappings to use for the plot. Defaults to
#' \code{ggplot2::aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude",
#' colours=cMethod)}. Not used if \code{droplets} is a \code{ggplot} object.
#' @param finalCentres A data frmae of final centres to plot (e.g. those
#' returned by the k-means or c-means algorithms). If \code{NULL}, nothing is
#' plotted. Defaults to \code{NULL}.
#' @param initialCentres A data frame of initial centres to plot (e.g. initial
#' cluster centres used in the k-means). If \code{NULL}, nothing is plotted.
#' Defaults to \code{NULL}. This parameter is useful for illustrative reasons.
#' @param selectedCentre An initial centre to highlight. This should be either
#' "NN", "NP", "PN" or "PP". If \code{NULL}, nothing is highlighted. Defaults
#' to \code{NULL}. This parameter is useful for illustrative reasons.
#' @param pointSize The size to draw each droplet. Defaults to 1.
#' @param plotLimits A list of 2-element vectors with names \code{x} and
#' \code{y}. These are used to fix the x and y limits of the plot, which is
#' especially useful for comparing plots. Defaults to \code{list(x=c(1000,
#' 9000), y=c(3000, 13500))}.
#' @param legendLabels The character vector corresponding to the labels for the
#' legend. The elements of the vector should correspond to the NN, NP, PN, PP,
#' Rain and N/A classes, respectively. Defaults to \code{ddpcr$classesRain}.
#'
#' @return A \code{ggplot} object with all of the given information above.
#'
#' @name dropletPlot
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get a data frame and relabel the "Cluster" column to the right form.
#' aWell <- KRASdata[["E03"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#'
#' ## Plot the data frame.
#' dropletPlot(aWell, cMethod="Cluster")
#'
#' ## Plot a ddpcrWell object.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' dropletPlot(aWell, cMethod="Cluster")
#'
#' ## Plot a ddpcrPlate object.
#' krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
#' dropletPlot(krasPlate, cMethod="Cluster")
#'
#' ## Use K-means clustering to classify a single sample. Then plot the
#' ## classification and final cluster centres.
#' aWell <- kmeansClassify(aWell)
#' centres <- clusterCentres(aWell, cMethod="kmeans")
#' dropletPlot(aWell, cMethod="kmeans", finalCentres=centres)
#'
#' @export

dropletPlot <- function(droplets,
                        ch1Label="Ch1 Amplitude",
                        ch2Label="Ch2 Amplitude",
                        ...) {
  UseMethod("dropletPlot")
}


# Still need to set an S4 generic for S4 classes.

#' @export

setGeneric("dropletPlot")


# This is an S3 method because 'gg' is an S3 class.

#' @exportMethod dropletPlot

dropletPlot.gg <- function(droplets,
                           ch1Label="Ch1 Amplitude",
                           ch2Label="Ch2 Amplitude",
                           finalCentres=NULL, initialCentres=NULL,
                           selectedCentre=NULL,
                           pointSize=1,
                           plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)),
                           legendLabels=ddpcr$classesRain) {
  p <- droplets +
    geom_point(alpha=0.3, size=pointSize) +
    scale_colour_manual(values=ddpcr$dropColours, labels=legendLabels)

  # Plot the final centres.
  if(!is.null(finalCentres)) {
    p <- p + geom_point(data=finalCentres,
                        fill="#000000",
                        colour="#FFFFFF",
                        alpha=0.8,
                        shape=9,
                        size=6)
  }

  # Plot the initial centres, highlighting any selected ones.
  if(!is.null(initialCentres)) {
    if(is.null(selectedCentre)) {
      selectedCentre <- ddpcr$na
    }
    p <- p +
      geom_point(
        data=initialCentres[rownames(initialCentres)==selectedCentre, ],
        fill="#FFFFFF", colour="#000000", alpha=0.8, shape=23, size=6) +
      geom_point(
        data=initialCentres[rownames(initialCentres)!=selectedCentre, ],
        fill="#000000", colour="#FFFFFF", alpha=0.8, shape=23, size=6)
  }

  # Label the axes.
  p <- p + ylab(ch1Label)
  p <- p + xlab(ch2Label)

  # Standardise the limits to make it easy to compare plots.
  p + expand_limits(x=plotLimits$x, y=plotLimits$y) +
    whiteTheme(legendPosition=c(1, 1), legendJustification=c(1, 1))
}


#' @description If a \code{data.frame} is given as a parameter, it should
#' correspond to droplets with their classification.
#'
#' @rdname dropletPlot
#'
#' @exportMethod dropletPlot

setMethod(
  "dropletPlot", "data.frame",
  function(droplets,
           ch1Label="Ch1 Amplitude",
           ch2Label="Ch2 Amplitude",
           cMethod="None",
           mapping=aes_string(x="Ch2.Amplitude",
                              y="Ch1.Amplitude",
                              colour=cMethod),
           finalCentres=NULL, initialCentres=NULL, selectedCentre=NULL,
           pointSize=1, plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)),
           legendLabels=ddpcr$classesRain) {
    if(nrow(droplets) > 0) {
      # Add a dummy column if needed.
      if(cMethod == "None" && !"None" %in% colnames(droplets))
        droplets$None <- factor(c("N/A"), levels=ddpcr$classesRain)

      # Get the right ggplot object.
      p <- ggplot(droplets, mapping=mapping)
    } else {
      # Nothing to draw.
      p <- drawBlank()
    }

    dropletPlot(p,
                ch1Label=ch1Label, ch2Label=ch2Label,
                finalCentres=finalCentres,
                initialCentres=initialCentres,
                pointSize=pointSize,
                plotLimits=plotLimits,
                legendLabels=legendLabels)
  }
)


#' @description If a \code{ddpcrWell} object is given as a parameter, plot the
#' droplets in the well with its classification.
#'
#' @rdname dropletPlot
#'
#' @exportMethod dropletPlot

setMethod(
  "dropletPlot", "ddpcrWell",
  function(droplets,
           ch1Label="Ch1 Amplitude",
           ch2Label="Ch2 Amplitude",
           cMethod="None",
           mapping=aes_string(x="Ch2.Amplitude",
                              y="Ch1.Amplitude",
                              colour=cMethod),
           finalCentres=NULL, initialCentres=NULL, selectedCentre=NULL,
           pointSize=1, plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)),
           legendLabels=ddpcr$classesRain) {
    p <- ggplot.well(droplets, cMethod=cMethod, mapping=mapping)
    dropletPlot(p,
                ch1Label=ch1Label, ch2Label=ch2Label,
                finalCentres=finalCentres,
                initialCentres=initialCentres,
                pointSize=pointSize,
                plotLimits=plotLimits,
                legendLabels=legendLabels)
  }
)


#' @rdname dropletPlot

#' @description If a \code{ddpcrPlate} object is given as a parameter, plot the
#' droplets from all wells with their classifications.
#'
#' @exportMethod dropletPlot

setMethod(
  "dropletPlot", "ddpcrPlate",
  function(droplets,
           ch1Label="Ch1 Amplitude",
           ch2Label="Ch2 Amplitude",
           cMethod="None",
           mapping=aes_string(x="Ch2.Amplitude",
                              y="Ch1.Amplitude",
                              colour=cMethod),
           finalCentres=NULL, initialCentres=NULL, selectedCentre=NULL,
           pointSize=1, plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)),
           legendLabels=ddpcr$classesRain) {
    p <- ggplot.plate(droplets, cMethod=cMethod, mapping=mapping)
    dropletPlot(p, ch1Label=ch1Label, ch2Label=ch2Label,
                finalCentres=finalCentres,
                initialCentres=initialCentres,
                pointSize=pointSize,
                plotLimits=plotLimits,
                legendLabels=legendLabels)
  }
)

#' @title KRAS mutant and wild type droplet counts and Poisson estimates.
#'
#' @description A data frame of droplet counts using the standard 
#' \code{Cluster} classification from \code{\link{KRASdata}}. Each row 
#' corresponds to a well/sample and the columns \code{PP}, \code{PN}, \code{NP} 
#' and \code{NN} show how many droplets were in each cluster. The remaining 
#' rows were calculated from the counts figures except for the 
#' \code{InputAmount} column.
#'
#' @details The data frame was created by:
#' \preformatted{krasPlate <- ddpcrPlate(wells=KRASdata)
#' KRAScounts <- plateSummary(krasPlate, cMethod="Cluster")
#' onesVector <- c(1, 1, 1)
#' runAmount <- c(64 * onesVector, 16 * onesVector, 4 * onesVector, onesVector)
#' KRAScounts$InputAmount <- runAmount
#' 
#' KRAScountsWellCol <- KRAScounts
#' KRAScountsWellCol$Well <- rownames(KRAScounts)
#' KRAScountsWellCol <- KRAScountsWellCol[, c(18,1:17)]
#' rownames(KRAScountsWellCol) <- NULL
#' }
#'
#' @docType data
#'
#' @usage data(KRAScounts)
#'
#' @format A data frame where each row corresponds to a well/sample.
#'
#' @return A data frame.
#'
#' @name KRAScounts
#'
#' @author From the \code{\link{KRASdata}} dataset created by Mahmood Ayub, 
#' \email{mahmood.ayub@cruk.manchester.ac.uk}
#'
#' @keywords datasets

"KRAScounts"


#' @rdname KRAScounts
#'
#' @description \code{KRAScountsWellCol} is the same data frame but has 
#' a \code{Well} column instead of named rows.
#'
#' @usage data(KRAScountsWellCol)

"KRAScountsWellCol"


#' @rdname KRAScounts
#'
#' @description \code{KRAScountsQS} is a data frame imported from a CSV created 
#' by Bio-Rad's QuantaSoft.
#'
#' @usage data(KRAScountsQS)

"KRAScountsQS"

#' @import class
#' @import methods
NULL

#' @title Use the k-nearest neighbour algorithm to classify the wells in
#' a \code{ddpcrWell} or \code{ddpcrPlate} object, or in a data frame.
#'
#' @param droplets A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
#' object, or a data frame with columns \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude}.
#' @param trainData A data frame of training data with columns
#' \code{Ch1.Amplitude} and \code{Ch2.Amplitude}.
#' @param cl A vector of classes corresponding to \code{trainData}.
#' @param k The number of nearest neighbours to use in the algorithm.
#' @param prob The minimal proportion of votes for the winning class needed to
#' assert that a droplet belongs to the class. This figure should be a float
#' between 0 and 1. For example, if 0.6 then at least 60% of a droplet's
#' k-nearest neighbours need to be of one class, otherwise it is classified as
#' "Rain". Defaults to 0, i.e. we do not use "Rain".
#' @param ... Other options depending on the type of \code{droplets}.
#'
#' @return An object with the new classification.
#'
#' @seealso This method uses the \code{\link[class]{knn}} function.
#' @seealso To manually set and retrieve classifications, use the
#' \code{\link{wellClassification}}, \code{\link{plateClassification}} and
#' \code{\link{plateClassificationMethod}} methods.
#' @seealso \code{kmeansClassify} provides a wrapper for the k-means clustering
#' algorithm.
#'
#' @name knnClassify
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ### Use the KRASdata dataset for all of these examples.
#'
#' ## Use k-means clustering to classify one sample. Use this as training
#' ## data for the K-Nearest Neighbour algorithm.
#' trainingData <- KRASdata[["E03"]]
#' trainingData <- kmeansClassify(trainingData)$data
#'
#' ## Classify a dataframe using k-NN with k = 1 and the above training data.
#' aWell <- knnClassify(
#'            KRASdata[["F03"]],
#'            trainData=trainingData[, c("Ch1.Amplitude", "Ch2.Amplitude")],
#'            cl=trainingData$class,
#'            k=1)
#' dropletPlot(aWell, cMethod="class")  # visualising the classification
#'
#' ## We can change k to a larger number, here with a ddpcrWell object.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' aWell <- knnClassify(
#'            aWell,
#'            trainData=trainingData[, c("Ch1.Amplitude", "Ch2.Amplitude")],
#'            cl=trainingData$class,
#'            k=3)
#' dropletPlot(aWell, cMethod="knn")  # visualising the classification
#'
#' ## Changing the 'prob' parameter means that droplets with less than 'prob'
#' ## of the votes will not be classified. We do this for a ddpcrPlate
#' ## object.
#' krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
#' krasPlate <- knnClassify(
#'                krasPlate,
#'                trainData=trainingData[, c("Ch1.Amplitude", "Ch2.Amplitude")],
#'                cl=trainingData$class,
#'                k=3,
#'            prob=0.6)
#' dropletPlot(krasPlate, cMethod="knn")  # visualising the classification
#'
#' @export

setGeneric("knnClassify", function(droplets, trainData, cl, k, prob=0.0, ...) {
  standardGeneric("knnClassify")
})


#' @rdname knnClassify
#'
#' @description If \code{droplets} is a data frame, the droplets are classified
#' using the k-nearest neighbour algorithm against a training data set.
#'
#' @param fullTable If \code{TRUE}, returns a full data frame of droplets and
#' their classification; if \code{FALSE}, simply returns the classified vector.
#' Defaults to \code{TRUE}.
#'
#' @return If \code{droplets} is a data frame, return data frame or factor
#' (depending on the value of \code{fullTable}) of the droplet classification
#' under the k-NN algorithm.
#'
#' @exportMethod knnClassify

setMethod(
  "knnClassify", "data.frame",
  function(droplets, trainData, cl, k, prob=0.0, fullTable=TRUE) {
    # Only take the amplitudes columns into account.
    droplets <- droplets[, c("Ch1.Amplitude", "Ch2.Amplitude")]

    # Use the k-NN algorithm to classify the droplets.
    knnOut <- class::knn(trainData, droplets, cl, k, prob=prob)

    # Add rain if specified.
    if(prob) {
      knnOut <- factor(
        ifelse(
          attr(knnOut, "prob") >= prob,
          as.character(knnOut),
          ddpcr$rain
        ),
        levels=ddpcr$classesRain
      )
    }

    if(fullTable) {
      data.frame(droplets, "class"=knnOut)
    } else {
      knnOut
    }
  }
)


#' @rdname knnClassify
#'
#' @description If \code{droplets} is a \code{ddpcrWell} object, the droplets
#' in the well are classified and returned in another \code{ddpcrWell} object.
#'
#' @exportMethod knnClassify

setMethod("knnClassify", "ddpcrWell",
  function(droplets, trainData, cl, k, prob=0.0) {
    # Retrieve the droplets and set the classification.
    df <- amplitudes(droplets)
    kn <- knnClassify(droplets=df, trainData=trainData, cl=cl,
                      k=k, prob=prob, fullTable=FALSE)
    wellClassification(droplets, "knn") <- kn

    validObject(droplets)
    return(droplets)
  }
)

#' @rdname knnClassify
#'
#' @description If \code{droplets} is a \code{ddpcrPlate} object, the
#' wells are combined and classified together, with the resulting
#' classification assigned to the \code{ddpcrPlate} object.
#'
#' @exportMethod knnClassify

setMethod("knnClassify", "ddpcrPlate",
  function(droplets, trainData, cl, k, prob=0.0) {
    # Combine everything and classify.
    df <- do.call(rbind, amplitudes(droplets))
    kn <- knnClassify(droplets=df, trainData=trainData, cl=cl,
                      k=k, prob=prob, fullTable=FALSE)
    plateClassification(droplets, "knn") <- kn

    validObject(droplets)
    return(droplets)
  }
)

#' @import stats
NULL

#' Get the mean of each cluster.
#'
#' @description After classifying droplets, we can compute the mean for each
#' class.
#'
#' @param droplets A data frame of droplets with \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude} columns, as well as a classification column (see the
#' parameter \code{classCol}).
#' @param classCol The column (name or number) from \code{droplets}
#' representing the class.
#'
#' @return A list or data frame of means of each class.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get the means of the clusters.
#' aWell <- KRASdata[["E03"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#' classMeans(aWell, classCol="Cluster")
#'
#' ## We repeat the above but with a sample with no "PP" cluster.
#' aWell <- KRASdata[["H04"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#' classMeans(aWell, classCol="Cluster")
#'
#' @export

classMeans <- function(droplets, classCol="class") {
  means <- stats::aggregate(
    droplets[, c("Ch1.Amplitude", "Ch2.Amplitude")],
    by=list(droplets[, classCol]), mean
  )
  data.frame(means, row.names=1)
}


#' Get the covariance of a cluster.
#'
#' Get the covariance of a single cluster.
#'
#' @param cl The cluster of which to find the covariance.
#' @param droplets A data frame of droplets with \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude} columns, as well as a class column (see the parameter
#' \code{classCol}).
#' @param classCol The column (name or number) from \code{droplets}
#' representing the class.
#'
#' @return The covariance matrix of the chosen cluster. If not defined, return
#' \code{NULL}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.cov <- function(cl, droplets, classCol) {
  # Find covariance of each cluster.
  covariance <- stats::cov(
    droplets[droplets[, classCol] == cl, c("Ch1.Amplitude", "Ch2.Amplitude")]
  )

  # Return NULL if there are no droplets in the class.
  if(anyNA(covariance)) {
    return(NULL)
  } else {
    return(covariance)
  }
}


#' Get the covariance of each cluster.
#'
#' After classifying droplets, we can compute the covariance for each class.
#'
#' @param droplets A data frame of droplets with \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude} columns, as well as a class column (see the parameter
#' \code{classCol}).
#' @param classCol The column (name or number) from \code{droplets}
#' representing the class.
#'
#' @return A list of covariance matrices of each cluster.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get the covariance matrix of the clusters.
#' aWell<- KRASdata[["E03"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#' classCov(aWell, classCol="Cluster")
#'
#' ## We repeat the above but with a sample with no "PP" cluster.
#' aWell <- KRASdata[["H04"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#' classCov(aWell, classCol="Cluster")
#'
#' @export

classCov <- function(droplets, classCol="class") {
  covs <- lapply(ddpcr$classes, .cov, droplets, classCol)
  setNames(covs, ddpcr$classes)
}


#' Get the inverse of a matrix
#'
#' @param s A 2x2 matrix.
#'
#' @return The inverse of `s`, or NULL if the matrix is singular
#'
#' Given a matrix, compute the inverse or return \code{NULL} if it is singular.

.matrixInverse <- function(s) {
  if(is.null(s)) {
    return(NULL)
  } else {
    tryCatch({
      inv <- solve(s, matrix(c(1,0,0,1), 2, 2))
      colnames(inv) <- rownames(s)
      inv
    },
    error=function(e) NULL)
  }
}

#' Get some basic statistical properties for each class.
#'
#' This function gives the mean, covariance and inverse of the covariance for
#' each of the classes.
#'
#' @param droplets A data frame of droplets with \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude} columns, as well as a class column (see the parameter
#' \code{classCol}).
#' @param classCol The column (name or number) from \code{droplets}
#' representing the class.
#'
#' @return A list (grouped by class name) of lists with keys \code{mean},
#' \code{cov} and \code{cov.inv}. If \code{cov} is a singular matrix, then
#' \code{cov.inv} will be \code{NULL}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get some basic statistical properties of the clusters.
#' aWell <- KRASdata[["E03"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#' classStats(aWell, classCol="Cluster")
#'
#' ## We repeat the above but with a sample with no "PP" cluster.
#' aWell <- KRASdata[["H04"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#' classStats(aWell, classCol="Cluster")
#'
#' @export

classStats <- function(droplets, classCol="class") {
  means <- classMeans(droplets, classCol)
  covs <- classCov(droplets, classCol)

  # Compute the inverses of the covariance matrices.
  covs.inv <- lapply(covs, .matrixInverse)

  # Return everything as a list with class as the key, followed by mean, cov
  # and cov.inv.
  s <- lapply(
    ddpcr$classes,
    function(cl) {
      m <- t(means[cl, ])
      names(m) <- c("Ch1.Amplitude", "Ch2.Amplitude")
      list("mean"=m,
           "cov"=covs[[cl]],
           "cov.inv"=covs.inv[[cl]])
    }
  )
  setNames(s, ddpcr$classes)
}

context("Classification means, covariances")

testDir <- system.file("testdata", package = "twoddpcr")

test_that("centres for three clusters are found", {
  testWell <- ddpcrWell(file.path(testDir, "sample_A04_Amplitude.csv"))
  cl <- wellClassification(testWell, cMethod="Sample", withAmplitudes=TRUE)

  centres <- data.frame(c("NN", "NP", "PN"),
                        "Ch1.Amplitude"=c(5015, 5430, 10100),
                        "Ch2.Amplitude"=c(2510, 7060, 2100),
                        row.names=1)
  expect_identical(classMeans(cl, classCol="Sample"), centres)
})

test_that("centres for four clusters are found", {
  testWell <- ddpcrWell(file.path(testDir, "sample_A05_Amplitude.csv"))
  cl <- wellClassification(testWell, cMethod="Sample", withAmplitudes=TRUE)

  centres <- data.frame(c("NN", "NP", "PN", "PP"),
                        "Ch1.Amplitude"=c(5020, 5450, 10050, 9050),
                        "Ch2.Amplitude"=c(1520, 7050, 2050, 6050),
                        row.names=1)
  expect_identical(classMeans(cl, classCol="Sample"), centres)
})

test_that("centres for four clusters are found (more droplets)", {
  testWell <- ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))
  cl <- wellClassification(testWell, cMethod="Sample", withAmplitudes=TRUE)

  centres <- data.frame(c("NN", "NP", "PN", "PP"),
                        "Ch1.Amplitude"=c((5000 + 5000 + 6800) / 3,
                                          5500, 10000, 9000),
                        "Ch2.Amplitude"=c((1500 + 1500 + 1600) / 3,
                                          7000, 2000, 6000),
                        row.names=1)
  expect_identical(classMeans(cl, classCol="Sample"), centres)
})

test_that("centres for two clusters are found (more droplets)", {
  testWell <- ddpcrWell(file.path(testDir, "sample_B06_Amplitude.csv"))
  cl <- wellClassification(testWell, cMethod="Sample", withAmplitudes=TRUE)
  centres <-
    data.frame(c("NN", "NP"),
               "Ch1.Amplitude"=c((5000 + 5016 + 5011 + 5005 + 4995) / 5,
                                 (5506 + 5494 + 5503 + 5494 + 5502) / 5),
               "Ch2.Amplitude"=c((1500 + 1497 + 1504 + 1497 + 1498) / 5,
                                 (6996 + 7005 + 6998 + 6996 + 7006) / 5),
               row.names=1)
  expect_identical(classMeans(cl, classCol="Sample"), centres)
})



getDfDiff <- function(x, cl, knownCovs)
{
  compCov <- classCov(cl, classCol="Sample")[[x]]
  ourCov <- knownCovs[[x]]
  if(is.null(compCov) && is.null(ourCov))
    return(0)
  else
    return(max(abs(compCov - ourCov)))
}

test_that("covariances for two clusters are found (more droplets)", {
  testWell <- ddpcrWell(file.path(testDir, "sample_B06_Amplitude.csv"))
  cl <- wellClassification(testWell, cMethod="Sample", withAmplitudes=TRUE)
  knownCovs <-
    list("NN"=data.frame(c("Ch1.Amplitude", "Ch2.Amplitude"),
                         "Ch1.Amplitude"=c(70.30, 3.15),
                         "Ch2.Amplitude"=c(3.15, 8.70),
                         row.names=1),
         "NP"=data.frame(c("Ch1.Amplitude", "Ch2.Amplitude"),
                         "Ch1.Amplitude"=c(30.20, -5.95),
                         "Ch2.Amplitude"=c(-5.95, 24.20),
                         row.names=1),
         "PN"=NULL,
         "PP"=NULL)
  maxDiff <- max(vapply(ddpcr$classes, getDfDiff, numeric(1), cl, knownCovs))
  expect_lte(maxDiff, 0.01)
})

#' Try to get well names from a vector of filenames.
#'
#' If each of the given filenames are of the form
#' "<PlateName>_<WellName>_Amplitude.csv", where <WellName> is of the form A01,
#' B01, etc., then this function can extract the <WellName> component.
#' Otherwise, the whole file name is assumed to be the well name.
#'
#' @param filenames A character vector of filenames with .csv extension.
#'
#' @return A character vector of well names.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get the well names (recognised format).
#' extractWellNames(c("Sample_Plate_Name_G02_Amplitude.csv",
#'                    "Sample_Plate_Name_H02_Amplitude.csv",
#'                    "Sample_Plate_Name_A03_Amplitude.csv",
#'                    "Sample_Plate_Name_B03_Amplitude.csv"))
#'
#' ## Get the well names (unrecognised format).
#' extractWellNames(c("Sample_G02.csv",
#'                    "Sample_H02.csv",
#'                    "Sample_A03.csv",
#'                    "Sample_B03.csv"))
#'
#' @export

extractWellNames <- function(filenames) {
  if(all(grepl("_Amplitude.csv$", filenames))) {
    vapply(gsub("_Amplitude\\.csv$", "", filenames),
           function(f) { substr(f, nchar(f)-2, nchar(f)) }, character(1))
  } else {
    # Assume that the file name is the well name.
    gsub("\\.csv$", "", basename(filenames))
  }
}


#' Try to get plate name from a filename.
#'
#' If the given filename is of the form "<PlateName>_<WellName>_Amplitude.csv",
#' where <WellName> is of the form A01, B01, etc., then this function can
#' extract the <PlateName> component. Otherwise, an empty string is returned.
#'
#' @param filename A character string corresponding to a filename with .csv
#' extension.
#'
#' @return A character string corresponding to the plate name. This is "" if
#' filename is not in a known format.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get the plate name (recognised format).
#' extractPlateName(c("Sample_Plate_Name_G02_Amplitude.csv"))
#'
#' ## Get the plate name (unrecognised format).
#' extractPlateName(c("Sample_G02.csv"))
#'
#' @export

extractPlateName <- function(filename) {
  if(all(grepl("_Amplitude.csv$", filename))) {
    vapply(gsub("_Amplitude\\.csv$", "", filename),
           function(f) { substr(f, 0, nchar(f)-4) }, character(1))
  } else {
    # Unknown format.
    ""
  }
}


#' Read all given CSV files into a list.
#'
#' Bio-Rad's QuantaSoft can export droplet amplitude data from multiple wells
#' into CSV files for each well. This function can read these CSV files into
#' a list. Note that empty wells will be ignored.
#'
#' @param path The path containing the CSV files (can be a combination of
#' directories and individual CSV file paths). Each file will have
#' a \code{Ch1.Amplitude}, \code{Ch2.Amplitude} and possibly classification
#' columns, e.g. by default, QuantaSoft returns a \code{Cluster} column too.
#' @param wellCol If \code{TRUE}, an additional column is added with the well
#' name.  This is useful if we need to merge all the data in the output list
#' and we want to identify the original well of each droplet. Defaults to
#' \code{FALSE}.
#' @param sortByLetter If \code{TRUE}, the resulting list is sorted by the
#' letter in the well names first, e.g. "A02" comes before "B01". If
#' \code{FALSE}, the result is sorted by the numeric component of the well
#' names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.
#'
#' @return A list of data frames, each containing the data from a CSV file with
#' the corresponding well name.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Read all of the droplet amplitudes from CSV files in a directory.
#' moreAmpsDir <- system.file("extdata", "more-amplitudes", package="twoddpcr")
#' someWells <- readCSVDataFrame(moreAmpsDir)
#'
#' ## We can read files from directories and files at the same time.
#' ampFile <- system.file("extdata", "amplitudes", "sample_B03_Amplitude.csv",
#'                        package="twoddpcr")
#' someWells <- readCSVDataFrame(c(moreAmpsDir, ampFile))
#'
#' ## If samples have been ordered by "A01", "A02", "A03", etc. instead of
#' ## "A01", "B01", "C01", etc., we can set the sortByLetter flag to TRUE.
#' someWells <- readCSVDataFrame(moreAmpsDir, sortByLetter=TRUE)
#'
#' ## Setting wellCol to TRUE adds an extra column with the well name. If we
#' ## bind the data frames together, we can track where the droplets came from.
#' someWells <- readCSVDataFrame(moreAmpsDir, wellCol=TRUE)
#' someWells <- do.call(rbind, someWells)
#' head(someWells)
#' tail(someWells)
#'
#' @export

readCSVDataFrame <- function(path, wellCol=FALSE, sortByLetter=FALSE) {
  if(!all(file.exists(path))) {
    stop("Not all files and/or directories exist.")
  }

  # Directories.
  dirFiles <- list.files(path=path[dir.exists(path)], pattern="*.csv$",
                         full.names=TRUE)
  # Files.
  filenames <- c(dirFiles, path[!dir.exists(path)])

  # If possible, extract the well name from the filenames.
  wellNames <- extractWellNames(filenames)
  names(filenames) <- wellNames

  # Read the files.
  tryCatch({
    wellData <- lapply(filenames, utils::read.csv)

    # Remove any empty files.
    nonemptyWells <- (vapply(wellData, nrow, numeric(1)) != 0)
    names(nonemptyWells) <- NULL
    wellData <- wellData[nonemptyWells]
    wellNames <- wellNames[nonemptyWells]
  },
  error=function(e) {
    stop("Error in read.csv: Perhaps the header row has a differing number ",
         "of columns to\nthe rest of the file? ",
         "(Check rows for trailing commas.)")
  })

  if(wellCol) {
    wellData <- lapply(seq_along(wellData),
                       function(i) {
                         if(nrow(wellData[[i]]) > 0) {
                           data.frame(wellData[[i]], "Well"=wellNames[[i]])
                         } else {
                           wellData[[i]]
                         }
                       })
  }
  names(wellData) <- wellNames

  # How to sort the wells?
  if(sortByLetter) {
    wellData[order(names(wellData))]
  } else {
    wellData[order(substr(names(wellData), start=2, stop=3),
                   substr(names(wellData), start=1, stop=1))]
  }
}

context("k-NN classification")

testDir <- system.file("testdata", package = "twoddpcr")

# Create some training data.
trAm <- readCSVDataFrame(file.path(testDir, "sample_A05_Amplitude.csv"))[[1]]
trAm <- trAm[, c("Ch1.Amplitude", "Ch2.Amplitude")]
trCl <- gridClassify(trAm,
                     ch1NNThreshold=6500, ch2NNThreshold=1900,
                     ch1NPThreshold=6500, ch2NPThreshold=5000,
                     ch1PNThreshold=9000, ch2PNThreshold=2500,
                     ch1PPThreshold=7500, ch2PPThreshold=5000,
                     fullTable=FALSE)

test_that("k-NN still works when the test set has fewer clusters", {
  set.seed(42)
  testWell <- ddpcrWell(file.path(testDir, "sample_A04_Amplitude.csv"))
  testWell <- knnClassify(testWell, trAm, trCl, k=1)
  knc <- wellClassification(testWell, "knn")
  expect_equal(length(unique(knc)), 3)
})

test_that("k-NN works for a ddpcrPlate", {
  set.seed(42)
  testPlate <- ddpcrPlate(testDir)
  testPlate <- knnClassify(testPlate, trAm, trCl, k=1)
  knc <- unlist(plateClassification(testPlate, "knn"))
  expect_equal(length(unique(knc)), 4)
})

test_that("k-NN works for a ddpcrPlate", {
  set.seed(42)
  testPlate <- ddpcrPlate(testDir)
  testPlate <- knnClassify(testPlate, trAm, trCl, k=3)
  knc <- unlist(plateClassification(testPlate, "knn"))
  expect_equal(length(unique(knc)), 4)
})

context("Loading data to the classes")

testDir <- system.file("testdata", package = "twoddpcr")
testWell <- ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))


test_that("Well names are correctly loaded", {
  expect_equal(names(readCSVDataFrame(testDir)), c("B03", "A04", "A05", "B06"))
  expect_equal(names(readCSVDataFrame(testDir, sortByLetter=TRUE)),
               c("A04", "A05", "B03", "B06"))
  expect_s3_class(readCSVDataFrame(testDir)[["B03"]], "data.frame")
  expect_s3_class(readCSVDataFrame(testDir)[["A04"]], "data.frame")
  expect_s3_class(readCSVDataFrame(testDir)[["A05"]], "data.frame")
  expect_s3_class(readCSVDataFrame(testDir)[["B06"]], "data.frame")
})

test_that("The objects are S4 objects", {
  expect_s4_class(ddpcrWell(), class="ddpcrWell")
  expect_s4_class(
    ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv")),
    class="ddpcrWell"
  )
  expect_s4_class(ddpcrPlate(), class="ddpcrPlate")
  expect_s4_class(ddpcrPlate(testDir), class="ddpcrPlate")
})

test_that("Files that don't exist are handled", {
  expect_error(ddpcrWell("a-file-that-doesnt-exist.csv"))
  expect_error(ddpcrPlate("a-dir-that-doesnt-exist"))
})

#' Inline \code{textInputs}.
#'
#' By default, \code{\link[shiny]{textInput}} objects are added to the page
#' below each other. This function allows for inline \code{textInput} fields.
#'
#' @param inputId The identifier for the textInput object.
#' @param label The text label to display alongside.
#' @param value The default value of the textInput.
#' @param size The size (width) and maxlength.
#'
#' @return A \code{div} with the appropriate label and input field.
#'
#' @references Adapted from: http://stackoverflow.com/a/21132918/1262569

textInputRow <- function (inputId, label, value="", size=NULL) {
  div(style="display:inline-block",
        tags$label(label, `for` = inputId),
        tags$input(id = inputId, type="text", value=value,
                          class="input-small", size=size, maxlength=size)
  )
}

#' Inline \code{numericInputs}.
#'
#' By default, \code{\link[shiny]{numericInput}} objects are added to the page
#' below each other. This function allows for inline \code{numericInput}
#' fields.
#'
#' @param inputId The identifier for the numericInput object.
#' @param label The text label to display alongside.
#' @param value The default value of the numericInput.
#' @param size The size (width) and maxlength.
#'
#' @return A \code{div} with the appropriate label and input field.
#'
#' @references Adapted from: http://stackoverflow.com/a/21132918/1262569

numericInputRow <- function (inputId, label, value="", size=NULL) {
  div(style="display:inline-block",
        tags$label(label, `for` = inputId),
        tags$input(id = inputId, type="number", value=value,
                          class="input-small", size=size, maxlength=size)
  )
}

#' Shiny visualisation UI.
#'
#' A Shiny UI for interactive ddPCR droplet classification.
#'
#' @return A Shiny UI.
#'
#' @import shiny
#' @include shinyVisGlobal.R
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @export

shinyVisUI <- function() {
  tagList(
    tags$head(
      tags$style(
        HTML("
          .help-block ul, .help-block ol {
            padding-left: 1.2em;
          }
          .multicol {
            height: auto;
            -webkit-column-count: 4;
            -moz-column-count: 4;
            column-count: 4;
          }
          div.checkbox {
            margin-top: 0px;
          }
          .shiny-output-error-validation {
            color: #D8006B;
          }
          "
        )
      )
    ),
    navbarPage(title="twoddpcr", id="tdNavbarPage",
      tabPanel("Input",
        sidebarLayout(
          sidebarPanel(width=3,
            radioButtons("datasetType", "Dataset to Use", inline=TRUE,
              c("From File", "Sample KRAS")
            ),
            conditionalPanel("input.datasetType == 'From File'",
              fileInput("inFile", "Choose Amplitude CSV Files",
                accept=c("text/csv",
                         "text/comma-separated-values,text/plain",
                         ".csv"),
                multiple=TRUE
              )
            ),
            uiOutput("useThisDatasetPH"),
            div(style="margin-top: 2ex",
              strong("Help"),
              helpText(
                tags$ol(
                  tags$li(
                    "Upload your own dataset or use the supplied KRAS sample ",
                    "dataset."
                  ),
                  tags$li(
                    "Click the 'Use This Dataset' button to load it."
                  )
                ),
                "Note that empty wells will be ignored."
              )
            ),
            radioButtons("sortWellsBy", "Sort Wells By:",
              c("Numbers First", "Letters First")
            )
          ), # sidebarPanel
          mainPanel(width=8,
            div(
              h4("About"),
              p(
                "A Shiny web application for ddPCR analysis. It is part of
                the ",
                a(
                  href="https://bioconductor.org/packages/twoddpcr/",
                  "twoddpcr", target="_blank"
                ),
                "Bioconductor package. If you use this package, please ",
                a(
                  href="https://bioconductor.org/packages/release/bioc/vignettes/twoddpcr/inst/doc/twoddpcr.html#citing-twoddpcr",
                  "cite it.", target="_blank"
                )
              ),
              h4("General Usage"),
              helpText(
                "Work your way along the tabs. For more detailed help, see ",
                "the 'Help' section in each tab's side panel."
              )
            ),
            div(style="padding-bottom: 2ex",
              h4("Labels"),
              "Set the labels for the channels. These will be printed on ",
              "the plots and the summary tables generated."
            ),
            div(
              textInputRow("ch1Label", "Ch1 Label", "Mt Amplitude"),
              textInputRow("ch1Abbrev", "Abbreviation", "Mt", size=4)
            ),
            div(style="padding-bottom: 2ex",
              textInputRow("ch2Label", "Ch2 Label", "Wt Amplitude"),
              textInputRow("ch2Abbrev", "Abbreviation", "Wt", size=4)
            ),
            uiOutput("setChLabelsPH")
          )
        ) # sidebarLayout
      ), # tabPanel "input"
      tabPanel("Select Wells",
        sidebarLayout(
          sidebarPanel(width=3,
            conditionalPanel("output.datasetSelectionSuccess",
              textInput("plateName", "Plate name", ""),
              radioButtons("viewMode", "Samples to Use",
                c("All", "Manual Selection"), inline=TRUE
              ),
              conditionalPanel("input.viewMode == 'Manual Selection'",
                strong("Wells"),
                uiOutput("wellSelectionPH")
              ),
              actionButton("useTheseWells", "Use These Wells"),
              div(style="margin-top: 2ex",
                strong("Help"),
                helpText(
                  tags$ol(
                    tags$li(
                      "Choose the wells that you wish to classify."
                    ),
                    tags$li(
                      "Click the 'Use These Wells' button to confirm the ",
                      "choice."
                    )
                  ),
                  "Use the 'Plate View' options to show/hide empty wells."
                )
              ),
              radioButtons("plateViewMode", "Plate View",
                c("Show All Wells", "Hide Empty Wells")
              )
            )
          ), # sidebarPanel
          mainPanel(width=8,
            h4("Wells in Plate"),
            p("This shows an overview of the plate. Each of the smaller boxes
              represents a well in the plate. Droplet amplitudes are plotted
              for wells that were used."),
            plotOutput("plotFacetGrid", height="650")
          ) # mainPanel
        ) #sidebarLayout
      ), #tabPanel "Select Wells"
      tabPanel("Classify",
        sidebarLayout(
          sidebarPanel(width=3,
            conditionalPanel("output.wellSelectionSuccess",
              selectInput("classifyMode", "Classification Mode",
                shinyVis$classifyModes
              ),
              checkboxInput("normalise", "Normalise data", FALSE),
              uiOutput("normaliseCheck"),
              conditionalPanel("input.classifyMode == 'Thresholds'",
                div(class="row-fluid",
                  div(class="span3",
                    numericInput("ch1Threshold", "Ch1 Threshold",
                      shinyVis$threshDefault$ch1,
                      min=shinyVis$threshLimits$ch1$min,
                      max=shinyVis$threshLimits$ch1$max, step=1
                    )
                  ),
                  div(class="span3",
                    numericInput("ch2Threshold", "Ch2 Threshold",
                      shinyVis$threshDefault$ch2,
                      min=shinyVis$threshLimits$ch2$min,
                      max=shinyVis$threshLimits$ch2$max, step=1
                    )
                  )
                )
              ),
              conditionalPanel(
                "input.classifyMode == 'K-Nearest Neighbour'",
                numericInput("knnK", "k (# of nearest neighbours)", 1),
                checkboxInput("knnProb", "Use k-NN Confidence", FALSE),
                conditionalPanel("input.knnProb",
                  sliderInput("knnConf", "Confidence Level",
                    0.0, 1.0, 0.7
                  )
                )
              ),
              conditionalPanel(
                "input.classifyMode == 'K-means Clustering' ||
                 input.classifyMode == 'Grid'",
               uiOutput("selectedClassPH")
              ),
              conditionalPanel(
                "input.classifyMode == 'K-means Clustering'",
                checkboxInput("removeThisClass", "Remove This Class",
                  FALSE
                ),
                tags$strong("Initial Centres"),
                verbatimTextOutput("centresOutput")
              ),
              conditionalPanel(
                "input.classifyMode == 'Grid'",
                strong("Grid Thresholds"),
                verbatimTextOutput("gridThesholdsOutput")
              ),
              actionButton("classify", "Run Classification"),
              div(style="margin-top: 2ex",
                strong("Help"),
                helpText(
                  "Choose a 'Classification Mode'. ",
                  tags$ul(
                    tags$li("'K-means Clustering' works well in most cases."),
                    tags$li("'Thresholds' works well if the clusters ",
                                   "are well-separated.")
                  ),
                  "See the",
                  a(href="https://bioconductor.org/packages/release/bioc/vignettes/twoddpcr/inst/doc/twoddpcr.html#analysis-of-the-data",
                    "Bioconductor vignette", target="_blank"
                  ),
                  "for a discussion comparing these two approaches.",
                  p(
                    "Use 'Normalise data' to minimise variations between
                    clusters in different wells."
                  )
                )
              ),
              conditionalPanel(
                "input.classifyMode == 'K-means Clustering'",
                div(
                  strong("K-means Clustering Help"),
                  helpText(
                    "K-means clustering requires well-selected cluster ",
                    "centres.",
                    br(),
                    tags$ol(
                      tags$li("Choose a class from 'Selected Class'."),
                      tags$li("Click on the plot to set a new centre.")
                    ),
                    p("Use the 'Remove This Class' checkbox if there is no
                    cluster."),
                    p(
                      "Note that badly chosen centres could lead to error
                      messages. In this case, try setting centres close to the
                      centres of clusters and remove classes if they are not
                      present."
                    )
                  )
                )
              ),
              conditionalPanel("input.classifyMode == 'Thresholds'",
                div(
                  strong("Thresholds Help"),
                  helpText(
                    tags$ul(
                      tags$li("Divide the plot into four quadrants."),
                      tags$li("Click on the plot to set new thresholds.")
                    )
                  )
                )
              ),
              conditionalPanel("input.classifyMode == 'Grid'",
                div(
                  strong("Grid Help"),
                  helpText(
                    "Divide the plot into four regions ",
                    "(droplets not in the regions are treated as rain).",
                    tags$ol(
                      tags$li("Select a class."),
                      tags$li(
                        "Click on the plot to set new thresholds for this ",
                        "class."
                      )
                    )
                  )
                )
              ),
              conditionalPanel(
                "input.classifyMode == 'K-Nearest Neighbour'",
                div(
                  strong("K-Nearest Neighbour Help"),
                  helpText(
                    tags$ul(
                      tags$li("Use training data."),
                      tags$li(
                        "The k-nearest neighbours in the training data are ",
                        "used to decide on the class of each droplet."
                      ),
                      tags$li(
                        "'Use k-NN Confidence' for setting the fraction of ",
                        "votes required for classification."
                      )
                    )
                  )
                )
              ),
              sliderInput("heatWidth", "Bin Width", 50, 500, 100)
            )
          ), # sidebarPanel
          mainPanel(width=8,
            h4("Droplets in Selected Wells"),
            p("A density plot of the selected wells."),
            plotOutput("plotSelectedWells", height="650",
                              click="plot_click")
          ) # mainPanel
        ) #sidebarLayout
      ), #tabPanel "Classify"
      tabPanel("Results",
        sidebarLayout(
          sidebarPanel(width=3,
            conditionalPanel("output.datasetSelectionSuccess",
              selectInput("clToShow", "Classification To Show",
                c("None")
              ),
              radioButtons("resultsViewMode", "Sample to View",
                c("All", "Manual Selection"), inline=TRUE
              ),
              conditionalPanel(
                "input.resultsViewMode == 'Manual Selection'",
                div(style="padding-bottom: 2ex",
                  strong("Wells"),
                  uiOutput("resultsWellsPH"),
                  actionButton("showResultsWells", "Show Wells")
                )
              ),
              conditionalPanel("output.thresholdsSet",
                checkboxInput("showThresholds", "Show Thresholds", FALSE)
              ),
              checkboxInput("finalCentres", "Show Final Centres", FALSE),
              radioButtons("rainType", "Rain Type",
                c("No Rain", "Mahalanobis", "Standard Deviation")
              ),
              conditionalPanel("input.rainType == 'Mahalanobis'",
                uiOutput("mvnRainNNPH"), uiOutput("mvnRainNPPH"),
                uiOutput("mvnRainPNPH"), uiOutput("mvnRainPPPH")
              ),
              conditionalPanel("input.rainType == 'Standard Deviation'",
                uiOutput("sdRainNNPH"), uiOutput("sdRainNPPH"),
                uiOutput("sdRainPNPH"), uiOutput("sdRainPPPH")
              ),
              conditionalPanel("input.rainType != 'No Rain'",
                div(style="padding-bottom: 2ex",
                  actionButton("makeItRain", "Make it Rain")
                )
              ),
              div(
                strong("Help"),
                helpText(
                  tags$ul(
                    tags$li(
                      "The 'Export Amplitudes to File' button creates a zip ",
                      "file containing CSV droplet amplitude files."
                    ),
                    tags$li(
                      "Note: the exported amplitudes are classifed as 'NN',
                      'NP', 'PN' and 'PP' (N=Negative, P=Positive). Using the
                      default labels, these are abbreviations for 'Mt-Wt-',
                      'Mt-Wt'+, 'Mt+Wt-' and 'Mt+Wt+', respectively."
                    ),
                    tags$li(
                      "The 'Set as Training Data' button creates training ",
                      "data to be used with the K-NN algorithm."
                    )
                  )
                )
              ),
              div(
                strong("Rain Help"),
                helpText(
                  tags$ul(
                    tags$li(
                      "Droplets can fall between clusters and therefore have
                      classifications that can be subjective. Defining these
                      droplets as 'rain' helps to remove ambiguity."
                    ),
                    tags$li(
                      "Recommended: 'Mahalanobis' takes cluster rotations into
                      account."
                    ),
                    tags$li(
                      "'Standard Deviation' gives linear cut-offs."
                    )
                  )
                )
              )
            )
          ), # sidebarPanel
          mainPanel(width=8,
            h4("Classification"),
            p("The outcome of the chosen classification method."),
            plotOutput("plotClassification", height="650"),
            uiOutput("exportAmplitudesPH")
          ) # mainPanel
        ) #sidebarLayout
      ), #tabPanel "Results"
      tabPanel("Summary",
        sidebarLayout(
          sidebarPanel(width=3,
            conditionalPanel("output.uploadSuccess ||
                input.datasetType == 'Sample KRAS'",
              div(
                conditionalPanel("output.summarySet",
                  strong("File Options"),
                  div(style="padding-bottom: 2ex",
                    downloadButton("exportSummaryButton",
                      "Export Summary to File"
                    )
                  ),
                  div(style="padding-bottom: 2ex",
                    downloadButton("generateHtmlReport",
                      "Generate HTML Report"
                    )
                  )
                ),
                strong("Help"),
                helpText(
                  tags$ul(
                    tags$li(
                      "Positive/negative droplets counts are summarised here."
                    ),
                    tags$li(
                      "The summary can be exported to a CSV file or a report
                      generated using the buttons above."
                    ),
                    tags$li(
                      "'AcceptedDroplets' is the total number of droplets in
                      each well (if necessary, after subtracting rain)."
                    ),
                    tags$li(
                      "The 'Concentration' figures are estimates for the number
                      of starting molecules per uL."
                    ),
                    tags$li(
                      "The 'CopiesPer20uLWell' figures are estimates for the
                      number of starting molecules in a 20uL well."
                    ),
                    tags$li(
                      "'Ratio' is the ratio of channel 1 molecules to channel 2
                      molecules."
                    ),
                    tags$li(
                      "'FracAbun' is short for 'fractional abundance'. It
                      estimates how many starting channel 1 molecules there
                      were out of all molecules. The reported figure is a
                      percentage."
                    )
                  )
                )
              )
            )
          ), # sidebarPanel
          mainPanel(width=8,
            h4("Plate summary"),
            p("A summary of the number of droplets in each of the chosen wells.
              Poisson estimates of the starting numbers of molecules is also
              provided."),
            dataTableOutput("wellsSummary")
          ) # mainPanel
        ) #sidebarLayout
      ), #tabPanel "Summary"
      navbarMenu("Advanced",
        tabPanel("Options",
          sidebarLayout(
            sidebarPanel(width=3,
              strong("Help"),
              helpText(
                p(
                  "The options here are global variables used for calculations
                  and plotting."
                ),
                h5("Droplet Volume"),
                p("The volume of each droplet. Defaults to 0.85nl."),
                h5("Minimum Cluster Separation"),
                p(
                  "This figure is used for normalisation. Each well has
                  k-means clustering run on the NN/NP and NN/PN clusters
                  separately. If two cluster centres are less than the
                  'Minimum Separation' figure apart, then the clustering
                  result is rejected."
                ),
                h5("Plot limits"),
                p(
                  "The minimum and maximum values for Ch1 and Ch2 to plot.
                  This allows us to increase the size of the plot only, not
                  decrease it. If droplets lie outside the defined min/max
                  values, the plot area will be increased automatically."
                )
              )
            ), # sidebarPanel
            mainPanel(width=8,
              h4("Options"),
              div(
                numericInput("dropletVolume", "Droplet Volume (nl)", 0.85),
                uiOutput("setDropletVolumePH")
              ),
              div(
                numericInput(
                  "minSeparation", "Minimum Cluster Separation", 2000
                ),
                uiOutput("setMinSeparationPH")
              ),
              div(
                strong("Plot limits")
              ),
              div(
                numericInputRow("ch1min", "Ch1 min", 3000),
                numericInputRow("ch1max", "Ch1 max", 13500)
              ),
              div(style="padding-bottom: 2ex",
                numericInputRow("ch2min", "Ch2 min", 1000),
                numericInputRow("ch2max", "Ch2 max", 9000)
              ),
              uiOutput("setPlotLimitsPH")
            ) # mainPanel
          ) # sidebarLayout
        ), # tabPanel "Options"
        tabPanel("View Training",
          sidebarLayout(
            sidebarPanel(width=3,
              div(
                strong("Help"),
                helpText(
                  tags$ul(
                    tags$li(
                      "The current training data will be shown in the plot on
                      the right."
                    ),
                    tags$li(
                      "To create new training data, classify some data and in
                      the 'Results' tab click the 'Set as Training Data'
                      button."
                    )
                  )
                )
              )
            ), # sidebarPanel
            mainPanel(width=8,
              h4("Current training data"),
              p("If set, the current training data will be shown below. This
                will be used as training data for the k-nearest neighbour
                alogrithm."),
              plotOutput("plotTraining", height="650")
            ) # mainPanel
          ) # sidebarLayout
        ) # tabPanel "View Training"
      ), # navbarMenu "More"
      tabPanel("Help",
        sidebarLayout(
          sidebarPanel(width=3,
            div(
              "Options appear here."
            ),
            div(
              strong("Help"),
              helpText("Help information for each panel appears here.")
            )
          ), # sidebarPanel
          mainPanel(width=8,
            h4("About"),
            p(
              "A Shiny web application for ddPCR analysis. It is part of
              the ",
              a(
                href="https://bioconductor.org/packages/twoddpcr/",
                "twoddpcr", target="_blank"
              ),
              "Bioconductor package. If you use this package, please ",
              a(
                href="https://bioconductor.org/packages/release/bioc/vignettes/twoddpcr/inst/doc/twoddpcr.html#citing-twoddpcr",
                "cite it.", target="_blank"
              )
            ),
            p(
              "The package and this Shiny app are maintained by Anthony
              Chiu. It was developed using ddPCR experiments performed by
              Mahmood Ayub. The project was managed by Caroline Dive,
              Ged Brady (",
              a(href="http://www.cruk.manchester.ac.uk/Research/CRUK-MI-Groups/CEP/Home",
                "Clinical and Experimental Pharmacology Group, Cancer
                Research UK Manchester Institute", target="_blank"),
              ") and Crispin J. Miller (",
              a(href="http://www.cruk.manchester.ac.uk/Research/CRUK-MI-Groups/RNA-Biology-Computational-Biology/Home",
                "RNA Biology Group, Cancer Research UK Manchester
                Institute", target="_blank"),
              ")."
            ),
            h4("General Usage"),
            p(
              "Work your way along the tabs from left-to-right. Help
              information is available in the side-panel on each tab.
              Each tab can be summarised as:"
            ),
            tags$ol(
              tags$li("Input: Select the dataset."),
              tags$li("Select Wells: Choose the wells to use"),
              tags$li("Classify: Gate the wells."),
              tags$li("Results: View the results."),
              tags$li("Summary: View/extract the computed figures.")
            ),
            h4("Input"),
            p("Select the dataset to use. This can be:"),
            tags$ul(
              tags$li(
                "Loaded from droplet amplitude CSV files. These can be
                exported from Bio-Rad's QuantaSoft software but must be two
                channel data; further instructions can be found in the ",
                a(
                  href="https://bioconductor.org/packages/release/bioc/vignettes/twoddpcr/inst/doc/twoddpcr.html#exporting-droplet-amplitudes-from-quantasoft-to-csv-files",
                  "twoddpcr package vignette.", target="_blank"
                ),
                "Note that empty wells will be ignored."
              ),
              tags$li(
                "The sample KRAS dataset can be used as a toy example."
              )
            ),
            p(
              "The labels for the two targets (in the two channels) can be
              customised."
            ),
            tags$ul(
              tags$li(
                "'Ch1/Ch2 Label' are used in the plots of the droplet
                amplitudes."
              ),
              tags$li(
                "The corresponding 'Abbreviation' field is used in the
                summary of computed figures. They are prefixed to various
                column names."
              )
            ),
            h4("Select Wells"),
            p(
              "This tab shows an overview of the wells that were loaded.
              From here, we select the samples/wells to be used:"
            ),
            tags$ul(
              tags$li("'All' uses all of the wells."),
              tags$li(
                "'Manual Selection' allows the selection of individual wells."
              )
            ),
            p(
              "We can choose to view the nonempty wells by changing the
              'Plate View' to 'Hide Empty Wells'."
            ),
            h4("Classify"),
            p(
              "This tab is used for the gating of the droplets. The 'K-means
              Clustering' and 'Thresholds' approaches are discussed in the ",
              a(href="https://bioconductor.org/packages/release/bioc/vignettes/twoddpcr/inst/doc/twoddpcr.html#analysis-of-the-data",
                "Bioconductor vignette.", target="_blank"
              ),
              "In general, 'K-means Clustering' should work without any
              modifications if the data forms four clear clusters; just click
              'Run Classification'."
            ),
            p(
              "If the clusters are well separated, 'Thresholds' should work
              too."
            ),
            h5("K-means Clustering"),
            p(
              "K-means clustering generally works well but it requires
              well-selected cluster centres. To do this:"
            ),
            tags$ol(
              tags$li("Choose a class from 'Selected Class'."),
              tags$li(
                "Click on the density plot to set a new centre for the
                selected class."
              )
            ),
            p(
              "Use the 'Remove This Class' checkbox if there is no cluster."
            ),
            p(
              "Note that badly chosen centres could lead to error messages. In
              this case, try setting centres close to the centres of clusters
              and remove classes if they are not present."
            ),
            h5("Thresholds"),
            p(
              "This works well if the clusters are well separated. This mode
              sets thresholds to divide the plot into four quadrants. To do
              this, either"
            ),
            tags$ul(
              tags$li("Click on the plot to set the new thresholds."),
              tags$li(
                "Manually change the 'Ch1 Threshold' and 'Ch2 Threshold'
                figures."
              )
            ),
            h5("Grid"),
            p(
              "This mode divides the plot into four regions, each
              corresponding to one of the four classes. Any droplets
              not included in these regions are treated as 'rain'. To
              change the regions:"
            ),
            tags$ol(
              tags$li("Choose a class from 'Selected Class'."),
              tags$li(
                "Click on the density plot to set a new region for the
                selected class."
              )
            ),
            h5("K-Nearest Neighbour"),
            p(
              "This method requires the use of training data. This method
              should only be used by experts. The full work-flow is as
              follows:"
            ),
            tags$ol(
              tags$li(
                "To set training data: classify some wells (e.g. one or two
                wells with little noise) and then 'Set as Training Data' in
                the 'Results' tab. The resulting training data can be viewed
                in 'Advanced > View Training'."
              ),
              tags$li(
                "The parameter 'k' can be adjusted, i.e. for each droplet,
                the k-NN algorithm finds the k-nearest training droplets and
                decides on the classification by majority vote."
              ),
              tags$li(
                "'Use k-NN Confidence' refines the majority required, i.e.
                if the proportion of the winning class does not exceed the
                'Confidence Level', then no classification is assigned."
              )
            ),
            h4("Results"),
            p(
              "This tab shows the resulting classification. Which wells to
              show can be changed under 'Sample to View'."
            ),
            p(
              "The ambiguous regions between clusters ('Rain') can be removed
              using two methods. The 'Mahalanobis' method is recommended with
              some manual tweaking of the parameters. It fits clusters to
              ellipses, while the 'Standard Deviation' method is restricted to
              linear cut-offs."
            ),
            tags$ul(
              tags$li(
                "Mahalanobis: This is based on Mahalanobis distance. It fits
                each cluster to a distribution and removes droplets too far
                from the cluster centre. This can be adjusted for each cluster
                with the sliders."
              ),
              tags$li(
                "Standard Deviation: This works calculated the mean and
                standard deviation of each cluster in both channels. These
                two figures are used to find linear cut-offs."
              )
            ),
            "The classification can be exported as a CSV file for later use.
            It can also be set as training data for the k-nearest neighbour
            classification method.",
            h4("Summary"),
            p(
              "This tab shows a summarised count of the numbers of droplets in
              each class and the resulting estimates of the concentration of
              mutants in each sample. It also reports the fractional abundance
              ('FracAbun') of the channel 1 target. In some use cases, this
              corresponds to the variant allele frequency."
            ),
            p(
              "This summary table can be exported as a CSV file, which can
              then be imported in a spreadsheet. The results and summary table
              can also be used to create an HTML report."
            )
          )
        ) # sidebarLayout
      ) # tabPanel "input"
    ) # navbarPage
  ) # tagList
}

#' Find the number of wells in the data frame.
#'
#' Auxiliary function to find the number of wells that appear in the data
#' frame, each with the same frequency (almost certainly once or twice). If
#' some wells appear more than others, the function stops because the data is
#' in an unknown format.
#'
#' Bio-Rad's QuantaSoft produces data in long form tables, i.e. for each well
#' there is a row for each target such as mutant and wild type. In this
#' package, we prefer to work with wide form tables that combine the mutant and
#' wild type parts.
#'
#' @param df A data frame of droplet counts with a \code{Well} column.
#'
#' @return An integer giving the number of wells.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.numberOfWells <- function(df) {
  if(nrow(df) == 0) {
    stop("Input data frame has zero rows.")
  }

  # Assume that the row names are the well names, and hence none are repeated.
  if(!"Well" %in% colnames(df)) {
    return(nrow(df))
  }

  # Check that each well appears the same number of times in df.
  wellOccurances <- unique(table(as.character(df$Well)))
  if(length(wellOccurances) == 1) {
    return(nrow(df) / wellOccurances[1])
  } else {
    stop("Some wells appear more than others in the data frame.")
  }
}


#' Extract the well names from a data frame.
#'
#' Get the well names from a data frame, checking if there is a \code{Well}
#' column or by using the row numbering.
#'
#' @param df A data frame.
#'
#' @return A factor of row names.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.getWellNames <- function(df) {
  if("Well" %in% colnames(df)) {
    return(df$Well)
  } else {
    return(rownames(df))
  }
}


#' Retain cluster counts and user-specified columns in data frames.
#'
#' Take a data frame of droplet counts and returns only the raw "PP", "PN",
#' "NP" and "NN" counts, plus any additional columns specified.
#'
#' @param df A data frame with droplet count columns in one of the following
#' formats:
#' \itemize{
#'   \item{\code{PP}, \code{PN}, \code{NP}, \code{NN}};
#'   \item{\code{Ch1.Ch2.}, \code{Ch1.Ch2..1}, \code{Ch1.Ch2..2},
#'   \code{Ch1.Ch2..3}};
#'   \item{\code{Ch1+Ch2+}, \code{Ch1+Ch2-}, \code{Ch1-Ch2+}, \code{Ch1-Ch2-}};
#'   or
#'   \item{\code{Ch1pCh2p}, \code{Ch1pCh2n}, \code{Ch1nCh2p}, \code{Ch1nCh2n}}.
#' }
#' @param rows A vector of rows (numbers or well names) to keep from the
#' original data frame. If set to \code{NULL}, all wells will be used. Defaults
#' to \code{NULL}.
#' @param rowID If set, this field is used as the row names. If \code{NULL},
#' the existing row names from \code{df} are used. Defaults to \code{NULL}.
#' @param keepCols A vector of columns to keep from \code{df}. If \code{NULL},
#' no extra columns are added. Defaults to \code{NULL}.
#' @param keepColNames A vector of new column names for \code{keepCols}. If
#' \code{NULL}, the column names from \code{keepCols} are reused. Defaults to
#' \code{NULL}.
#'
#' @return A data frame with the counts in the \code{PP}, \code{PN}, \code{PN}
#' and \code{PN} convention.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Take a data frame with row names given by the well names. Get a simple
#' ## count of droplets in each cluster.
#' parseClusterCounts(KRAScounts)
#'
#' ## Keep only the row numbers 3, 6 and 9.
#' parseClusterCounts(KRAScounts, rows=c(3, 6, 9))
#'
#' ## Keep only the rows labelled "F03", "A04", "D04".
#' parseClusterCounts(KRAScounts, rows=c("F03", "A04", "D04"))
#'
#' ## Take a data frame with a 'Well' column and do the same as above.
#' parseClusterCounts(KRAScountsWellCol, rowID="Well")
#'
#' ## Keep the 'InputAmount' column.
#' parseClusterCounts(KRAScounts, keepCols=c("InputAmount"))
#'
#' ## Keep the 'InputAmount' column and rename it.
#' parseClusterCounts(KRAScounts, keepCols=c("InputAmount"),
#'                    keepColNames=c("NanogramsIn"))
#'
#' @export

parseClusterCounts <- function(df, rows=NULL, rowID=NULL,
                               keepCols=NULL, keepColNames=NULL) {
  numWells <- .numberOfWells(df)

  # The number of rows to use is given by the number of unique wells.
  if(is.null(rows)) {
    rows <- seq_len(numWells)
  } else {
    # If characters, they will be unique.
    if(is.character(rows)) {
      # Find the indices of the matches.
      rows <- match(unique(rows), .getWellNames(df))
      if(any(is.na(rows))) {
        stop("Not all well names specified in 'rows' are present in 'df'.")
      }
    } else {
      # Numbered rows given: check that there are no repeats.
      if("Well" %in% colnames(df)) {
        selectedWellNames <- df[rows, "Well"]
      } else if(is.character(rownames(df))) {
        selectedWellNames <- rownames(df[rows, ])
      }

      rows <- match(unique(selectedWellNames), .getWellNames(df))
    }
  }

  # Set the rownames as the wells.
  if("Well" %in% colnames(df)) {
    rownames(df)[seq(numWells)] <- as.character(df$Well[seq(numWells)])
  }

  # Find the droplet counts in the different channels. We deal with a variety
  # of column name styles.
  if(all(c("Ch1.Ch2.", "Ch1.Ch2..1", "Ch1.Ch2..2", "Ch1.Ch2..3") %in%
         colnames(df))) {
    pp <- "Ch1.Ch2."
    pn <- "Ch1.Ch2..1"
    np <- "Ch1.Ch2..2"
    nn <- "Ch1.Ch2..3"
  } else if(all(c("Ch1+Ch2+", "Ch1+Ch2-", "Ch1-Ch2+", "Ch1-Ch2-") %in%
                colnames(df))) {
    pp <- "Ch1+Ch2+"
    pn <- "Ch1+Ch2-"
    np <- "Ch1-Ch2+"
    nn <- "Ch1-Ch2-"
  } else if(all(c("Ch1pCh2p", "Ch1pCh2n", "Ch1nCh2p", "Ch1nCh2n") %in%
                colnames(df))) {
    pp <- "Ch1pCh2p"
    pn <- "Ch1pCh2n"
    np <- "Ch1nCh2p"
    nn <- "Ch1nCh2n"
  } else if(all(c("PP", "PN", "NP", "NN") %in% colnames(df))) {
    pp <- "PP"
    pn <- "PN"
    np <- "NP"
    nn <- "NN"
  } else {
    stop("Droplet channel counts not found. See ?parseClusterCounts for ",
         "accepted\ncolumn name formats.")
  }

  # Some of the given rows are not in df.
  if(any(!rows %in% seq_len(nrow(df)))) {
    stop("Argument 'rows' contains indices not in 'df'.")
  }

  # Create data frame with basic columns.
  d <- data.frame("PP"=df[rows, pp], "PN"=df[rows, pn],
                  "NP"=df[rows, np], "NN"=df[rows, nn])

  # Add row names if needed.
  if(nrow(df) > 1) {
    if(is.null(rowID)) {
      rn <- rownames(df)[rows]
    } else {
      rn <- df[rows, rowID]
    }
    d <- data.frame(rn, d, row.names=1)
  }

  # Columns specified---retain these only.
  if(!is.null(keepCols)) {
    # Don't rename the columns to keep.
    if(is.null(keepColNames)) {
      keepColNames <- keepCols
    }

    d[, keepColNames] <- df[rows, keepCols]
  }

  d
}


#' Get a vector of essential dependent columns.
#'
#' Get a list of the essential columns in the ddPCR data that depend on the
#' target (e.g. mutant or wild type).
#'
#' @param prefix A string to prepend to each of the essential column names.
#' Defaults to \code{""} (the empty string).
#'
#' @return A vector of essential column names with an optional prefix.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.essentialDependentCols <- function(prefix="") {
  dc <- c("Positives",
          "Negatives",
          "Concentration",
          "CopiesPer20uLWell",
          "PoissonConfMax",
          "PoissonConfMin",
          "PoissonConfMax68",
          "PoissonConfMin68")
  paste0(prefix, dc)
}


#' Get a vector of all dependent columns.
#'
#' Get a list of the columns in the ddPCR data that depend on the target (e.g.
#' mutant or wild type). This includes columns that cannot be calculated from
#' the very basic droplet counts.
#'
#' @param prefix A string to prepend to each of the column names. Defaults to
#' \code{""} (the empty string).
#'
#' @return A vector of column names with an optional prefix.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.dependentCols <- function(prefix="") {
  dc <- c(.essentialDependentCols(),
          "Threshold",
          "MeanAmplitudeofPositives",
          "MeanAmplitudeofNegatives",
          "MeanAmplitudeTotal")
  paste0(prefix, dc)
}


#' Makes a long form data frame into wide form.
#'
#' Returns a data frame with the dependent columns prefixed with given labels
#' (depending on the targets). All relevant columns are retained.
#'
#' @param df A data frame created by calling \code{read.csv} on the raw ddPCR
#' output.
#' @param ch1Label The prefix to use for the channel 1 target. Defaults to
#' "Mt".
#' @param ch2Label The prefix to use for the channel 2 target. Defaults to
#' "Wt".
#' @param rows The number of rows to retain from the original data frame. If
#' \code{NULL}, all of the wells are used. Defaults to \code{NULL}.
#'
#' @return A data frame with the target rows merged.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Cast output from Bio-Rad's QuantaSoft into wide form.
#' castSummary(KRAScountsQS)
#'
#' ## Only retain selected rows.
#' castSummary(KRAScountsQS, rows=c(1,4:6))
#'
#' @export

castSummary <- function(df, ch1Label="Mt", ch2Label="Wt", rows=NULL) {
  # Stop if the labels are the same.
  if(ch1Label == ch2Label) {
    stop("The labels 'ch1Label' and 'ch2Label' should be different.")
  }

  # We only need to look at the top half for the ch1 data data.
  if(is.null(rows)) {
    rows <- seq_len(nrow(df)/2)
  }

  # Create a fresh data frame with the independent columns.
  d <- parseClusterCounts(
    df,
    rows,
    rowID="Well",
    keepCols=c(
      "AcceptedDroplets",
      "Ratio",
      "PoissonRatioMax",
      "PoissonRatioMin",
      "PoissonRatioMax68",
      "PoissonRatioMin68",
      "FractionalAbundance",
      "PoissonFractionalAbundanceMax",
      "PoissonFractionalAbundanceMin",
      "PoissonFractionalAbundanceMax68",
      "PoissonFractionalAbundanceMin68",
      "Linkage"
    ),
    keepColNames=c(
      "AcceptedDroplets",
      "Ratio",
      "PoisRatioMax",
      "PoisRatioMin",
      "PoisRatioMax68",
      "PoisRatioMin68",
      "FracAbun",
      "PoisFracAbunMax",
      "PoisFracAbunMin",
      "PoisFracAbunMax68",
      "PoisFracAbunMin68",
      "Linkage"
    )
  )
  # Prepend the labels to the dependent column names.
  d[, .dependentCols(ch1Label)] <- df[rows, .dependentCols()]
  d[, .dependentCols(ch2Label)] <- df[rows+(nrow(df)/2), .dependentCols()]

  d
}


#' Checks a data frame is a wide-form table.
#'
#' Our preferred data frame format is to have things in a wide-form data frame,
#' i.e. to have channel 1 and channel 2 data both in the same row.
#'
#' @param df A data frame.
#' @param ch1Label The prefix to use for the channel 1 target. Defaults to
#' "Mt".
#' @param ch2Label The prefix to use for the channel 2 target. Defaults to
#' "Wt".
#'
#' @return \code{TRUE} if \code{df} is considered to be of the correct format
#' and \code{FALSE} otherwise.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}


.isWideForm <- function(df, ch1Label="Mt", ch2Label="Wt") {
  any(c(.essentialDependentCols(ch1Label),
        .essentialDependentCols(ch2Label)) %in% colnames(df))
}


#' Take a data frame and compute the abundance of molecules.
#'
#' Returns a data frame with basic counts, the concentration of each kind of
#' target molecule, the ratio ch1:ch2 molecules, and the fractional abundance
#' of ch1 molecules in the overall count.
#'
#' @param df A data frame with droplet count columns in one of the following
#' formats:
#' \itemize{
#'   \item{\code{PP}, \code{PN}, \code{NP}, \code{NN}};
#'   \item{\code{Ch1.Ch2.}, \code{Ch1.Ch2..1}, \code{Ch1.Ch2..2},
#'   \code{Ch1.Ch2..3}};
#'   \item{\code{Ch1+Ch2+}, \code{Ch1+Ch2-}, \code{Ch1-Ch2+}, \code{Ch1-Ch2-}};
#'   or
#'   \item{\code{Ch1pCh2p}, \code{Ch1pCh2n}, \code{Ch1nCh2p}, \code{Ch1nCh2n}}.
#' }
#' @param ch1Label The prefix to use for the channel 1 target. Defaults to
#' "Mt".
#' @param ch2Label The prefix to use for the channel 2 target. Defaults to
#' "Wt".
#' @param rows A vector of rows (numbers or well names) to keep from the
#' original data frame. If set to \code{NULL}, all wells will be used. Defaults
#' to \code{NULL}.
#' @param rowID If set, this field is used as the row names. If \code{NULL},
#' the existing row names from \code{df} are used. Defaults to \code{NULL}.
#' @param keepCols A vector of columns to keep from \code{df}. If \code{NULL},
#' no extra columns are added. Defaults to \code{NULL}.
#' @param keepColNames A vector of new column names for \code{keepCols}. If
#' \code{NULL}, the column names from \code{keepCols} are reused. Defaults to
#' \code{NULL}.
#'
#' @return A data frame with
#' \itemize{
#'   \item \code{rowID} as the row names (if given);
#'   \item the droplet counts per channel;
#'   \item the number of ch1 and ch2 positive and negative readings;
#'   \item the ch1 and ch2 concentration, copies per 20ul, and total copies per
#'   20ul;
#'   \item the ratio of ch1 to ch2 molecules; and
#'   \item the fractional abundance of ch1 molecules in the overall molecule
#'   count (as a percentage).
#' }
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Take a data frame with row names given by the well names. Get estimates
#' ## for the numbers of molecules in each sample..
#' fullCountsSummary(KRAScounts)
#'
#' ## Keep only the row numbers 3, 6 and 9.
#' fullCountsSummary(KRAScounts, rows=c(3, 6, 9))
#'
#' ## Keep only the rows labelled "F03", "A04", "D04".
#' fullCountsSummary(KRAScounts, rows=c("F03", "A04", "D04"))
#'
#' ## Take a data frame with a 'Well' column and do the same as above.
#' fullCountsSummary(KRAScountsWellCol, rowID="Well")
#'
#' ## Keep the 'InputAmount' column.
#' fullCountsSummary(KRAScounts, keepCols=c("InputAmount"))
#'
#' ## Keep the 'InputAmount' column and rename it.
#' fullCountsSummary(KRAScounts, keepCols=c("InputAmount"),
#'                   keepColNames=c("NanogramsIn"))
#' @export

fullCountsSummary <- function(df, ch1Label="Mt", ch2Label="Wt",
                              rows=NULL, rowID=NULL, keepCols=NULL,
                              keepColNames=NULL) {
  # Basic numbers.
  d <- parseClusterCounts(df, rows, rowID, keepCols, keepColNames)
  d$AcceptedDroplets <- d$PP + d$PN + d$NP + d$NN
  d[, paste0(ch1Label, "Positives")] <- d$PP + d$PN
  d[, paste0(ch1Label, "Negatives")] <- d$NP + d$NN
  d[, paste0(ch2Label, "Positives")] <- d$PP + d$NP
  d[, paste0(ch2Label, "Negatives")] <- d$PN + d$NN

  # Concentration.
  d[, paste0(ch1Label, "Concentration")] <-
    -log(1 - d[, paste0(ch1Label, "Positives")] / d$AcceptedDroplets) /
      ddpcr$dropletVolume
  d[, paste0(ch2Label, "Concentration")] <-
    -log(1 - d[, paste0(ch2Label, "Positives")] / d$AcceptedDroplets) /
      ddpcr$dropletVolume
  d[, paste0(ch1Label, "CopiesPer20uLWell")] <-
    20 * d[, paste0(ch1Label, "Concentration")]
  d[, paste0(ch2Label, "CopiesPer20uLWell")] <-
    20 * d[, paste0(ch2Label, "Concentration")]
  d$TotalCopiesPer20uLWell <-
    d[, paste0(ch1Label, "CopiesPer20uLWell")] +
    d[, paste0(ch2Label, "CopiesPer20uLWell")]

  # Ratio.
  d$Ratio <- log(1 - d[, paste0(ch1Label, "Positives")] / d$AcceptedDroplets) /
    log(1 - d[, paste0(ch2Label, "Positives")] / d$AcceptedDroplets)

  # Fractional abundance.
  d$FracAbun <-
    100 * log(1 - d[, paste0(ch1Label, "Positives")] / d$AcceptedDroplets) /
    (log(1 - d[, paste0(ch1Label, "Positives")] / d$AcceptedDroplets) +
     log(1 - d[, paste0(ch2Label, "Positives")] / d$AcceptedDroplets))

  d
}

#' @include global.R
#' @include themes.R
#' @import methods
#' @import stats
NULL

#' Mahalanobis distance of droplets from a distribution.
#'
#' Find the Mahalanobis distance of all droplets from a given distribution.
#'
#' @param droplets A data frame of droplets with \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude} columns.
#' @param clusStats A list of statistics for a cluster generated by
#' \code{\link{classStats}}. This should have a \code{mean}, \code{cov} and
#' \code{cov.inv} values.
#'
#' @return A vector of numbers, where each one corresponds to the distance of
#' that droplet from the given distribution.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.mahDist <- function(droplets, clusStats) {
  if(is.null(clusStats$cov.inv)) {
    return(0)
  } else {
    n <- seq_along(nrow(droplets))
    x <- split(droplets[, c("Ch1.Amplitude", "Ch2.Amplitude")], n)
    mapply(mahalanobis, x,
           MoreArgs=list(center=clusStats$mean, cov=clusStats$cov.inv,
                         inverted=TRUE))
  }
}

#' Fuzzy clusters by bivariate normal distributions.
#'
#' Assume that the class \code{cl} is bivariate normally distributed. This
#' method adds fuzziness to the class. Other classes are not changed.
#'
#' @param droplets A data frame of droplets with \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude} columns, as well as a class column (see the parameter
#' \code{classCol}).
#' @param cl The class to focus on. This should be either "NN", "NP", "PN" or
#' "PP".
#' @param maxDistance An integer corresponding to the maximum Mahalanobis
#' distance for which we will consider points to be members of the class, i.e.
#' this is the level outside of which we consider droplets to be too far from
#' the cluster.
#' @param classCol The column (name or number) from \code{droplets}
#' representing the class.
#'
#' @return A factor corresponding to the class column with \code{Rain} entries
#' added for the class \code{cl}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.classwiseMahalanobisRain <- function(droplets, cl, maxDistance=30,
                                      classCol="class") {
  clusStats <- classStats(droplets, classCol=classCol)[[cl]]

  # Retain the droplets within the chosen maxDistance of the mean of its class.
  droplets[droplets[, classCol] == cl, classCol] <-
    ifelse(
      .mahDist(droplets[droplets[, classCol] == cl, ],
               clusStats=clusStats) <= maxDistance,
      as.character(droplets[droplets[, classCol] == cl, classCol]),
      ddpcr$rain
    )

  factor(droplets[, classCol], levels=ddpcr$classesRain)
}


#' Define 'rain' (unclassified) droplets by fitting the clusters to
#' bivariate normal distributions.
#'
#' Assume that each of the classified clusters are bivariate normally
#' distributed. We add fuzziness to the classifications by assigning droplets
#' far away from the centres as "Rain". We use the Mahalanobis distance for
#' each cluster to determine whether a droplet is 'too far away'.
#'
#' @param droplets A \code{ddpcrWell} or \code{ddpcrPlate} object, or
#' a data frame of droplets with "Ch1.Amplitude" and "Ch2.Amplitude" columns,
#' as well as a class column.
#' @param cMethod The name or column number of the classification for which we
#' want to add rain to.
#' @param maxDistances A list of (levels) with keys in \code{c("NN", "PN",
#' "NP", "PP")}. If the list is empty or set as \code{NULL}, no rain is added.
#' If set as a single integer \code{n}, this value is taken for all classes,
#' i.e. \code{list("NN"=n, "PN"=n, "NP"=n, "PP"=n)}.
#' @param ... Other options depending on the type of \code{droplets}.
#'
#' @return An object where the specified class has "Rain" entries added.
#'
#' @name mahalanobisRain
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @aliases multivariateRain multivariateNormalRain mvNormalRain mvnRain
#'
#' @examples
#' ## Take a data frame of droplets of transform it into the rigth format.
#' droplets <- KRASdata[["E03"]]
#' droplets$Cluster <- relabelClasses(droplets, classCol="Cluster")
#'
#' ## Add rain as a new column.
#' droplets$ClusterMahRain <-
#'     mahalanobisRain(droplets, cMethod="Cluster", fullTable=FALSE)
#' table(droplets$ClusterMahRain)
#'
#' ## The maximum distance around each mean can be changed uniformly.
#' droplets$ClusterMahRain <-
#'     mahalanobisRain(droplets, cMethod="Cluster", maxDistances=35,
#'                     fullTable=FALSE)
#' table(droplets$ClusterMahRain)
#'
#' ## Or we can change the maximum distances for each individual cluster.
#' droplets$ClusterMahRain <-
#'     mahalanobisRain(droplets, cMethod="Cluster",
#'                     maxDistances=list(NN=35, NP=30, PN=30, PP=30),
#'                     fullTable=FALSE)
#' table(droplets$ClusterMahRain)
#'
#' # This method works the same for ddpcrWell objects.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' aWell <- mahalanobisRain(aWell, cMethod="Cluster")
#' table(wellClassification(aWell, cMethod="ClusterMahRain"))
#'
#' # Likewise for ddpcrPlate objects.
#' krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
#' krasPlate <- mahalanobisRain(krasPlate, cMethod="Cluster")
#' lapply(plateClassification(krasPlate, cMethod="ClusterMahRain"), table)
#'
#' @export

setGeneric(
  "mahalanobisRain", function(droplets, cMethod, maxDistances=30,...) {
    standardGeneric("mahalanobisRain")
})


#' @rdname mahalanobisRain
#'
#' @param fullTable If \code{TRUE}, returns a full data frame of droplets and
#' their classification; if \code{FALSE}, simply returns a factor corresponding
#' to this classification. Defaults to \code{TRUE}.
#'
#' @exportMethod mahalanobisRain

setMethod("mahalanobisRain", "data.frame",
  function(droplets, cMethod, maxDistances=30, fullTable=TRUE) {
    # maxDistances is just a number---assume that all of the classes
    # have the same maximum distances
    if(is.numeric(maxDistances) && length(maxDistances) == 1) {
      n <- length(ddpcr$classes)
      maxDistances <- setNames(rep(maxDistances, n), ddpcr$classes)
    } else if(is.null(maxDistances)) {
      # Assume that an empty vector means no rain.
      maxDistances <- list()
    } else if(!is.list(maxDistances)) {
      # Not a list and none of the conditions above---do not know how to
      # handle.
      stop("'maxDistances' should be a named list with names in c(",
           ddpcr$nn, ", ", ddpcr$np, ", ", ddpcr$pn, ", ",
           ddpcr$pp, ")")
    }

    # Loop through the maxDistances and check where droplets lie.
    for(className in names(maxDistances)) {
      droplets[, cMethod] <-
        .classwiseMahalanobisRain(droplets, className,
                                  maxDistances[[className]],
                                  classCol=cMethod)

    }

    if(fullTable) {
      droplets[, c("Ch1.Amplitude", "Ch2.Amplitude", cMethod)]
    } else {
      droplets[, cMethod]
    }
  }
)


#' @rdname mahalanobisRain
#'
#' @exportMethod mahalanobisRain

setMethod("mahalanobisRain", "ddpcrWell",
  function(droplets, cMethod, maxDistances=30) {
    cl <- wellClassification(droplets, cMethod=cMethod, withAmplitudes=TRUE)
    cl <- mahalanobisRain(cl, cMethod=cMethod, maxDistances=maxDistances,
                          fullTable=FALSE)
    wellClassification(droplets, paste0(cMethod, "MahRain")) <- cl
    droplets
  }
)


#' @rdname mahalanobisRain
#'
#' @exportMethod mahalanobisRain

setMethod("mahalanobisRain", "ddpcrPlate",
  function(droplets, cMethod, maxDistances=30) {
    cl <- plateClassification(droplets, cMethod=cMethod, withAmplitudes=TRUE)
    cl <- do.call(rbind, cl)
    rainy <- mahalanobisRain(cl, cMethod=cMethod, maxDistances=maxDistances,
                             fullTable=FALSE)
    plateClassification(droplets, paste0(cMethod, "MahRain")) <- rainy
    droplets
  }
)

#' Shiny app.
#'
#' A shiny app for interactive ddPCR droplet classification.
#'
#' @return A Shiny application
#'
#' @import shiny
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @export

shinyVisApp <- function() {
  shiny::shinyApp(
    ui=shinyVisUI(),
    server=function(input, output, session) {
      shinyVisServer(input, output, session)
    }
  )
}

#' @include global.R
#' @import methods
#' @import utils
NULL

#' An S4 class for the classification of a single well in a ddPCR
#' experiment.
#'
#' @slot dropletAmplitudes A data frame with columns \code{Ch1.Amplitude}
#' and \code{Ch2.Amplitude} corresponding to all the droplets in the ddPCR
#' well.
#' @slot classification A vector of factors, where the levels are given by
#' \code{ddpcr$classesRain}.
#'
#' @name ddpcrWell-class
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @export ddpcrWell
#' @exportClass ddpcrWell

.ddpcrWell <-
  setClass("ddpcrWell",
    slots=c(
      dropletAmplitudes="data.frame",
      classification="data.frame"
    ),
    prototype=list(
      dropletAmplitudes=data.frame("Ch1.Amplitude"=double(),
                                   "Ch2.Amplitude"=double()),
      classification=data.frame(factor(c(), levels=ddpcr$classesRain))
    ),
    validity=function(object) {
      if(!all(c("Ch1.Amplitude", "Ch2.Amplitude") %in%
              colnames(object@dropletAmplitudes))) {
        return(paste("The droplet amplitudes data frame does not have the ",
                     "correct column names."))
      }
      if(nrow(object@classification) > 0 &&
              nrow(object@dropletAmplitudes) != nrow(object@classification)) {
        return(paste("The number of droplets is not the same as the number ",
                     "of classifications."))
      }
      return(TRUE)
    }
  )


#' Extract a classification from a data frame.
#'
#' Check that non-Ch*Amplitude columns are in a known classification format and
#' coerce it to a factor.
#'
#' @param colName The name of the column to focus on.
#' @param well The data frame from which to extract the classifications.
#'
#' @return A factor with levels in \code{ddpcr$classesRain}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.getClassificationData <- function(colName, well) {
  if(!colName %in% c("Ch1.Amplitude", "Ch2.Amplitude")) {
    # "NN", "NP", "PN", "PP" format.
    if((is.factor(well[, colName])
        && all(levels(well[, colName]) %in% ddpcr$classesRain))
       || (is.character(well[, colName])
           && all(well[, colName] %in% ddpcr$classesRain))) {
      factor(well[, colName], levels=ddpcr$classesRain)
    } else if(all(unique(well[, colName]) %in% c(1, 2, 3, 4))) {
      # QuantaSoft format.
      factor(ifelse(well[, colName]==1, ddpcr$nn,
             ifelse(well[, colName]==2, ddpcr$pn,
             ifelse(well[, colName]==4, ddpcr$np,
                                        ddpcr$pp))),
             levels=ddpcr$classesRain)
    } else {
      warning("Ignoring column ", colName, " (unrecognised format).")
      data.frame(row.names=seq_len(nrow(well)))
    }
  } else {
    data.frame(row.names=seq_len(nrow(well)))
  }
}


#' The constructor for the \code{ddpcrWell} class.
#'
#' @param well A well with columns \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude} and optional classification columns. This can be in the
#' form of a data frame or the path to a droplet amplitude CSV file.
#'
#' @return A \code{ddpcrWell} object with the given droplets in the well.
#'
#' @rdname ddpcrWell-class
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## A \code{ddpcrWell} object can be created from data from a list of data
#' ## frames.
#' ddpcrWell(KRASdata[[1]])
#'
#' ## An CSV file of droplet amplitudes can also be loaded.
#' ampFile <- system.file("extdata/amplitudes/sample_B03_Amplitude.csv",
#'                        package="twoddpcr")
#' ddpcrWell(ampFile)
#'
#' @export

setGeneric("ddpcrWell", function(well) {
  standardGeneric("ddpcrWell")
})

#' @rdname ddpcrWell-class
#'
#' @export

setMethod("ddpcrWell", "data.frame", function(well) {
    # Make the data frame in the right format.
    well <- setChannelNames(well)

    # Try to make a ddpcrWell object the data frame.
    if(all(c("Ch1.Amplitude", "Ch2.Amplitude") %in% colnames(well))) {
      # The droplet amplitudes.
      amps <- well[, c("Ch1.Amplitude", "Ch2.Amplitude")]

      # If they exist, get the classification(s).
      # print(colnames(well))
      cl <- lapply(colnames(well), .getClassificationData, well)
      names(cl) <- colnames(well)
      cl <- as.data.frame(do.call(cbind, cl))

      # Add a default "None" column to droplet classifications (if needed).
      dc <- factor(rep(ddpcr$na, nrow(well)), levels=ddpcr$classesRain)
      if(!is.null(cl) && !"None" %in% colnames(cl)) {
        cl <- data.frame("None"=dc, cl)
      } else if(is.null(cl)) {
        cl <- data.frame("None"=dc)
      }

      # Set the classifications.
      .ddpcrWell(dropletAmplitudes=amps, classification=cl)
    } else {
      stop("The given 'well' is missing the 'Ch1.Amplitude' and ",
           "'Ch2.Amplitude' columns.")
    }
  }
)


#' @rdname ddpcrWell-class
#'
#' @export

setMethod("ddpcrWell", "character", function(well) {
  # Character string well: hopefully a filename.
  if(is.character(well)) {
    # Just look at the first one.
    well <- well[1]

    # File or directory path.
    if(file.exists(well)) {
      well <- readCSVDataFrame(well)[[1]]
      if(nrow(well) == 0)
        warning("No droplet amplitudes loaded. Was this intended?")
      ddpcrWell(well)
    } else {
      stop("The string 'well' is not a file.")
    }
  }
})


#' @rdname ddpcrWell-class
#'
#' @export

setMethod("ddpcrWell", "missing", function(well) {
  well <- data.frame("Ch1.Amplitude"=double(), "Ch2.Amplitude"=double())
  ddpcrWell(well)
})


#' @rdname ddpcrWell-class
#'
#' @export

setMethod("ddpcrWell", "ddpcrWell", function(well) {
  well
})


#' @title Retrieve droplet amplitudes.
#'
#' @description Retrieve the droplet amplitudes from an object.
#'
#' @param theObject A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
#' object.
#'
#' @return If \code{theObject} is a \code{\link{ddpcrWell}} object, return
#' a data frame of droplet amplitudes with columns "Ch1.Amplitude" and
#' "Ch2.Amplitude". If \code{theObject} is a \code{\link{ddpcrPlate}} object,
#' return a list of data frames.
#'
#' @seealso \code{\link{wellClassification}} for the classification of the
#' droplets.
#'
#' @name amplitudes
#'
#' @examples
#' ## Set a ddpcrWell object with no data.
#' aWell <- ddpcrWell(well=data.frame("Ch1.Amplitude"=double(),
#'                                    "Ch2.Amplitude"=double()))
#'
#' ## This can be checked to be empty.
#' amplitudes(aWell)
#'
#' ## Alternatively, load some data.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#'
#' ## We check again and see that it has been populated.
#' head(amplitudes(aWell))
#'
#' # Get all of the KRASdata droplet amplitudes.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' allDroplets <- amplitudes(krasPlate)
#' str(allDroplets)
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @export

setGeneric("amplitudes", function(theObject) {
  standardGeneric("amplitudes")
})

#' @rdname amplitudes
#'
#' @exportMethod amplitudes

setMethod("amplitudes", "ddpcrWell", function(theObject) {
  theObject@dropletAmplitudes
})


#' Retrieve a classification vector.
#'
#' Retrieve the classification from a \code{\link{ddpcrWell}} object.
#'
#' @param theObject A \code{\link{ddpcrWell}} object.
#' @param cMethod The names (or column numbers) of the classification to
#' retrieve. If \code{NULL}, then all of the classifications are obtained.
#' Defaults to \code{NULL} when retrieving. When setting a classification, this
#' cannot be \code{NULL}.
#' @param withAmplitudes Logical value. If \code{TRUE}, returns a data frame
#' with the droplet amplitudes and corresponding classifications. If
#' \code{FALSE}, returns the classification vector only. Defaults to
#' \code{FALSE}.
#' @param value A factor with the same length as the number of droplets in
#' \code{theObject}, with levels in \code{ddpcr$classesRain}.
#'
#' @return A factor or data frame corresponding to the requested
#' classification(s).
#'
#' @seealso \code{\link{wellClassificationMethod}} for the name of the
#' classification method.
#'
#' @examples
#' ## Take some droplets with a given classification.
#' amplitudes <- KRASdata[["E03"]][, c("Ch1.Amplitude", "Ch2.Amplitude")]
#'
#' ## Create a ddpcrWell object with the amplitudes only.
#' aWell <- ddpcrWell(well=amplitudes)
#'
#' ## This has no classification yet.
#' head(wellClassification(aWell))
#'
#' ## We check the classification now, showing the amplitudes as well.
#' head(wellClassification(aWell, withAmplitudes=TRUE))
#'
#' ## Now set a sample classification.
#' wellClassification(aWell, cMethod="Sample") <-
#'   rep(c("NN", "NP", "PN", "PP"), numDroplets(aWell) / 4)
#' head(wellClassification(aWell, withAmplitudes=TRUE))
#'
#' @name wellClassification
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @export

setGeneric("wellClassification",
  function(theObject, cMethod=NULL, withAmplitudes=FALSE) {
    standardGeneric("wellClassification")
  }
)

#' @rdname wellClassification
#'
#' @exportMethod wellClassification

setMethod("wellClassification", "ddpcrWell",
  function(theObject, cMethod=NULL, withAmplitudes=FALSE) {
    if (is.null(cMethod)) {
      cMethod <- colnames(theObject@classification)
    }

    if (withAmplitudes) {
      df <- cbind(theObject@dropletAmplitudes,
                             theObject@classification[, cMethod])
      clCols <- seq_len(ncol(df))[-c(1,2)]
      colnames(df)[clCols] <- cMethod
      return(df)
    } else {
      return(theObject@classification[, cMethod])
    }
  }
)


#' @rdname wellClassification
#'
#' @export

setGeneric("wellClassification<-", function(theObject, cMethod, value) {
    standardGeneric("wellClassification<-")
  }
)

#' @rdname wellClassification
#'
#' @export

setReplaceMethod("wellClassification", "ddpcrWell",
  function(theObject, cMethod, value) {
    if(length(value) != numDroplets(theObject))
      stop("The length of 'value' should be the same as the number ",
           "of droplets in the well.")
    theObject@classification[, cMethod] <-
      factor(value, levels=ddpcr$classesRain)
    validObject(theObject)
    return(theObject)
  }
)


#' Retrieve the classification method.
#'
#' Retrieve the names of the classification methods for
#' a \code{\link{ddpcrWell}} object.
#'
#' @param theObject A \code{\link{ddpcrWell}} object.
#' @param cMethod If modifying the classification methods, this should be
#' a vector of existing classification names or numbers.
#' @param value A character vector (of the same length as \code{cMethod})
#' giving a new names for the chosen classification methods.
#'
#' @return The classification method names.
#'
#' @seealso \code{\link{wellClassification}} for the classification of the
#' droplets.
#'
#' @examples
#' ## Create a ddpcrWell object with some data and classification.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#'
#' ## Retrieve the classification method names.
#' head(wellClassificationMethod(aWell))
#'
#' ## Set a classification method name to something new.
#' wellClassificationMethod(aWell, cMethod="Cluster") <- "QuantaSoft"
#'
#' ## We check the classification now, showing the amplitudes as well.
#' wellClassificationMethod(aWell)
#'
#' @name wellClassificationMethod
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @export

setGeneric("wellClassificationMethod", function(theObject) {
  standardGeneric("wellClassificationMethod")
})

#' @rdname wellClassificationMethod
#'
#' @exportMethod wellClassificationMethod

setMethod("wellClassificationMethod", "ddpcrWell", function(theObject) {
    colnames(theObject@classification)
})


#' @rdname wellClassificationMethod
#'
#' @export

setGeneric("wellClassificationMethod<-", function(theObject, cMethod, value) {
  standardGeneric("wellClassificationMethod<-")
})

#' @rdname wellClassificationMethod
#'
#' @export

setReplaceMethod(
  "wellClassificationMethod", "ddpcrWell",
  function(theObject, cMethod, value) {
    if(is.character(cMethod)) {
      if(!cMethod %in% names(theObject@classification))
        stop("The parameter 'cMethod' is not an existing ",
             "classification method name.")
      n <- which(names(theObject@classification) %in% cMethod)
    } else {
      n <- cMethod
    }

    names(theObject@classification)[n] <- value
    validObject(theObject)
    return(theObject)
  }
)


#' @rdname ddpcrWell-class
#'
#' @inheritParams methods::show

setMethod("show", "ddpcrWell", function(object) {
  cat("ddpcrWell object\n")
  cat("number of droplets: ", numDroplets(object), "\n", sep="")
  if(!isEmpty(object)) {
    cat("classification methods:", wellClassificationMethod(object), "\n")
  }
})

#' Shiny visualisation server.
#'
#' A Shiny server for interactive ddPCR droplet classification.
#'
#' @param input Shiny input list.
#' @param output Shiny output list.
#' @param session Shiny session.
#'
#' @return A Shiny server.
#'
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @include shinyVisGlobal.R
#' @import ggplot2
#' @import shiny
#' @export

shinyVisServer <- function(input, output, session) {
  # Error messages.
  messages <- reactiveValues(
    error="No ddPCR droplet amplitude data loaded.",
    uploadError=""
  )

  # Variables to store the base set of samples, the current selection, and
  # various parameters.
  wells <- reactiveValues(
    all=ddpcrPlate(),  # base set of samples
    selected=ddpcrPlate(),  # current selection
    manaulSelection=c(),  # wells chosen by manual selection
    plateName=""
  )

  # The classification result and its summary table.
  results <- reactiveValues(
    drops=ddpcrPlate(),
    selected=ddpcrPlate(),
    manualSelection=c(),  # wells chosen by manual selection
    baseMode="None",
    mode="None",
    summary=NULL  # summarised data frame of the wells
  )

  # Labels to use for plots etc.
  chLabels <- reactiveValues(
    ch1="Mt Amplitude", ch1Abbrev="Mt",
    ch2="Wt Amplitude", ch2Abbrev="Wt",
    errorMsg=""
  )

  # The internally used symbol for the selected class.
  selectedClass <- reactiveValues(
    value="NN"
  )

  # Labels using the user-specified prefixes.
  abbrevLabels <- function(decreasing=FALSE) {
    abbrevs <- c(chLabels$ch1Abbrev, chLabels$ch2Abbrev)
    labels <- c(paste0(abbrevs, "-", collapse=""),
                paste0(abbrevs, c("-", "+"), collapse=""),
                paste0(abbrevs, c("+", "-"), collapse=""),
                paste0(abbrevs, "+", collapse=""))
    if(decreasing) {
      labels <- rev(labels)
    }
    return(labels)
  }

  # Other global variables.
  globals <- reactiveValues(
    minSeparation=2000,
    plotLimits=list(x=c(1000, 9000), y=c(3000, 13500))
  )

  # Action button for setting the channel labels (as long as they are
  # reasonable).
  output$setChLabelsPH <- renderUI({
    validate(
      need(input$ch1Label != input$ch2Label &&
           input$ch1Abbrev != input$ch2Abbrev,
           "The labels for the channels should be different."),
      need(input$ch1Label != "" && input$ch2Label != "" &&
           input$ch1Abbrev != "" && input$ch2Abbrev != "",
           "The labels should not be empty.")
    )

    actionButton("setChLabels", "Set Labels")
  })


  observeEvent(input$setChLabels, {
    chLabels$ch1 <- input$ch1Label
    chLabels$ch1Abbrev <- input$ch1Abbrev
    chLabels$ch2 <- input$ch2Label
    chLabels$ch2Abbrev <- input$ch2Abbrev
    setSummary(results$mode, sortByLetter=sortByLetter())
  })

  # A map between the selectInput name and the internal name.
  classifyModeMap <- list("Thresholds"="thresholds",
                          "Grid"="grid",
                          "K-Nearest Neighbour"="knn",
                          "K-means Clustering"="kmeans")

  # Get an internal mode name from the long name.
  internalMode <- function(m) {
    if(is.null(m)) {
      return("None")
    } else if(m %in% names(classifyModeMap)) {
      return(classifyModeMap[[m]])
    } else {
      return(m)
    }
  }

  # Get the long name from the internal mode name.
  longMode <- function(m) {
    modeMatch <- (m == classifyModeMap)
    if(any(modeMatch)) {
      return(names(classifyModeMap)[which(modeMatch)])
    } else {
      return(m)
    }
  }

  # Set a mode variable.
  clMode <- reactive({
    switch(input$classifyMode,
           "Thresholds"="thresholds",
           "Grid"="grid",
           "K-Nearest Neighbour"="knn",
           "K-means Clustering"="kmeans")
  })

  # Training set used for k-NN algorithm.
  trainingData <- reactiveValues(
    drops=data.frame(
      "Ch1.Amplitude"=double(),
      "Ch2.Amplitude"=double(),
      class=factor(c(), levels=ddpcr$classesRain)
    )
  )

  # Set the wells$selected variable according to the wells selected in the app.
  setSelectedWells <- function() {
    if(is.null(wells$all)) {
      wells$selected <- ddpcrPlate()
    } else if(input$viewMode == "All") {
      wells$selected <- wells$all
    } else if(input$viewMode == "Manual Selection") {
      if(length(input$wellSelection) == 0) {
        sel <- list()
      } else {
        sel <- input$wellSelection
      }
      wells$selected <- ddpcrPlate(wells=wells$all[sel])
      wells$manualSelection <- input$wellSelection
    }

    # Normalise the wells if desired.
    if(input$normalise) {
      tryCatch({
        wells$selected <- renormalisePlate(wells$selected,
                                           initialCentres=startingCentres(),
                                           minSeparation=globals$minSeparation)
      },
      warning=function(e) {
        messages$error <- as.character(e) ######## protect
      },
      error=function(e) {
        messages$error <- as.character(e) ######## protect
      })
    } else {
      messages$error <- ""
    }
  }

  # Set the results$all variable according to the wells selected in the
  # app.
  setResultsWells <- function() {
    if(is.null(results$all)) {
      results$selected <- ddpcrPlate()
    } else if(input$resultsViewMode == "All") {
      results$selected <- results$all
    } else if(input$resultsViewMode == "Manual Selection") {
      if(length(input$resultsWells) == 0) {
        sel <- list()
      } else {
        sel <- input$resultsWells
      }
      results$selected <- ddpcrPlate(wells=results$all[sel])
      results$manualSelection <- input$resultsWells
    }
  }

  # Check that the given ddpcrPlate object has a rainy 'm' class with
  # a specified prefix.
  rainyModeExists <- function(drops, m, prefix) {
    if(!is.null(drops) && (length(drops) > 0)) {
      mWithRain <- paste0(m, prefix, "Rain")
      if(mWithRain %in% plateClassificationMethod(drops)) {
        return(TRUE)
      }
    }
    return(FALSE)
  }

  # Check that the given ddpcrPlate object has a multivariate rainy 'm' class.
  mvnRainyModeExists <- function(drops, m) {
    rainyModeExists(drops, m, "Mvn")
  }

  # Check that the given ddpcrPlate object has an SD rainy 'm' class.
  sdRainyModeExists <- function(drops, m) {
    rainyModeExists(drops, m, "Sd")
  }

  # Use the current grid thresholds to set training data.
  setTrainingDataFromGrid <- function() {
    td <- gridClassify(wells$selected,
      gridThresholds$NN$ch1, gridThresholds$NN$ch2,
      gridThresholds$NP$ch1, gridThresholds$NP$ch2,
      gridThresholds$PN$ch1, gridThresholds$PN$ch2,
      gridThresholds$PP$ch1, gridThresholds$PP$ch2,
      "class"
    )
    trainingData$drops <- do.call(rbind, removeDropletClasses(td, "class"))
  }

  # Show any existing classification methods.
  updateClassifications <- function(selected=NULL) {
    # Select the correct methods to show.
    if(!is.null(results$all) && !isEmpty(results$all)) {
      clMethods <- commonClassificationMethod(results$all)
    } else {
      clMethods <- c("None")
    }

    # Remove rainy classification methods from the list.
    clMethods <- clMethods[!grepl("Rain$", clMethods)]

    # Get the long form names for the classification methods.
    longClMethods <- vapply(clMethods, longMode, character(1))
    names(longClMethods) <- NULL

    # Do we change the selection?
    if(is.null(selected)) {
      updateSelectInput(session, "clToShow", choices=longClMethods)
    } else {
      updateSelectInput(session, "clToShow", choices=longClMethods,
                        selected=selected)
    }
  }

  # Check whether upload was successful.
  output$uploadSuccess <- reactive({
    return(messages$error == "" &&
           length(input$inFile$name) > 0 && length(wells$all) > 0)
  })
  outputOptions(output, "uploadSuccess", suspendWhenHidden=FALSE)

  # Check whether a dataset has been selected.
  output$datasetSelectionSuccess <- reactive({
    return(!is.null(wells$all) && !isEmpty(wells$all))
  })
  outputOptions(output, "datasetSelectionSuccess", suspendWhenHidden=FALSE)

  # Check whether some wells have been selected.
  output$wellSelectionSuccess <- reactive({
    return(!is.null(wells$selected) && !isEmpty(wells$selected))
  })
  outputOptions(output, "wellSelectionSuccess", suspendWhenHidden=FALSE)

  # Show the "Use This Dataset" action button only if droplet amplitude CSVs
  # have been uploaded.
  output$useThisDatasetPH <- renderUI({
    validate(
      need(input$datasetType == "Sample KRAS" ||
           (messages$uploadError == "" && length(input$inFile$name) > 0 &&
            length(wells$loadedAll) > 0), {
             if(messages$uploadError != "") {
               msg <- paste0("CSV file upload failed: ",
                             sub("\\s+$", "", messages$uploadError), " ")
             } else {
               msg <- ""
             }

             msg <- paste0(msg, "Please upload two channel droplet amplitude ",
                           "CSV files")

             if(messages$uploadError != "") {
               msg <- paste0(msg, ". ")
             } else {
               msg <- paste0(msg, " or use the 'Sample KRAS' dataset. ")
             }

             msg <- paste0(msg, "For details, see the 'Help' tab.")
           })
    )
    actionButton("useThisDataset", "Use This Dataset")
  })

  # Import CSV files and update all of the variables.
  loadFromFile <- function() {
    tryCatch({
      # User uploads CSV files.
      if(is.null(input$inFile)) {
        d <- list()
      } else {
        d <- lapply(input$inFile$datapath, utils::read.csv)
        nonemptyWells <- (vapply(d, nrow, numeric(1)) != 0)  # Remove empty wells.
        d <- d[nonemptyWells]
        names(d) <- extractWellNames(input$inFile$name)[nonemptyWells]

        # Load the plate name.
        wells$loadedPlateName <- extractPlateName(input$inFile$name[1])
        names(wells$loadedPlateName) <- NULL
      }

      wells$loadedAll <- ddpcrPlate(wells=d)
      messages$uploadError <- ""
    },
    warning=function(e) {
      wells$loadedAll <- ddpcrPlate()
      messages$uploadError <- "invalid CSV file format."
    },
    error=function(e) {
      wells$loadedAll <- ddpcrPlate()
      messages$uploadError <- "invalid CSV file format."
    })

  }

  # Get the droplet data for each well in the selected dataset.
  observeEvent(input$inFile, {
    loadFromFile()
  })

  # Load from file or use the sample dataset.
  observeEvent(input$useThisDataset, {
    if(input$datasetType == "From File" && !is.null(wells$loadedAll)) {
      # Set the well data from those loaded.
      wells$plateName <- wells$loadedPlateName
      wells$all <- wells$loadedAll

      # Allow the user to view previous "Results" if they already exist without
      # having to classify anything.
      cmethods <- commonClassificationMethod(wells$all)
      if(length(cmethods[cmethods != "None"]) >= 1) {
        results$all <- wells$all
        results$selected <- wells$all
        messages$error <- ""
      } else {
        results$all <- ddpcrPlate()
      }

      # Update
      updateNavbarPage(session, "tdNavbarPage", selected="Select Wells")
      updateTextInput(session, "plateName", value=wells$plateName)
      updateRadioButtons(session, "viewMode", selected="Overview")
      updateClassifications()
    } else if(input$datasetType == "Sample KRAS") {
      wells$plateName <- "Sample KRAS"
      environment(KRASdata) <- asNamespace("twoddpcr")
      wells$all <- ddpcrPlate(wells=twoddpcr::KRASdata)
      messages$error <- ""

      # Since we changed datasets, the selected wells should be reset.
      updateNavbarPage(session, "tdNavbarPage", selected="Select Wells")
      updateTextInput(session, "plateName", value=wells$plateName)
      updateRadioButtons(session, "viewMode", selected="Overview")

      # Allow the previous classifications in the "Results" tab to be viewed.
      results$all <- wells$all
      results$selected <- wells$all

      # Update the classification modes available.
      updateClassifications()
    }
  })

  observeEvent(input$plateName, {
    wells$plateName <- input$plateName
  })

  # Combine all of the droplet data, or use the data in the selected wells.
  observeEvent(input$useTheseWells, {
    setSelectedWells()
    updateNavbarPage(session, "tdNavbarPage", selected="Classify")
  })

  observeEvent(input$showResultsWells, {
    setResultsWells()
  })

  observeEvent(input$resultsViewMode, {
    setResultsWells()
  })

  # Manual thresholds.
  thresholds <- reactiveValues(
    ch1=shinyVis$threshDefault$ch1,
    ch2=shinyVis$threshDefault$ch2
  )

  # Thresholds to use for gridClassify.
  gridThresholds <- reactiveValues(
    NN=list(ch1=6500, ch2=1900),
    NP=list(ch1=6500, ch2=5000),
    PN=list(ch1=10000, ch2=2900),
    PP=list(ch1=7500, ch2=5000)
  )

  # K-means centres.
  initialCentres <- reactiveValues(
    NN=list(val=c(5000, 1500), removed=FALSE),
    PN=list(val=c(10000, 2000), removed=FALSE),
    NP=list(val=c(5500, 7000), removed=FALSE),
    PP=list(val=c(9000, 6000), removed=FALSE)
  )

  # How are we sorting the wells?
  sortByLetter <- reactive({
    return(input$sortWellsBy == "Letters First")
  })

  # Set the summary of wells for classification method 'm'.
  setSummary <- function(m, sortByLetter) {
    if(!is.null(results$all) && m != "None") {
      s <- plateSummary(results$all, m,
                        ch1Label=chLabels$ch1Abbrev,
                        ch2Label=chLabels$ch2Abbrev,
                        sortByLetter=sortByLetter)
      colnames(s)[1:4] <- abbrevLabels(decreasing=TRUE)
      results$summary <- data.frame("Well"=rownames(s), s, check.names=FALSE)
    } else {
      results$summary <- NULL
    }
  }

  # Checkboxes for the wells. Useful when the view mode is "Manual Selection".
  output$wellSelectionPH <- renderUI({
    if(!is.null(wells$all)) {
      wellNames <- sortWells(names(wells$all), sortByLetter())
      div(align="left", class="multicol",
        checkboxGroupInput("wellSelection", NULL,
                           choices=wellNames,
                           selected=wells$manualSelection)
      )
    }
  })

  # Change the sort order of wells
  observeEvent(input$sortWellsBy, {
    if(!is.null(results$summary)) {
      results$summary <-
        sortDataFrame(results$summary, sortByLetter=sortByLetter())
    }
  })

  # Checkboxes for the wells. Useful when the view mode is "Manual Selection".
  output$resultsWellsPH <- renderUI({
    if(!is.null(results$all) && !is.null(results$selected)) {
      wellNames <- sortWells(names(results$all), sortByLetter())
      div(align="left", class="multicol",
        checkboxGroupInput("resultsWells", NULL,
                           choices=wellNames,
                           selected=results$manualSelection)
      )
    }
  })

  # Normalise the data.
  observeEvent(input$normalise, {
    setSelectedWells()
  })

  # Show an error message if the normalisation failed.
  output$normaliseCheck <- renderUI({
    validate(
      need(messages$error == "", messages$error)
    )
  })

  # Radio buttons for the currently selected class.
  output$selectedClassPH <- renderUI({
    radioButtons("selectedClass", "Selected Class", abbrevLabels(),
                 inline=TRUE)
  })

  # Get the currently selected centre.
  observeEvent(input$selectedClass, {
    abbLabels <- abbrevLabels()
    if(input$selectedClass == abbLabels[1]) {
      selectedClass$value <- "NN"
    } else if(input$selectedClass == abbLabels[2]) {
      selectedClass$value <- "NP"
    } else if(input$selectedClass == abbLabels[3]) {
      selectedClass$value <- "PN"
    } else if(input$selectedClass == abbLabels[4]) {
      selectedClass$value <- "PP"
    }
  })

  # Are we viewing thresholds classification and have thresholds been saved?
  output$thresholdsSet <- reactive({
    return(!is.null(results$baseMode) && !is.na(results$baseMode) &&
       results$baseMode == "thresholds" &&
       !is.null(results$ch1Threshold) &&
       !is.null(results$ch2Threshold))
  })
  outputOptions(output, "thresholdsSet", suspendWhenHidden=FALSE)

  # Toggle the status of the selected class.
  observeEvent(input$removeThisClass, {
    initialCentres[[selectedClass$value]]$removed <- input$removeThisClass
  })

  # Update the "Remove This Class" checkbox depending on the selected class.
  observeEvent(selectedClass$value, {
    updateCheckboxInput(session, "removeThisClass",
                        value=initialCentres[[selectedClass$value]]$removed)
  })

  # Update the mode based on the selected classification to show.
  observeEvent(input$clToShow, {
    m <- internalMode(input$clToShow)
    results$baseMode <- m

    if(input$rainType == "Mahalanobis" &&
       mvnRainyModeExists(results$all, m)) {
      results$mode <- paste0(m, "MahRain")
    } else if(input$rainType == "Standard Deviation" &&
            sdRainyModeExists(results$all, m)) {
      results$mode <- paste0(m, "sdRain")
    } else {
      results$mode <- m
    }

    setSummary(results$mode, sortByLetter=sortByLetter())
  })

  # The numerical input for the thresholds will be rounded to intergers.
  observeEvent(input$ch1Threshold, {
    thresholds$ch1 <- round(input$ch1Threshold)
  })
  observeEvent(input$ch2Threshold, {
    thresholds$ch2 <- round(input$ch2Threshold)
  })

  # Mouse clicks.
  observeEvent(input$plot_click, {
    # Round to integers... surely these don't need to be floats.
    ch1 <- round(input$plot_click$y)
    ch2 <- round(input$plot_click$x)

    # Setting thresholds with mouse clicks.
    if(clMode() == "thresholds") {
      # Update the UI.
      updateNumericInput(session, "ch1Threshold", value=ch1)
      updateNumericInput(session, "ch2Threshold", value=ch2)

      # Set the internal variables.
      thresholds$ch1 <- ch1
      thresholds$ch2 <- ch2
    } else if(clMode() == "grid") {
      gridThresholds[[selectedClass$value]]$ch1 <- ch1
      gridThresholds[[selectedClass$value]]$ch2 <- ch2
    } else if(clMode() == "kmeans" && !input$removeThisClass) {
      # Setting cluster centres.
      initialCentres[[selectedClass$value]] <-
        list(val=c(ch1, ch2), removed=FALSE)
    }
  })

  # Retrieve the initial centres set in the app.
  startingCentres <- function() {
    # Remove any classes that are marked as being 'removed'.
    centres <- lapply(Filter(Negate(function(x) { x$removed }),
                             reactiveValuesToList(initialCentres)),
                      function(x) { x$val })

    # Turn the centres list into a data frame.
    centresDf <- as.data.frame(t(as.data.frame(centres)))
    colnames(centresDf) <- c("Ch1.Amplitude", "Ch2.Amplitude")
    centresDf
  }

  # Retrieve a data frame of grid thresholds.
  getGridThresholds <- function() {
    data.frame(
      "Ch1.Amplitude"=c(gridThresholds$NN$ch1,
                        gridThresholds$NP$ch1,
                        gridThresholds$PN$ch1,
                        gridThresholds$PP$ch1),
      "Ch2.Amplitude"=c(gridThresholds$NN$ch2,
                        gridThresholds$NP$ch2,
                        gridThresholds$PN$ch2,
                        gridThresholds$PP$ch2),
      "class"=c(ddpcr$nn, ddpcr$np, ddpcr$pn, ddpcr$pp)
    )
  }

  # "Run classification" listener.
  observeEvent(input$classify, {
    tryCatch({
      if(isEmpty(wells$selected)) {
        messages$error <- "No wells selected for classification."
        updateNavbarPage(session, "tdNavbarPage", selected="Results")
      } else {
        if(clMode() == "thresholds") {
          results$all <- thresholdClassify(wells$selected,
                                                 ch1Threshold=thresholds$ch1,
                                                 ch2Threshold=thresholds$ch2)
          results$ch1Threshold <- thresholds$ch1
          results$ch2Threshold <- thresholds$ch2
          messages$error <- ""
        } else if(clMode() == "kmeans") {
          withProgress(message="Running k-means algorithm", value=0, {
              results$all <-
                kmeansClassify(wells$selected, centres=startingCentres())
              messages$error <- ""
            incProgress(1)
          })
        } else if(clMode() == "grid") {
          results$all <-
            gridClassify(wells$selected,
                         gridThresholds$NN$ch1, gridThresholds$NN$ch2,
                         gridThresholds$NP$ch1, gridThresholds$NP$ch2,
                         gridThresholds$PN$ch1, gridThresholds$PN$ch2,
                         gridThresholds$PP$ch1, gridThresholds$PP$ch2,
                         classMethodLabel="grid",
                         naLabel=ddpcr$rain)
          messages$error <- ""
        } else if(clMode() == "knn") {
          withProgress(message="Running k-NN algorithm",
                       detail="This can take a while...", value=0, {
            if(nrow(trainingData$drops) == 0) {
              setTrainingDataFromGrid()
            }

            results$all <-
              knnClassify(wells$selected,
                trainingData$drops[, c("Ch1.Amplitude", "Ch2.Amplitude")],
                trainingData$drops$class, k=input$knnK, prob=input$knnProb)

            messages$error <- ""
            incProgress(1)
          })
        }

        # Set the results modes.
        setResultsWells()
        results$mode <- clMode()
        results$baseMode <- clMode()

        # Switch to the results tab.
        setSummary(clMode(), sortByLetter=sortByLetter())
        updateRadioButtons(session, "resultsViewMode", selected="All")
        updateRadioButtons(session, "rainType", selected="No Rain")

        updateClassifications(selected=input$classifyMode)
      }
    },
    warning=function(e) {
      messages$error <- as.character(e) ######## protect
    },
    error=function(e) {
      messages$error <- as.character(e) ######## protect
    })
    updateNavbarPage(session, "tdNavbarPage", selected="Results")
  })

  # Show the Mahalanobis rain sliders with correct labels.
  output$mvnRainNNPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("mvnRainNN", label[1], 1, 100, 30)
  })
  output$mvnRainNPPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("mvnRainNP", label[2], 1, 100, 30)
  })
  output$mvnRainPNPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("mvnRainPN", label[3], 1, 100, 30)
  })
  output$mvnRainPPPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("mvnRainPP", label[4], 1, 100, 30)
  })

  # Show the SD rain sliders with correct labels.
  output$sdRainNNPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("sdRainNN", label[1], 1, 100, 30)
  })
  output$sdRainNPPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("sdRainNP", label[2], 1, 100, 30)
  })
  output$sdRainPNPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("sdRainPN", label[3], 1, 100, 30)
  })
  output$sdRainPPPH <- renderUI({
    label <- abbrevLabels()
    sliderInput("sdRainPP", label[4], 1, 100, 30)
  })

  # Toggle rain: this will change the mode; update the summary.
  observeEvent(input$rainType, {
    # Base mode with and without rain.
    bm <- results$baseMode
    bmMahRain <- paste0(bm, "MahRain")
    bmSdRain <- paste0(bm, "SdRain")

    if(input$rainType == "No Rain") {
      results$mode <- bm
      setSummary(results$mode, sortByLetter=sortByLetter())
    } else if(input$rainType == "Mahalanobis" &&
            bmMahRain %in% commonClassificationMethod(results$all)) {
      results$mode <- bmMahRain
      setSummary(results$mode, sortByLetter=sortByLetter())
    } else if(input$rainType == "Standard Deviation" &&
            bmSdRain %in% commonClassificationMethod(results$all)) {
      results$mode <- bmSdRain
      setSummary(results$mode, sortByLetter=sortByLetter())
    }
  })

  # Add rain.
  observeEvent(input$makeItRain, {
    withProgress(message="Computing rain",
                 detail="This can take a moment...", value=0, {
      if(input$rainType == "Mahalanobis") {
        results$all <-
          mahalanobisRain(
            results$all,
            cMethod=results$baseMode,
            maxDistances=list("NN"=input$mvnRainNN, "NP"=input$mvnRainNP,
                              "PN"=input$mvnRainPN, "PP"=input$mvnRainPP))

        # Set the mode.
        results$mode <- paste0(results$baseMode, "MahRain")
      } else if(input$rainType == "Standard Deviation") {
        results$all <-
          sdRain(
            results$all,
            cMethod=results$baseMode,
            errorLevel=list("NN"=input$sdRainNN, "NP"=input$sdRainNP,
                            "PN"=input$sdRainPN, "PP"=input$sdRainPP))

        # Set the mode.
        results$mode <- paste0(results$baseMode, "SdRain")
      }

      setResultsWells()
      setSummary(results$mode, sortByLetter=sortByLetter())
    })
  })

  # Render a facet_grid of all the wells.
  output$plotFacetGrid <- renderPlot({
    validate(
      need(!is.null(wells$all) && !isEmpty(wells$all),
           "Please load a dataset on the 'Input' tab.")
    )

    withProgress(message="Rendering the plot",
        detail="This can take a moment...", value=0, {
      if(input$plateViewMode == "Show All Wells") {
        showAllWells <- TRUE
      } else {
        showAllWells <- FALSE
      }

      return(facetPlot(wells$all,
                       ch1Label=chLabels$ch1,
                       ch2Label=chLabels$ch2,
                       binwidth=input$heatWidth,
                       plotLimits=globals$plotLimits,
                       showEmptyWells=showAllWells))
      incProgress(1)
    })
  })


  # Render density plot of selected wells along with UI elements for helping
  # with the selected classification mode.
  output$plotSelectedWells <- renderPlot({
    validate(
      need(!is.null(wells$selected) && !isEmpty(wells$selected),
           "Please choose some wells in the 'Select Wells' tab.")
    )

    withProgress(message="Rendering the plot",
        detail="This can take a moment...", value=0, {
      p <- heatPlot(wells$selected,
                    ch1Label=chLabels$ch1, ch2Label=chLabels$ch2,
                    binwidth=input$heatWidth,
                    plotLimits=globals$plotLimits)

      # Draw thresholds.
      if(clMode() == "thresholds") {
        p <- p + geom_hline(yintercept=thresholds$ch1) +
          geom_vline(xintercept=thresholds$ch2)
      } else if(clMode() == "grid") {
        # Draw the regions that are cut out for the grid.
        # Get a data frame of the grid thresholds.
        df <- getGridThresholds()
        ch1 <- substr(df$class, 1, 1)
        ch2 <- substr(df$class, 2, 2)

        # Highlight the regions to keep.
        p <-
          p + geom_rect(data=df[df$class == "NN", ],
                        aes_string(xmin=-Inf, xmax="Ch2.Amplitude",
                                   ymin=-Inf, ymax="Ch1.Amplitude"),
                        fill="green", colour="green4", alpha=0.2) +
          geom_rect(data=df[df$class == "NP", ],
                    aes_string(xmin="Ch2.Amplitude", xmax=Inf,
                               ymin=-Inf, ymax="Ch1.Amplitude"),
                    fill="green", colour="green4", alpha=0.2) +
          geom_rect(data=df[df$class == "PN", ],
                    aes_string(xmin=-Inf, xmax="Ch2.Amplitude",
                               ymin="Ch1.Amplitude", ymax=Inf),
                    fill="green", colour="green4", alpha=0.2) +
          geom_rect(data=df[df$class == "PP", ],
                    aes_string(xmin="Ch2.Amplitude", xmax=Inf,
                               ymin="Ch1.Amplitude", ymax=Inf),
                    fill="green", colour="green4", alpha=0.2)
      }

      # Draw initial centres.
      if(clMode() == "kmeans") {
        centres <- startingCentres()
        selectedCentre <- selectedClass$value
        p <- p +
          geom_point(data=centres[rownames(centres) == selectedCentre, ],
                     aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude"),
                     fill="#FFFFFF", colour="#000000", shape=23, size=6) +
          geom_point(data=centres[rownames(centres) != selectedCentre, ],
                     aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude"),
                     fill="#000000", colour="#FFFFFF", shape=23, size=6)
      }
      return(p)
      incProgress(1)
    })
  })


  # Plot the classification.
  output$plotClassification <- renderPlot({
    validate(
      need(!is.null(results$all) && !isEmpty(results$all),
           "Please classify droplets in the 'Classify' tab."),
      need(messages$error == "", messages$error)
    )

    withProgress(message="Rendering the plot",
        detail="This can take a moment...", value=0, {
      # Re-label the legend.
      labels <- c(abbrevLabels(), "Rain", "N/A")

      p <- dropletPlot(results$selected,
                       ch1Label=chLabels$ch1,
                       ch2Label=chLabels$ch2,
                       cMethod=results$mode,
                       plotLimits=globals$plotLimits,
                       legendLabels=labels)

      # Retrieve thresholds and plot them.
      if(!is.null(results$baseMode) &&
         results$baseMode == "thresholds" &&
         !is.null(results$ch1Threshold) &&
         !is.null(results$ch2Threshold) &&
         input$showThresholds) {
        p <- p + geom_hline(yintercept=results$ch1Threshold) +
          geom_vline(xintercept=results$ch2Threshold)
      }

      # Plot the final centres.
      if(input$finalCentres) {
        finalCentres <- combinedCentres(results$all, results$mode)
        p <- p + geom_point(data=finalCentres, fill="#000000",
                            colour="#FFFFFF", shape=22, size=6)
      }
      return(p)
      incProgress(1)
    })
  })

  # Plot the training data.
  output$plotTraining <- renderPlot({
    validate(
      need(nrow(trainingData$drops) > 0, "No training data has been set.")
    )
    withProgress(message="Rendering the plot",
        detail="This can take a moment...", value=0, {
      labels <- c(abbrevLabels(), "Rain", "N/A")
      p <- dropletPlot(trainingData$drops,
                       ch1Label=chLabels$ch1,
                       ch2Label=chLabels$ch2,
                       cMethod="class",
                       plotLimits=globals$plotLimits,
                       legendLabels=labels)
      return(p)
      incProgress(1)
    })
  })

  # Use the current results as training data.
  observeEvent(input$setClassificationAsTrainingData, {
    if(!is.null(results$all) &&
       sum(numDroplets(results$all)) > 0) {
      trainingData$drops <-
        do.call(rbind, removeDropletClasses(results$all, cMethod=results$mode))
      names(trainingData$drops)[3] <- "class"
    }
  })

  # Show Bio-Rad-like table.
  output$wellsSummary <- renderDataTable({
    validate(
      need(!is.null(results$all) && !isEmpty(results$all) &&
           messages$error == "",
           "Please classify droplets in the 'Classify' tab.")
    )
    if(!is.null(results$summary)) {
      results$summary
    } else {
      data.frame()
    }
  })

  # Show the export amplitudes button when there are some results.
  output$exportAmplitudesPH <- renderUI({
    if(!is.null(results$all) && !is.null(results$summary)) {
      div(
        style="padding-top: 2ex",
        strong("Droplet export"),
        div(
          style="padding-top: 1ex",
          downloadButton("exportAmplitudesButton", "Export Amplitudes to File")
        ),
        div(
          style="padding-top: 2ex",
          actionButton("setClassificationAsTrainingData",
            "Set as Training Data"
          )
        )
      )
    }
  })

  # Export the amplitudes to file.
  output$exportAmplitudesButton <- downloadHandler(
    filename=function() { paste0(wells$plateName, "_", results$mode,
                                 "-amplitudes.zip") },
    content=function(file) {
      exportZip(results$all, file, prefix=paste0(wells$plateName, "_"))
    },
    contentType="application/zip"
  )

  # A summary table has been created.
  output$summarySet <- reactive({
    return(!is.null(results$all) && !is.null(results$summary))
  })
  outputOptions(output, "summarySet", suspendWhenHidden=FALSE)

  # Export the data summary to file.
  output$exportSummaryButton <- downloadHandler(
    filename=function() {
      paste0(wells$plateName, "-", results$mode, ".csv")
    },
    content=function(file) {
      exportTable(results$summary[, -1], file, delim=",",
                  leadingColName="Well")
    }
  )

  # Export the data summary to file.
  output$generateHtmlReport <- downloadHandler(
    filename=function() {
      paste0(wells$plateName, "-", results$mode, "-report.html")
    },
    content=function(file) {
      # Copy the report file to a temporary directory before processing it.
      tempReport <- file.path(normalizePath(tempdir()), "report-html.Rmd")
      rmdLoc <- system.file("rmd", "report-html.Rmd", package = "twoddpcr")
      file.copy(rmdLoc, tempReport, overwrite=TRUE)

      # Check the rain type of the current mode.
      if(length(grep("MahRain", results$mode)) > 0) {
        rainType <- "Mahalanobis"
      } else if(length(grep("SdRain", results$mode)) > 0) {
        rainType <- "Standard deviation"
      } else {
        rainType <- "None"
      }

      # Set up parameters to pass to the Rmd document.
      params <- list(plateName=wells$plateName,
                     plate=results$all,
                     cMethod=results$mode,
                     longMode=longMode(results$baseMode),
                     rainType=rainType,
                     summaryTable=results$summary[, -1])


      rmarkdown::render(tempReport, output_file=file,
        params = params,
        envir = new.env(parent = globalenv())
      )
    }
  )

  # Show the initial centres used in k-means clustering.
  output$centresOutput <- renderPrint({
    sc <- startingCentres()

    # Add a class column
    labels <- abbrevLabels()
    lab <- vapply(rownames(sc),
           function(x) {
             if(x == "NN") {
               "NN"=labels[1]
             } else if(x == "NP") {
               "NP"=labels[2]
             } else if(x == "PN") {
               "PN"=labels[3]
             } else if(x == "PP") {
               "PP"=labels[4]
             }
           }, character(1))
    cbind("class"=lab, sc)
  })

  output$gridThesholdsOutput <- renderPrint({
    getGridThresholds()
  })

  # Render the droplet volume action button.
  output$setDropletVolumePH <- renderUI({
    validate(
      need(is.numeric(input$dropletVolume) && input$dropletVolume > 0,
           "The droplet volume should be a positive number.")
    )
    div(
      style="padding-bottom: 2ex",
      actionButton("setDropletVolume", "Set Droplet Volume")
    )
  })

  # Set the droplet volume.
  observeEvent(input$setDropletVolume, {
    setDropletVolume(volume=(input$dropletVolume * 0.001))
    setSummary(results$mode, sortByLetter=sortByLetter())
  })

  # Render the minimum cluster separation action button.
  output$setMinSeparationPH <- renderUI({
    validate(
      need(is.numeric(input$minSeparation) && input$minSeparation > 0,
           "The minimum cluster separation should be a positive number.")
    )
    div(
      style="padding-bottom: 2ex",
      actionButton("setMinSeparation", "Set Minimum Cluster Separation")
    )
  })

  # Set the minimum cluster separation.
  observeEvent(input$setMinSeparation, {
    globals$minSeparation <- input$minSeparation
    setSelectedWells()
  })

  # Render the plot limit action button.
  output$setPlotLimitsPH <- renderUI({
    validate(
      need(is.numeric(input$ch1min) && is.numeric(input$ch1max) &&
           is.numeric(input$ch2min) && is.numeric(input$ch2max),
           "The plot limit figures should be numbers."),
      need(input$ch1min < input$ch1max && input$ch2min < input$ch2max,
           "The min figures should be less than its corresponding max figure.")
    )
    div(
      style="padding-bottom: 2ex",
      actionButton("setPlotLimits", "Set Plot Limits")
    )
  })

  # Set the plot limits.
  observeEvent(input$setPlotLimits, {
    globals$plotLimits <-
      list(x=c(input$ch2min, input$ch2max), y=c(input$ch1min, input$ch1max))
  })
}

#' @include global.R
#' @include ddpcrWell.R
#' @import methods
#' @import stats
#' @import utils
#' @importClassesFrom S4Vectors SimpleList
#' @importFrom S4Vectors elementType
NULL


#' Check the types of the elements in a \code{SimpleList}.
#'
#' Check the types of the elements in a \code{SimpleList}.
#'
#' @param x An object.
#'
#' @return The types of objects in the \code{SimpleList} object.
#'
#' @export

setMethod("elementType", "SimpleList", function(x) x@elementType)


#' An S4 class for multiple wells in a ddPCR experiment.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @name ddpcrPlate-class
#'
#' @export ddpcrPlate
#' @exportClass ddpcrPlate

.ddpcrPlate <-
  setClass(
    "ddpcrPlate",
    contains="SimpleList",
    prototype=prototype(elementType="ddpcrWell"),
    validity=function(object) {
      # All elements of 'wells' should be 'ddpcrWell' objects.
      if(any(lapply(object, class) != "ddpcrWell")) {
        return("All wells should be 'ddpcrWell' objects.")
      }

      return(TRUE)
    }
  )


#' The constructor for the \code{ddpcrPlate} class.
#'
#' @param wells Either:
#' \itemize{
#'   \item a list of \code{\link{ddpcrWell}} objects,
#'   \item a list of data frames of droplet amplitudes, or
#'   \item a character vector corresponding to a file path(s) containing CSV
#'   files of raw droplet amplitude data.
#' }
#'
#' @return A \code{ddpcrPlate} object with the given wells.
#'
#' @rdname ddpcrPlate-class
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## A \code{ddpcrPlate} object can be created from data from a list of data
#' ## frames.
#' ddpcrPlate(KRASdata)
#'
#' ## A directory (or individual files) of droplet amplitude CSVs can also be
#' ## loaded.
#' moreAmpsDir <- system.file("extdata", "more-amplitudes", package="twoddpcr")
#' ddpcrPlate(moreAmpsDir)
#'
#' @export


setGeneric("ddpcrPlate", function(wells) {
  standardGeneric("ddpcrPlate")
})

#' @rdname ddpcrPlate-class
#'
#' @export

setMethod("ddpcrPlate", "list", function(wells) {
  # Try to make ddpcrWell objects from a list of data frames.
  if(all(vapply(wells, class, character(1)) == "data.frame")) {
    # Set the column names to the correct format, then coerce them.
    wells <- setChannelNames(wells)
    wells <- lapply(wells, ddpcrWell)
  }

  setNames(.ddpcrPlate(listData=wells), names(wells))
}
)

#' @rdname ddpcrPlate-class
#'
#' @export

setMethod("ddpcrPlate", "ddpcrPlate", function(wells) {
  wells <- as.list(wells)
  ddpcrPlate(wells)
})

#' @rdname ddpcrPlate-class
#'
#' @export

setMethod("ddpcrPlate", "character", function(wells) {
  # Character string wells: hopefully a directory path.
  # File or directory path---read it.
  if(all(file.exists(wells))) {
    wells <- readCSVDataFrame(wells)
    if(length(wells) == 0) {
      warning("No droplet amplitudes loaded. Was this intended?")
    }
    ddpcrPlate(lapply(wells, ddpcrWell))
  } else {
    stop("The string 'wells' is not a file or directory path.")
  }
}
)

#' @rdname ddpcrPlate-class
#'
#' @export

setMethod("ddpcrPlate", "missing", function(wells) {
  .ddpcrPlate(listData=list())
})


#' @rdname amplitudes
#'
#' @exportMethod amplitudes

setMethod("amplitudes", "ddpcrPlate", function(theObject) {
  if(length(theObject) == 0) {
    return(data.frame("Ch1.Amplitude"=double(),
                      "Ch2.Amplitude"=double()))
  } else {
    return(lapply(theObject, amplitudes))
  }
})


#' Splits a long vector and according to a vector of sizes.
#'
#' Takes one long vector/factor and splits it into a list of vectors, where the
#' lengths are given by a vector of sizes. This may be the same as another
#' given list of vectors. Particularly useful if we want to combine a list of
#' data, do some analysis on the combined data, then split the analysis.
#'
#' @param vec The vector to split.
#' @param wellSizes A numeric vector corresponding to sizes of the wells.
#' @param wellNames A character vector corresponding to the names of the wells.
#'
#' @return A list of vectors split into the given lengths.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.slice <- function(vec, wellSizes, wellNames) {
  sliced <- setNames(vector("list", length(wellNames)), wellNames)
  i <- 1
  for(j in seq_along(wellSizes)) {
    s <- wellSizes[j]
    sliced[[wellNames[j]]] <- vec[i:(i+s-1)]
    i <- i + s
  }
  sliced
}


#' Retrieve the well names to use from a given list.
#'
#' We simply retrieve the \code{names} from a given list, but also perform some
#' checks to make sure that the names are consistent with a given
#' \code{\link{ddpcrPlate}} object.
#'
#' @param theObject A \code{\link{ddpcrPlate}} object.
#' @param aList A list from which we wish to extract well names.
#'
#' @return The names of \code{aList}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.extractWellNames <- function(theObject, aList) {
  # Set well names.
  if(!all(is.null(names(aList))) && all(names(aList) %in% names(theObject))) {
    wells <- names(aList)
  } else {
    stop("Not all names specified in the list 'aList' ",
         "are well names in 'theObject'.")
  }

  # Inconsistencies between the given list and wells.
  if(!all(wells %in% names(theObject))) {
    stop("Some of the given 'wells' are not valid well names in ",
         "'theObject'.")
  }

  wells
}


#' Set and retrieve classifications for multiple wells.
#'
#' Retrieve multiple classification factors that have been assigned to
#' a \code{ddpcrPlate} object.
#'
#' @param theObject A \code{\link{ddpcrPlate}} object.
#' @param cMethod This is the name of the classification to retrieve and should
#' be a character vector. If \code{NULL}, then all of the classifications are
#' obtained. Defaults to \code{NULL}.
#' @param value Either:
#' \itemize{
#'   \item A list of factors, where each item of the list corresponds to
#'   a well;
#'   \item A single factor corresponding to all of the wells combined. This
#'   should be ordered by the order of the output of the
#'   \code{\link{amplitudes}} function when the rows of the data frames have
#'   been bound together, i.e. with \code{do.call(rbind,
#'   amplitudes(theObject))}.
#' }
#' @param withAmplitudes If \code{TRUE}, the droplet amplitudes are included.
#' Defaults to \code{FALSE}.
#' @param wellCol If \code{TRUE}, an additional column is included in the
#' output, where each entry is the name of the well from which the droplet
#' originated. In this case, this setting forces the \code{withAmplitudes}
#' parameter to \code{TRUE}. Defaults to \code{FALSE}.
#'
#'
#' @return If requesting one classification without the amplitudes, a list of
#' factors corresponding to the classifications is returned. Otherwise, a list
#' of data frames is returned where each row corresponds to a droplet in the
#' corresponding well.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ### The examples here show how this method works by setting classifications
#' ### using data frames. To do this, we use the
#' ### \code{\link{thresholdClassify}} method on _data frames_. Note that
#' ### \code{thresholdClassify} also works directly on \code{ddpcrWell} and
#' ### \code{ddpcrPlate} objects; this is simply an illustration of
#' ### how to use the \code{plateClassification} method directly. In general,
#' ### it is recommended to use \code{thresholdClassify} directly on
#' ### \code{ddpcrPlate} objects.
#'
#' ## Create a ddpcrPlate object.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#'
#' ## Classify a data frame of droplets and keep it in a _single_ data frame.
#' ## Set the new classification from this.
#' droplets <- do.call(rbind, amplitudes(krasPlate))
#' clSingle <- thresholdClassify(droplets,
#'                               ch1Threshold=7000, ch2Threshold=3500,
#'                               fullTable=FALSE)
#' plateClassification(krasPlate, "thresholdSing") <- clSingle
#'
#' ## We can also set the new classification from a list of factors.
#' clList <- lapply(KRASdata, thresholdClassify, ch1Threshold=7000,
#'                  ch2Threshold=3500, fullTable=FALSE)
#' plateClassification(krasPlate, "thresholdList") <- clList
#'
#' ## We can get all of the classifications as a list of data frames.
#' plate <- plateClassification(krasPlate)
#' lapply(plate, head, n=1)
#'
#' ## We can include the droplet amplitudes columns.
#' plate <- plateClassification(krasPlate, withAmplitudes=TRUE)
#' lapply(plate, head, n=1)
#'
#' ## We can focus on specific classifications.
#' plate <- plateClassification(krasPlate, cMethod=c("thresholdSing",
#'                                                   "thresholdList"))
#' lapply(plate, head, n=1)
#'
#' ## The wellCol option adds an extra column showing which well the droplet
#' ## came from.
#' plate <- plateClassification(krasPlate, withAmplitudes=TRUE, wellCol=TRUE)
#' lapply(plate, head, n=1)
#'
#'
#' @name plateClassification
#'
#' @export

setGeneric(
  "plateClassification",
  function(theObject, cMethod=NULL, withAmplitudes=FALSE, wellCol=FALSE) {
    standardGeneric("plateClassification")
  }
)

#' @rdname plateClassification
#'
#' @exportMethod plateClassification

setMethod("plateClassification", "ddpcrPlate",
  function(theObject, cMethod=NULL, withAmplitudes=FALSE, wellCol=FALSE) {
    # Force withAmplitudes to be true if we're including a well column.
    if(wellCol && !withAmplitudes) {
      withAmplitudes <- TRUE
    }

    mc <- lapply(theObject, wellClassification,
                 withAmplitudes=withAmplitudes, cMethod=cMethod)

    # Retrieve the classification. Simplify to a factor if one classification
    # has been requested without amplitudes; use data frames otherwise.
    # if(!withAmplitudes && (length(cMethod) == 1))

    # Add a well column to show where the droplet originated.
    if(wellCol) {
      wellNames <- names(theObject)
      mc <- lapply(
        wellNames, function(w) {
          data.frame(mc[[w]], "Well"=factor(w, levels = unique(wellNames)))
        }
      )
      names(mc) <- wellNames
    }

    mc
  }
)

#' @rdname plateClassification
#'
#' @export

setGeneric("plateClassification<-", function(theObject, cMethod, value) {
    standardGeneric("plateClassification<-")
  }
)

#' @rdname plateClassification
#'
#' @export

setReplaceMethod("plateClassification", c("ddpcrPlate", "character", "list"),
  function(theObject, cMethod, value) {
    # Basic checks on the well names.
    wells <- .extractWellNames(theObject, value)
    wellDropletCount <- vapply(
      wells, function(w) numDroplets(theObject[[w]]), numeric(1)
    )
    if(any(vapply(value, length, numeric(1)) != wellDropletCount)) {
      stop("The number of elements in the list items do not match ",
           "those of the existing wells of the same name.")
    }

    for(i in seq_along(wells)) {
      w <- wells[i]
      wellClassification(theObject[[w]], cMethod=cMethod) <- value[[i]]
    }

    validObject(theObject)
    return(theObject)
  }
)

#' @rdname plateClassification
#'
#' @export

setReplaceMethod("plateClassification", c("ddpcrPlate", "character", "factor"),
  function(theObject, cMethod, value) {
    # The classification 'value' is one long factor, so should be for the
    # combined wells.

    # Check that the vector length is correct.
    multiNumDroplets <- numDroplets(theObject)
    if(length(value) != sum(multiNumDroplets)) {
      stop("The length of 'vec' is not the same as the sum of 'wellSizes'.")
    }

    # Slice it.
    cl <- .slice(value, multiNumDroplets, names(theObject))

    # Set the classification.
    for(w in names(theObject)) {
      wellClassification(theObject[[w]], cMethod=cMethod) <- cl[[w]]
    }

    validObject(theObject)
    return(theObject)
  }
)


#' Set or retrieve the classification method strings for multiple wells.
#'
#' \code{plateClassificationMethod} retrieves multiple classification methods
#' that have been assigned to a \code{ddpcrPlate} object.
#'
#' @param theObject A \code{\link{ddpcrPlate}} object.
#' @param cMethod This should represent existing classification method(s) for
#' all wells in \code{theObject}. It can be given in the form of a:
#' \itemize{
#'   \item Character vector. If this vector is shorter than the length of
#'   \code{wells}, this vector's elements will be repeated.
#'   \item List of character vectors.
#' }
#' @param value New classification method(s) in the same form as
#' \code{cMethod}.
#'
#' @return \code{plateClassificationMethod} returns a list of character strings
#' corresponding to the classification methods.
#'
#' @seealso \code{\link{plateClassification}} for the classifications.
#'
#' @aliases plateClassName plateClassificationName plateClassMethod
#'
#' @rdname plateClassificationMethod
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get the classification methods for the KRASdata dataset.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' plateClassificationMethod(krasPlate)
#'
#' ## Change the "Cluster" column to "QS".
#' plateClassificationMethod(krasPlate, "Cluster") <- "QS"
#' plateClassificationMethod(krasPlate)
#'
#' ## Usually, all of the classification names are the same for all wells. We
#' ## use the \code{commonClassificationMethod} method to retrieve the ones
#' ## common to all wells.
#' commonClassificationMethod(krasPlate)
#'
#' @export

setGeneric("plateClassificationMethod", function(theObject) {
  standardGeneric("plateClassificationMethod")
})

#' @rdname plateClassificationMethod
#'
#' @exportMethod plateClassificationMethod

setMethod("plateClassificationMethod", "ddpcrPlate", function(theObject) {
  wellNames <- names(theObject)
  setNames(lapply(theObject, wellClassificationMethod), wellNames)
})

#' @rdname plateClassificationMethod
#'
#' @export

setGeneric("plateClassificationMethod<-", function(theObject, cMethod, value) {
  standardGeneric("plateClassificationMethod<-")
})

#' @rdname plateClassificationMethod
#'
#' @export

setReplaceMethod(
  "plateClassificationMethod", "ddpcrPlate",
  function(theObject, cMethod, value) {
    if(is.list(cMethod)) {
      cMethod <- unlist(cMethod)
    }
    if(is.list(value)) {
      value <- unlist(value)
    }

    if(is.vector(cMethod) && is.vector(value)) {
      wells <- names(theObject)

      # Set classification method for all wells, repeating elements of
      # cMethod if necessary.
      for(i in seq_along(wells)) {
        w <- wells[[i]]
        cmWrap <- cMethod[[(i - 1) %% length(cMethod) + 1]]
        wellClassificationMethod(theObject[[w]], cmWrap) <-
          value[[(i - 1) %% length(value) + 1]]
      }
    } else {
      stop("'cMethod' and 'value' should be vectors or lists ",
           "of indices or character strings.")
    }

    validObject(theObject)
    return(theObject)
  }
)


#' @rdname plateClassificationMethod
#'
#' @description \code{commonClassificationMethod} retrieves the classification
#' methods common to all the wells in the given \code{ddpcrPlate} object.
#'
#' @return \code{commonClassificationMethod} returns a vector of character
#' strings indicating which classification methods appear in all wells.
#'
#' @export

setGeneric("commonClassificationMethod", function(theObject) {
  standardGeneric("commonClassificationMethod")
})

#' @rdname plateClassificationMethod
#'
#' @exportMethod commonClassificationMethod

setMethod("commonClassificationMethod", "ddpcrPlate", function(theObject) {
  if(length(theObject) == 0) {
    return(0)
  } else {
    x <- plateClassificationMethod(theObject)
    common <- x[[1]]
    for(i in seq_along(x)) {
      common <- intersect(common, x[[i]])
    }
    return(common)
  }
}
)


#' @rdname ddpcrPlate-class
#'
#' @inheritParams methods::show

setMethod("show", "ddpcrPlate", function(object) {
  cat("ddpcrPlate object\n")
  cat("number of wells: ", length(object), "\n", sep="")
  if(!isEmpty(object)) {
    cat("well names: ", sep="")
    maxNumWells <- 10
    wellNames <- names(object)
    if(length(object) <= maxNumWells) {
      cat(wellNames, "\n", sep=" ")
    } else {
      remNumWells <- length(object) - maxNumWells
      cat(wellNames[seq(maxNumWells)],
          "...\n            (plus", remNumWells, "wells omitted)\n", sep=" ")
    }
  }
})

#' @import methods
#' @import utils
NULL

#' @title Exports an object to file.
#'
#' @param theObject The dataframe to export.
#' @param location The location to export to. This should be a filename if we
#' are using \code{exportZip}, or we are using \code{exportTable} and
#' \code{theObject} is a data frame or \code{ddpcrWell} object. If
#' \code{theObject} is a \code{ddpcrPlate} object, this should be
#' a directory.
#' @param delim The character to use as a field separator. Defaults to ",",
#' i.e. export a CSV.
#' @param ... Other options depending on the type of \code{theObject}.
#'
#' @details Note that filenames of the form \code{Anything_A01_Amplitude.csv}
#' can be read by \code{\link{readCSVDataFrame}} so that the well name can be
#' extracted successfully (in this case \code{A01}). Where it is used, see the
#' default value of the parameter \code{suffix}.
#'
#' @return Exports a file.
#'
#' @name exportTable
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Output to a temporary directory.
#' tmpOut <- file.path(normalizePath(tempdir()))
#'
#' ## Read some counts data and generate a summary data frame.
#' df <- fullCountsSummary(KRAScountsQS)
#' summaryDf <- fullCopiesSummary(df)
#'
#' ## Write the summary to a CSV file.
#' exportTable(summaryDf, file.path(tmpOut, "summary-table.csv"))
#'
#' ## Write the summary to a tab-separated text file.
#' exportTable(summaryDf, file.path(tmpOut, "summary-table.txt"), delim="\t")
#'
#' ## Write the summary to a CSV file with leading column labelled "Patient".
#' exportTable(summaryDf, file.path(tmpOut, "summary-table.csv"),
#'             leadingColName="Patient")
#'
#' ## Read a droplet amplitude CSV file to a ddpcrWell object.
#' ampFile <- system.file("extdata", "amplitudes", "sample_B03_Amplitude.csv",
#'                        package="twoddpcr")
#' aWell <- ddpcrWell(well=ampFile)
#'
#' ## Classify the droplets into 4 clusters.
#' aWell <- kmeansClassify(aWell, centres=4)
#'
#' ## Write the amplitudes to a CSV file with the old and new classifications.
#' exportTable(aWell,
#'   location=file.path(tmpOut, "With_Kmeans_B03_Amplitude.csv"))
#'
#' ## Write the amplitudes to a CSV file with the new classification only.
#' exportTable(aWell,
#'   location=file.path(tmpOut, "With_Kmeans_B03_Amplitude.csv"),
#'   cMethod="kmeans")
#'
#' ## Read all amplitude files in a directory to a ddpcrPlate object.
#' moreAmpsDir <- system.file("extdata", "more-amplitudes", package="twoddpcr")
#' krasPlate <- ddpcrPlate(wells=moreAmpsDir)
#'
#' ## Classify the droplets into 4 clusters.
#' krasPlate <- kmeansClassify(krasPlate, centres=4)
#'
#' ## Write the amplitudes to multiple files in a directory with the old and
#' ## new classifications.
#' exportTable(krasPlate, location=file.path(tmpOut, "amplitudes-classified"))
#'
#' ## Write the amplitudes to multiple files with the new classification only
#' ## and a custom prefix for the filenames.
#' exportTable(krasPlate, location=file.path(tmpOut, "amplitudes-classified"),
#'             cMethod="kmeans", prefix="Kmeans_Only_")
#'
#' ## Export to a zip file.
#' exportZip(krasPlate,
#'           location=file.path(tmpOut, "amplitudes-classified/all.zip"),
#'           cMethod="kmeans", prefix="Kmeans_Only_")
#'
#'
#'
#' @export

setGeneric("exportTable", function(theObject, location, delim=",", ...) {
  standardGeneric("exportTable")
})

#' @rdname exportTable
#'
#' @description If given a data frame, \code{exportTable} exports the whole
#' data frame to file. This could be a data frame of any form. A few options
#' are available that can be used to determine the format of the file that is
#' exported, e.g. using a heading for the row names 'column', or omitting row
#' names altogether.
#'
#' @param leadingColName The name of the leading column, i.e. the 'row names'
#' of the dataframe. This could be a patient identifier or the well used in the
#' ddPCR experiment. If \code{NULL}, the exported heading will be an empty
#' string. Defaults to \code{NULL}.
#' @param row.names If \code{NULL}, exports a column corresponding to the row
#' names; if \code{FALSE}, no such column is included. If 'leadingColName' is
#' not \code{FALSE}, row.names is assumed to be \code{FALSE}. Defaults to
#' \code{TRUE}.
#'
#' @exportMethod exportTable

setMethod(
  "exportTable", "data.frame",
  function(theObject, location, delim=",",
           leadingColName=NULL, row.names=TRUE) {
    if(is.null(leadingColName)) {
      if(delim == ",") {
        write.csv(theObject, location, row.names=row.names)
      } else {
        write.table(theObject, location, sep=delim, col.names=NA,
                    row.names=row.names)
      }
    } else {
      # Insert the row names as the leading column and name it.
      d <- data.frame(rownames(theObject), theObject, check.names=FALSE)
      colnames(d)[1] <- leadingColName

      if(delim == ",") {
        write.csv(d, location, row.names=FALSE)
      } else {
        write.table(d, location, sep=delim, row.names=FALSE)
      }
    }
  }
)


#' @rdname exportTable
#'
#' @description If a \code{ddpcrWell} is given, \code{exportTable} exports to
#' a single file with specified/all classification methods.
#'
#' @param cMethod The name or column number of the classification methods in
#' a \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}} object to export
#' to file. If \code{NULL}, all of the classification methods are exported.
#' Defaults to \code{NULL}.
#'
#' @exportMethod exportTable

setMethod(
  "exportTable", "ddpcrWell",
  function(theObject, location, delim=",", cMethod=NULL) {
    df <- wellClassification(theObject, cMethod=cMethod, withAmplitudes=TRUE)
    exportTable(theObject=df, location=location, delim=delim,
                leadingColName=NULL, row.names=FALSE)
  }
)


#' @rdname exportTable
#'
#' @description If a \code{ddpcrPlate} is given, \code{exportTable}
#' exports to a directory in the given \code{location}, where one file is
#' created for each of the wells. If it does not exist, the directory
#' \code{location} will be created as long as all other parent directories
#' exist.
#'
#' @param prefix For \code{ddpcrPlate} objects, this is the prefix to
#' prepend to the output filenames.
#' @param suffix For \code{ddpcrPlate} objects, this is the suffix to
#' append to the output filenames. This is typically the filename extension,
#' e.g. ".csv" or ".txt". Defaults to ".csv".
#'
#' @exportMethod exportTable

setMethod(
  "exportTable", "ddpcrPlate",
  function(theObject, location, delim=",", cMethod=NULL, prefix="",
           suffix="_Amplitude.csv") {
    if(!dir.exists(location)) {
      dir.create(file.path(location))
    }

    # Get the data frame to export.
    df <- plateClassification(theObject, cMethod=cMethod, withAmplitudes=TRUE)

    # Export individual files.
    fNames <- vapply(
      names(theObject),
      function(w) {
        filePath <- paste0(location, "/", prefix, w, suffix)
        exportTable(theObject=df[[w]], location=filePath,
                    delim=delim, leadingColName=NULL,
                    row.names=FALSE)
        filePath
      },
      character(1)
    )
    invisible(fNames)
  }
)


#' @description \code{exportZip} takes a \code{ddpcrPlate} object and
#' exports it as a zip file.
#'
#' @rdname exportTable
#'
#' @export

setGeneric("exportZip",
  function(theObject, location, delim=",", cMethod=NULL, prefix="",
           suffix="_Amplitude.csv") {
    standardGeneric("exportZip")
  }
)

#' @rdname exportTable
#'
#' @exportMethod exportZip

setMethod("exportZip", "ddpcrPlate",
  function(theObject, location, delim=",", cMethod=NULL, prefix="",
           suffix="_Amplitude.csv") {
    # Remember where we are.

    # Get the absolute path of the file to export to.
    locDir <- normalizePath(dirname(location))
    locBase <- basename(location)
    location <- paste(locDir, locBase, sep="/")

    tryCatch({
      # Make a temporary directory and go there.
      tmpDir <- normalizePath(tempdir())
      if(!dir.exists(tmpDir))
        dir.create(file.path(tmpDir))
      owd <- setwd(tmpDir)
      on.exit(setwd(owd))  # return to the original working directory on exit

      # Create the zip file.
      outDirName <- dirname(location)
      if(!dir.exists(outDirName)) {
        dir.create(outDirName)
      }
      zipFile <- zip(zipfile=location,
                     files=exportTable(theObject=theObject, location=".",
                                       delim=delim, cMethod=cMethod,
                                       prefix=prefix, suffix=suffix))
      if(file.exists(paste0(location, ".zip"))) {
        file.rename(paste0(location, ".zip"), location)
      }
    },
    error=function(e) {
      stop(e)
    })
  }
)

#' @import methods
NULL

#' Round to at least n decimal places.
#'
#' For a data frame, if an extry is < 1, then round it to n significant
#' figures. If it is >= 1, then round it to n decimal places.
#'
#' @param df A data frame.
#' @param n How many decimal places/significant figures to round to.
#'
#' @return The data frame \code{x} with rounded entries.

.roundIt <- function(df, n=3) {
  for(cn in colnames(df)) {
    if(is.numeric(df[, cn])) {
      df[, cn] <-
        ifelse(abs(df[, cn]) < 1, signif(df[, cn], n), round(df[, cn], n))
    }
  }
  df
}


#' Get a vector of droplet positive and negative counts.
#'
#' Take a vector of classes and return a vector of positive and negative
#' counts that is compatible with ddPCR analysis.
#'
#' @param cl A vector of classes that correspond to droplet amplitude data. The
#' vector should only contain the values "PP", "PN", "NP" or "NN".
#'
#' @return A vector corresponding to "PP", "PN", "NP" and "NN".
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Take a data frame and make it into the right format.
#' aWell <- KRASdata[["E03"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#'
#' ## Count the number of droplets in each cluster.
#' positiveCounts(aWell$Cluster)
#'
#' @export

positiveCounts <- function(cl) {
  ppCount <- sum(cl == ddpcr$pp)
  pnCount <- sum(cl == ddpcr$pn)
  npCount <- sum(cl == ddpcr$np)
  nnCount <- sum(cl == ddpcr$nn)

  data.frame("PP"=ppCount, "PN"=pnCount, "NP"=npCount, "NN"=nnCount)
}


#' Counts the number of positives and negatives in an experiment and
#' produces estimates for the number of molecules.
#'
#' Takes a collection of classified droplets, each corresponding to a well, and
#' produces a list of positive/negative counts and estimates of how many
#' molecules are in each well.
#'
#' @param wells Either a \code{\link{ddpcrPlate}} object or a list of data
#' frames, each of which comprises droplet amplitudes and their corresponding
#' classifications in a given well.
#' @param ... Other options depending on the type of \code{wells}.
#' @param ch1Label The prefix to use for the channel 1 target. Defaults to
#' "Mt".
#' @param ch2Label The prefix to use for the channel 2 target. Defaults to
#' "Wt".
#' @param sortByLetter If \code{TRUE}, the resulting data frame is sorted by
#' the letter in the well names first, e.g. "A02" comes before "B01". If
#' \code{FALSE}, the result is sorted by the numeric component of the well
#' names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.
#'
#' @return A data frame with droplet counts and molecules number estimates for
#' each well.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Take a ddpcrPlate object and summarise its wells.
#' krasPlate <- ddpcrPlate(KRASdata)
#' plateSummary(krasPlate, cMethod="Cluster")
#'
#' @export

setGeneric(
  "plateSummary",
  function(wells, ..., ch1Label="Mt", ch2Label="Wt", sortByLetter=FALSE) {
    standardGeneric("plateSummary")
  }
)


#' @rdname plateSummary
#'
#' @exportMethod plateSummary

setMethod(
  "plateSummary", "list",
  function(wells, ch1Label="Mt", ch2Label="Wt", sortByLetter=FALSE) {
    # No wells; return an empty data frame.
    if(length(wells) == 0) {
      data.frame()
    } else {
      # Molecule counts.
      allCounts <- do.call(rbind, lapply(wells, positiveCounts))
      cs <- fullCountsSummary(
        data.frame(Well=names(wells), allCounts),
        ch1Label=ch1Label, ch2Label=ch2Label)

      # Sort the wells by letters or numbers first.
      cs <- sortDataFrame(cs, sortByLetter=sortByLetter)

      .roundIt(cs)
    }
  }
)


#' @rdname plateSummary
#'
#' @param cMethod The classification method to create a summary for.
#'
#' @exportMethod plateSummary

setMethod("plateSummary", "ddpcrPlate",
  function(wells, cMethod, ch1Label="Mt", ch2Label="Wt",
               sortByLetter=FALSE) {
    cl <- plateClassification(wells, cMethod=cMethod, withAmplitudes=TRUE)
    plateSummary(cl, ch1Label=ch1Label, ch2Label=ch2Label,
                 sortByLetter=sortByLetter)
  }
)

#' Return given well names sorted.
#'
#' Well names can be sorted according to the leading letter or the trailing
#' digit.
#'
#' @param wellNames The well names to sort.
#' @param sortByLetter If \code{TRUE}, the resulting list is sorted by the
#' letter in the well names first, e.g. "A02" comes before "B01". If
#' \code{FALSE}, the result is sorted by the numeric component of the well
#' names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.
#'
#' @return The well names sorted.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Use the KRASdata dataset as an example.
#' plate <- ddpcrPlate(wells=KRASdata)
#' wellNames <- names(plate)
#'
#' ## Sample sorting.
#' sortWells(wellNames=wellNames, sortByLetter=FALSE)
#' sortWells(wellNames=wellNames, sortByLetter=TRUE)
#'
#' @export sortWells

sortWells <- function(wellNames, sortByLetter) {
  if(sortByLetter) {
    wellNames[order(wellNames)]
  } else {
    wellNames[order(substr(wellNames, start=2, stop=3),
                    substr(wellNames, start=1, stop=1))]
  }
}


#' Sorts a data frame according to the well names.
#'
#' Well names can be sorted according to the leading letter or the trailing
#' digit.
#'
#' @param df A data frame with row names of the form A01, A02, B01, etc.
#' @param sortByLetter If \code{TRUE}, the resulting list is sorted by the
#' letter in the well names first, e.g. "A02" comes before "B01". If
#' \code{FALSE}, the result is sorted by the numeric component of the well
#' names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.
#'
#' @return The data frame \code{df} with the rows sorted.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Sort a subset of the KRAScounts data frame.
#' df <- KRAScounts[, c("Ratio", "FracAbun")]
#' sortDataFrame(df=df, sortByLetter=FALSE)
#' sortDataFrame(df=df, sortByLetter=TRUE)
#'
#' @export sortDataFrame

sortDataFrame <- function(df, sortByLetter=FALSE) {
  if(sortByLetter) {
    df[order(rownames(df)), ]
  } else {
    df[order(substr(rownames(df), start=2, stop=3),
             substr(rownames(df), start=1, stop=1)), ]
  }
}

#' @include global.R
#' @include themes.R
#' @include dropletPlot.R
#' @import methods
#' @import ggplot2
#' @import hexbin
NULL

#' @title Draw each of the individual wells in a ddPCR experiment.
#'
#' @description Plot each of the wells in a \code{\link{ddpcrPlate}} object or
#' a large data frame of droplets. By default, a density plot is returned for
#' speed purposes.
#'
#' @param droplets A \code{ddpcrPlate} object or a data frame of droplet
#' amplitudes with a "Well" column.
#' @param ch1Label The label for the channel 1 target. Defaults to "Ch1
#' Amplitude".
#' @param ch2Label The label for the channel 2 target. Defaults to "Ch2
#' Amplitude".
#' @param cMethod This should be the name or column number of \code{droplets}
#' corresponding to the classification to be plotted. This column should only
#' have entries in "NN", "PN", "NP, "PP", "Rain" and "N/A". If "None", plots
#' the droplets with all of them classified as \code{N/A}. If \code{NULL},
#' a density plot is plotted. Defaults to \code{NULL}.
#' @param binwidth The width of each hexagonal bin in the density plot. Ignored
#' if \code{cMethod} is not \code{NULL} (see \code{pointSize} instead).
#' Defaults to 100.
#' @param pointSize If \code{cMethod} is not \code{NULL}, this is the size to
#' draw each droplet. Otherwise this parameter is ignored (see \code{binwidth}
#' instead). Defaults to 0.1.
#' @param plotLimits A list of 2-element vectors with names \code{x} and
#' \code{y}. These are used to fix the x and y limits of the plot, which is
#' especially useful for comparing plots. Defaults to \code{list(x=c(1000,
#' 9000), y=c(3000, 13500))}.
#' @param showEmptyWells If \code{TRUE}, plots
#' a \code{\link[ggplot2]{facet_grid}} of all the wells in the plate, including
#' the empty ones. If \code{FALSE}, plots a \code{\link[ggplot2]{facet_wrap}}
#' of only the loaded (nonempty) wells. Defaults to \code{FALSE}.
#'
#' @return A collection of plots as a \code{\link[ggplot2]{ggplot}} object.
#'
#' @aliases allPlot plotAll
#'
#' @seealso By default, each subplot uses the same plotting style as
#' \code{\link{heatPlot}}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @references The nice log-scaled palette was achieved using
#' \url{http://www.everydayanalytics.ca/2014/09/5-ways-to-do-2d-histograms-in-r.html}
#'
#' @examples
#' ## Plot a facet wrap of density plots of each well.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' facetPlot(krasPlate)
#'
#' @export

setGeneric("facetPlot",
  function(droplets, ch1Label="Ch1 Amplitude", ch2Label="Ch2 Amplitude",
           cMethod=NULL, binwidth=100, pointSize=0.1,
           plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)),
           showEmptyWells=FALSE) {
    standardGeneric("facetPlot")
  }
)


#' @rdname facetPlot
#'
#' @importFrom RColorBrewer brewer.pal
#' @importFrom scales trans_format
#' @exportMethod facetPlot

setMethod("facetPlot", "data.frame",
  function(droplets,
           ch1Label="Ch1 Amplitude", ch2Label="Ch2 Amplitude",
           cMethod=NULL, binwidth=100, pointSize=0.1,
           plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)),
           showEmptyWells=FALSE) {
    if(!is.null(cMethod) &&
       (cMethod == "Well" || cMethod == which(colnames(droplets) == "Well"))) {
      stop("The parameter 'cMethod' should not be the 'Well' column.")
    } else if(!is.null(cMethod) && !cMethod %in% colnames(droplets)) {
      stop("'", cMethod, "' is not a valid 'cMethod' value.")
    }

    if(nrow(droplets) > 0) {
      droplets$WellLetter <-
        factor(substr(droplets$Well, start=1, stop=1), levels=LETTERS[1:8])
      droplets$WellDigit <-
        factor(substr(droplets$Well, start=2, stop=3),
               levels=formatC(1:12, width=2, format="d", flag="0"))

      # Use a nice palette.
      rf <- grDevices::colorRampPalette(
        rev(RColorBrewer::brewer.pal(11, 'Spectral')))
      r <- rf(32)

      # Draw the heat plot with the colours on a log scale.
      if(is.null(cMethod)) {
        p <- ggplot(droplets, aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude")) +
          stat_binhex(binwidth=c(binwidth,binwidth)) +
          scale_fill_gradientn(
            name="# droplets", colours=r, trans="log",
            labels=scales::trans_format(
              "identity", function(x) round(x, 0)))
      } else {
        # standard droplet plot
        p <- dropletPlot(droplets, cMethod=cMethod, pointSize=pointSize)
      }
      p <- p + expand_limits(x=plotLimits$x, y=plotLimits$y)

      # Display all of the wells or just the nonempty ones.
      if(showEmptyWells) {
        p <- p + facet_grid(WellLetter ~ WellDigit, drop=FALSE)
      } else {
        p <- p + facet_wrap(~ Well)
      }

      # Label the axes.
      p <- p + ylab(ch1Label)
      p <- p + xlab(ch2Label)

      # Theme options.
      p + whiteTheme() +
        theme(axis.text.x=element_text(angle=90, vjust=0.5, hjust=1))
    } else {
      dropletPlot(droplets, ch1Label=ch1Label, ch2Label=ch2Label,
                  plotLimits=plotLimits)
    }
  }
)

#' @rdname facetPlot
#'
#' @exportMethod facetPlot

setMethod("facetPlot", "ddpcrPlate",
  function(droplets,
           ch1Label="Ch1 Amplitude", ch2Label="Ch2 Amplitude",
           cMethod=NULL, binwidth=100, pointSize=0.1,
           plotLimits=list(x=c(1000, 9000), y=c(3000, 13500)),
           showEmptyWells=FALSE) {
    if(sum(numDroplets(droplets)) > 0) {
      cl <- do.call(rbind, plateClassification(droplets, wellCol=TRUE))
      facetPlot(cl,
                ch1Label=ch1Label, ch2Label=ch2Label,
                cMethod=cMethod, binwidth=binwidth, pointSize=pointSize,
                plotLimits=plotLimits, showEmptyWells=showEmptyWells)
    } else {
      dropletPlot(droplets, ch1Label=ch1Label, ch2Label=ch2Label,
                  plotLimits=plotLimits)
    }
  }
)

#' @title Classifying and summarising 2-d droplet digitial PCR (ddPCR) data.
#'
#' @description The \code{twoddpcr} package takes droplet amplitude data from 
#' Bio-Rad's QuantaSoft and can classify the droplets. A summary of the 
#' positive/negative droplet counts can be generated, which can then be used to 
#' estimate the number of molecules using the Poisson distribution.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

"_PACKAGE"

#' @import stats
NULL

#' K-means classify a data frame where the droplets are negative in the same
#' channels only.
#'
#' @param df A data frame corresponding to a well with droplets corresponding
#' only to "NN" and "NP" or "NN" and "PN".
#' @param channel The channel on which to classify (1 or 2).
#' @param minSeparation The minimum distance required between two cluster
#' centres in order for us to assume that k-means found two distinct clusters.
#' Defaults to 2000.
#' @param centres A data frame of centres. The data frame should have columns
#' \code{Ch1.Amplitude} and \code{Ch2.Amplitude} and row names corresponding
#' the cluster label, e.g. "NN", "NP", "PN" or "PP".
#' @param fullTable Whether to return a full table or just a vector. Defaults
#' to `TRUE`
#'
#' @return A classification for \code{df}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @importFrom stats dist

.classifyDfOnChannel <- function(df, channel, centres=NULL,
                                 minSeparation=2000, fullTable=TRUE) {
  # K-means classify with two clusters.
  km <- kmeansClassify(df, centres=centres, fullTable=fullTable)

  # If the cluster centres are too close, reject the classification
  # and use the original one.
  if(dist(km$centres[, channel]) >= minSeparation) {
    km$data
  } else {
    if(fullTable) {
      colnames(df)[3] <- "class"
      df
    } else {
      df$kmeans
    }
  }
}


#' K-means classify a list of data frames individually, where each data frame
#' comprises droplets that are negative in the same channels only.
#'
#' @param cl List of data frames, where each data frame corresponds to a well
#' with droplets corresponding only to "NN" and "NP" or "NN" and "PN".
#' @param channel The channel on which to classify (1 or 2).
#' @param minSeparation The minimum distance required between two cluster
#' centres in order for us to assume that k-means found two distinct clusters.
#' Defaults to 2000.
#' @param centres A data frame of centres. The data frame should have columns
#' \code{Ch1.Amplitude} and \code{Ch2.Amplitude} and row names corresponding
#' the cluster label, e.g. "NN", "NP", "PN" or "PP".
#' @param fullTable Whether to return a full table or just a vector. Defaults
#' to `TRUE`
#'
#' @return A classification for \code{cl}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.classifyOnChannel <- function(cl, channel, centres=NULL, minSeparation=2000,
                               fullTable=TRUE) {
  if(is.null(centres)) {
    if(channel == 1) {
      centres <- data.frame(Ch1.Amplitude=c(0, 10000), Ch2.Amplitude=c(0, 0))
      rownames(centres) <- c("NN", "PN")
    } else if(channel == 2) {
      centres <- data.frame(Ch1.Amplitude=c(0, 0), Ch2.Amplitude=c(0, 7000))
      rownames(centres) <- c("NN", "NP")
    }
  }

  lapply(cl, .classifyDfOnChannel, channel, centres, minSeparation, fullTable)
}


#' Normalise a well on one channel only and then transform it back to the
#' original (combined) scale.
#'
#' @param wellDf A data frame of the well's droplet amplitudes.
#' @param combinedCentres A data frame of the combined (average) centres of the
#' non-normalised wells.
#' @param wellCentres A data frame of centres corresponding to the given
#' \code{channel}.
#' @param channel An integer 1 or 2 corresponding to the channel that we are
#' interested in.
#'
#' @return A data frame with the rescaled amplitudes in the chosen channel.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.renormaliseByChannel <- function(wellDf, combinedCentres, wellCentres,
                                  channel) {
  if(!channel %in% c(1, 2)) {
    stop("The parameter 'channel' should be 1 or 2.")
  }

  # Select the well.
  s <- wellDf

  # Positive and negative cluster labels.
  n <- ddpcr$nn
  if(channel == 1) {
    ch <- "Ch1.Amplitude"
    p <- ddpcr$pn
  } else if(channel == 2) {
    ch <- "Ch2.Amplitude"
    p <- ddpcr$np
  }

  # Set transformation factors if they don't exist.
  if(is.na(wellCentres[n, ch])) {
    wellCentreN <- combinedCentres[n, ch]
  } else {
    wellCentreN <- wellCentres[n, ch]
  }

  if(is.na(wellCentres[p, ch])) {
    wellCentreP <- combinedCentres[p, ch]
  } else {
    wellCentreP <- wellCentres[p, ch]
  }

  # Transform.
  translFactor <- wellCentreN
  scaleFactor <- wellCentreP - wellCentreN
  rescaleFactor <- combinedCentres[p, ch] - combinedCentres[n, ch]
  retranslFactor <- combinedCentres[n, ch]

  s[, ch] <- s[, ch] - translFactor
  s[, ch] <- s[, ch] / scaleFactor
  s[, ch] <- s[, ch] * rescaleFactor
  s[, ch] <- s[, ch] + retranslFactor

  s
}


#' Normalise a well in both channels and then transform it back to the original
#' (combined) scale.
#'
#' @param allDf A list of data frames, where each one corresponds to a well's
#' droplet amplitudes.
#' @param well The name or number of the well to normalise.
#' @param combinedCentres A data frame of the combined (average) centres of the
#' non-normalised wells.
#' @param indivCentres1 A data frame of centres corresponding to channel 1.
#' @param indivCentres2 A data frame of centres corresponding to channel 2.
#'
#' @return A list of data frames with the rescaled amplitudes in both channels.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.renormaliseWell <- function(allDf, well, combinedCentres,
                             indivCentres1, indivCentres2) {
  s <- allDf[[well]]
  s <- .renormaliseByChannel(s, combinedCentres, indivCentres2[[well]],
                             channel=2)
  .renormaliseByChannel(s, combinedCentres, indivCentres1[[well]], channel=1)
}


#' Find the centres of each of the wells in a given channel.
#'
#' The plate should have been classified by k-means clustering.
#'
#' @param plate A \code{ddpcrPlate} object from which to extract the centres.
#' @param cMethod The classification method to use (in the form of a character
#' string).
#' @param channel An integer 1 or 2 corresponding to the channel of interest.
#' @param minSeparation The minimum distance required between two cluster
#' centres in order for us to assume that k-means found two distinct clusters.
#' Defaults to 2000.
#'
#' @return A list of data frames, where each data frame has information about
#' the centres in the channel of interest.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.getChannelCentres <- function(plate, cMethod, channel, minSeparation=2000) {
  if(channel == 1) {
    toRemove <- c("NP", "PP")
  } else if(channel == 2) {
    toRemove <- c("PN", "PP")
  } else {
    stop("The parameter 'channel' should be 1 or 2.")
  }

  # Remove the unneeded droplets.
  cl <- removeDropletClasses(plate, cMethod=cMethod, classesToRemove=toRemove)
  cl <- .classifyOnChannel(cl, channel=channel, minSeparation=minSeparation)
  clusterCentres(ddpcrPlate(cl), cMethod="class")
}


#' @title Normalise all wells in a plate to the overall/average cluster
#' positions.
#'
#' @description Each well is scaled in the direction of the two axes
#' independently. The algorithm works as follows:
#' \enumerate{
#'   \item Classify the entire plate using k-means clustering in order to
#'     roughly identify clusters.
#'   \item For each channel and each well:
#'     \enumerate{
#'       \item Remove the positive clusters in the other channel.
#'       \item Re-run k-means clustering with \eqn{k = 2} to obtain new
#'         cluster centres. If the centres are too close (default distance
#'         2000), reject these new cluster centres and use the old centres.
#'       \item Use the new centres for each well to rescale to the same scale
#'       as the average/overall scale.
#'     }
#' }
#'
#' @param plate A \code{ddpcrPlate} object.
#' @param initialCentres A matrix or data frame of (rough estimates) of centres
#' of each of the clusters in the combined data. This will be used for an
#' initial run of k-means clustering.
#' @param minSeparation The minimum distance required between two cluster
#' centres in order for us to assume that k-means clustering found two distinct
#' clusters. This is used when classifying droplets along a single channel and
#' helps to reject classifications where there is only one cluster, e.g. when
#' there are no mutants in a well. Defaults to 2000.
#'
#' @return A list of data frames with the rescaled amplitudes in both channels.
#'
#' @name renormalisePlate
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Normalise the KRAS data.
#' plate <- ddpcrPlate(wells=KRASdata)
#' normPlate <- renormalisePlate(plate)
#'
#' @export

renormalisePlate <- function(plate,
                             initialCentres=matrix(c(0, 0, 10000, 0,
                                                     0, 7000, 10000, 7000),
                                                   ncol=2, byrow=TRUE),
                             minSeparation=2000) {
  # Classify everything first and get the combined centres.
  plate <- kmeansClassify(plate, centres=initialCentres)
  combCentres <- combinedCentres(plate, cMethod="kmeans")

  # Get the centres for the WT/Mut-only classification
  indivCentres1 <- .getChannelCentres(plate, cMethod="kmeans", channel=1,
                                      minSeparation=minSeparation)
  indivCentres2 <- .getChannelCentres(plate, cMethod="kmeans", channel=2,
                                      minSeparation=minSeparation)

  # Get all of the droplet amplitudes.
  clAll <- plateClassification(plate, cMethod="kmeans", withAmplitudes=TRUE)

  # Renormalise each of the wells.
  normAll <- lapply(names(clAll),
                    .renormaliseWell, allDf=clAll, combinedCentres=combCentres,
                    indivCentres1=indivCentres1, indivCentres2=indivCentres2)

  ddpcrPlate(setNames(normAll, names(clAll)))
}

#' @import methods
#' @importFrom S4Vectors isEmpty
NULL

#' Retrieve the number of droplets.
#'
#' Retrieves the number of droplets in a \code{\link{ddpcrWell}} or
#' \code{\link{ddpcrPlate}} object.
#'
#' @param theObject A \code{\link{ddpcrPlate}} object.
#' @param ... Other parameters depending on the type of \code{theObject}.
#'
#' @return For \code{ddpcrWell} objects, return the number of droplets as an
#' integer.
#'
#' @name numDroplets
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @aliases numberDroplets numDrops numberDrops numberOfDroplets numOfDroplets
#' numberOfDrops
#'
#' @examples
#' ## Count the number of droplets in a well.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' numDroplets(aWell)
#'
#' @export

setGeneric("numDroplets", function(theObject, ...) {
  standardGeneric("numDroplets")
})

#' @rdname numDroplets
#'
#' @exportMethod numDroplets

setMethod("numDroplets", "ddpcrWell", function(theObject) {
  nrow(theObject@dropletAmplitudes)
})


#' @rdname numDroplets
#'
#' @return For \code{ddpcrPlate} objects, return a named vector. The names
#' correspond to a well name and each item corresponding to the number of
#' droplets in that well.
#'
#' @examples
#' ## Get all of the wells in a named vector.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' (numberDroplets <- numDroplets(krasPlate))
#' sum(numberDroplets)
#'
#' ## We can choose to get a subset of the wells.
#' (numberDroplets <- numDroplets(krasPlate[c("H03", "A04")]))
#' sum(numberDroplets)
#'
#' @exportMethod numDroplets

setMethod("numDroplets", "ddpcrPlate", function(theObject) {
  # Handle the special case where there are no wells.
  if(length(theObject) == 0) {
    return(c())
  }

  vapply(theObject, numDroplets, numeric(1))
})


#' Is a \code{\link{ddpcrWell}} object empty?
#'
#' Returns a logical value as to whether the given object has no
#' droplets/wells.
#'
#' @param x An object to test for emptiness.
#'
#' @return A logical value.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Check that an empty ddpcrPlate object is in fact empty.
#' krasPlate <- ddpcrPlate(wells=list())
#' isEmpty(krasPlate)
#'
#' ## Now add some amplitude data and check that is not empty.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' isEmpty(krasPlate)
#'
#' @rdname ddpcrWell-methods
#'
#' @exportMethod isEmpty

setMethod("isEmpty", "ddpcrWell", function(x) {
  if(numDroplets(x) == 0) {
    return(TRUE)
  } else {
    return(FALSE)
  }
})


#' @rdname ddpcrWell-methods
#'
#' @exportMethod isEmpty

setMethod("isEmpty", "ddpcrPlate", function(x) {
  if(length(x) == 0) {
    return(TRUE)
  } else {
    return(sum(numDroplets(x)) == 0)
  }
})

#' @include ddpcrPlate.R
#' @include ddpcrWell.R
#' @import methods
#'
NULL

#' Retrieve the cluster centres.
#'
#' @description \code{clusterCentres} retrieves the cluster centres for
#' a \code{\link{ddpcrWell}} object or the centres for each well in
#' a \code{\link{ddpcrPlate}} object.
#'
#' @param theObject A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
#' object.
#' @param cMethod The classification method for which to obtain the centres.
#'
#' @return If a \code{ddpcrWell} object is given, \code{clusterCentres} returns
#' the cluster centres as a data frame.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get the centres of a sample with 4 clusters.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' clusterCentres(aWell, "Cluster")
#'
#' ## Get the centres of a sample with 3 clusters.
#' aWell <- ddpcrWell(well=KRASdata[["H04"]])
#' clusterCentres(aWell, "Cluster")
#'
#' ## Retrieve the cluster centres of each of the wells in a \code{ddpcrPlate}
#' ## object.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' clusterCentres(krasPlate, cMethod="Cluster")
#'
#' ## Retrieve the cluster centres of all wells combined.
#' combinedCentres(krasPlate, cMethod="Cluster")
#'
#' @name clusterCentres
#'
#' @aliases clusterCenters wellCentres wellCenters
#'
#' @export

setGeneric("clusterCentres", function(theObject, cMethod) {
  standardGeneric("clusterCentres")
})

#' @rdname clusterCentres
#'
#' @exportMethod clusterCentres

setMethod("clusterCentres", "ddpcrWell", function(theObject, cMethod) {
  wellCl <- wellClassification(theObject, withAmplitudes=TRUE)
  classMeans(wellCl, classCol=cMethod)
})

#' @rdname clusterCentres
#'
#' @return If a \code{ddpcrPlate} object is given, \code{clusterCentres} return
#' a list of data frames, where each data frame corresponds to the cluster
#' centres of a well.
#'
#' @aliases plateCentres plateCenters
#'
#' @exportMethod clusterCentres

setMethod("clusterCentres", "ddpcrPlate", function(theObject, cMethod) {
  lapply(theObject, clusterCentres, cMethod)
})


#' @rdname clusterCentres
#'
#' @description \code{combinedCentres} retrieves the cluster centres for all of
#' the wells together.
#'
#' @return \code{combinedCentres} returns a data frame of the centres of all of
#' the wells combined.
#'
#' @aliases combinedCenters combinedPlateCentres combinedPlateCenters
#'
#' @export

setGeneric("combinedCentres", function(theObject, cMethod) {
  standardGeneric("combinedCentres")
})

#' @rdname clusterCentres
#'
#' @exportMethod combinedCentres

setMethod("combinedCentres", "ddpcrPlate", function(theObject, cMethod) {
  cl <- do.call(rbind, plateClassification(theObject, withAmplitudes=TRUE))
  classMeans(cl, classCol=cMethod)
})

#' @import ggplot2
NULL

#' Use a theme with a white background and grey lines.
#'
#' The default \code{\link[ggplot2]{ggplot}} theme has a grey background. This
#' layer can be added to change the aesthetics.
#'
#' @param legendPosition Where to position the legend. This can be "none",
#' "left", "right", "bottom", "top" or a numeric vector of length two. See the
#' documentation for \code{\link[ggplot2]{theme}}.
#' @param legendJustification The justification to use for the legend
#' positioning. This should be "center" or a two-element vector. Defaults to
#' "center".
#'
#' @return A \code{ggplot} theme layer.
#'
#' @seealso This function uses \code{\link[ggplot2]{theme}}.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Get a data frame in the right format.
#' aWell <- KRASdata[["E03"]]
#' aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
#'
#' ## Plot it with the white theme.
#' ggplot2::ggplot(aWell, ggplot2::aes(x=Ch2.Amplitude, y=Ch1.Amplitude)) +
#'   ggplot2::geom_point(ggplot2::aes(colour=Cluster)) +
#'   whiteTheme()
#'
#' @export

whiteTheme <- function(legendPosition="right", legendJustification="center") {
  theme_bw(base_family="Helvetica") +
    theme(panel.grid.major=element_line(size=.5, color="grey"),
      axis.line=element_line(size=.7, color="black"),
      legend.position=legendPosition,
      legend.justification=legendJustification)
}

#' @import methods
NULL

#' @title K-means classify the wells in a \code{ddpcrWell} or
#' \code{ddpcrPlate} object, or in a data frame.
#'
#' @param droplets A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
#' object, or a data frame with columns \code{Ch1.Amplitude} and
#' \code{Ch2.Amplitude}.
#' @param centres Either:
#' \itemize{
#'   \item A matrix corresponding to the initial centres to use for the k-means
#'   algorithm; or
#'   \item An integer corresponding to the number of clusters. If this is set,
#'   the initial centres are randomly set.
#' }
#' Defaults to \code{matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000), ncol=2,
#' byrow=TRUE)}
#' @param ... Other options depending on the type of \code{droplets}.
#'
#' @return An object with the new classification.
#'
#' @seealso This method uses the \code{\link[stats]{kmeans}} function.
#' @seealso To manually set and retrieve classifications, use the
#' \code{\link{wellClassification}}, \code{\link{plateClassification}} and
#' \code{\link{plateClassificationMethod}} methods.
#' @seealso For a supervised classification approach, one may want to consider
#' \code{\link{knnClassify}}.
#'
#' @name kmeansClassify
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ### Use the KRASdata dataset for all of these examples.
#'
#' ## Use K-means clustering to classify droplets into four (the default
#' ## number) classes.
#' aWell <- kmeansClassify(KRASdata[["E03"]])
#'
#' ## We can look the the classification or the centres.
#' head(aWell$data)
#' aWell$centres
#'
#' ## Specify 3 centres for a different sample in KRASdata.
#' aWell <- kmeansClassify(KRASdata[["H04"]], centres=3)
#' head(aWell$data)
#'
#' ## We can be more specific with the choice of centres.
#' aWell <- kmeansClassify(KRASdata[["H04"]],
#'                        centres=matrix(c(5000, 1500, 5500, 7000, 10000,
#'                                         2000), ncol=2, byrow=TRUE))
#'
#' ## We can use \code{ddpcrWell} objects directly as a parameter.
#' aWell <- ddpcrWell(well=KRASdata[["E03"]])
#' kmeansClassify(aWell)
#'
#' ## We can take multiple samples in a \code{ddpcrPlate} object and
#' ## classify everything together.
#' krasPlate <- ddpcrPlate(wells=KRASdata)
#' kmeansClassify(krasPlate)
#'
#' @export kmeansClassify

setGeneric("kmeansClassify",
  function(droplets,
           centres=matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000),
                          ncol=2, byrow=TRUE),
           ...) {
    standardGeneric("kmeansClassify")
  }
)


#' @rdname kmeansClassify
#'
#' @description If \code{droplets} is a data frame, the droplets are classified
#' using the k-means clustering algorithm.
#'
#' @param fullTable If \code{TRUE}, returns a full data frame of droplets and
#' their classification; if \code{FALSE}, simply returns a factor corresponding
#' to this classification. Defaults to \code{TRUE}.
#'
#' @return If \code{droplets} is a data frame, a list is returned with the
#' following components:
#'   \item{data}{A data frame or vector corresponding to the classification.}
#'   \item{centres}{A data frame listing the final centre points from the
#'   k-means algorithm with the corresponding cluster labels.}
#'
#' @importFrom stats kmeans
#' @exportMethod kmeansClassify

setMethod(
  "kmeansClassify", "data.frame",
  function(droplets,
           centres=matrix(c(0, 0, 10000, 0, 0, 7000, 10000,
                            7000), ncol=2, byrow=TRUE),
           fullTable=TRUE) {
    if(is.matrix(centres) || is.data.frame(centres)) {
      if(nrow(centres) == 0 || nrow(centres) > 4) {
        stop("The parameter 'centres' should be a matrix with 1, 2, 3 or 4 ",
             "rows.")
      }
    } else if(is.numeric(centres) && centres %% 1 == 0) {
      if(centres <= 0 || centres > 4) {
        stop("The parameter 'centres' should be 1, 2, 3, 4 or a matrix.")
      }
    } else {
      stop("The parameter 'centres' should be a matrix or integer.")
    }

    # Use the k-means algorithm to classify.
    fit <- kmeans(droplets[, c("Ch1.Amplitude", "Ch2.Amplitude")], centres)
    df <- data.frame("Ch1.Amplitude"=droplets$Ch1.Amplitude,
                     "Ch2.Amplitude"=droplets$Ch2.Amplitude,
                     "class"=fit$cluster)

    # Get the centres of the clusters found by k-means.
    finalCentres <- data.frame(fit$centers,
                               "class"=c(seq_len(nrow(fit$centers))))

    # Relabel everything.
    if(!is.null(rownames(centres)) &
       all(rownames(centres) %in% ddpcr$classes)) {
      df$class <- relabelClasses(df, presentClasses=rownames(centres))
      finalCentres$class <-
        relabelClasses(finalCentres, presentClasses=rownames(centres))
    } else {
      df$class <- relabelClasses(df)
      finalCentres$class <- relabelClasses(finalCentres)
    }

    if(fullTable) {
      list(data=df, centres=finalCentres)
    } else {
      list(data=df$class, centres=finalCentres)
    }
  }
)


#' @rdname kmeansClassify
#'
#' @description For \code{ddpcrWell}, the droplets are classified by using the
#' k-means clustering algorithm.
#'
#' @exportMethod kmeansClassify

setMethod("kmeansClassify", "ddpcrWell",
  function(droplets, centres=matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000),
                                    ncol=2, byrow=TRUE)) {
    # Get new classification and assign it.
    df <- amplitudes(droplets)
    km <- kmeansClassify(df, centres=centres, fullTable=FALSE)
    wellClassification(droplets, "kmeans") <- km$data

    validObject(droplets)
    return(droplets)
  }
)


#' @rdname kmeansClassify
#'
#' @description For \code{ddpcrPlate}, all of the wells are combined and
#' classified, with this new classification assigned to the
#' \code{ddpcrPlate} object.
#'
#' @exportMethod kmeansClassify

setMethod("kmeansClassify", "ddpcrPlate",
  function(droplets, centres=matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000),
                                    ncol=2, byrow=TRUE)) {
    # Combine everything and classify.
    df <- do.call(rbind, amplitudes(droplets))
    km <- kmeansClassify(df, centres=centres, fullTable=FALSE)
    plateClassification(droplets, "kmeans") <- km$data

    validObject(droplets)
    return(droplets)
  }
)

#' @title Droplet amplitude data for KRAS mutant and wild type molecules.
#'
#' @description A data frame of ddPCR droplet amplitudes using KRAS cell lines 
#' and pre-defined mutant/wild type ratios. The existing classification under 
#' the column name \code{Cluster} was obtained from Bio-Rad's QuantaSoft by 
#' setting the \code{Ch1.Amplitude} threshold to \code{6789} and the 
#' \code{Ch2.Amplitude} threshold to \code{3000}.
#'
#' @docType data
#'
#' @usage data(KRASdata)
#'
#' @format A list of data frames, each of which has columns 
#' \code{Ch1.Amplitude}, \code{Ch2.Amplitude} and \code{Cluster}.
#'
#' @return A data frame.
#'
#' @author From ddPCR experiments run by Mahmood Ayub, 
#' \email{mahmood.ayub@cruk.manchester.ac.uk}
#'
#' @keywords datasets

"KRASdata"

#' Get the very basic columns of a data frame.
#'
#' It is useful to see the droplet counts for each class in addition to the
#' overall droplet count at a glance.
#'
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#'
#' @return A data frame with the \code{PP}, \code{PN}, \code{NP}, \code{NN} and
#' \code{AcceptedDroplets} figures.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' df <- fullCountsSummary(KRAScountsQS)
#' basicsSummary(df)
#'
#' @export

basicsSummary <- function(df) {
  df[, c("PP", "PN", "NP", "NN", "AcceptedDroplets")]
}


#' Get the mutant copies per 20ul of a data frame.
#'
#' Returns a data frame with the number of mutant copies per 20ul.
#'
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#'
#' @return A data frame with the basic columns and mutant copies per 20ul.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.getMutCopies <- function(df) {
  data.frame("MUT"=c("MUT"), "Copies/20ul"=df$MtCopiesPer20uLWell,
             check.names=FALSE)
}


#' Get the mutant copies per 20ul of a data frame in the context of the
#' basic counts.
#'
#' Returns a data frame with the basic figures and the number of mutant copies
#' per 20ul.
#'
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#'
#' @return A data frame with the basic columns and mutant copies per 20ul.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' df <- fullCountsSummary(KRAScountsQS)
#' mutantCopiesSummary(df)
#'
#' @export

mutantCopiesSummary <- function(df) {
  if(!.isWideForm(df)) {
    stop("Input data frame is of the wrong format. ",
         "Try castMtWt first.")
  }
  data.frame(basicsSummary(df), .getMutCopies(df), check.names=FALSE)
}


#' Get the wild type copies per 20ul of a data frame.
#'
#' Returns a data frame with the number of wild type copies per 20ul.
#'
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#'
#' @return A data frame with the basic columns and wild type copies per 20ul.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.getWtCopies <- function(df) {
  data.frame("WT"=c("WT"), "Copies/20ul"=df$WtCopiesPer20uLWell,
             check.names=FALSE)
}


#' Get the wild type copies per 20ul of a data frame in the context of the
#' basic counts.
#'
#' Returns a data frame with the basic figures and the number of wild type
#' copies per 20ul.
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#'
#' @return A data frame with the basic columns and wild type copies per 20ul.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' df <- fullCountsSummary(KRAScountsQS)
#' wildTypeCopiesSummary(df)
#'
#' @export

wildTypeCopiesSummary <- function(df) {
  if(!.isWideForm(df)) {
    stop("Input data frame is of the wrong format. ",
         "Try castMtWt first.")
  }
  data.frame(basicsSummary(df), .getWtCopies(df), check.names=FALSE)
}


#' Get the total number of molecules in 20ul.
#'
#' Get the total number of copies of mutant and wild type molecules in a 20ul
#' well.
#'
#' @param df An input data frame with copies per 20ul figures.
#'
#' @return A vector listing the total numbers of copies per 20ul well.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.totalCopies <- function(df) {
  if(is.null(df$TotalCopiesPer20uLWell)) {
    df$MtCopiesPer20uLWell + df$WtCopiesPer20uLWell
  } else {
    df$TotalCopiesPer20uLWell
  }
}


#' Get a summary of the number of molecules in 20ul.
#'
#' Returns a data frame with a summary of the number of mutant and wild type
#' copies per 20ul.
#'
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#'
#' @return A data frame with mutant and wild type copies per 20ul, the total
#' number of copies per 20ul, and a flag indicating if there are more than
#' 2 mutant copies per 20ul.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

.getAllSummary <- function(df) {
  data.frame("MA Calc"=c("MA Calc"),
             "MUT Copies/20ul"=df$MtCopiesPer20uLWell,
             "WT Copies/20ul"=df$WtCopiesPer20uLWell,
             "Total Copies/20ul"=.totalCopies(df),
             "%MUT"=df$FracAbun,
             "MUT Copies > 2"=ifelse(df$MtCopiesPer20uLWell>2, 1, 0),
             check.names=FALSE)
}


#' Get the total copies per 20ul of a data frame in the context of the
#' basic counts.
#'
#' Returns a data frame with the basic figures and a summary of the number of
#' copies per 20ul.
#'
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#'
#' @return A data frame with the basic data columns, mutant and wild type
#' copies per 20ul, the total number of copies per 20ul, and a flag indicating
#' if there are more than 2 mutant copies per 20ul.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' df <- fullCountsSummary(KRAScountsQS)
#' copiesSummary(df)
#'
#' @export

copiesSummary <- function(df) {
  if(!.isWideForm(df)) {
    stop("Input data frame is of the wrong format. ",
         "Try castMtWt first.")
  }
  data.frame(basicsSummary(df), .getAllSummary(df), check.names=FALSE)
}


#' Get all of the counts data in a summarised data frame.
#'
#' Returns a data frame with all the copies information, plus any optional
#' columns. This function is intended to be used as a final summary of the
#' molecule counts.
#'
#' @param df A data frame generated by \code{\link{fullCountsSummary}}.
#' @param extraCols A vector of column names from \code{df} to include. If
#' \code{NULL}, no extra columns are added. Defaults to \code{NULL}.
#'
#' @return A data frame with the basic figures, the mutant counts, the wild
#' type counts, the summarised counts, and extraCols if specified. Prints an
#' additional column for notes, indicating whether this run failed or if there
#' were fewer than 8000 accepted droplets.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' df <- fullCountsSummary(KRAScountsQS)
#' fullCopiesSummary(df)
#'
#' @export

fullCopiesSummary <- function(df, extraCols=NULL) {
  if(!.isWideForm(df)) {
    stop("Input data frame is of the wrong format. ",
         "Try castMtWt first.")
  }

  # Build a data frame with the details of the copies plus extra columns.
  d <- data.frame(basicsSummary(df), .getMutCopies(df), .getWtCopies(df),
                  .getAllSummary(df), check.names=FALSE)

  # Include any extra columns.
  if(!is.null(extraCols)) {
    d <- data.frame(d,
                    df[, extraCols],
                    "Total Copies/20ul"=.totalCopies(df),
                    check.names=FALSE)
  }

  # Add some notes to the end.
  d$Notes <- ifelse(is.na(df$AcceptedDroplets),
               "Not done",
             ifelse(df$AcceptedDroplet == 0,
               "Failed",
             ifelse(df$AcceptedDroplets <= 8000,
               "<= 8000 droplets",
             "None")))
  d
}

#' @import methods
NULL

#' Checks whether an object is a data frame with two leading double columns.
#'
#' @param df A data frame.
#'
#' @return A logical value: whether the data frame meets the criteria.

.isTwoDimDataFrame <- function(df) {
  return(is.data.frame(df) && ncol(df) >= 2 &&
         is.numeric(df[, 1]) && is.numeric(df[, 2]))
}

#' Rename the channels.
#'
#' We use the channel names "Ch1.Amplitude" and "Ch2.Amplitude" by default.
#' This method allows us to change it at will.
#'
#' @param droplets A data frame or list of data frames. Each data frame should
#' have at least two columns, where the first two columns should be vectors of
#' doubles.
#' @param ch1 The channel 1 label.
#' @param ch2 The channel 2 label.
#'
#' @return The object \code{droplets} with the channels renamed.
#'
#' @name setChannelNames
#'
#' @examples
#' ## Ensure that a data frame has channels named "Ch1.Amplitude" and
#' ## "Ch2.Amplitude".
#' aWell <- KRASdata[["E03"]]
#' aWell <- setChannelNames(aWell)
#' colnames(aWell)
#'
#' ## Perhaps we want to abbreviate the channel names.
#' aWell <- setChannelNames(aWell, "Ch1", "Ch2")
#' colnames(aWell)
#'
#' ## The same operator works for a list of data frames.
#' krasWells <- KRASdata
#' krasWells <- setChannelNames(krasWells, "Ch1", "Ch2")
#' lapply(krasWells, colnames)[1:3]
#'
#' @export

setGeneric("setChannelNames",
  function(droplets, ch1="Ch1.Amplitude", ch2="Ch2.Amplitude") {
    standardGeneric("setChannelNames")
  }
)


#' @rdname setChannelNames
#'
#' @exportMethod setChannelNames

setMethod("setChannelNames", "data.frame",
  function(droplets, ch1="Ch1.Amplitude", ch2="Ch2.Amplitude") {
    if(.isTwoDimDataFrame(droplets)) {
      colnames(droplets)[1:2] <- c(ch1, ch2)
      droplets
    } else {
      stop("Not all data frames represent 2-d droplet amplitudes.")
    }
  }
)


#' @rdname setChannelNames
#'
#' @exportMethod setChannelNames

setMethod("setChannelNames", "list",
  function(droplets, ch1="Ch1.Amplitude", ch2="Ch2.Amplitude") {
    if(all(vapply(droplets, class, character(1)) == "data.frame")) {
      lapply(droplets, setChannelNames, ch1=ch1, ch2=ch2)
    } else {
      stop("Not all of the list elements are data frames.")
    }
  }
)

#' An environment for package variables.
#'
#' Stores default variables used in the package.
#'
#' @return An environment for storing package variables.
#'
#' @export
ddpcr <- new.env()

# Global class names.
ddpcr$nn <- "NN"
ddpcr$pn <- "PN"
ddpcr$np <- "NP"
ddpcr$pp <- "PP"
ddpcr$rain <- "Rain"
ddpcr$na <- "N/A"
ddpcr$classes <- c(ddpcr$nn, ddpcr$np, ddpcr$pn, ddpcr$pp)
ddpcr$classesRain <- c(ddpcr$classes, ddpcr$rain, ddpcr$na)

# Colour-blind-friendly palette.
ddpcr$dropColours <- c("#0072B2", "#CC79A7", "#009E73", "#E69F00",
                       "#999999", "#999999")
names(ddpcr$dropColours) <- ddpcr$classesRain

ddpcr$dropletVolume <- 0.00085   # This is the volume given by Bio-Rad.


#' Set the droplet volume in microlitres (ul).
#'
#' Change the volume of droplets used in the ddPCR experiment.
#'
#' @param volume The new volume of each droplet. Defaults to 0.00085, which is
#' the default given by Bio-Rad.
#'
#' @return Sets the internal droplet volume.
#'
#' @aliases setDropVolume setDropletVol setDropVol
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Change the droplet volume.
#' ddpcr$dropletVolume
#' setDropletVolume(0.00091)
#' ddpcr$dropletVolume
#'
#' @export

setDropletVolume <- function(volume=0.00085) {
  ddpcr$dropletVolume <- volume
}

#' @import methods
#' @import ggplot2
NULL

#' @title ggplot methods for the \code{\link{ddpcrWell}} and
#' \code{\link{ddpcrPlate}} classes.
#'
#' @description These functions work in the same way as the original
#' \code{\link[ggplot2]{ggplot}} method, but handles the coercion of the object
#' into a data frame.
#'
#' @param data A \code{ddpcrWell} or \code{ddpcrPlate} object.
#' @param mapping A list of aesthetic mappings to use for the plot. Defaults to
#' \code{ggplot2::aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude",
#' colour=cMethod)}, where \code{cMethod} is taken from the parameter of the
#' same name.
#' @param cMethod The name or column number of the classification to use. This
#' is renamed internally to "class" for use with \code{mapping}. Defaults to
#' "None".
#' @param ... Other arguments passed onto \code{\link[ggplot2]{ggplot}}.
#' @param environment Where to look if a mapping variable is not defined.
#' Defaults to \code{parent.frame()}, i.e. the environment in which
#' \code{ggplot.well()} or \code{ggplot.multiwell()} is called.
#'
#' @return A \code{\link[ggplot2]{ggplot}} object using the slots in the given
#' object.
#'
#' @name ggplot.well
#'
#' @aliases ggplot.well ggplot.wells ggplot.plate ggplot.multiwell
#'
#' @seealso \code{\link{dropletPlot}} builds upon these \code{ggplot} methods
#' to plot droplet amplitude plots with a colour-blind friendly palette.
#' @seealso The original \code{\link[ggplot2]{ggplot}} method in the
#' \code{ggplot2} package is used internally.
#'
#' @author Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
#'
#' @examples
#' ## Plot the droplets in one well.
#' library(ggplot2)
#' aWell <- ddpcrWell(KRASdata[["E03"]])
#' ggplot.well(aWell, cMethod="Cluster") + geom_point()
#'
#' ## Plot the droplets in all of the wells in a single plot.
#' krasPlate <- ddpcrPlate(KRASdata)
#' ggplot.plate(krasPlate, cMethod="Cluster") + geom_point()
#'
#' @export

setGeneric(
  "ggplot.well",
  function(data, mapping=aes_string(x="Ch2.Amplitude",
                                    y="Ch1.Amplitude",
                                    colour=cMethod),
           cMethod=NULL, ..., environment=parent.frame()) {
    standardGeneric("ggplot.well")
  }
)

#' @rdname ggplot.well
#'
#' @description \code{ggplot.well} is a \code{\link[ggplot2]{ggplot}} method
#' for the \code{\link{ddpcrWell}} class.
#'
#' @exportMethod ggplot.well

setMethod("ggplot.well", "ddpcrWell",
  function(data, mapping=aes_string(x="Ch2.Amplitude",
                                    y="Ch1.Amplitude",
                                    colour=cMethod),
           cMethod="None", ..., environment=parent.frame()) {
    if(numDroplets(data) == 0) {
      # Nothing to plot. To stop things breaking, remove references to
      # a meaningless 'colour' aesthetic.
      mapping <- mapping[Filter(Negate(function(k) { k == "colour" }),
                                names(as.list(mapping)))]
      ggplot(data.frame("Ch1.Amplitude"=double(), "Ch2.Amplitude"=double()),
             mapping, ...)
    } else {
      # Standard ggplot object.
      data <- wellClassification(data, cMethod=cMethod, withAmplitudes=TRUE)
      ggplot(data, mapping, ...)
    }
  }
)


#' @rdname ggplot.well
#'
#' @export

setGeneric(
  "ggplot.plate",
  function(data, mapping=aes_string(x="Ch2.Amplitude",
                                    y="Ch1.Amplitude",
                                    colour=class),
           cMethod="None", ..., environment=parent.frame()) {
    standardGeneric("ggplot.plate")
  }
)

#' @rdname ggplot.well
#'
#' @description \code{ggplot.multiwell} is a \code{\link[ggplot2]{ggplot}}
#' method for the \code{\link{ddpcrPlate}} class.
#'
#' @exportMethod ggplot.plate

setMethod(
  "ggplot.plate", "ddpcrPlate",
  function(data, mapping=aes_string(x="Ch2.Amplitude",
                                    y="Ch1.Amplitude",
                                    colour=cMethod),
           cMethod="None", ..., environment=parent.frame()) {
    if(sum(numDroplets(data)) == 0) {
      # Remove references to colour.
      mapping <- mapping[Filter(Negate(function(k) { k == "colour" }),
                                names(as.list(mapping)))]
      ggplot(data.frame("Ch1.Amplitude"=double(), "Ch2.Amplitude"=double()),
             mapping, ...)
    } else {
      data <- plateClassification(data, cMethod=cMethod, withAmplitudes=TRUE)
      data <- do.call(rbind, data)
      ggplot(data, mapping, ...)
    }
  }
)

#' A Shiny environment.
#'
#' Stores modes used the in Shiny UI and internal defaults.
#'
#' @return An environment for storing Shiny variables.
#'
#' @export
shinyVis <- new.env()

# Modes.
shinyVis$classifyModes <- c("K-means Clustering", "Thresholds",
                            "Grid", "K-Nearest Neighbour")

# Thresholds for gating and all plots.
shinyVis$threshDefault <- list(ch1=7000, ch2=3500)
shinyVis$threshLimits <- list(ch1=list(min=3000, max=13500),
                              ch2=list(min=1000, max=9000))

context("Removing droplet classes")

# Dummy data set with classification to check.
df <- data.frame("Ch1.Amplitude"=c(1, 2, 3, 4, 5, 6),
                 "Ch2.Amplitude"=c(1, 2, 3, 4, 5, 6),
                 "class"=c("NN", "NP", "PN", "PP", "N/A", "Rain"))

test_that("Classes are correctly removed (without rain)", {
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c(),
                                keepUnclassified=FALSE)
    as.character(res$class)
  }, c("NN", "NP", "PN", "PP"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("NN"),
                                keepUnclassified=FALSE)
    as.character(res$class)
  }, c("NP", "PN", "PP"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("NP"),
                                keepUnclassified=FALSE)
    as.character(res$class)
  }, c("NN", "PN", "PP"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("PN"),
                                keepUnclassified=FALSE)
    as.character(res$class)
  }, c("NN", "NP", "PP"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("PP"),
                                keepUnclassified=FALSE)
    as.character(res$class)
  }, c("NN", "NP", "PN"))
})

test_that("Classes are correctly removed (without rain)", {
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c(),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "NP", "PN", "PP", "N/A", "Rain"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("NN"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NP", "PN", "PP", "N/A", "Rain"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("NP"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "PN", "PP", "N/A", "Rain"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("PN"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "NP", "PP", "N/A", "Rain"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("PP"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "NP", "PN", "N/A", "Rain"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("N/A"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "NP", "PN", "PP", "Rain"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class", classesToRemove=c("Rain"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "NP", "PN", "PP", "N/A"))
})

test_that("Classes are correctly removed (multiple classes)", {
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class",
                                classesToRemove=c("PN", "PP"),
                                keepUnclassified=FALSE)
    as.character(res$class)
  }, c("NN", "NP"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class",
                                classesToRemove=c("NP", "PP"),
                                keepUnclassified=FALSE)
    as.character(res$class)
  }, c("NN", "PN"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class",
                                classesToRemove=c("PN", "PP"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "NP", "N/A", "Rain"))
  expect_equal({
    res <- removeDropletClasses(df, cMethod="class",
                                classesToRemove=c("NP", "PP"),
                                keepUnclassified=TRUE)
    as.character(res$class)
  }, c("NN", "PN", "N/A", "Rain"))
})

context("Facet plot")

krasPlate <- ddpcrPlate(KRASdata)

test_that("Facet plot gives a output with correct parameters", {
  expect_s3_class(facetPlot(krasPlate), c("gg", "ggplot"))
  expect_s3_class(facetPlot(krasPlate, cMethod=NULL), c("gg", "ggplot"))
  expect_s3_class(facetPlot(krasPlate, cMethod="Cluster"), c("gg", "ggplot"))
})

test_that("Facet plot fails when plotting the wrong column", {
  expect_error(facetPlot(krasPlate, cMethod="Well"))
  expect_error(facetPlot(krasPlate, cMethod="AAA"))
})

context("Plate summary")

testDir <- system.file("testdata", package = "twoddpcr")

testPlate <- ddpcrPlate(testDir)
centres <- matrix(c(5000, 1500, 5500, 7000, 10000, 2000, 9000, 6000),
                  ncol=2, byrow=TRUE)
testPlate <- kmeansClassify(testPlate, centres=centres)
kmeansSummary <- plateSummary(testPlate, cMethod="kmeans")

test_that("Summary generated", {
  expect_equal(rownames(kmeansSummary), c("B03", "A04", "A05", "B06"))
  expect_true(all(kmeansSummary$PP %% 1 == 0))
  expect_true(all(kmeansSummary$PN %% 1 == 0))
  expect_true(all(kmeansSummary$NP %% 1 == 0))
  expect_true(all(kmeansSummary$NN %% 1 == 0))
  expect_true(all(kmeansSummary$AcceptedDroplets %% 1 == 0))
  expect_true(all(kmeansSummary$MtPositives %% 1 == 0))
  expect_true(all(kmeansSummary$MtNegatives %% 1 == 0))
  expect_true(all(kmeansSummary$WtPositives %% 1 == 0))
  expect_true(all(kmeansSummary$WtNegatives %% 1 == 0))
  expect_true(all(is.numeric(kmeansSummary$MtConcentration)))
  expect_true(all(is.numeric(kmeansSummary$WtConcentration)))
  expect_true(all(is.numeric(kmeansSummary$MtCopiesPer20uLWell)))
  expect_true(all(is.numeric(kmeansSummary$WtCopiesPer20uLWell)))
  expect_true(all(is.numeric(kmeansSummary$TotalCopiesPer20uLWell)))
  expect_true(all(is.numeric(kmeansSummary$TotalCopiesPer20uLWell)))
  expect_true(all(is.numeric(kmeansSummary$Ratio)))
  expect_true(all(is.numeric(kmeansSummary$FracAbun)))
})

testPlate <- mahalanobisRain(testPlate, cMethod="kmeans", maxDistances=3)
rainySummary <- plateSummary(testPlate, cMethod="kmeansMahRain")

test_that("Rain is removed", {
  expect_true(all(rainySummary$PP <= kmeansSummary$PP))
  expect_true(all(rainySummary$PN <= kmeansSummary$PN))
  expect_true(all(rainySummary$NP <= kmeansSummary$NP))
  expect_true(all(rainySummary$NN <= kmeansSummary$NN))
  expect_true(all(rainySummary$AcceptedDroplets <=
                  kmeansSummary$AcceptedDroplets))
  expect_true(any(rainySummary$AcceptedDroplets <
                  kmeansSummary$AcceptedDroplets))
})

context("Retrieving droplets")

testDir <- system.file("testdata", package = "twoddpcr")

test_that("Droplets can be retrieved in a data frame", {
  expect_s3_class(amplitudes(ddpcrWell()), "data.frame")
  expect_s3_class(amplitudes(ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))),
                  class="data.frame")
  expect_equal(class(amplitudes(ddpcrPlate())), "data.frame")
  expect_equal(class(amplitudes(ddpcrPlate(testDir))), "list")
  expect_equal(class(do.call(rbind, amplitudes(ddpcrPlate(testDir)))),
               "data.frame")
})

test_that("The wells names are loaded from filenames", {
  expect_equal(names(ddpcrPlate(testDir)), c("B03", "A04", "A05", "B06"))
})

test_that("There are the right number of droplets", {
  expect_equal(numDroplets(ddpcrWell()), 0)
  expect_equal(numDroplets(ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))), 6)
  expect_equal(numDroplets(ddpcrPlate()), c())
  expect_equivalent(numDroplets(ddpcrPlate(testDir)), c(6, 4, 4, 10))
  expect_equivalent(numDroplets(ddpcrPlate(list(A01=ddpcrWell()))), c(0),
                    info="Plate with an empty well")
})

test_that("isEmpty works as expected", {
  expect_true(isEmpty(ddpcrWell()))
  expect_true(isEmpty(ddpcrPlate()))
  expect_true(isEmpty(ddpcrPlate(list(A01=ddpcrWell()))),
              info="Plate with an empty well")

  expect_false(isEmpty(ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))))
  expect_false(isEmpty(ddpcrPlate(testDir)))
})

context("Classifying by grid")

testDir <- system.file("testdata", package = "twoddpcr")
testWell <- ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))
testPlate <- ddpcrPlate(testDir)

test_that("gridClassify classifies the droplets correctly", {
  testPlate <- gridClassify(testPlate,
                            ch1NNThreshold=6500, ch2NNThreshold=1900,
                            ch1NPThreshold=6500, ch2NPThreshold=5000,
                            ch1PNThreshold=9000, ch2PNThreshold=2500,
                            ch1PPThreshold=7500, ch2PPThreshold=5000)
  cl <- unlist(plateClassification(testPlate, cMethod="grid"))
  expect_equal(sum(cl == "NN"), 9)
  expect_equal(sum(cl == "NP"), 8)
  expect_equal(sum(cl == "PN"), 3)
  expect_equal(sum(cl == "PP"), 2)
  expect_equal(sum(cl == "Rain"), 2)
})

test_that("thresholdClassify classifies the droplets correctly", {
  testPlate <- thresholdClassify(testPlate,
                                 ch1Threshold=7000, ch2Threshold=3000)
  cl <- unlist(plateClassification(testPlate, cMethod="thresholds"))
  expect_equal(sum(cl == "NN"), 10)
  expect_equal(sum(cl == "NP"), 9)
  expect_equal(sum(cl == "PN"), 3)
  expect_equal(sum(cl == "PP"), 2)
  expect_equal(sum(cl == "Rain"), 0)
})

test_that("gridClassify stops if the thresholds overlap", {
  expect_error(
    gridClassify(testPlate,
                 ch1NNThreshold=6500, ch2NNThreshold=3000,
                 ch1NPThreshold=6500, ch2NPThreshold=3000,
                 ch1PNThreshold=6499, ch2PNThreshold=3000,
                 ch1PPThreshold=6500, ch2PPThreshold=3000)
  )
  expect_error(
    gridClassify(testPlate,
                 ch1NNThreshold=6500, ch2NNThreshold=3000,
                 ch1NPThreshold=6500, ch2NPThreshold=3000,
                 ch1PNThreshold=6500, ch2PNThreshold=3000,
                 ch1PPThreshold=6499, ch2PPThreshold=3000)
  )
  expect_error(
    gridClassify(testPlate,
                 ch1NNThreshold=6500, ch2NNThreshold=3000,
                 ch1NPThreshold=6500, ch2NPThreshold=2999,
                 ch1PNThreshold=6500, ch2PNThreshold=3000,
                 ch1PPThreshold=6500, ch2PPThreshold=3000)
  )
  expect_error(
    gridClassify(testPlate,
                 ch1NNThreshold=6500, ch2NNThreshold=3000,
                 ch1NPThreshold=6500, ch2NPThreshold=3000,
                 ch1PNThreshold=6500, ch2PNThreshold=3000,
                 ch1PPThreshold=6500, ch2PPThreshold=2999)
  )
  expect_error(
    gridClassify(testPlate,
                 ch1NNThreshold=6000, ch2NNThreshold=3000,
                 ch1NPThreshold=6000, ch2NPThreshold=3000,
                 ch1PNThreshold=6000, ch2PNThreshold=3000,
                 ch1PPThreshold=6000, ch2PPThreshold=3000),
    regexp=NA
  )
})

context("k-means clustering")

testDir <- system.file("testdata", package = "twoddpcr")

test_that("k-means works for 3 classes", {
  testWell <- ddpcrWell(file.path(testDir, "sample_A04_Amplitude.csv"))
  centres <- matrix(c(5000, 1500, 5500, 7000, 10000, 2000),
                    ncol=2, byrow=TRUE)
  testWell <- kmeansClassify(testWell, centres=centres)
  kmc <- wellClassification(testWell, cMethod="kmeans")
  expect_equal(length(unique(kmc)), 3)
})

test_that("k-means works for 4 classes", {
  testPlate <- ddpcrPlate(testDir)
  centres <- matrix(c(5000, 1500, 5500, 7000, 10000, 2000, 9000, 6000),
                    ncol=2, byrow=TRUE)
  testPlate <- kmeansClassify(testPlate, centres=centres)
  kmc <- unlist(plateClassification(testPlate, cMethod="kmeans"))
  expect_equal(length(unique(kmc)), 4)
})

test_that("k-means error if clusters/centres are not close", {
  testWell <- ddpcrWell(file.path(testDir, "sample_A04_Amplitude.csv"))
  centres <- matrix(c(5000, 1500, 5500, 7000, 10000, 2000, 9000, 6000),
                    ncol=2, byrow=TRUE)
  expect_error(kmeansClassify(testWell, centres=centres))
})

test_that("k-means errors for centres", {
  testPlate <- ddpcrPlate(testDir)
  centres <- matrix(c(5000, 1500, 5500, 7000, 10000, 2000, 9000, 6000,
                      7000, 4000), ncol=2, byrow=TRUE)
  expect_error(kmeansClassify(testPlate, centres=centres))
  expect_error(kmeansClassify(testPlate, centres=5))

  noCentres <- matrix()
  expect_error(kmeansClassify(testPlate, centres=noCentres))
  expect_error(kmeansClassify(testPlate, centres=0))
  expect_error(kmeansClassify(testPlate, centres=-1))
  expect_error(kmeansClassify(testPlate, centres=3.5))
  expect_error(kmeansClassify(testPlate, centres="centres"))
})

context("SD rain")

testDir <- system.file("testdata", package = "twoddpcr")

test_that("SD rain works for small sample", {
  testWell <- ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))
  centres <- matrix(c(5000, 1500, 5500, 7000, 10000, 2000, 9000, 6000),
                    ncol=2, byrow=TRUE)
  testWell <- kmeansClassify(testWell, centres=centres)
  expect_error(sdRain(testWell, cMethod="kmeans", errorLevel=3), NA)
})

test_that("SD rain removes ambiguous droplets", {
  testPlate <- ddpcrPlate(testDir)
  centres <- matrix(c(5000, 1500, 5500, 7000, 10000, 2000, 9000, 6000),
                    ncol=2, byrow=TRUE)
  testPlate <- kmeansClassify(testPlate, centres=centres)
  testPlate <- sdRain(testPlate, cMethod="kmeans", errorLevel=3)

  kmeansCl <- unlist(plateClassification(testPlate, cMethod="kmeans"))
  rainCl <- unlist(plateClassification(testPlate, cMethod="kmeansSdRain"))

  expect_true("kmeansSdRain" %in% commonClassificationMethod(testPlate))

  expect_lte(sum(rainCl == "NN"), sum(kmeansCl == "NN"))
  expect_lte(sum(rainCl == "NP"), sum(kmeansCl == "NP"))
  expect_lte(sum(rainCl == "PN"), sum(kmeansCl == "PN"))
  expect_lte(sum(rainCl == "PP"), sum(kmeansCl == "PP"))

  # The above tests are for <=, but the test data has been constructed so that
  # there are some major outliers, hence the following is strictly > 0.
  expect_gt(sum(rainCl == "Rain"), 0)

  # These should also be > 0.
  expect_gt(sum(rainCl == "NN"), 0)
  expect_gt(sum(rainCl == "NP"), 0)
  expect_gt(sum(rainCl == "PN"), 0)
  expect_gt(sum(rainCl == "PP"), 0)
})

context("Getting and setting classification")

testDir <- system.file("testdata", package = "twoddpcr")
testWell <- ddpcrWell(file.path(testDir, "sample_B03_Amplitude.csv"))
testPlate <- ddpcrPlate(testDir)

test_that("Existing classification can be retrieved", {
  expect_equal(wellClassification(testWell, cMethod="Sample"),
               factor(c("NN", "NN", "NP", "PN", "PP", "NN"),
                      levels=ddpcr$classesRain))
})

test_that("Classification can be set and retrieved (ddpcrWell)", {
    wellClassification(testWell, cMethod="manual") <-
      factor(c("NN", "NN", "NP", "PN", "PP", "Rain"), levels=ddpcr$classesRain)
  expect_true("manual" %in% wellClassificationMethod(testWell))
  expect_equal(
    wellClassification(testWell, cMethod="manual"),
    factor(c("NN", "NN", "NP", "PN", "PP", "Rain"), levels=ddpcr$classesRain)
  )
})

test_that("Classification can be set and retrieved (ddpcrPlate)", {
  # ddpcrPlate by list of factors
  plateClassification(testPlate, cMethod="manual") <-
    list(
      "B03"=factor(c("NN", "NN", "NP", "PN", "PP", "Rain"),
                   levels=ddpcr$classesRain),
      "A04"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "A05"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "B06"=factor(c("NN", "NN", "NN", "NN", "NN",
                     "NP", "NP", "NP", "NP", "NP"),
                   levels=ddpcr$classesRain)
    )
  expect_true("manual" %in% commonClassificationMethod(testPlate))
  expect_equal(
    plateClassification(testPlate, cMethod="manual"),
    list(
      "B03"=factor(c("NN", "NN", "NP", "PN", "PP", "Rain"),
                   levels=ddpcr$classesRain),
      "A04"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "A05"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "B06"=factor(c("NN", "NN", "NN", "NN", "NN",
                     "NP", "NP", "NP", "NP", "NP"),
                   levels=ddpcr$classesRain)
    )
  )

  # ddpcrPlate by a long factor
  plateClassification(testPlate, cMethod="manual") <-
    factor(c("NN", "NN", "NP", "PN", "PP", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NN", "NN", "NN", "NN",
             "NP", "NP", "NP", "NP", "NP"),
           levels=ddpcr$classesRain)
  expect_true("manual" %in% commonClassificationMethod(testPlate))
  expect_equal(
    plateClassification(testPlate, cMethod="manual"),
    list(
      "B03"=factor(c("NN", "NN", "NP", "PN", "PP", "Rain"),
                   levels=ddpcr$classesRain),
      "A04"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "A05"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "B06"=factor(c("NN", "NN", "NN", "NN", "NN",
                     "NP", "NP", "NP", "NP", "NP"),
                   levels=ddpcr$classesRain)
    )
  )

 # binding together
  expect_equivalent(
    unlist(plateClassification(testPlate, cMethod="manual")),
    factor(c("NN", "NN", "NP", "PN", "PP", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NN", "NN", "NN", "NN",
             "NP", "NP", "NP", "NP", "NP"),
           levels=ddpcr$classesRain)
  )

  # withAmplitudes should give a list of data frames
  cl <- plateClassification(testPlate, cMethod="manual", withAmplitudes=TRUE)
  expect_named(cl, c("B03", "A04", "A05", "B06"))
  expect_s3_class(cl[["B03"]], "data.frame")
  expect_s3_class(cl[["A04"]], "data.frame")
  expect_s3_class(cl[["A05"]], "data.frame")
  expect_s3_class(cl[["B06"]], "data.frame")
  expect_named(cl[["B03"]], c("Ch1.Amplitude", "Ch2.Amplitude", "manual"))
  expect_named(cl[["A04"]], c("Ch1.Amplitude", "Ch2.Amplitude", "manual"))
  expect_named(cl[["A05"]], c("Ch1.Amplitude", "Ch2.Amplitude", "manual"))
  expect_named(cl[["B06"]], c("Ch1.Amplitude", "Ch2.Amplitude", "manual"))

  # withAmplitudes and binding the results
  cl <- plateClassification(testPlate, cMethod="manual",
                            withAmplitudes=TRUE)
  cl <- do.call(rbind, cl)
  expect_s3_class(cl, "data.frame")
  expect_named(cl, c("Ch1.Amplitude", "Ch2.Amplitude", "manual"))


  # wellCol
  cl <- plateClassification(testPlate, cMethod="manual",
                            withAmplitudes=TRUE, wellCol=TRUE)
  expect_named(cl[["B03"]],
               c("Ch1.Amplitude", "Ch2.Amplitude", "manual", "Well"))

  # wellCol and binding
  cl <- plateClassification(testPlate, cMethod="manual", withAmplitudes=TRUE,
                            wellCol=TRUE)
  cl <- do.call(rbind, cl)
  expect_named(cl,
               c("Ch1.Amplitude", "Ch2.Amplitude", "manual", "Well"))
  expect_equal(levels(cl$Well), c("B03", "A04", "A05", "B06"))
})

test_that("Trying to set classification of the wrong number of droplets", {
  expect_error(
    wellClassification(testWell, cMethod="manual") <-
      factor(c("NN", "NN", "NP", "PN", "PP"), levels=ddpcr$classesRain),
  )
  expect_error(
    wellClassification(testWell, cMethod="manual") <-
      factor(c("NN", "NN", "NP", "PN", "PP", "Rain", "NN"),
             levels=ddpcr$classesRain),
  )

  # ddpcrPlate by list of factors
  expect_error(
    plateClassification(testPlate, cMethod="manual") <-
    list(
      "B03"=factor(c("NN", "NN", "NP", "PN", "PP", "Rain"),
                   levels=ddpcr$classesRain),
      "A04"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "A05"=factor(c("NN", "NP", "PN", "Rain"),
                   levels=ddpcr$classesRain),
      "B06"=factor(c("NN", "NN", "NN", "NN", "NN",
                     "PP", "PP", "PP", "PP", "PP", "NN"),
                   levels=ddpcr$classesRain)
    )
  )
  expect_error(
    plateClassification(testPlate, cMethod="manual") <-
    factor(c("NN", "NN", "NP", "PN", "PP", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NN", "NN", "NN", "NN",
             "PP", "PP", "PP", "PP", "PP", "NN"),
           levels=ddpcr$classesRain),
  )
  expect_error(
    plateClassification(testPlate, cMethod="manual") <-
    factor(c("NN", "NN", "NP", "PN", "PP", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NP", "PN", "Rain",
             "NN", "NN", "NN", "NN", "NN",
             "PP", "PP", "PP", "PP"),
           levels=ddpcr$classesRain),
  )
})

---
title: "twoddpcr report"
output: html_document
params:
  plateName: NA
  plate: NA
  cMethod: NA
  longMode: NA
  rainType: NA
  summaryTable: NA
---

This document is a short report generated by the [twoddpcr Shiny 
app](http://shiny.cruk.manchester.ac.uk/twoddpcr/).

**Plate name:** `r params$plateName`

**Classification method:** `r params$longMode`

**Rain type:** `r params$rainType`

## Classification plots

The combined wells in the *`r params$plateName`* plate classify as follows:

```{r warning=FALSE, message=FALSE, echo=FALSE}
dropletPlot(params$plate, cMethod=params$cMethod)
```

The individual wells can be seen as:

```{r warning=FALSE, message=FALSE, echo=FALSE}
lapply(params$plate, dropletPlot, cMethod=params$cMethod)
```

## Summary

From the above classifications, the number of positive droplets and estimated 
number of starting molecules is summarised below.

```{r echo=FALSE}
knitr::kable(params$summaryTable)
```

---
title: "twoddpcr: A package for Droplet Digital PCR analysis"
author: "Anthony Chiu"
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('twoddpcr')`"
output:
  BiocStyle::html_document:
    fig_width: 5
    fig_height: 4
vignette: >
  %\VignetteIndexEntry{twoddpcr: A package for Droplet Digital PCR analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# Introduction

Droplet Digital PCR (ddPCR) is a system from Bio-Rad for estimating the number 
of genomic fragments in samples. ddPCR attaches fluorochromes to targets of 
interest, for example, mutant and wild type KRAS. Each sample is then divided 
into 20,000 droplets and qPCR is run on each droplet. The brightness of these 
droplets is measured in two channels, each corresponding to our targets.
The amplitudes of the droplets can be plotted and the results analysed to see 
whether droplets can be called as:

* Positive in both channels (PP),
* Positive in Channel 1 only (PN),
* Positive in Channel 2 only (NP), or
* Negative in both channels (NN).

There are variations in the brightnesses of the droplets; this can be 
particularly evident in and around the PP cluster, where there may be some 
crosstalk due the presence of both fluorochromes. The classification of 
droplets is therefore not necessarily as simple as deciding on brightness 
thresholds for each channel, above which a positive reading is called in that 
channel.

This vignette demonstrates how the `twoddpcr` package may be used to load data, 
classified and how to quickly create summaries.


# Installing the `twoddpcr` package

The package can be installed from Bioconductor using:

```{r eval=FALSE}
install.packages("BiocManager")
BiocManager::install("twoddpcr")
```

Alternatively, it can be installed from GitHub using:

```{r eval=FALSE}
library(devtools)
install_github("CRUKMI-ComputationalBiology/twoddpcr")
```

Another alternative is to install the package from source:

```{r eval=FALSE}
install.packages("</path/to/twoddpcr/>", repos=NULL, type="source")
```


# Loading the `twoddpcr` package

Once the package has been installed, it can be loaded in the usual way:

```{r results="hide", warning=FALSE, message=FALSE}
library(twoddpcr)
```


# Using the in-built dataset

Our example uses the `KRASdata` dataset, which comes as part of the package.
This dataset was created as a triplicate four-fold serial dilution with 5% A549 
mutant KRAS cell lines and 95% H1048 wild type KRAS cells as starting material.

To follow along with this dataset, create a `ddpcrPlate` object using:

```{r}
plate <- ddpcrPlate(wells=KRASdata)
```

To follow along with your own dataset, see the 
[Appendix](#using-other-datasets).


# Basic plots

All of the droplets can be plotted to see how they tend cluster:

```{r fig.ext='png'}
dropletPlot(plate)
```

This might not be particularly informative; for example, a density plot may be 
more appropriate:

```{r fig.ext='png'}
heatPlot(plate)
```

It can be seen here that most of the droplets are concentrated in the 
bottom-left and bottom-right clusters.

To take a different view, all of the wells could be plotted side-by-side:

```{r fig.ext='png', fig.width=6, fig.height=5}
facetPlot(plate)
```


# Plotting the droplets and existing classifications

Since the droplet amplitudes were extracted from Bio-Rad's _QuantaSoft_, there 
may already be some kind of classification. This can be checked with the 
`commonClassificationMethod` method, which retrieves the classification methods 
that exist for all of the wells in the plate:

```{r}
commonClassificationMethod(plate)
```

The `Cluster` classification can be plotted:

```{r fig.ext='png'}
dropletPlot(plate, cMethod="Cluster")
```

Again, these are all of the wells in the plate superimposed onto the same plot.
This gives a good overall picture, but the detection of rare alleles in 
_individual_ wells is where ddPCR is particularly useful. The wells that used 
in the plate are:

```{r}
names(plate)
```

Individual wells can be selected using the `[[...]]` syntax (as with lists in 
_R_). These can be plotted in the same way using `dropletPlot`. For example:

```{r fig.ext='png'}
dropletPlot(plate[["F03"]], cMethod="Cluster")
dropletPlot(plate[["E04"]], cMethod="Cluster")
```


# Independent linear gating on the channels (`thresholdClassify`)

This section illustrates how the `Cluster` classification was obtained, 
although the original classification was found using _QuantaSoft_.
The classification here involves setting linear gates (thresholds) for the two 
channels `Ch1.Amplitude` and `Ch2.Amplitude`, above each of which we will call 
a positive reading for that channel.

```{r}
plate <- thresholdClassify(plate, ch1Threshold=6789, ch2Threshold=3000)
```

The `commonClassificationMethod` method shows that there is now a new 
classification method:

```{r}
commonClassificationMethod(plate)
```

The `thresholds` classification can be plotted using `dropletPlot` but changing 
the `cMethod` parameter:

```{r fig.ext='png'}
dropletPlot(plate, cMethod="thresholds")
```


# Classifying using the k-means algorithm (`kmeansClassify`)

Visually, it appears that the classification in the previous section does not 
accurately classify a region between the main `NP` and `PP` clusters. There are 
a number of algorithms that could be used to better classify the clusters; one 
such example is the k-means clustering algorithm. The k-means algorithm is 
relatively fast but requires that we know how many clusters there are. With 
this in mind, it helps to classify all of the wells together so that human 
intervention is not required to judge whether some clusters in individual wells 
are empty. To run the algorithm on `ddpcrPlate` objects, the `kmeansClassify` 
method is used:

```{r fig.ext='png'}
plate <- kmeansClassify(plate)
commonClassificationMethod(plate)
dropletPlot(plate, cMethod="kmeans")
```

Notice how the `PP` cluster incorporates more of the droplets when compared to 
the `thresholds` case. Visually, it appears that k-means captures the 
clustering behaviour of the droplets more accurately.

Using the same wells chosen before, it is interesting to see how the individual 
wells classify:

```{r fig.ext='png'}
dropletPlot(plate[["F03"]], cMethod="kmeans")
dropletPlot(plate[["E04"]], cMethod="kmeans")
```


# Adding "rain"

There are regions between clusters where the classification is ambiguous, e.g. 
above and to the left of the NP cluster. These regions can be labelled as 
"Rain" and removed from the droplet counts in each of the clusters.
To achieve this, the `mahalanobisRain` method can be used.

```{r}
plate <- mahalanobisRain(plate, cMethod="kmeans", maxDistances=3)
```

The classification methods are now:

```{r}
commonClassificationMethod(plate)
```

Whenever droplets are relabelled as `Rain` using the `mahalanobisRain` method, 
the character string "MahRain" is appended to the classification name to 
distinguish it from the original. This classification is plotted as:

```{r fig.ext='png', fig.width=5, fig.height=4}
dropletPlot(plate, cMethod="kmeansMahRain")
```

This does not look particularly good; a lot of droplets that should be 
classified have been labelled as "Rain" instead. To remedy this, the 
`maxDistances` parameter can be adjusted to control the maximum (Mahalanobis) 
distance that droplets can be from the cluster centres.
Some fine-tuning of this parameter gives:

```{r}
plate <- mahalanobisRain(plate, cMethod="kmeans",
                         maxDistances=list(NN=35, NP=35, PN=35, PP=35))
commonClassificationMethod(plate)
```

The plot now looks slightly different:

```{r fig.ext='png', fig.width=5, fig.height=4}
dropletPlot(plate, cMethod="kmeansMahRain")
```


# Creating a summary

Using the number of droplets in each classification, the Poisson distribution 
can be used to estimate the number of fragments/molecules in the starting 
sample. For the k-means classification with rain, this gives the summary:

```{r fig.ext='png', fig.width=5, fig.height=4}
kmeansMahRainSummary <- plateSummary(plate, cMethod="kmeansMahRain")
head(kmeansMahRainSummary)
```

The first few columns `PP`, `PN`, `NP` and `NN` are the numbers of droplets in 
each class, whereas `AcceptedDroplets` is the sum of these. `MtPositives` is 
the number of droplets where a mutant has been called and conversely 
`MtNegatives` is the number of droplets with no mutants called. The 
`MtConcentration` is the Poisson estimate of how many mutant fragments there 
are per 1uL, while the `MtCopiesPer20uLWell` is the same figure multiplied
by 20. There are `Wt` (wild type) analogues of all of these `Mt` figures. 
Finally, `Ratio` is the figure `MtConcentration/WtConcentration` and `FracAbun` 
is the fractional abundance of mutants in the sample, i.e. `100 
* MtConcentration/(MtConcentration + WtConcentration)`.

The summaries for other classifications can still be produced by changing the 
`cMethod` parameter to one of those that exist in 
`commonClassificationMethod(plate)`.

This concludes the main walkthrough of this vignette.


# Analysis of the data

## Comparison of classification methods

As mentioned above, the `KRASdata` dataset was created as a triplicate 
four-fold serial dilution with 5% mutant and 95% wild type starting material. 
A data frame can be created to reflect this along with the mutant concentration 
values of each well.

```{r}
inputNg <- c(rep(64, 3), rep(16, 3), rep(4, 3), rep(1, 3))
mtConcentrations <-
  data.frame(
    x=inputNg,
    Cluster=plateSummary(plate, cMethod="Cluster")$MtConcentration, 
    kmeans=plateSummary(plate, cMethod="kmeans")$MtConcentration, 
    kmeansMahRain=kmeansMahRainSummary$MtConcentration)
knitr::kable(mtConcentrations)
```

The mutant concentration values can be plotted and the various classification 
methods compared against each other:

```{r fig.width=9, fig.height=3.5}
library(ggplot2)
library(reshape2)
mtConcentrationsLong <- melt(mtConcentrations, id.vars=c("x"))
ggplot(mtConcentrationsLong, aes_string("x", "value")) +
  geom_point() + geom_smooth(method="lm") + facet_wrap(~variable)
```

Numerically, the regression lines have coefficients of determination (R^2^ 
values):

```{r}
bioradLmSummary <- summary(lm(x ~ Cluster, data=mtConcentrations))
kmLmSummary <- summary(lm(x ~ kmeans, data=mtConcentrations))
kmMahRainLmSummary <- summary(lm(x ~ kmeansMahRain, data=mtConcentrations))
knitr::kable(c("Cluster"=bioradLmSummary$r.squared,
               "kmeans"=kmLmSummary$r.squared,
               "kmeansMahRain"=kmMahRainLmSummary$r.squared))
```

## Discussion

As shown above, the regression lines fit the data from all of the 
classification methods very well. Moreover, the R^2^ values are all similar and 
very close to 1. Therefore all of the approaches are very good and nothing can 
be said about which of the methods is better or worse. The density plot created 
by `heatPlot` above shows that the number of droplets in the `PP` cluster is 
relatively small compared to the other clusters, particularly at the bottom of 
the `PP` cluster. This explains why the regression lines are very similar.

An advantage of the `twoddpcr` package's k-means based approach is that setting 
thresholds manually can be subjective. In addition, the k-means clustering 
algorithm is more appropriate for finding clusters when the `PN` cluster 
'leans' and the `NP` cluster 'lifts'.

Setting rain using standard deviation is a commonly used approach in ddPCR 
analysis to remove false positives. It involves setting Ch1 and Ch2 thresholds 
for each cluster and removes droplets that are too far from the cluster 
centres. This method was introduced in [@jones14]. However, it is not possible 
to set such thresholds for the `NP` cluster above because, for example, setting 
a low Ch1 threshold would exclude too much from the top-right of the cluster, 
whereas setting a high Ch1 threshold would exclude nothing at all. The 
`twoddpcr` package's Mahalanobis rain method allows this kind of approach to be 
used, while still respecting the shapes of the clusters.


# Other classification tools

This section explains how other classification methods can be used. The methods 
already described above should suffice, but there are some droplet patterns 
that prevent them from working as well as we would like. The following methods 
are alternative techniques that can be used.


## Classifying using the k-NN algorithm (`knnClassify`)

Another classification algorithm is the k-nearest neighbour (k-NN) algorithm. 
The algorithm is very simple: For each droplet in the plate, look at the 
classifications of its nearest $k$-neighbours in a training set.
Assign the majority classification to the droplet.

The challenge now is to find a good dataset that is not too large, since this 
would slow the algorithm considerably for marginal gains. A training set should 
also have minimal noise.

To start, two wells `E03` and `A04` are chosen that reflect the clustering 
pattern of the plate without too much noise. We create a new (virtual) plate 
with the amplitudes from these wells.

```{r}
trainWells <- plate[c("E03", "A04")]
trainPlate <- ddpcrPlate(wells=trainWells)
```

To create the training classification, the k-means algorithm is useful:

```{r fig.ext='png'}
trainPlate <- kmeansClassify(trainPlate)
dropletPlot(trainPlate, cMethod="kmeans")
```

We see that k-means has worked quite well here, since the training set is 
relatively noise-free. However, it is clear that there is a `PN` droplet that 
is much closer to other `PP` droplets than the rest of the `PN` cluster. Noise 
can be removed by adding rain:

```{r fig.ext='png', fig.width=5, fig.height=4}
trainPlate <- mahalanobisRain(trainPlate, cMethod="kmeans", maxDistances=3)
dropletPlot(trainPlate, cMethod="kmeansMahRain")
```

This is a much less noisy classification to use. The training data needs to be 
a data frame and should also ignore the droplets classified as `Rain`; the 
`removeDropletClasses` method removes these droplets:

```{r}
trainSet <- removeDropletClasses(trainPlate, cMethod="kmeansMahRain")
trainSet <- do.call(rbind, trainSet)
colnames(trainSet)
```

We can check that the `Rain` droplets have been removed:

```{r}
table(trainSet$kmeansMahRain)
```

Next, we use this classification as the training set for the k-NN algorithm:

```{r}
trainAmplitudes <- trainSet[, c("Ch1.Amplitude", "Ch2.Amplitude")]
trainCl <- trainSet$kmeansMahRain
plate <- knnClassify(plate, trainData=trainAmplitudes, cl=trainCl, k=3)
```

Again, it can be checked that there is a new classification method:

```{r}
commonClassificationMethod(plate)
```

This classification can be plotted in the same way as before:

```{r fig.ext='png'}
dropletPlot(plate, cMethod="knn")
```


## Classifying the four 'corners' of a plot (`gridClassify`)

There may be some datasets where the above classification techniques do not 
work satisfactorily. As long as the main clusters have good separation from 
each other, the `gridClassify` method may be used. This method defines four 
'corner' regions with linear cut-offs in each channel; the remaining droplets 
are labelled as "Rain". To see how this works, consider the following (crude) 
example:

```{r}
plate <- gridClassify(plate,
                      ch1NNThreshold=6500, ch2NNThreshold=2110,
                      ch1NPThreshold=5765, ch2NPThreshold=5150,
                      ch1PNThreshold=8550, ch2PNThreshold=2450,
                      ch1PPThreshold=6700, ch2PPThreshold=3870)
dropletPlot(plate, cMethod="grid")
```

This is not a particularly great classification, but this option exists should 
it be required. It is tedious to set the parameters above, so it may be helpful 
to use the [Shiny app](#shiny-app-for-non-r-users) to aid in this process.


## Adding rain with `sdRain`

Since droplets tend to cluster into ellipse-like structures, the 
`mahalanobisRain` method should usually suffice for labelling ambiguous 
droplets as "Rain". An alternative way is to use the mean and standard 
deviation of each of the clusters (in both channels). To do this, use the 
`sdRain` method:

```{r}
plate <- sdRain(plate, cMethod="kmeans")
dropletPlot(plate, cMethod="kmeansSdRain")
```

As is the case with Mahalanobis rain, the rain levels could be tweaked a little:

```{r}
plate <- sdRain(plate, cMethod="kmeans",
                errorLevel=list(NN=5, NP=5, PN=3, PP=3))
dropletPlot(plate, cMethod="kmeansSdRain")
```



## Custom classifications

If you wish to use your own classification methods, the droplet information 
would need to be extracted and can also be added to the `ddpcrPlate` object. 
The basic workflow would be:

1. Retrieve the droplet amplitudes using `amplitudes` and combine them in a 
   single data frame:
    ```{r eval=FALSE}
    allDrops <- amplitudes(plate)
    allDrops <- do.call(rbind, amplitudes)
    ```
2. Classify the droplets using your own method:
    ```{r eval=FALSE}
    allDrops$class <- someClassificationMethod(allDrops)
    ```
3. Add the classification to `plate`:
    ```{r eval=FALSE}
    plateClassification(plate, cMethod="nameOfCMethod") <- allDrops$class
    ```

The `ddpcrPlate` class only understands classifications if it is a factor with 
levels `c("NN", "NP", "PN", "PP", "Rain", "N/A")`. If the result of your custom 
classification method returns a vector/factor with four classes (with maybe 
some "Rain" or "N/A"), then the vector/factor may be relabelled by:

```{r eval=FALSE}
relabelClasses(allDrops, classCol="class")
```

If there are fewer than four classes, `relabelClasses` will try to guess which 
of the classes are present. To help the method correctly label the clusters, 
set the `presentClasses` parameter:
   
```{r eval=FALSE}
relabelClasses(allDrops, classCol="class", presentClasses=c("NN", "NP", "PN"))
```


# Appendix

## Shiny-based GUI for non-R users

A Shiny app is included in the package, which provides a GUI that allows 
interactive use of the package for ddPCR analysis. This can be run from an 
interactive R session using:

```{r eval=FALSE}
shinyVisApp()
```

This can also be accessed at 
[http://shiny.cruk.manchester.ac.uk/twoddpcr/](http://shiny.cruk.manchester.ac.uk/twoddpcr/).

To run on your own Shiny server, a file called `app.R` should be created with 
the following code:

```{r eval=FALSE}
library(shiny)
library(twoddpcr)

# Disable warnings.
options(warn=-1)

shiny::shinyApp(
  ui=shinyVisUI(),
  server=function(input, output, session)
  {
    shinyVisServer(input, output, session)
  }
)
```


## Exporting droplet amplitudes from _QuantaSoft_ to CSV files

If you have run your own two channel ddPCR experiments that have produced a
_QuantaSoft_ Plate (`.qlp`) file, then the raw droplet amplitudes can be
extracted for use with the `twoddpcr` package. To do this:

1. Run _QuantaSoft_.
2. Load a plate (from a _QuantaSoft_ Plate `.qlp` file).
3. Select the samples to use by using the `Ctrl` and/or `Shift` key with the 
   mouse.
4. Click `Options` in the top-right.
5. Click `Export Amplitude and Cluster Data`.
6. Select a location to export the amplitude files to.
   This can take a while to complete.

The amplitudes will be exported to a number of CSV files in the chosen 
location, with one file for each well. Each file is named 
`<PlateName>_<WellNumber>_Amplitude.csv`, where `<PlateName>` is the name of 
the `.qlp` file without the extension and `<WellNumber>` is the position in the 
plate, e.g. `B03`. These amplitude files are now ready to be loaded using the 
`twoddpcr` package.


## Using other datasets

The example in this vignette can be followed using a different dataset, such as 
those from your own ddPCR experiments. To load a dataset:

1. Follow the instructions in the [exporting droplet amplitudes 
   section](#exporting-droplet-amplitudes-from-quantasoft-to-csv-files).
2. The droplets can be imported using:
   
    ```{r eval=FALSE}
    plate <- ddpcrPlate(well="data/amplitudes")
    ```
  Here, `data/amplitudes` should be changed to the directory containing the 
  droplet amplitude files.


## Problems reading files

While loading data, the following error message may appear:

```
Error in read.table(file = file, header = header, sep = sep, quote = quote,  :
  duplicate 'row.names' are not allowed
```

Possible solution: The number of columns in the header row might differ from 
the number of columns in the other rows. For example, there may be extra 
commas/tabs at the end of some lines. In such cases, the removal of 'empty' 
columns should fix the problem.


# Citing `twoddpcr`

If you use the `twoddpcr` package in your work, please cite the [Bioinformatics 
paper](http://dx.doi.org/10.1093/bioinformatics/btx308):

```{r}
citation("twoddpcr")
```


# Further reading

[@rodiger15] describes how to use R in order to analyse ddPCR data using the 
`dpcR` package.


# Session information

Here is the output of `sessionInfo()` on the system on which this document 
was compiled:

```{r sessionInfo, echo=FALSE}
sessionInfo()
```


# References

---
references:
- id: rodiger15
  title: "R as an Environment for the Reproducible Analysis of DNA 
  Amplification Experiments"
  author:
  - family: Rödiger
    given: Stefan
  - family: Burdukiewicz
    given: Michał
  - family: Blagodatskikh
    given: K. A.
  - family: Schierack
    given: P. R.
  container-title: The R Journal
  volume: 7
  issue: 2
  publisher: The R Foundation
  page: 127--150
  type: article-journal
  issued:
    year: 2015
- id: jones14
  title: "Low copy target detection by Droplet Digital PCR through application 
  of a novel open access bioinformatic pipeline, 'definetherain'"
  author:
  - family: Jones
    given: M.
  - family: Williams
    given: J.
  - family: Gartner
    given: K.
  - family: Phillips
    given: R.
  - family: Hurst
    given: J.
  - family: Frater
    given: J.
  container-title: J Virol Methods
  volume: 202
  issue: 2
  publisher: Elsevier
  page: 46--53
  type: article-journal
  issued:
    year: 2014
---

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCSVDataFrame.R
\name{readCSVDataFrame}
\alias{readCSVDataFrame}
\title{Read all given CSV files into a list.}
\usage{
readCSVDataFrame(path, wellCol = FALSE, sortByLetter = FALSE)
}
\arguments{
\item{path}{The path containing the CSV files (can be a combination of
directories and individual CSV file paths). Each file will have
a \code{Ch1.Amplitude}, \code{Ch2.Amplitude} and possibly classification
columns, e.g. by default, QuantaSoft returns a \code{Cluster} column too.}

\item{wellCol}{If \code{TRUE}, an additional column is added with the well
name.  This is useful if we need to merge all the data in the output list
and we want to identify the original well of each droplet. Defaults to
\code{FALSE}.}

\item{sortByLetter}{If \code{TRUE}, the resulting list is sorted by the
letter in the well names first, e.g. "A02" comes before "B01". If
\code{FALSE}, the result is sorted by the numeric component of the well
names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.}
}
\value{
A list of data frames, each containing the data from a CSV file with
the corresponding well name.
}
\description{
Bio-Rad's QuantaSoft can export droplet amplitude data from multiple wells
into CSV files for each well. This function can read these CSV files into
a list. Note that empty wells will be ignored.
}
\examples{
## Read all of the droplet amplitudes from CSV files in a directory.
moreAmpsDir <- system.file("extdata", "more-amplitudes", package="twoddpcr")
someWells <- readCSVDataFrame(moreAmpsDir)

## We can read files from directories and files at the same time.
ampFile <- system.file("extdata", "amplitudes", "sample_B03_Amplitude.csv",
                       package="twoddpcr")
someWells <- readCSVDataFrame(c(moreAmpsDir, ampFile))

## If samples have been ordered by "A01", "A02", "A03", etc. instead of
## "A01", "B01", "C01", etc., we can set the sortByLetter flag to TRUE.
someWells <- readCSVDataFrame(moreAmpsDir, sortByLetter=TRUE)

## Setting wellCol to TRUE adds an extra column with the well name. If we
## bind the data frames together, we can track where the droplets came from.
someWells <- readCSVDataFrame(moreAmpsDir, wellCol=TRUE)
someWells <- do.call(rbind, someWells)
head(someWells)
tail(someWells)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/facetPlot.R
\name{facetPlot}
\alias{facetPlot}
\alias{allPlot}
\alias{plotAll}
\alias{facetPlot,data.frame-method}
\alias{facetPlot,ddpcrPlate-method}
\title{Draw each of the individual wells in a ddPCR experiment.}
\usage{
facetPlot(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  cMethod = NULL,
  binwidth = 100,
  pointSize = 0.1,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500)),
  showEmptyWells = FALSE
)

\S4method{facetPlot}{data.frame}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  cMethod = NULL,
  binwidth = 100,
  pointSize = 0.1,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500)),
  showEmptyWells = FALSE
)

\S4method{facetPlot}{ddpcrPlate}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  cMethod = NULL,
  binwidth = 100,
  pointSize = 0.1,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500)),
  showEmptyWells = FALSE
)
}
\arguments{
\item{droplets}{A \code{ddpcrPlate} object or a data frame of droplet
amplitudes with a "Well" column.}

\item{ch1Label}{The label for the channel 1 target. Defaults to "Ch1
Amplitude".}

\item{ch2Label}{The label for the channel 2 target. Defaults to "Ch2
Amplitude".}

\item{cMethod}{This should be the name or column number of \code{droplets}
corresponding to the classification to be plotted. This column should only
have entries in "NN", "PN", "NP, "PP", "Rain" and "N/A". If "None", plots
the droplets with all of them classified as \code{N/A}. If \code{NULL},
a density plot is plotted. Defaults to \code{NULL}.}

\item{binwidth}{The width of each hexagonal bin in the density plot. Ignored
if \code{cMethod} is not \code{NULL} (see \code{pointSize} instead).
Defaults to 100.}

\item{pointSize}{If \code{cMethod} is not \code{NULL}, this is the size to
draw each droplet. Otherwise this parameter is ignored (see \code{binwidth}
instead). Defaults to 0.1.}

\item{plotLimits}{A list of 2-element vectors with names \code{x} and
\code{y}. These are used to fix the x and y limits of the plot, which is
especially useful for comparing plots. Defaults to \code{list(x=c(1000,
9000), y=c(3000, 13500))}.}

\item{showEmptyWells}{If \code{TRUE}, plots
a \code{\link[ggplot2]{facet_grid}} of all the wells in the plate, including
the empty ones. If \code{FALSE}, plots a \code{\link[ggplot2]{facet_wrap}}
of only the loaded (nonempty) wells. Defaults to \code{FALSE}.}
}
\value{
A collection of plots as a \code{\link[ggplot2]{ggplot}} object.
}
\description{
Plot each of the wells in a \code{\link{ddpcrPlate}} object or
a large data frame of droplets. By default, a density plot is returned for
speed purposes.
}
\examples{
## Plot a facet wrap of density plots of each well.
krasPlate <- ddpcrPlate(wells=KRASdata)
facetPlot(krasPlate)

}
\references{
The nice log-scaled palette was achieved using
\url{http://www.everydayanalytics.ca/2014/09/5-ways-to-do-2d-histograms-in-r.html}
}
\seealso{
By default, each subplot uses the same plotting style as
\code{\link{heatPlot}}.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusterStats.R
\name{.cov}
\alias{.cov}
\title{Get the covariance of a cluster.}
\usage{
.cov(cl, droplets, classCol)
}
\arguments{
\item{cl}{The cluster of which to find the covariance.}

\item{droplets}{A data frame of droplets with \code{Ch1.Amplitude} and
\code{Ch2.Amplitude} columns, as well as a class column (see the parameter
\code{classCol}).}

\item{classCol}{The column (name or number) from \code{droplets}
representing the class.}
}
\value{
The covariance matrix of the chosen cluster. If not defined, return
\code{NULL}.
}
\description{
Get the covariance of a single cluster.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalise.R
\name{renormalisePlate}
\alias{renormalisePlate}
\title{Normalise all wells in a plate to the overall/average cluster
positions.}
\usage{
renormalisePlate(
  plate,
  initialCentres = matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000), ncol = 2, byrow =
    TRUE),
  minSeparation = 2000
)
}
\arguments{
\item{plate}{A \code{ddpcrPlate} object.}

\item{initialCentres}{A matrix or data frame of (rough estimates) of centres
of each of the clusters in the combined data. This will be used for an
initial run of k-means clustering.}

\item{minSeparation}{The minimum distance required between two cluster
centres in order for us to assume that k-means clustering found two distinct
clusters. This is used when classifying droplets along a single channel and
helps to reject classifications where there is only one cluster, e.g. when
there are no mutants in a well. Defaults to 2000.}
}
\value{
A list of data frames with the rescaled amplitudes in both channels.
}
\description{
Each well is scaled in the direction of the two axes
independently. The algorithm works as follows:
\enumerate{
  \item Classify the entire plate using k-means clustering in order to
    roughly identify clusters.
  \item For each channel and each well:
    \enumerate{
      \item Remove the positive clusters in the other channel.
      \item Re-run k-means clustering with \eqn{k = 2} to obtain new
        cluster centres. If the centres are too close (default distance
        2000), reject these new cluster centres and use the old centres.
      \item Use the new centres for each well to rescale to the same scale
      as the average/overall scale.
    }
}
}
\examples{
## Normalise the KRAS data.
plate <- ddpcrPlate(wells=KRASdata)
normPlate <- renormalisePlate(plate)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/global.R
\name{setDropletVolume}
\alias{setDropletVolume}
\alias{setDropVolume}
\alias{setDropletVol}
\alias{setDropVol}
\title{Set the droplet volume in microlitres (ul).}
\usage{
setDropletVolume(volume = 0.00085)
}
\arguments{
\item{volume}{The new volume of each droplet. Defaults to 0.00085, which is
the default given by Bio-Rad.}
}
\value{
Sets the internal droplet volume.
}
\description{
Change the volume of droplets used in the ddPCR experiment.
}
\examples{
## Change the droplet volume.
ddpcr$dropletVolume
setDropletVolume(0.00091)
ddpcr$dropletVolume

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggplot.R
\name{ggplot.well}
\alias{ggplot.well}
\alias{ggplot.wells}
\alias{ggplot.plate}
\alias{ggplot.multiwell}
\alias{ggplot.well,ddpcrWell-method}
\alias{ggplot.plate,ddpcrPlate-method}
\title{ggplot methods for the \code{\link{ddpcrWell}} and
\code{\link{ddpcrPlate}} classes.}
\usage{
ggplot.well(
  data,
  mapping = aes_string(x = "Ch2.Amplitude", y = "Ch1.Amplitude", colour = cMethod),
  cMethod = NULL,
  ...,
  environment = parent.frame()
)

\S4method{ggplot.well}{ddpcrWell}(
  data,
  mapping = aes_string(x = "Ch2.Amplitude", y = "Ch1.Amplitude", colour = cMethod),
  cMethod = "None",
  ...,
  environment = parent.frame()
)

ggplot.plate(
  data,
  mapping = aes_string(x = "Ch2.Amplitude", y = "Ch1.Amplitude", colour = class),
  cMethod = "None",
  ...,
  environment = parent.frame()
)

\S4method{ggplot.plate}{ddpcrPlate}(
  data,
  mapping = aes_string(x = "Ch2.Amplitude", y = "Ch1.Amplitude", colour = cMethod),
  cMethod = "None",
  ...,
  environment = parent.frame()
)
}
\arguments{
\item{data}{A \code{ddpcrWell} or \code{ddpcrPlate} object.}

\item{mapping}{A list of aesthetic mappings to use for the plot. Defaults to
\code{ggplot2::aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude",
colour=cMethod)}, where \code{cMethod} is taken from the parameter of the
same name.}

\item{cMethod}{The name or column number of the classification to use. This
is renamed internally to "class" for use with \code{mapping}. Defaults to
"None".}

\item{...}{Other arguments passed onto \code{\link[ggplot2]{ggplot}}.}

\item{environment}{Where to look if a mapping variable is not defined.
Defaults to \code{parent.frame()}, i.e. the environment in which
\code{ggplot.well()} or \code{ggplot.multiwell()} is called.}
}
\value{
A \code{\link[ggplot2]{ggplot}} object using the slots in the given
object.
}
\description{
These functions work in the same way as the original
\code{\link[ggplot2]{ggplot}} method, but handles the coercion of the object
into a data frame.

\code{ggplot.well} is a \code{\link[ggplot2]{ggplot}} method
for the \code{\link{ddpcrWell}} class.

\code{ggplot.multiwell} is a \code{\link[ggplot2]{ggplot}}
method for the \code{\link{ddpcrPlate}} class.
}
\examples{
## Plot the droplets in one well.
library(ggplot2)
aWell <- ddpcrWell(KRASdata[["E03"]])
ggplot.well(aWell, cMethod="Cluster") + geom_point()

## Plot the droplets in all of the wells in a single plot.
krasPlate <- ddpcrPlate(KRASdata)
ggplot.plate(krasPlate, cMethod="Cluster") + geom_point()

}
\seealso{
\code{\link{dropletPlot}} builds upon these \code{ggplot} methods
to plot droplet amplitude plots with a colour-blind friendly palette.

The original \code{\link[ggplot2]{ggplot}} method in the
\code{ggplot2} package is used internally.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrPlate.R
\name{elementType,SimpleList-method}
\alias{elementType,SimpleList-method}
\title{Check the types of the elements in a \code{SimpleList}.}
\usage{
\S4method{elementType}{SimpleList}(x)
}
\arguments{
\item{x}{An object.}
}
\value{
The types of objects in the \code{SimpleList} object.
}
\description{
Check the types of the elements in a \code{SimpleList}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dropletPlot.R
\name{dropletPlot}
\alias{dropletPlot}
\alias{dropletPlot,data.frame-method}
\alias{dropletPlot,ddpcrWell-method}
\alias{dropletPlot,ddpcrPlate-method}
\title{Plot a droplet classification with a colour-blind palette, optional
cluster centres and fixed axes.}
\usage{
dropletPlot(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  ...
)

\S4method{dropletPlot}{data.frame}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  cMethod = "None",
  mapping = aes_string(x = "Ch2.Amplitude", y = "Ch1.Amplitude", colour = cMethod),
  finalCentres = NULL,
  initialCentres = NULL,
  selectedCentre = NULL,
  pointSize = 1,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500)),
  legendLabels = ddpcr$classesRain
)

\S4method{dropletPlot}{ddpcrWell}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  cMethod = "None",
  mapping = aes_string(x = "Ch2.Amplitude", y = "Ch1.Amplitude", colour = cMethod),
  finalCentres = NULL,
  initialCentres = NULL,
  selectedCentre = NULL,
  pointSize = 1,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500)),
  legendLabels = ddpcr$classesRain
)

\S4method{dropletPlot}{ddpcrPlate}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  cMethod = "None",
  mapping = aes_string(x = "Ch2.Amplitude", y = "Ch1.Amplitude", colour = cMethod),
  finalCentres = NULL,
  initialCentres = NULL,
  selectedCentre = NULL,
  pointSize = 1,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500)),
  legendLabels = ddpcr$classesRain
)
}
\arguments{
\item{droplets}{An object corresponding to droplet amplitudes and their
classifications. This can be in the form of:
\itemize{
  \item A data frame with columns \code{Ch1.Amplitude}, \code{Ch2.Amplitude}
  and a classification column (see the parameter \code{cMethod}).
  \item A \code{\link{ddpcrWell}} object.
  \item A \code{\link{ddpcrPlate}} object.
  \item A \code{\link[ggplot2]{ggplot}} (\code{gg}) object. For example,
  this could be the output of \code{\link[twoddpcr]{ggplot.well}} or
  \code{\link[=ggplot.well]{ggplot.plate}}. We should not need to use this
  unless we are writing new methods to plot new data types.
}}

\item{ch1Label}{The label for the channel 1 target. Defaults to "Ch1
Amplitude".}

\item{ch2Label}{The label for the channel 2 target. Defaults to "Ch2
Amplitude".}

\item{...}{Other plotting parameters that depend on the object type of
\code{droplets}.}

\item{cMethod}{This should be the name or column number of \code{droplets}
corresponding to the classification. This column should only have entries in
"NN", "PN", "NP, "PP", "Rain" and "N/A". If "None", plots the droplets with
all of them classified as \code{N/A}. Defaults to "None".}

\item{mapping}{A list of aesthetic mappings to use for the plot. Defaults to
\code{ggplot2::aes_string(x="Ch2.Amplitude", y="Ch1.Amplitude",
colours=cMethod)}. Not used if \code{droplets} is a \code{ggplot} object.}

\item{finalCentres}{A data frmae of final centres to plot (e.g. those
returned by the k-means or c-means algorithms). If \code{NULL}, nothing is
plotted. Defaults to \code{NULL}.}

\item{initialCentres}{A data frame of initial centres to plot (e.g. initial
cluster centres used in the k-means). If \code{NULL}, nothing is plotted.
Defaults to \code{NULL}. This parameter is useful for illustrative reasons.}

\item{selectedCentre}{An initial centre to highlight. This should be either
"NN", "NP", "PN" or "PP". If \code{NULL}, nothing is highlighted. Defaults
to \code{NULL}. This parameter is useful for illustrative reasons.}

\item{pointSize}{The size to draw each droplet. Defaults to 1.}

\item{plotLimits}{A list of 2-element vectors with names \code{x} and
\code{y}. These are used to fix the x and y limits of the plot, which is
especially useful for comparing plots. Defaults to \code{list(x=c(1000,
9000), y=c(3000, 13500))}.}

\item{legendLabels}{The character vector corresponding to the labels for the
legend. The elements of the vector should correspond to the NN, NP, PN, PP,
Rain and N/A classes, respectively. Defaults to \code{ddpcr$classesRain}.}
}
\value{
A \code{ggplot} object with all of the given information above.
}
\description{
Plot an object comprising droplet amplitudes and their
classification. If specified, centres of clusters can be marked, e.g.
k-means clustering can take a set of centres as the initial centres of the
algorithm, and the algorithm also outputs the final cluster centres. Limits
to the axes can also be set for ease of comparison and consistency.

If a \code{ggplot} object is given as a parameter, this method will simply
plot it with the pretty colours, centres and restrictions on the axes.

If a \code{data.frame} is given as a parameter, it should
correspond to droplets with their classification.

If a \code{ddpcrWell} object is given as a parameter, plot the
droplets in the well with its classification.

If a \code{ddpcrPlate} object is given as a parameter, plot the
droplets from all wells with their classifications.
}
\examples{
## Get a data frame and relabel the "Cluster" column to the right form.
aWell <- KRASdata[["E03"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")

## Plot the data frame.
dropletPlot(aWell, cMethod="Cluster")

## Plot a ddpcrWell object.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
dropletPlot(aWell, cMethod="Cluster")

## Plot a ddpcrPlate object.
krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
dropletPlot(krasPlate, cMethod="Cluster")

## Use K-means clustering to classify a single sample. Then plot the
## classification and final cluster centres.
aWell <- kmeansClassify(aWell)
centres <- clusterCentres(aWell, cMethod="kmeans")
dropletPlot(aWell, cMethod="kmeans", finalCentres=centres)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrPlate.R
\name{.extractWellNames}
\alias{.extractWellNames}
\title{Retrieve the well names to use from a given list.}
\usage{
.extractWellNames(theObject, aList)
}
\arguments{
\item{theObject}{A \code{\link{ddpcrPlate}} object.}

\item{aList}{A list from which we wish to extract well names.}
}
\value{
The names of \code{aList}.
}
\description{
We simply retrieve the \code{names} from a given list, but also perform some
checks to make sure that the names are consistent with a given
\code{\link{ddpcrPlate}} object.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseCounts.R
\name{.isWideForm}
\alias{.isWideForm}
\title{Checks a data frame is a wide-form table.}
\usage{
.isWideForm(df, ch1Label = "Mt", ch2Label = "Wt")
}
\arguments{
\item{df}{A data frame.}

\item{ch1Label}{The prefix to use for the channel 1 target. Defaults to
"Mt".}

\item{ch2Label}{The prefix to use for the channel 2 target. Defaults to
"Wt".}
}
\value{
\code{TRUE} if \code{df} is considered to be of the correct format
and \code{FALSE} otherwise.
}
\description{
Our preferred data frame format is to have things in a wide-form data frame,
i.e. to have channel 1 and channel 2 data both in the same row.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseCounts.R
\name{.numberOfWells}
\alias{.numberOfWells}
\title{Find the number of wells in the data frame.}
\usage{
.numberOfWells(df)
}
\arguments{
\item{df}{A data frame of droplet counts with a \code{Well} column.}
}
\value{
An integer giving the number of wells.
}
\description{
Auxiliary function to find the number of wells that appear in the data
frame, each with the same frequency (almost certainly once or twice). If
some wells appear more than others, the function stops because the data is
in an unknown format.
}
\details{
Bio-Rad's QuantaSoft produces data in long form tables, i.e. for each well
there is a row for each target such as mutant and wild type. In this
package, we prefer to work with wide form tables that combine the mutant and
wild type parts.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseCounts.R
\name{castSummary}
\alias{castSummary}
\title{Makes a long form data frame into wide form.}
\usage{
castSummary(df, ch1Label = "Mt", ch2Label = "Wt", rows = NULL)
}
\arguments{
\item{df}{A data frame created by calling \code{read.csv} on the raw ddPCR
output.}

\item{ch1Label}{The prefix to use for the channel 1 target. Defaults to
"Mt".}

\item{ch2Label}{The prefix to use for the channel 2 target. Defaults to
"Wt".}

\item{rows}{The number of rows to retain from the original data frame. If
\code{NULL}, all of the wells are used. Defaults to \code{NULL}.}
}
\value{
A data frame with the target rows merged.
}
\description{
Returns a data frame with the dependent columns prefixed with given labels
(depending on the targets). All relevant columns are retained.
}
\examples{
## Cast output from Bio-Rad's QuantaSoft into wide form.
castSummary(KRAScountsQS)

## Only retain selected rows.
castSummary(KRAScountsQS, rows=c(1,4:6))

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusterStats.R
\name{classMeans}
\alias{classMeans}
\title{Get the mean of each cluster.}
\usage{
classMeans(droplets, classCol = "class")
}
\arguments{
\item{droplets}{A data frame of droplets with \code{Ch1.Amplitude} and
\code{Ch2.Amplitude} columns, as well as a classification column (see the
parameter \code{classCol}).}

\item{classCol}{The column (name or number) from \code{droplets}
representing the class.}
}
\value{
A list or data frame of means of each class.
}
\description{
After classifying droplets, we can compute the mean for each
class.
}
\examples{
## Get the means of the clusters.
aWell <- KRASdata[["E03"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
classMeans(aWell, classCol="Cluster")

## We repeat the above but with a sample with no "PP" cluster.
aWell <- KRASdata[["H04"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
classMeans(aWell, classCol="Cluster")

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plateSummary.R
\name{positiveCounts}
\alias{positiveCounts}
\title{Get a vector of droplet positive and negative counts.}
\usage{
positiveCounts(cl)
}
\arguments{
\item{cl}{A vector of classes that correspond to droplet amplitude data. The
vector should only contain the values "PP", "PN", "NP" or "NN".}
}
\value{
A vector corresponding to "PP", "PN", "NP" and "NN".
}
\description{
Take a vector of classes and return a vector of positive and negative
counts that is compatible with ddPCR analysis.
}
\examples{
## Take a data frame and make it into the right format.
aWell <- KRASdata[["E03"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")

## Count the number of droplets in each cluster.
positiveCounts(aWell$Cluster)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseCounts.R
\name{.essentialDependentCols}
\alias{.essentialDependentCols}
\title{Get a vector of essential dependent columns.}
\usage{
.essentialDependentCols(prefix = "")
}
\arguments{
\item{prefix}{A string to prepend to each of the essential column names.
Defaults to \code{""} (the empty string).}
}
\value{
A vector of essential column names with an optional prefix.
}
\description{
Get a list of the essential columns in the ddPCR data that depend on the
target (e.g. mutant or wild type).
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalise.R
\name{.renormaliseByChannel}
\alias{.renormaliseByChannel}
\title{Normalise a well on one channel only and then transform it back to the
original (combined) scale.}
\usage{
.renormaliseByChannel(wellDf, combinedCentres, wellCentres, channel)
}
\arguments{
\item{wellDf}{A data frame of the well's droplet amplitudes.}

\item{combinedCentres}{A data frame of the combined (average) centres of the
non-normalised wells.}

\item{wellCentres}{A data frame of centres corresponding to the given
\code{channel}.}

\item{channel}{An integer 1 or 2 corresponding to the channel that we are
interested in.}
}
\value{
A data frame with the rescaled amplitudes in the chosen channel.
}
\description{
Normalise a well on one channel only and then transform it back to the
original (combined) scale.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/relabelClasses.R
\name{relabelClasses}
\alias{relabelClasses}
\title{Re-label clusters.}
\usage{
relabelClasses(droplets, classCol = "class", presentClasses = ddpcr$classes)
}
\arguments{
\item{droplets}{A data frame of droplet amplitudes with a classification.}

\item{classCol}{The column (name or number) from 'droplets' representing
the class.}

\item{presentClasses}{A vector of classes that we want to label. Must be
a subset of c("NN", "NP", "PN", "PP") and must have the same number of
classes as the number of unique classes in the class column.}
}
\value{
The classification column relabelled with "NN", "NP", "PN" and "PP".
}
\description{
An attempt to label clusters with "NN", "NP", "PN" or "PP" automatically.
(This will not generalise to amplitudes in only a single channel.)
}
\examples{
## Look at the "Cluster" column that was created by Bio-Rad's QuantaSoft.
aWell <- KRASdata[["E03"]]
str(aWell$Cluster)

## Relabel the classes to see the difference.
relabelled <- relabelClasses(aWell, classCol="Cluster")
str(relabelled)
levels(relabelled)

## We choose a sample with 3 clusters.
unique(KRASdata[["H04"]]$Cluster)

## We can check that there is no "PP" class, so specify the others only.
relabelled <- relabelClasses(KRASdata[["H04"]], classCol="Cluster",
                             presentClasses=c("NN", "PN", "NP"))
table(relabelled)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flatPlot.R
\name{flatPlot}
\alias{flatPlot}
\alias{flatPlot,data.frame-method}
\alias{flatPlot,ddpcrWell-method}
\alias{flatPlot,ddpcrPlate-method}
\title{Plot droplet amplitudes with all droplets classified as "N/A" (or
a chosen class).}
\usage{
flatPlot(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  classString = ddpcr$na,
  initialCentres = NULL,
  selectedCentre = NULL,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)

\S4method{flatPlot}{data.frame}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  classString = ddpcr$na,
  initialCentres = NULL,
  selectedCentre = NULL,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)

\S4method{flatPlot}{ddpcrWell}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  classString = ddpcr$na,
  initialCentres = NULL,
  selectedCentre = NULL,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)

\S4method{flatPlot}{ddpcrPlate}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  classString = ddpcr$na,
  initialCentres = NULL,
  selectedCentre = NULL,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)
}
\arguments{
\item{droplets}{A data frame of droplet amplitudes, or
a \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}} object.}

\item{ch1Label}{The label for the channel 1 target. Defaults to "Ch1
Amplitude".}

\item{ch2Label}{The label for the channel 2 target. Defaults to "Ch2
Amplitude".}

\item{classString}{The class that all droplets should be classified as.
Defaults to the \code{ddpcr$na} ("N/A") character string.}

\item{initialCentres}{A data frame of initial centres to plot (e.g. initial
cluster centres used in the k-means). This is _not_ restricted to the class
\code{classString} only. If \code{NULL}, nothing is plotted. Defaults to
\code{NULL}.}

\item{selectedCentre}{An initial centre to highlight. This should be either
"NN", "PN", "NP" or "PP", but is _not_ restricted to the class 'classString'
only. If \code{NULL}, nothing is highlighted. Defaults to \code{NULL}.}

\item{plotLimits}{A list of 2-element vectors with names \code{x} and
\code{y}. These are used to fix the x and y limits of the plot, which is
especially useful for comparing plots. Defaults to
\code{list(x=c(1000, 9000), y=c(3000, 13500))}.}
}
\value{
A ggplot object in just one colour corresponding to
\code{classString}.
}
\description{
There are occasions where classification algorithms fail for
various reasons (such as poor choice/number of centres in k-means
clustering). In these cases, it may be helpful to the user if an app draws
a 'flat' plot with just one colour rather than nothing at all.

If a \code{ddpcrWell} object is given as a parameter, plot the
droplets in the well and colour them according to a given class.

If a \code{ddpcrPlate} object is given as a parameter,
plot the droplets in all wells and colour them according to a given class.
}
\examples{
## Plot the data frame with no classification.
aWell <- KRASdata[["E03"]]
flatPlot(aWell)

## Take a ddpcrWell object that is mostly classified as "NN" and colour it
## as such.
aWell <- KRASdata[["H04"]]
emptiedWell <- aWell[aWell$Cluster == 1, ]
emptiedWell <- ddpcrWell(well=emptiedWell)
flatPlot(emptiedWell, classString="NN")

## Plotting all of a ddpcrPlate object works the same way.
krasPlate <- ddpcrPlate(wells=KRASdata)
flatPlot(krasPlate)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/removeDropletClasses.R
\name{removeDropletClasses}
\alias{removeDropletClasses}
\alias{removeDropletClasses,data.frame-method}
\alias{removeDropletClasses,ddpcrWell-method}
\alias{removeDropletClasses,ddpcrPlate-method}
\title{Retrieve a data frame of droplet amplitudes with droplets of a given class
removed.}
\usage{
removeDropletClasses(
  droplets,
  ...,
  classesToRemove = NULL,
  keepUnclassified = FALSE
)

\S4method{removeDropletClasses}{data.frame}(
  droplets,
  cMethod = "class",
  classesToRemove = NULL,
  keepUnclassified = FALSE
)

\S4method{removeDropletClasses}{ddpcrWell}(
  droplets,
  cMethod,
  classesToRemove = NULL,
  keepUnclassified = FALSE
)

\S4method{removeDropletClasses}{ddpcrPlate}(
  droplets,
  cMethod,
  classesToRemove = NULL,
  keepUnclassified = FALSE
)
}
\arguments{
\item{droplets}{A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
object, or a data frame with columns \code{Ch1.Amplitude},
\code{Ch2.Amplitude} and a classification column.}

\item{...}{Other parameters depending on the type of \code{droplets}.}

\item{classesToRemove}{A vector of character strings corresponding to the
classes that should be removed. Defaults to \code{NULL}, i.e. remove
nothing.}

\item{keepUnclassified}{A logical flag determining whether unclassified
droplets (i.e. "Rain" or "N/A") should be kept. Defaults to \code{FALSE},
i.e. remove them.}

\item{cMethod}{This is the name or column number corresponding to the
classification in \code{droplets}. This column should only have entries in
"NN", "PN", "NP, "PP", "Rain" and "N/A". Defaults to "class".}
}
\value{
If a \code{ddpcrWell} object is given, return a data frame
corresponding to \code{droplets} with the given droplet classes removed.
If a \code{ddpcrPlate} object is given, return a list of data frames
instead.
}
\description{
By default, all droplets classified as "N/A" or "Rain" will be removed.
Including these droplets is useful for visualisation purposes, but they
could be a problem in some scenarios, e.g. if we wish to use the
classification as a training data set.
}
\examples{
## Take a data frame and transform it into the right format.
aWell <- KRASdata[["E03"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")

## Add rain using the Mahalanobis distance.
aWell$ClusterMahRain <-
    mahalanobisRain(aWell, cMethod="Cluster", fullTable=FALSE)
table(aWell$ClusterMahRain)

## Suppose we want to use this for training. Remove the "Rain" droplets.
aWellCleaned <- removeDropletClasses(aWell, cMethod="ClusterMahRain")
table(aWellCleaned$ClusterMahRain)

## All of the above works with ddpcrWell objects.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
aWell <- mahalanobisRain(aWell, cMethod="Cluster")
trainingData <- removeDropletClasses(aWell, cMethod="ClusterMahRain")
table(wellClassification(aWell, "ClusterMahRain"))
table(trainingData$ClusterMahRain)

## Likewise for ddpcrPlate objects we can create the training data.
krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "F03", "G03")])
krasPlate <- mahalanobisRain(krasPlate, cMethod="Cluster")
trainingData <- removeDropletClasses(krasPlate, cMethod="ClusterMahRain")
cl <- plateClassification(krasPlate, cMethod="ClusterMahRain")
cl <- unlist(cl)
table(cl)
td <- do.call(rbind, trainingData)
table(td$ClusterMahRain)

## We could also remove other droplet classes, such as the "PN" and "PP"
## clusters.
noPNPP <- removeDropletClasses(krasPlate, cMethod="ClusterMahRain",
                               classesToRemove=c("PN", "PP"))
td <- do.call(rbind, noPNPP)
table(td$ClusterMahRain)

## The same could be done, but with the "Rain" retained.
noPNPPWithRain <- removeDropletClasses(krasPlate, cMethod="ClusterMahRain",
                                       classesToRemove=c("PN", "PP"),
                                       keepUnclassified=TRUE)
td <- do.call(rbind, noPNPPWithRain)
table(td$ClusterMahRain)


}
\seealso{
This function can remove "N/A" droplets from classifications
produced by \code{\link{gridClassify}}.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/KRAScounts.R
\docType{data}
\name{KRAScounts}
\alias{KRAScounts}
\alias{KRAScountsWellCol}
\alias{KRAScountsQS}
\title{KRAS mutant and wild type droplet counts and Poisson estimates.}
\format{
A data frame where each row corresponds to a well/sample.

An object of class \code{data.frame} with 12 rows and 18 columns.

An object of class \code{data.frame} with 24 rows and 63 columns.
}
\usage{
data(KRAScounts)

data(KRAScountsWellCol)

data(KRAScountsQS)
}
\value{
A data frame.
}
\description{
A data frame of droplet counts using the standard 
\code{Cluster} classification from \code{\link{KRASdata}}. Each row 
corresponds to a well/sample and the columns \code{PP}, \code{PN}, \code{NP} 
and \code{NN} show how many droplets were in each cluster. The remaining 
rows were calculated from the counts figures except for the 
\code{InputAmount} column.

\code{KRAScountsWellCol} is the same data frame but has 
a \code{Well} column instead of named rows.

\code{KRAScountsQS} is a data frame imported from a CSV created 
by Bio-Rad's QuantaSoft.
}
\details{
The data frame was created by:
\preformatted{krasPlate <- ddpcrPlate(wells=KRASdata)
KRAScounts <- plateSummary(krasPlate, cMethod="Cluster")
onesVector <- c(1, 1, 1)
runAmount <- c(64 * onesVector, 16 * onesVector, 4 * onesVector, onesVector)
KRAScounts$InputAmount <- runAmount

KRAScountsWellCol <- KRAScounts
KRAScountsWellCol$Well <- rownames(KRAScounts)
KRAScountsWellCol <- KRAScountsWellCol[, c(18,1:17)]
rownames(KRAScountsWellCol) <- NULL
}
}
\author{
From the \code{\link{KRASdata}} dataset created by Mahmood Ayub, 
\email{mahmood.ayub@cruk.manchester.ac.uk}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinyVisServer.R
\name{shinyVisServer}
\alias{shinyVisServer}
\title{Shiny visualisation server.}
\usage{
shinyVisServer(input, output, session)
}
\arguments{
\item{input}{Shiny input list.}

\item{output}{Shiny output list.}

\item{session}{Shiny session.}
}
\value{
A Shiny server.
}
\description{
A Shiny server for interactive ddPCR droplet classification.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrPlate.R
\docType{class}
\name{ddpcrPlate-class}
\alias{ddpcrPlate-class}
\alias{.ddpcrPlate}
\alias{ddpcrPlate}
\alias{ddpcrPlate,list-method}
\alias{ddpcrPlate,ddpcrPlate-method}
\alias{ddpcrPlate,character-method}
\alias{ddpcrPlate,missing-method}
\alias{show,ddpcrPlate-method}
\title{An S4 class for multiple wells in a ddPCR experiment.}
\usage{
ddpcrPlate(wells)

\S4method{ddpcrPlate}{list}(wells)

\S4method{ddpcrPlate}{ddpcrPlate}(wells)

\S4method{ddpcrPlate}{character}(wells)

\S4method{ddpcrPlate}{missing}(wells)

\S4method{show}{ddpcrPlate}(object)
}
\arguments{
\item{wells}{Either:
\itemize{
  \item a list of \code{\link{ddpcrWell}} objects,
  \item a list of data frames of droplet amplitudes, or
  \item a character vector corresponding to a file path(s) containing CSV
  files of raw droplet amplitude data.
}}

\item{object}{Any R object}
}
\value{
A \code{ddpcrPlate} object with the given wells.
}
\description{
An S4 class for multiple wells in a ddPCR experiment.

The constructor for the \code{ddpcrPlate} class.
}
\examples{
## A \code{ddpcrPlate} object can be created from data from a list of data
## frames.
ddpcrPlate(KRASdata)

## A directory (or individual files) of droplet amplitude CSVs can also be
## loaded.
moreAmpsDir <- system.file("extdata", "more-amplitudes", package="twoddpcr")
ddpcrPlate(moreAmpsDir)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaries.R
\name{.getAllSummary}
\alias{.getAllSummary}
\title{Get a summary of the number of molecules in 20ul.}
\usage{
.getAllSummary(df)
}
\arguments{
\item{df}{A data frame generated by \code{\link{fullCountsSummary}}.}
}
\value{
A data frame with mutant and wild type copies per 20ul, the total
number of copies per 20ul, and a flag indicating if there are more than
2 mutant copies per 20ul.
}
\description{
Returns a data frame with a summary of the number of mutant and wild type
copies per 20ul.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalise.R
\name{.getChannelCentres}
\alias{.getChannelCentres}
\title{Find the centres of each of the wells in a given channel.}
\usage{
.getChannelCentres(plate, cMethod, channel, minSeparation = 2000)
}
\arguments{
\item{plate}{A \code{ddpcrPlate} object from which to extract the centres.}

\item{cMethod}{The classification method to use (in the form of a character
string).}

\item{channel}{An integer 1 or 2 corresponding to the channel of interest.}

\item{minSeparation}{The minimum distance required between two cluster
centres in order for us to assume that k-means found two distinct clusters.
Defaults to 2000.}
}
\value{
A list of data frames, where each data frame has information about
the centres in the channel of interest.
}
\description{
The plate should have been classified by k-means clustering.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrWell.R
\name{wellClassificationMethod}
\alias{wellClassificationMethod}
\alias{wellClassificationMethod,ddpcrWell-method}
\alias{wellClassificationMethod<-}
\alias{wellClassificationMethod<-,ddpcrWell-method}
\title{Retrieve the classification method.}
\usage{
wellClassificationMethod(theObject)

\S4method{wellClassificationMethod}{ddpcrWell}(theObject)

wellClassificationMethod(theObject, cMethod) <- value

\S4method{wellClassificationMethod}{ddpcrWell}(theObject, cMethod) <- value
}
\arguments{
\item{theObject}{A \code{\link{ddpcrWell}} object.}

\item{cMethod}{If modifying the classification methods, this should be
a vector of existing classification names or numbers.}

\item{value}{A character vector (of the same length as \code{cMethod})
giving a new names for the chosen classification methods.}
}
\value{
The classification method names.
}
\description{
Retrieve the names of the classification methods for
a \code{\link{ddpcrWell}} object.
}
\examples{
## Create a ddpcrWell object with some data and classification.
aWell <- ddpcrWell(well=KRASdata[["E03"]])

## Retrieve the classification method names.
head(wellClassificationMethod(aWell))

## Set a classification method name to something new.
wellClassificationMethod(aWell, cMethod="Cluster") <- "QuantaSoft"

## We check the classification now, showing the amplitudes as well.
wellClassificationMethod(aWell)

}
\seealso{
\code{\link{wellClassification}} for the classification of the
droplets.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mahRain.R
\name{.classwiseMahalanobisRain}
\alias{.classwiseMahalanobisRain}
\title{Fuzzy clusters by bivariate normal distributions.}
\usage{
.classwiseMahalanobisRain(droplets, cl, maxDistance = 30, classCol = "class")
}
\arguments{
\item{droplets}{A data frame of droplets with \code{Ch1.Amplitude} and
\code{Ch2.Amplitude} columns, as well as a class column (see the parameter
\code{classCol}).}

\item{cl}{The class to focus on. This should be either "NN", "NP", "PN" or
"PP".}

\item{maxDistance}{An integer corresponding to the maximum Mahalanobis
distance for which we will consider points to be members of the class, i.e.
this is the level outside of which we consider droplets to be too far from
the cluster.}

\item{classCol}{The column (name or number) from \code{droplets}
representing the class.}
}
\value{
A factor corresponding to the class column with \code{Rain} entries
added for the class \code{cl}.
}
\description{
Assume that the class \code{cl} is bivariate normally distributed. This
method adds fuzziness to the class. Other classes are not changed.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/knnClassify.R
\name{knnClassify}
\alias{knnClassify}
\alias{knnClassify,data.frame-method}
\alias{knnClassify,ddpcrWell-method}
\alias{knnClassify,ddpcrPlate-method}
\title{Use the k-nearest neighbour algorithm to classify the wells in
a \code{ddpcrWell} or \code{ddpcrPlate} object, or in a data frame.}
\usage{
knnClassify(droplets, trainData, cl, k, prob = 0, ...)

\S4method{knnClassify}{data.frame}(droplets, trainData, cl, k, prob = 0, fullTable = TRUE)

\S4method{knnClassify}{ddpcrWell}(droplets, trainData, cl, k, prob = 0)

\S4method{knnClassify}{ddpcrPlate}(droplets, trainData, cl, k, prob = 0)
}
\arguments{
\item{droplets}{A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
object, or a data frame with columns \code{Ch1.Amplitude} and
\code{Ch2.Amplitude}.}

\item{trainData}{A data frame of training data with columns
\code{Ch1.Amplitude} and \code{Ch2.Amplitude}.}

\item{cl}{A vector of classes corresponding to \code{trainData}.}

\item{k}{The number of nearest neighbours to use in the algorithm.}

\item{prob}{The minimal proportion of votes for the winning class needed to
assert that a droplet belongs to the class. This figure should be a float
between 0 and 1. For example, if 0.6 then at least 60% of a droplet's
k-nearest neighbours need to be of one class, otherwise it is classified as
"Rain". Defaults to 0, i.e. we do not use "Rain".}

\item{...}{Other options depending on the type of \code{droplets}.}

\item{fullTable}{If \code{TRUE}, returns a full data frame of droplets and
their classification; if \code{FALSE}, simply returns the classified vector.
Defaults to \code{TRUE}.}
}
\value{
An object with the new classification.

If \code{droplets} is a data frame, return data frame or factor
(depending on the value of \code{fullTable}) of the droplet classification
under the k-NN algorithm.
}
\description{
If \code{droplets} is a data frame, the droplets are classified
using the k-nearest neighbour algorithm against a training data set.

If \code{droplets} is a \code{ddpcrWell} object, the droplets
in the well are classified and returned in another \code{ddpcrWell} object.

If \code{droplets} is a \code{ddpcrPlate} object, the
wells are combined and classified together, with the resulting
classification assigned to the \code{ddpcrPlate} object.
}
\examples{
### Use the KRASdata dataset for all of these examples.

## Use k-means clustering to classify one sample. Use this as training
## data for the K-Nearest Neighbour algorithm.
trainingData <- KRASdata[["E03"]]
trainingData <- kmeansClassify(trainingData)$data

## Classify a dataframe using k-NN with k = 1 and the above training data.
aWell <- knnClassify(
           KRASdata[["F03"]],
           trainData=trainingData[, c("Ch1.Amplitude", "Ch2.Amplitude")],
           cl=trainingData$class,
           k=1)
dropletPlot(aWell, cMethod="class")  # visualising the classification

## We can change k to a larger number, here with a ddpcrWell object.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
aWell <- knnClassify(
           aWell,
           trainData=trainingData[, c("Ch1.Amplitude", "Ch2.Amplitude")],
           cl=trainingData$class,
           k=3)
dropletPlot(aWell, cMethod="knn")  # visualising the classification

## Changing the 'prob' parameter means that droplets with less than 'prob'
## of the votes will not be classified. We do this for a ddpcrPlate
## object.
krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
krasPlate <- knnClassify(
               krasPlate,
               trainData=trainingData[, c("Ch1.Amplitude", "Ch2.Amplitude")],
               cl=trainingData$class,
               k=3,
           prob=0.6)
dropletPlot(krasPlate, cMethod="knn")  # visualising the classification

}
\seealso{
This method uses the \code{\link[class]{knn}} function.

To manually set and retrieve classifications, use the
\code{\link{wellClassification}}, \code{\link{plateClassification}} and
\code{\link{plateClassificationMethod}} methods.

\code{kmeansClassify} provides a wrapper for the k-means clustering
algorithm.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCSVDataFrame.R
\name{extractPlateName}
\alias{extractPlateName}
\title{Try to get plate name from a filename.}
\usage{
extractPlateName(filename)
}
\arguments{
\item{filename}{A character string corresponding to a filename with .csv
extension.}
}
\value{
A character string corresponding to the plate name. This is "" if
filename is not in a known format.
}
\description{
If the given filename is of the form "<PlateName>_<WellName>_Amplitude.csv",
where <WellName> is of the form A01, B01, etc., then this function can
extract the <PlateName> component. Otherwise, an empty string is returned.
}
\examples{
## Get the plate name (recognised format).
extractPlateName(c("Sample_Plate_Name_G02_Amplitude.csv"))

## Get the plate name (unrecognised format).
extractPlateName(c("Sample_G02.csv"))

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gridClassify.R
\name{gridClassify}
\alias{gridClassify}
\alias{gridClassify,data.frame-method}
\alias{gridClassify,ddpcrWell-method}
\alias{gridClassify,ddpcrPlate-method}
\title{Use a 'grid' to create training data for classification algorithms.}
\usage{
gridClassify(
  droplets,
  ch1NNThreshold = 6500,
  ch2NNThreshold = 1900,
  ch1NPThreshold = 6500,
  ch2NPThreshold = 5000,
  ch1PNThreshold = 10000,
  ch2PNThreshold = 2900,
  ch1PPThreshold = 7500,
  ch2PPThreshold = 5000,
  ...
)

\S4method{gridClassify}{data.frame}(
  droplets,
  ch1NNThreshold = 6500,
  ch2NNThreshold = 1900,
  ch1NPThreshold = 6500,
  ch2NPThreshold = 5000,
  ch1PNThreshold = 10000,
  ch2PNThreshold = 2900,
  ch1PPThreshold = 7500,
  ch2PPThreshold = 5000,
  trainingData = TRUE,
  fullTable = TRUE,
  naLabel = ddpcr$rain
)

\S4method{gridClassify}{ddpcrWell}(
  droplets,
  ch1NNThreshold = 6500,
  ch2NNThreshold = 1900,
  ch1NPThreshold = 6500,
  ch2NPThreshold = 5000,
  ch1PNThreshold = 10000,
  ch2PNThreshold = 2900,
  ch1PPThreshold = 7500,
  ch2PPThreshold = 5000,
  classMethodLabel = "grid",
  naLabel = ddpcr$rain
)

\S4method{gridClassify}{ddpcrPlate}(
  droplets,
  ch1NNThreshold = 6500,
  ch2NNThreshold = 1900,
  ch1NPThreshold = 6500,
  ch2NPThreshold = 5000,
  ch1PNThreshold = 10000,
  ch2PNThreshold = 2900,
  ch1PPThreshold = 7500,
  ch2PPThreshold = 5000,
  classMethodLabel = "grid",
  naLabel = ddpcr$rain
)
}
\arguments{
\item{droplets}{A \code{\link{ddpcrWell}} object or a data frame of droplet
amplitudes with columns \code{Ch1.Amplitude} and \code{Ch2.Amplitude}.}

\item{ch1NNThreshold}{The channel 1 upper bound for the NN class. Defaults
to 6500.}

\item{ch2NNThreshold}{The channel 2 upper bound for the NN class. Defaults
to 1900.}

\item{ch1NPThreshold}{The channel 1 upper bound for the NP class. Defaults
to 6500.}

\item{ch2NPThreshold}{The channel 2 lower bound for the NP class. Defaults
to 5000.}

\item{ch1PNThreshold}{The channel 1 lower bound for the PN class. Defaults
to 10000.}

\item{ch2PNThreshold}{The channel 2 upper bound for the PN class. Defaults
to 2900.}

\item{ch1PPThreshold}{The channel 1 lower bound for the PP class. Defaults
to 7500.}

\item{ch2PPThreshold}{The channel 2 lower bound for the PP class. Defaults
to 5000.}

\item{...}{Other options depending on the type of \code{droplets}.}

\item{trainingData}{Whether to use the output as training data. If
\code{TRUE}, returns the _full table_ with the "N/A" entries removed; if
\code{FALSE}, the "N/A" entries are retained. Taken to be \code{FALSE} if
\code{fullTable} is set to \code{FALSE}. Defaults to \code{TRUE}. Ignored
if \code{droplets} is not a data frame.}

\item{fullTable}{Whether to return a data frame including amplitude
figures. If \code{TRUE}, a data frame with columns \code{Ch1.Amplitude},
\code{Ch1.Amplitude} and \code{class} is returned. If \code{FALSE}, a factor
with levels in \code{ddpcr$classesRain} is returned, where each entry
corresponds to each row in \code{droplets} (and \code{trainingData} is
automatically set to \code{FALSE}). Defaults to \code{TRUE}. Ignored if
\code{droplets} is not a data frame.}

\item{naLabel}{The label to use for unclassified droplets. Should be either
ddpcr$na ("N/A") or ddpcr$rain ("Rain"). Defaults to ddpcr$rain.}

\item{classMethodLabel}{A name (as a character string) of the classification
method. Defaults to "grid".}
}
\value{
If \code{droplets} is a data frame, return a data frame or factor
(depending on the \code{trainingData} and \code{fullTable} parameters) with
a classification for droplets in the chosen regions.

If \code{droplets} is a \code{ddpcrWell} object, return
a \code{ddpcrWell} object with the appropriate classification.

If \code{droplets} is a \code{ddpcrPlate} object, return
a \code{ddpcrPlate} object with the appropriate classification.
}
\description{
Classify droplets as "NN", "NP", "PN" or "PP". The
classification is based on upper bounds for negative readings and lower
bounds for positive readings; see the details and parameters for more
detail. If required (see the \code{trainingData} parameter), droplets that
are not classified will be given the label "N/A".
}
\details{
The \code{threshold} parameters correspond to those in the
following diagram:
\preformatted{Ch1 ^        |  |
    |        |  |
    |   PN   |  |
    |        |  |   PP
   e|________|  |
   g|........:..|_________
    |        :  :
   c|.............._______
   a|______  :  : |
    |      | :  : |  NP
    |  NN  | :  : |
    |      | :  : |
    --------------------->
           b f  h d    Ch2}
Specifically:
\describe{
  \item{a:}{\code{ch1NNThreshold},}
  \item{b:}{\code{ch2NNThreshold},}
  \item{c:}{\code{ch1PNThreshold},}
  \item{d:}{\code{ch2PNThreshold},}
  \item{e:}{\code{ch1NPThreshold},}
  \item{f:}{\code{ch2NPThreshold},}
  \item{g:}{\code{ch1PPThreshold},}
  \item{h:}{\code{ch2PPThreshold}.}
}
}
\examples{
## Use a grid to set training data for a data frame.
sgCl <- gridClassify(KRASdata[["E03"]],
                     ch1NNThreshold=5700, ch2NNThreshold=1700,
                     ch1NPThreshold=5400, ch2NPThreshold=5700,
                     ch1PNThreshold=9700, ch2PNThreshold=2050,
                     ch1PPThreshold=7200, ch2PPThreshold=4800)
str(sgCl)

## For data frame only, we can set the trainingData flag to FALSE so that
## the unclassified droplets are retained but labelled as "N/A"
sgCl <- gridClassify(KRASdata[["E03"]],
                     ch1NNThreshold=5700, ch2NNThreshold=1700,
                     ch1NPThreshold=5400, ch2NPThreshold=5700,
                     ch1PNThreshold=9700, ch2PNThreshold=2050,
                     ch1PPThreshold=7200, ch2PPThreshold=4800,
                     trainingData=FALSE)
dropletPlot(sgCl, cMethod="class")

## The same works for ddpcrWell objects.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
aWell <- gridClassify(aWell,
                      ch1NNThreshold=5700, ch2NNThreshold=1700,
                      ch1NPThreshold=5400, ch2NPThreshold=5700,
                      ch1PNThreshold=9700, ch2PNThreshold=2050,
                      ch1PPThreshold=7200, ch2PPThreshold=4800)
str(aWell)

## ddpcrPlate objects work in exactly the same way.
krasPlate <- ddpcrPlate(wells=KRASdata)
krasPlate <- gridClassify(krasPlate)
lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)

## The default classification method (column name) is 'gridClassify',
## which may be a bit long. It can be changed.
krasPlate <- gridClassify(krasPlate, classMethodLabel="training")
lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)

}
\seealso{
\code{\link{thresholdClassify}} is a special case of this
function.

\code{\link{removeDropletClasses}} retrieves a data frame with the
"N/A" (and "Rain") droplets removed. This can used for transforming
a grid-like classification into usable training data.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plateSummary.R
\name{.roundIt}
\alias{.roundIt}
\title{Round to at least n decimal places.}
\usage{
.roundIt(df, n = 3)
}
\arguments{
\item{df}{A data frame.}

\item{n}{How many decimal places/significant figures to round to.}
}
\value{
The data frame \code{x} with rounded entries.
}
\description{
For a data frame, if an extry is < 1, then round it to n significant
figures. If it is >= 1, then round it to n decimal places.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinyVisUI.R
\name{textInputRow}
\alias{textInputRow}
\title{Inline \code{textInputs}.}
\usage{
textInputRow(inputId, label, value = "", size = NULL)
}
\arguments{
\item{inputId}{The identifier for the textInput object.}

\item{label}{The text label to display alongside.}

\item{value}{The default value of the textInput.}

\item{size}{The size (width) and maxlength.}
}
\value{
A \code{div} with the appropriate label and input field.
}
\description{
By default, \code{\link[shiny]{textInput}} objects are added to the page
below each other. This function allows for inline \code{textInput} fields.
}
\references{
Adapted from: http://stackoverflow.com/a/21132918/1262569
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mahRain.R
\name{mahalanobisRain}
\alias{mahalanobisRain}
\alias{multivariateRain}
\alias{multivariateNormalRain}
\alias{mvNormalRain}
\alias{mvnRain}
\alias{mahalanobisRain,data.frame-method}
\alias{mahalanobisRain,ddpcrWell-method}
\alias{mahalanobisRain,ddpcrPlate-method}
\title{Define 'rain' (unclassified) droplets by fitting the clusters to
bivariate normal distributions.}
\usage{
mahalanobisRain(droplets, cMethod, maxDistances = 30, ...)

\S4method{mahalanobisRain}{data.frame}(droplets, cMethod, maxDistances = 30, fullTable = TRUE)

\S4method{mahalanobisRain}{ddpcrWell}(droplets, cMethod, maxDistances = 30)

\S4method{mahalanobisRain}{ddpcrPlate}(droplets, cMethod, maxDistances = 30)
}
\arguments{
\item{droplets}{A \code{ddpcrWell} or \code{ddpcrPlate} object, or
a data frame of droplets with "Ch1.Amplitude" and "Ch2.Amplitude" columns,
as well as a class column.}

\item{cMethod}{The name or column number of the classification for which we
want to add rain to.}

\item{maxDistances}{A list of (levels) with keys in \code{c("NN", "PN",
"NP", "PP")}. If the list is empty or set as \code{NULL}, no rain is added.
If set as a single integer \code{n}, this value is taken for all classes,
i.e. \code{list("NN"=n, "PN"=n, "NP"=n, "PP"=n)}.}

\item{...}{Other options depending on the type of \code{droplets}.}

\item{fullTable}{If \code{TRUE}, returns a full data frame of droplets and
their classification; if \code{FALSE}, simply returns a factor corresponding
to this classification. Defaults to \code{TRUE}.}
}
\value{
An object where the specified class has "Rain" entries added.
}
\description{
Assume that each of the classified clusters are bivariate normally
distributed. We add fuzziness to the classifications by assigning droplets
far away from the centres as "Rain". We use the Mahalanobis distance for
each cluster to determine whether a droplet is 'too far away'.
}
\examples{
## Take a data frame of droplets of transform it into the rigth format.
droplets <- KRASdata[["E03"]]
droplets$Cluster <- relabelClasses(droplets, classCol="Cluster")

## Add rain as a new column.
droplets$ClusterMahRain <-
    mahalanobisRain(droplets, cMethod="Cluster", fullTable=FALSE)
table(droplets$ClusterMahRain)

## The maximum distance around each mean can be changed uniformly.
droplets$ClusterMahRain <-
    mahalanobisRain(droplets, cMethod="Cluster", maxDistances=35,
                    fullTable=FALSE)
table(droplets$ClusterMahRain)

## Or we can change the maximum distances for each individual cluster.
droplets$ClusterMahRain <-
    mahalanobisRain(droplets, cMethod="Cluster",
                    maxDistances=list(NN=35, NP=30, PN=30, PP=30),
                    fullTable=FALSE)
table(droplets$ClusterMahRain)

# This method works the same for ddpcrWell objects.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
aWell <- mahalanobisRain(aWell, cMethod="Cluster")
table(wellClassification(aWell, cMethod="ClusterMahRain"))

# Likewise for ddpcrPlate objects.
krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
krasPlate <- mahalanobisRain(krasPlate, cMethod="Cluster")
lapply(plateClassification(krasPlate, cMethod="ClusterMahRain"), table)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaries.R
\name{wildTypeCopiesSummary}
\alias{wildTypeCopiesSummary}
\title{Get the wild type copies per 20ul of a data frame in the context of the
basic counts.}
\usage{
wildTypeCopiesSummary(df)
}
\arguments{
\item{df}{A data frame generated by \code{\link{fullCountsSummary}}.}
}
\value{
A data frame with the basic columns and wild type copies per 20ul.
}
\description{
Returns a data frame with the basic figures and the number of wild type
copies per 20ul.
}
\examples{
df <- fullCountsSummary(KRAScountsQS)
wildTypeCopiesSummary(df)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wellNameSort.R
\name{sortDataFrame}
\alias{sortDataFrame}
\title{Sorts a data frame according to the well names.}
\usage{
sortDataFrame(df, sortByLetter = FALSE)
}
\arguments{
\item{df}{A data frame with row names of the form A01, A02, B01, etc.}

\item{sortByLetter}{If \code{TRUE}, the resulting list is sorted by the
letter in the well names first, e.g. "A02" comes before "B01". If
\code{FALSE}, the result is sorted by the numeric component of the well
names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.}
}
\value{
The data frame \code{df} with the rows sorted.
}
\description{
Well names can be sorted according to the leading letter or the trailing
digit.
}
\examples{
## Sort a subset of the KRAScounts data frame.
df <- KRAScounts[, c("Ratio", "FracAbun")]
sortDataFrame(df=df, sortByLetter=FALSE)
sortDataFrame(df=df, sortByLetter=TRUE)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/twoddpcr.R
\docType{package}
\name{twoddpcr-package}
\alias{twoddpcr}
\alias{twoddpcr-package}
\title{Classifying and summarising 2-d droplet digitial PCR (ddPCR) data.}
\description{
The \code{twoddpcr} package takes droplet amplitude data from 
Bio-Rad's QuantaSoft and can classify the droplets. A summary of the 
positive/negative droplet counts can be generated, which can then be used to 
estimate the number of molecules using the Poisson distribution.
}
\seealso{
Useful links:
\itemize{
  \item \url{http://github.com/CRUKMI-ComputationalBiology/twoddpcr/}
  \item Report bugs at \url{http://github.com/CRUKMI-ComputationalBiology/twoddpcr/issues/}
}

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/isTwoDimDataFrame.R
\name{setChannelNames}
\alias{setChannelNames}
\alias{setChannelNames,data.frame-method}
\alias{setChannelNames,list-method}
\title{Rename the channels.}
\usage{
setChannelNames(droplets, ch1 = "Ch1.Amplitude", ch2 = "Ch2.Amplitude")

\S4method{setChannelNames}{data.frame}(droplets, ch1 = "Ch1.Amplitude", ch2 = "Ch2.Amplitude")

\S4method{setChannelNames}{list}(droplets, ch1 = "Ch1.Amplitude", ch2 = "Ch2.Amplitude")
}
\arguments{
\item{droplets}{A data frame or list of data frames. Each data frame should
have at least two columns, where the first two columns should be vectors of
doubles.}

\item{ch1}{The channel 1 label.}

\item{ch2}{The channel 2 label.}
}
\value{
The object \code{droplets} with the channels renamed.
}
\description{
We use the channel names "Ch1.Amplitude" and "Ch2.Amplitude" by default.
This method allows us to change it at will.
}
\examples{
## Ensure that a data frame has channels named "Ch1.Amplitude" and
## "Ch2.Amplitude".
aWell <- KRASdata[["E03"]]
aWell <- setChannelNames(aWell)
colnames(aWell)

## Perhaps we want to abbreviate the channel names.
aWell <- setChannelNames(aWell, "Ch1", "Ch2")
colnames(aWell)

## The same operator works for a list of data frames.
krasWells <- KRASdata
krasWells <- setChannelNames(krasWells, "Ch1", "Ch2")
lapply(krasWells, colnames)[1:3]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dropletPlot.R
\name{drawBlank}
\alias{drawBlank}
\title{Plot nothing.}
\usage{
drawBlank()
}
\value{
A blank \code{ggplot} object.
}
\description{
We may sometimes request that the \code{\link{dropletPlot}} method takes an
empty data frame as its argument, e.g. an empty CSV file is loaded. This
normally presents an error, which is not the desired output. This function
plots nothing to show that there was no data to plot.
}
\seealso{
\code{\link{ggplot.well}} and
\code{\link[=ggplot.well]{ggplot.plate}} are wrappers for plotting
\code{\link{ddpcrWell}} and \code{\link{ddpcrPlate}} objects.

If there is at least one droplet, the \code{\link{dropletPlot}}
method plots droplet amplitude classifications.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalise.R
\name{.renormaliseWell}
\alias{.renormaliseWell}
\title{Normalise a well in both channels and then transform it back to the original
(combined) scale.}
\usage{
.renormaliseWell(allDf, well, combinedCentres, indivCentres1, indivCentres2)
}
\arguments{
\item{allDf}{A list of data frames, where each one corresponds to a well's
droplet amplitudes.}

\item{well}{The name or number of the well to normalise.}

\item{combinedCentres}{A data frame of the combined (average) centres of the
non-normalised wells.}

\item{indivCentres1}{A data frame of centres corresponding to channel 1.}

\item{indivCentres2}{A data frame of centres corresponding to channel 2.}
}
\value{
A list of data frames with the rescaled amplitudes in both channels.
}
\description{
Normalise a well in both channels and then transform it back to the original
(combined) scale.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exportTable.R
\name{exportTable}
\alias{exportTable}
\alias{exportTable,data.frame-method}
\alias{exportTable,ddpcrWell-method}
\alias{exportTable,ddpcrPlate-method}
\alias{exportZip}
\alias{exportZip,ddpcrPlate-method}
\title{Exports an object to file.}
\usage{
exportTable(theObject, location, delim = ",", ...)

\S4method{exportTable}{data.frame}(
  theObject,
  location,
  delim = ",",
  leadingColName = NULL,
  row.names = TRUE
)

\S4method{exportTable}{ddpcrWell}(theObject, location, delim = ",", cMethod = NULL)

\S4method{exportTable}{ddpcrPlate}(
  theObject,
  location,
  delim = ",",
  cMethod = NULL,
  prefix = "",
  suffix = "_Amplitude.csv"
)

exportZip(
  theObject,
  location,
  delim = ",",
  cMethod = NULL,
  prefix = "",
  suffix = "_Amplitude.csv"
)

\S4method{exportZip}{ddpcrPlate}(
  theObject,
  location,
  delim = ",",
  cMethod = NULL,
  prefix = "",
  suffix = "_Amplitude.csv"
)
}
\arguments{
\item{theObject}{The dataframe to export.}

\item{location}{The location to export to. This should be a filename if we
are using \code{exportZip}, or we are using \code{exportTable} and
\code{theObject} is a data frame or \code{ddpcrWell} object. If
\code{theObject} is a \code{ddpcrPlate} object, this should be
a directory.}

\item{delim}{The character to use as a field separator. Defaults to ",",
i.e. export a CSV.}

\item{...}{Other options depending on the type of \code{theObject}.}

\item{leadingColName}{The name of the leading column, i.e. the 'row names'
of the dataframe. This could be a patient identifier or the well used in the
ddPCR experiment. If \code{NULL}, the exported heading will be an empty
string. Defaults to \code{NULL}.}

\item{row.names}{If \code{NULL}, exports a column corresponding to the row
names; if \code{FALSE}, no such column is included. If 'leadingColName' is
not \code{FALSE}, row.names is assumed to be \code{FALSE}. Defaults to
\code{TRUE}.}

\item{cMethod}{The name or column number of the classification methods in
a \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}} object to export
to file. If \code{NULL}, all of the classification methods are exported.
Defaults to \code{NULL}.}

\item{prefix}{For \code{ddpcrPlate} objects, this is the prefix to
prepend to the output filenames.}

\item{suffix}{For \code{ddpcrPlate} objects, this is the suffix to
append to the output filenames. This is typically the filename extension,
e.g. ".csv" or ".txt". Defaults to ".csv".}
}
\value{
Exports a file.
}
\description{
If given a data frame, \code{exportTable} exports the whole
data frame to file. This could be a data frame of any form. A few options
are available that can be used to determine the format of the file that is
exported, e.g. using a heading for the row names 'column', or omitting row
names altogether.

If a \code{ddpcrWell} is given, \code{exportTable} exports to
a single file with specified/all classification methods.

If a \code{ddpcrPlate} is given, \code{exportTable}
exports to a directory in the given \code{location}, where one file is
created for each of the wells. If it does not exist, the directory
\code{location} will be created as long as all other parent directories
exist.

\code{exportZip} takes a \code{ddpcrPlate} object and
exports it as a zip file.
}
\details{
Note that filenames of the form \code{Anything_A01_Amplitude.csv}
can be read by \code{\link{readCSVDataFrame}} so that the well name can be
extracted successfully (in this case \code{A01}). Where it is used, see the
default value of the parameter \code{suffix}.
}
\examples{
## Output to a temporary directory.
tmpOut <- file.path(normalizePath(tempdir()))

## Read some counts data and generate a summary data frame.
df <- fullCountsSummary(KRAScountsQS)
summaryDf <- fullCopiesSummary(df)

## Write the summary to a CSV file.
exportTable(summaryDf, file.path(tmpOut, "summary-table.csv"))

## Write the summary to a tab-separated text file.
exportTable(summaryDf, file.path(tmpOut, "summary-table.txt"), delim="\t")

## Write the summary to a CSV file with leading column labelled "Patient".
exportTable(summaryDf, file.path(tmpOut, "summary-table.csv"),
            leadingColName="Patient")

## Read a droplet amplitude CSV file to a ddpcrWell object.
ampFile <- system.file("extdata", "amplitudes", "sample_B03_Amplitude.csv",
                       package="twoddpcr")
aWell <- ddpcrWell(well=ampFile)

## Classify the droplets into 4 clusters.
aWell <- kmeansClassify(aWell, centres=4)

## Write the amplitudes to a CSV file with the old and new classifications.
exportTable(aWell,
  location=file.path(tmpOut, "With_Kmeans_B03_Amplitude.csv"))

## Write the amplitudes to a CSV file with the new classification only.
exportTable(aWell,
  location=file.path(tmpOut, "With_Kmeans_B03_Amplitude.csv"),
  cMethod="kmeans")

## Read all amplitude files in a directory to a ddpcrPlate object.
moreAmpsDir <- system.file("extdata", "more-amplitudes", package="twoddpcr")
krasPlate <- ddpcrPlate(wells=moreAmpsDir)

## Classify the droplets into 4 clusters.
krasPlate <- kmeansClassify(krasPlate, centres=4)

## Write the amplitudes to multiple files in a directory with the old and
## new classifications.
exportTable(krasPlate, location=file.path(tmpOut, "amplitudes-classified"))

## Write the amplitudes to multiple files with the new classification only
## and a custom prefix for the filenames.
exportTable(krasPlate, location=file.path(tmpOut, "amplitudes-classified"),
            cMethod="kmeans", prefix="Kmeans_Only_")

## Export to a zip file.
exportZip(krasPlate,
          location=file.path(tmpOut, "amplitudes-classified/all.zip"),
          cMethod="kmeans", prefix="Kmeans_Only_")



}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mahRain.R
\name{.mahDist}
\alias{.mahDist}
\title{Mahalanobis distance of droplets from a distribution.}
\usage{
.mahDist(droplets, clusStats)
}
\arguments{
\item{droplets}{A data frame of droplets with \code{Ch1.Amplitude} and
\code{Ch2.Amplitude} columns.}

\item{clusStats}{A list of statistics for a cluster generated by
\code{\link{classStats}}. This should have a \code{mean}, \code{cov} and
\code{cov.inv} values.}
}
\value{
A vector of numbers, where each one corresponds to the distance of
that droplet from the given distribution.
}
\description{
Find the Mahalanobis distance of all droplets from a given distribution.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaries.R
\name{fullCopiesSummary}
\alias{fullCopiesSummary}
\title{Get all of the counts data in a summarised data frame.}
\usage{
fullCopiesSummary(df, extraCols = NULL)
}
\arguments{
\item{df}{A data frame generated by \code{\link{fullCountsSummary}}.}

\item{extraCols}{A vector of column names from \code{df} to include. If
\code{NULL}, no extra columns are added. Defaults to \code{NULL}.}
}
\value{
A data frame with the basic figures, the mutant counts, the wild
type counts, the summarised counts, and extraCols if specified. Prints an
additional column for notes, indicating whether this run failed or if there
were fewer than 8000 accepted droplets.
}
\description{
Returns a data frame with all the copies information, plus any optional
columns. This function is intended to be used as a final summary of the
molecule counts.
}
\examples{
df <- fullCountsSummary(KRAScountsQS)
fullCopiesSummary(df)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sdRain.R
\name{sdRain}
\alias{sdRain}
\alias{sdRain,data.frame-method}
\alias{sdRain,ddpcrWell-method}
\alias{sdRain,ddpcrPlate-method}
\title{Add rain to a classification by using a chosen multiple of standard
deviation.}
\usage{
sdRain(droplets, cMethod, errorLevel = 5, ...)

\S4method{sdRain}{data.frame}(droplets, cMethod, errorLevel = 5, fullTable = TRUE)

\S4method{sdRain}{ddpcrWell}(droplets, cMethod, errorLevel = 5)

\S4method{sdRain}{ddpcrPlate}(droplets, cMethod, errorLevel = 5)
}
\arguments{
\item{droplets}{A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
object, or a droplet data frame including a classification column.}

\item{cMethod}{The name or column number of the classification for which we
want to add rain to.}

\item{errorLevel}{How many multiples of standard deviation from the mean of
each cluster to retain. Can be a list where each item corresponds to a class
name and the multiple for that class. Can also be a numeric vector of length
1, which is equivalent to a list with all the same entries. Defaults to 5.}

\item{...}{Other options depending on the type of \code{droplets}.}

\item{fullTable}{If \code{TRUE}, returns a full data frame of droplets with
an extra column of rainy data; if \code{FALSE}, simply returns a factor
where each entry corresponds to an entry in the original classification
column with added rain. Defaults to \code{FALSE}.}
}
\value{
If \code{droplets} is a data frame, return a data frame or factor
(depending on \code{fullTable}) where droplets with ambiguous
classifications are labelled as "Rain".

If \code{droplets} is a \code{ddpcrWell} object, return
a \code{ddpcrWell} object with a rainy classification.

If \code{droplets} is a \code{ddpcrPlate} object, return
a \code{ddpcrPlate} object with a rainy classifications.
}
\description{
Although we can use various algorithms to classify all droplets
in a ddPCR experiment, there will be some variation between the
classifications. We can perhaps have a relatively high confidence that
droplets near the centres of clusters do indeed belong to that cluster,
whereas we probably have a lower confidence in the classification of those
further away, say, near the 'boundary' of two clusters. We may view these
droplets (or a subset of them) as having an ambiguous class. This function
allows us to only consider droplets classified within a certain distance of
the means of each cluster and label the rest as "Rain".
}
\examples{
## Compare the types of droplets in a single well for the "Cluster" class
## and then with rain.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
aWell <- sdRain(aWell, cMethod="Cluster")
cl <- wellClassification(aWell)
table(cl$Cluster)
table(cl$ClusterSdRain)

## Compare the types of droplets in multiple wells for the "Cluster" class
## and then with rain.
krasPlate <- ddpcrPlate(wells=KRASdata[c("E03", "H03", "C04", "F04")])
krasPlate <- sdRain(krasPlate, cMethod="Cluster")
plateSummary(krasPlate, cMethod="Cluster")[, c(1:5)]
plateSummary(krasPlate, cMethod="ClusterSdRain")[, c(1:5)]

## The 'errorLevel' parameter can changed.
krasPlate <- sdRain(krasPlate, cMethod="Cluster", errorLevel=4)
plateSummary(krasPlate, cMethod="ClusterSdRain")[, c(1:5)]

## The 'errorLevel' parameter can also be changed for each cluster.
krasPlate <- sdRain(krasPlate, cMethod="Cluster",
                    errorLevel=list(NN=5, NP=5, PN=4, PP=3))
plateSummary(krasPlate, cMethod="ClusterSdRain")[, c(1:5)]

}
\references{
This approach was described in {Jones, M., Williams, J.,
Gaertner, K., Phillips, R., Hurst, J., & Frater, J. (2014). Low copy target
detection by Droplet Digital PCR through application of a novel open access
bioinformatic pipeline, "definetherain." Journal of Virological Methods,
202(100), 46--53. \url{http://doi.org/10.1016/j.jviromet.2014.02.020}}
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaries.R
\name{.totalCopies}
\alias{.totalCopies}
\title{Get the total number of molecules in 20ul.}
\usage{
.totalCopies(df)
}
\arguments{
\item{df}{An input data frame with copies per 20ul figures.}
}
\value{
A vector listing the total numbers of copies per 20ul well.
}
\description{
Get the total number of copies of mutant and wild type molecules in a 20ul
well.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/heatPlot.R
\name{heatPlot}
\alias{heatPlot}
\alias{densityPlot}
\alias{heatPlot,data.frame-method}
\alias{heatPlot,ddpcrWell-method}
\alias{heatPlot,ddpcrPlate-method}
\title{Draw a heat plot of the droplets.}
\usage{
heatPlot(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  binwidth = 100,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)

heatPlot(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  binwidth = 100,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)

\S4method{heatPlot}{data.frame}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  binwidth = 100,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)

\S4method{heatPlot}{ddpcrWell}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  binwidth = 100,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)

\S4method{heatPlot}{ddpcrPlate}(
  droplets,
  ch1Label = "Ch1 Amplitude",
  ch2Label = "Ch2 Amplitude",
  binwidth = 100,
  plotLimits = list(x = c(1000, 9000), y = c(3000, 13500))
)
}
\arguments{
\item{droplets}{A data frame of droplet amplitudes, a \code{ggplot},
\code{ddpcrWell} or \code{ddpcrPlate} object.}

\item{ch1Label}{The label for the channel 1 target. Defaults to "Ch1
Amplitude".}

\item{ch2Label}{The label for the channel 2 target. Defaults to "Ch2
Amplitude".}

\item{binwidth}{The width of each hexagonal bin in the 2d heat (density)
plot. Defaults to 100.}

\item{plotLimits}{A list of 2-element vectors with names \code{x} and
\code{y}. These are used to fix the x and y limits of the plot, which is
especially useful for comparing plots. Defaults to \code{list(x=c(1000,
9000), y=c(3000, 13500))}.}
}
\value{
A heat plot as a \code{\link[ggplot2]{ggplot}} object.
}
\description{
Using alpha transparency only, it is generally difficult to see
where droplets are truly distributed and concentrated. A heat (density) plot
gives a better illustration of this.
}
\examples{
## Density plot of a data frame.
heatPlot(KRASdata[["E03"]])

## Density plot of a ddpcrWell object.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
heatPlot(aWell)

## Density plot of a ddpcrPlate object with an adjusted bin size.
krasPlate <- ddpcrPlate(wells=KRASdata)
heatPlot(krasPlate, binwidth=50)

}
\references{
The nice log-scaled palette was achieved using
\url{http://www.everydayanalytics.ca/2014/09/5-ways-to-do-2d-histograms-in-r.html}
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/global.R
\docType{data}
\name{ddpcr}
\alias{ddpcr}
\title{An environment for package variables.}
\format{
An object of class \code{environment} of length 10.
}
\usage{
ddpcr
}
\value{
An environment for storing package variables.
}
\description{
Stores default variables used in the package.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plateSummary.R
\name{plateSummary}
\alias{plateSummary}
\alias{plateSummary,list-method}
\alias{plateSummary,ddpcrPlate-method}
\title{Counts the number of positives and negatives in an experiment and
produces estimates for the number of molecules.}
\usage{
plateSummary(
  wells,
  ...,
  ch1Label = "Mt",
  ch2Label = "Wt",
  sortByLetter = FALSE
)

\S4method{plateSummary}{list}(wells, ch1Label = "Mt", ch2Label = "Wt", sortByLetter = FALSE)

\S4method{plateSummary}{ddpcrPlate}(
  wells,
  cMethod,
  ch1Label = "Mt",
  ch2Label = "Wt",
  sortByLetter = FALSE
)
}
\arguments{
\item{wells}{Either a \code{\link{ddpcrPlate}} object or a list of data
frames, each of which comprises droplet amplitudes and their corresponding
classifications in a given well.}

\item{...}{Other options depending on the type of \code{wells}.}

\item{ch1Label}{The prefix to use for the channel 1 target. Defaults to
"Mt".}

\item{ch2Label}{The prefix to use for the channel 2 target. Defaults to
"Wt".}

\item{sortByLetter}{If \code{TRUE}, the resulting data frame is sorted by
the letter in the well names first, e.g. "A02" comes before "B01". If
\code{FALSE}, the result is sorted by the numeric component of the well
names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.}

\item{cMethod}{The classification method to create a summary for.}
}
\value{
A data frame with droplet counts and molecules number estimates for
each well.
}
\description{
Takes a collection of classified droplets, each corresponding to a well, and
produces a list of positive/negative counts and estimates of how many
molecules are in each well.
}
\examples{
## Take a ddpcrPlate object and summarise its wells.
krasPlate <- ddpcrPlate(KRASdata)
plateSummary(krasPlate, cMethod="Cluster")

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/numDroplets.R
\name{numDroplets}
\alias{numDroplets}
\alias{numberDroplets}
\alias{numDrops}
\alias{numberDrops}
\alias{numberOfDroplets}
\alias{numOfDroplets}
\alias{numberOfDrops}
\alias{numDroplets,ddpcrWell-method}
\alias{numDroplets,ddpcrPlate-method}
\title{Retrieve the number of droplets.}
\usage{
numDroplets(theObject, ...)

\S4method{numDroplets}{ddpcrWell}(theObject)

\S4method{numDroplets}{ddpcrPlate}(theObject)
}
\arguments{
\item{theObject}{A \code{\link{ddpcrPlate}} object.}

\item{...}{Other parameters depending on the type of \code{theObject}.}
}
\value{
For \code{ddpcrWell} objects, return the number of droplets as an
integer.

For \code{ddpcrPlate} objects, return a named vector. The names
correspond to a well name and each item corresponding to the number of
droplets in that well.
}
\description{
Retrieves the number of droplets in a \code{\link{ddpcrWell}} or
\code{\link{ddpcrPlate}} object.
}
\examples{
## Count the number of droplets in a well.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
numDroplets(aWell)

## Get all of the wells in a named vector.
krasPlate <- ddpcrPlate(wells=KRASdata)
(numberDroplets <- numDroplets(krasPlate))
sum(numberDroplets)

## We can choose to get a subset of the wells.
(numberDroplets <- numDroplets(krasPlate[c("H03", "A04")]))
sum(numberDroplets)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wellNameSort.R
\name{sortWells}
\alias{sortWells}
\title{Return given well names sorted.}
\usage{
sortWells(wellNames, sortByLetter)
}
\arguments{
\item{wellNames}{The well names to sort.}

\item{sortByLetter}{If \code{TRUE}, the resulting list is sorted by the
letter in the well names first, e.g. "A02" comes before "B01". If
\code{FALSE}, the result is sorted by the numeric component of the well
names first, e.g. "B01" comes before "A02". Defaults to \code{FALSE}.}
}
\value{
The well names sorted.
}
\description{
Well names can be sorted according to the leading letter or the trailing
digit.
}
\examples{
## Use the KRASdata dataset as an example.
plate <- ddpcrPlate(wells=KRASdata)
wellNames <- names(plate)

## Sample sorting.
sortWells(wellNames=wellNames, sortByLetter=FALSE)
sortWells(wellNames=wellNames, sortByLetter=TRUE)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrWell.R
\name{.getClassificationData}
\alias{.getClassificationData}
\title{Extract a classification from a data frame.}
\usage{
.getClassificationData(colName, well)
}
\arguments{
\item{colName}{The name of the column to focus on.}

\item{well}{The data frame from which to extract the classifications.}
}
\value{
A factor with levels in \code{ddpcr$classesRain}.
}
\description{
Check that non-Ch*Amplitude columns are in a known classification format and
coerce it to a factor.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusterStats.R
\name{classCov}
\alias{classCov}
\title{Get the covariance of each cluster.}
\usage{
classCov(droplets, classCol = "class")
}
\arguments{
\item{droplets}{A data frame of droplets with \code{Ch1.Amplitude} and
\code{Ch2.Amplitude} columns, as well as a class column (see the parameter
\code{classCol}).}

\item{classCol}{The column (name or number) from \code{droplets}
representing the class.}
}
\value{
A list of covariance matrices of each cluster.
}
\description{
After classifying droplets, we can compute the covariance for each class.
}
\examples{
## Get the covariance matrix of the clusters.
aWell<- KRASdata[["E03"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
classCov(aWell, classCol="Cluster")

## We repeat the above but with a sample with no "PP" cluster.
aWell <- KRASdata[["H04"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")
classCov(aWell, classCol="Cluster")

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaries.R
\name{basicsSummary}
\alias{basicsSummary}
\title{Get the very basic columns of a data frame.}
\usage{
basicsSummary(df)
}
\arguments{
\item{df}{A data frame generated by \code{\link{fullCountsSummary}}.}
}
\value{
A data frame with the \code{PP}, \code{PN}, \code{NP}, \code{NN} and
\code{AcceptedDroplets} figures.
}
\description{
It is useful to see the droplet counts for each class in addition to the
overall droplet count at a glance.
}
\examples{
df <- fullCountsSummary(KRAScountsQS)
basicsSummary(df)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinyVisApp.R
\name{shinyVisApp}
\alias{shinyVisApp}
\title{Shiny app.}
\usage{
shinyVisApp()
}
\value{
A Shiny application
}
\description{
A shiny app for interactive ddPCR droplet classification.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseCounts.R
\name{fullCountsSummary}
\alias{fullCountsSummary}
\title{Take a data frame and compute the abundance of molecules.}
\usage{
fullCountsSummary(
  df,
  ch1Label = "Mt",
  ch2Label = "Wt",
  rows = NULL,
  rowID = NULL,
  keepCols = NULL,
  keepColNames = NULL
)
}
\arguments{
\item{df}{A data frame with droplet count columns in one of the following
formats:
\itemize{
  \item{\code{PP}, \code{PN}, \code{NP}, \code{NN}};
  \item{\code{Ch1.Ch2.}, \code{Ch1.Ch2..1}, \code{Ch1.Ch2..2},
  \code{Ch1.Ch2..3}};
  \item{\code{Ch1+Ch2+}, \code{Ch1+Ch2-}, \code{Ch1-Ch2+}, \code{Ch1-Ch2-}};
  or
  \item{\code{Ch1pCh2p}, \code{Ch1pCh2n}, \code{Ch1nCh2p}, \code{Ch1nCh2n}}.
}}

\item{ch1Label}{The prefix to use for the channel 1 target. Defaults to
"Mt".}

\item{ch2Label}{The prefix to use for the channel 2 target. Defaults to
"Wt".}

\item{rows}{A vector of rows (numbers or well names) to keep from the
original data frame. If set to \code{NULL}, all wells will be used. Defaults
to \code{NULL}.}

\item{rowID}{If set, this field is used as the row names. If \code{NULL},
the existing row names from \code{df} are used. Defaults to \code{NULL}.}

\item{keepCols}{A vector of columns to keep from \code{df}. If \code{NULL},
no extra columns are added. Defaults to \code{NULL}.}

\item{keepColNames}{A vector of new column names for \code{keepCols}. If
\code{NULL}, the column names from \code{keepCols} are reused. Defaults to
\code{NULL}.}
}
\value{
A data frame with
\itemize{
  \item \code{rowID} as the row names (if given);
  \item the droplet counts per channel;
  \item the number of ch1 and ch2 positive and negative readings;
  \item the ch1 and ch2 concentration, copies per 20ul, and total copies per
  20ul;
  \item the ratio of ch1 to ch2 molecules; and
  \item the fractional abundance of ch1 molecules in the overall molecule
  count (as a percentage).
}
}
\description{
Returns a data frame with basic counts, the concentration of each kind of
target molecule, the ratio ch1:ch2 molecules, and the fractional abundance
of ch1 molecules in the overall count.
}
\examples{
## Take a data frame with row names given by the well names. Get estimates
## for the numbers of molecules in each sample..
fullCountsSummary(KRAScounts)

## Keep only the row numbers 3, 6 and 9.
fullCountsSummary(KRAScounts, rows=c(3, 6, 9))

## Keep only the rows labelled "F03", "A04", "D04".
fullCountsSummary(KRAScounts, rows=c("F03", "A04", "D04"))

## Take a data frame with a 'Well' column and do the same as above.
fullCountsSummary(KRAScountsWellCol, rowID="Well")

## Keep the 'InputAmount' column.
fullCountsSummary(KRAScounts, keepCols=c("InputAmount"))

## Keep the 'InputAmount' column and rename it.
fullCountsSummary(KRAScounts, keepCols=c("InputAmount"),
                  keepColNames=c("NanogramsIn"))
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrWell.R
\docType{class}
\name{ddpcrWell-class}
\alias{ddpcrWell-class}
\alias{.ddpcrWell}
\alias{ddpcrWell}
\alias{ddpcrWell,data.frame-method}
\alias{ddpcrWell,character-method}
\alias{ddpcrWell,missing-method}
\alias{ddpcrWell,ddpcrWell-method}
\alias{show,ddpcrWell-method}
\title{An S4 class for the classification of a single well in a ddPCR
experiment.}
\usage{
ddpcrWell(well)

\S4method{ddpcrWell}{data.frame}(well)

\S4method{ddpcrWell}{character}(well)

\S4method{ddpcrWell}{missing}(well)

\S4method{ddpcrWell}{ddpcrWell}(well)

\S4method{show}{ddpcrWell}(object)
}
\arguments{
\item{well}{A well with columns \code{Ch1.Amplitude} and
\code{Ch2.Amplitude} and optional classification columns. This can be in the
form of a data frame or the path to a droplet amplitude CSV file.}

\item{object}{Any R object}
}
\value{
A \code{ddpcrWell} object with the given droplets in the well.
}
\description{
An S4 class for the classification of a single well in a ddPCR
experiment.

The constructor for the \code{ddpcrWell} class.
}
\section{Slots}{

\describe{
\item{\code{dropletAmplitudes}}{A data frame with columns \code{Ch1.Amplitude}
and \code{Ch2.Amplitude} corresponding to all the droplets in the ddPCR
well.}

\item{\code{classification}}{A vector of factors, where the levels are given by
\code{ddpcr$classesRain}.}
}}

\examples{
## A \code{ddpcrWell} object can be created from data from a list of data
## frames.
ddpcrWell(KRASdata[[1]])

## An CSV file of droplet amplitudes can also be loaded.
ampFile <- system.file("extdata/amplitudes/sample_B03_Amplitude.csv",
                       package="twoddpcr")
ddpcrWell(ampFile)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}

Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/themes.R
\name{whiteTheme}
\alias{whiteTheme}
\title{Use a theme with a white background and grey lines.}
\usage{
whiteTheme(legendPosition = "right", legendJustification = "center")
}
\arguments{
\item{legendPosition}{Where to position the legend. This can be "none",
"left", "right", "bottom", "top" or a numeric vector of length two. See the
documentation for \code{\link[ggplot2]{theme}}.}

\item{legendJustification}{The justification to use for the legend
positioning. This should be "center" or a two-element vector. Defaults to
"center".}
}
\value{
A \code{ggplot} theme layer.
}
\description{
The default \code{\link[ggplot2]{ggplot}} theme has a grey background. This
layer can be added to change the aesthetics.
}
\examples{
## Get a data frame in the right format.
aWell <- KRASdata[["E03"]]
aWell$Cluster <- relabelClasses(aWell, classCol="Cluster")

## Plot it with the white theme.
ggplot2::ggplot(aWell, ggplot2::aes(x=Ch2.Amplitude, y=Ch1.Amplitude)) +
  ggplot2::geom_point(ggplot2::aes(colour=Cluster)) +
  whiteTheme()

}
\seealso{
This function uses \code{\link[ggplot2]{theme}}.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCSVDataFrame.R
\name{extractWellNames}
\alias{extractWellNames}
\title{Try to get well names from a vector of filenames.}
\usage{
extractWellNames(filenames)
}
\arguments{
\item{filenames}{A character vector of filenames with .csv extension.}
}
\value{
A character vector of well names.
}
\description{
If each of the given filenames are of the form
"<PlateName>_<WellName>_Amplitude.csv", where <WellName> is of the form A01,
B01, etc., then this function can extract the <WellName> component.
Otherwise, the whole file name is assumed to be the well name.
}
\examples{
## Get the well names (recognised format).
extractWellNames(c("Sample_Plate_Name_G02_Amplitude.csv",
                   "Sample_Plate_Name_H02_Amplitude.csv",
                   "Sample_Plate_Name_A03_Amplitude.csv",
                   "Sample_Plate_Name_B03_Amplitude.csv"))

## Get the well names (unrecognised format).
extractWellNames(c("Sample_G02.csv",
                   "Sample_H02.csv",
                   "Sample_A03.csv",
                   "Sample_B03.csv"))

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/isTwoDimDataFrame.R
\name{.isTwoDimDataFrame}
\alias{.isTwoDimDataFrame}
\title{Checks whether an object is a data frame with two leading double columns.}
\usage{
.isTwoDimDataFrame(df)
}
\arguments{
\item{df}{A data frame.}
}
\value{
A logical value: whether the data frame meets the criteria.
}
\description{
Checks whether an object is a data frame with two leading double columns.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseCounts.R
\name{.dependentCols}
\alias{.dependentCols}
\title{Get a vector of all dependent columns.}
\usage{
.dependentCols(prefix = "")
}
\arguments{
\item{prefix}{A string to prepend to each of the column names. Defaults to
\code{""} (the empty string).}
}
\value{
A vector of column names with an optional prefix.
}
\description{
Get a list of the columns in the ddPCR data that depend on the target (e.g.
mutant or wild type). This includes columns that cannot be calculated from
the very basic droplet counts.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrWell.R
\name{wellClassification}
\alias{wellClassification}
\alias{wellClassification,ddpcrWell-method}
\alias{wellClassification<-}
\alias{wellClassification<-,ddpcrWell-method}
\title{Retrieve a classification vector.}
\usage{
wellClassification(theObject, cMethod = NULL, withAmplitudes = FALSE)

\S4method{wellClassification}{ddpcrWell}(theObject, cMethod = NULL, withAmplitudes = FALSE)

wellClassification(theObject, cMethod) <- value

\S4method{wellClassification}{ddpcrWell}(theObject, cMethod) <- value
}
\arguments{
\item{theObject}{A \code{\link{ddpcrWell}} object.}

\item{cMethod}{The names (or column numbers) of the classification to
retrieve. If \code{NULL}, then all of the classifications are obtained.
Defaults to \code{NULL} when retrieving. When setting a classification, this
cannot be \code{NULL}.}

\item{withAmplitudes}{Logical value. If \code{TRUE}, returns a data frame
with the droplet amplitudes and corresponding classifications. If
\code{FALSE}, returns the classification vector only. Defaults to
\code{FALSE}.}

\item{value}{A factor with the same length as the number of droplets in
\code{theObject}, with levels in \code{ddpcr$classesRain}.}
}
\value{
A factor or data frame corresponding to the requested
classification(s).
}
\description{
Retrieve the classification from a \code{\link{ddpcrWell}} object.
}
\examples{
## Take some droplets with a given classification.
amplitudes <- KRASdata[["E03"]][, c("Ch1.Amplitude", "Ch2.Amplitude")]

## Create a ddpcrWell object with the amplitudes only.
aWell <- ddpcrWell(well=amplitudes)

## This has no classification yet.
head(wellClassification(aWell))

## We check the classification now, showing the amplitudes as well.
head(wellClassification(aWell, withAmplitudes=TRUE))

## Now set a sample classification.
wellClassification(aWell, cMethod="Sample") <-
  rep(c("NN", "NP", "PN", "PP"), numDroplets(aWell) / 4)
head(wellClassification(aWell, withAmplitudes=TRUE))

}
\seealso{
\code{\link{wellClassificationMethod}} for the name of the
classification method.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrPlate.R
\name{plateClassification}
\alias{plateClassification}
\alias{plateClassification,ddpcrPlate-method}
\alias{plateClassification<-}
\alias{plateClassification<-,ddpcrPlate,character,list-method}
\alias{plateClassification<-,ddpcrPlate,character,factor-method}
\title{Set and retrieve classifications for multiple wells.}
\usage{
plateClassification(
  theObject,
  cMethod = NULL,
  withAmplitudes = FALSE,
  wellCol = FALSE
)

\S4method{plateClassification}{ddpcrPlate}(
  theObject,
  cMethod = NULL,
  withAmplitudes = FALSE,
  wellCol = FALSE
)

plateClassification(theObject, cMethod) <- value

\S4method{plateClassification}{ddpcrPlate,character,list}(theObject, cMethod) <- value

\S4method{plateClassification}{ddpcrPlate,character,factor}(theObject, cMethod) <- value
}
\arguments{
\item{theObject}{A \code{\link{ddpcrPlate}} object.}

\item{cMethod}{This is the name of the classification to retrieve and should
be a character vector. If \code{NULL}, then all of the classifications are
obtained. Defaults to \code{NULL}.}

\item{withAmplitudes}{If \code{TRUE}, the droplet amplitudes are included.
Defaults to \code{FALSE}.}

\item{wellCol}{If \code{TRUE}, an additional column is included in the
output, where each entry is the name of the well from which the droplet
originated. In this case, this setting forces the \code{withAmplitudes}
parameter to \code{TRUE}. Defaults to \code{FALSE}.}

\item{value}{Either:
\itemize{
  \item A list of factors, where each item of the list corresponds to
  a well;
  \item A single factor corresponding to all of the wells combined. This
  should be ordered by the order of the output of the
  \code{\link{amplitudes}} function when the rows of the data frames have
  been bound together, i.e. with \code{do.call(rbind,
  amplitudes(theObject))}.
}}
}
\value{
If requesting one classification without the amplitudes, a list of
factors corresponding to the classifications is returned. Otherwise, a list
of data frames is returned where each row corresponds to a droplet in the
corresponding well.
}
\description{
Retrieve multiple classification factors that have been assigned to
a \code{ddpcrPlate} object.
}
\examples{
### The examples here show how this method works by setting classifications
### using data frames. To do this, we use the
### \code{\link{thresholdClassify}} method on _data frames_. Note that
### \code{thresholdClassify} also works directly on \code{ddpcrWell} and
### \code{ddpcrPlate} objects; this is simply an illustration of
### how to use the \code{plateClassification} method directly. In general,
### it is recommended to use \code{thresholdClassify} directly on
### \code{ddpcrPlate} objects.

## Create a ddpcrPlate object.
krasPlate <- ddpcrPlate(wells=KRASdata)

## Classify a data frame of droplets and keep it in a _single_ data frame.
## Set the new classification from this.
droplets <- do.call(rbind, amplitudes(krasPlate))
clSingle <- thresholdClassify(droplets,
                              ch1Threshold=7000, ch2Threshold=3500,
                              fullTable=FALSE)
plateClassification(krasPlate, "thresholdSing") <- clSingle

## We can also set the new classification from a list of factors.
clList <- lapply(KRASdata, thresholdClassify, ch1Threshold=7000,
                 ch2Threshold=3500, fullTable=FALSE)
plateClassification(krasPlate, "thresholdList") <- clList

## We can get all of the classifications as a list of data frames.
plate <- plateClassification(krasPlate)
lapply(plate, head, n=1)

## We can include the droplet amplitudes columns.
plate <- plateClassification(krasPlate, withAmplitudes=TRUE)
lapply(plate, head, n=1)

## We can focus on specific classifications.
plate <- plateClassification(krasPlate, cMethod=c("thresholdSing",
                                                  "thresholdList"))
lapply(plate, head, n=1)

## The wellCol option adds an extra column showing which well the droplet
## came from.
plate <- plateClassification(krasPlate, withAmplitudes=TRUE, wellCol=TRUE)
lapply(plate, head, n=1)


}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinyVisGlobal.R
\docType{data}
\name{shinyVis}
\alias{shinyVis}
\title{A Shiny environment.}
\format{
An object of class \code{environment} of length 3.
}
\usage{
shinyVis
}
\value{
An environment for storing Shiny variables.
}
\description{
Stores modes used the in Shiny UI and internal defaults.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinyVisUI.R
\name{shinyVisUI}
\alias{shinyVisUI}
\title{Shiny visualisation UI.}
\usage{
shinyVisUI()
}
\value{
A Shiny UI.
}
\description{
A Shiny UI for interactive ddPCR droplet classification.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusterCentres.R
\name{clusterCentres}
\alias{clusterCentres}
\alias{clusterCenters}
\alias{wellCentres}
\alias{wellCenters}
\alias{clusterCentres,ddpcrWell-method}
\alias{clusterCentres,ddpcrPlate-method}
\alias{plateCentres}
\alias{plateCenters}
\alias{combinedCentres}
\alias{combinedCenters}
\alias{combinedPlateCentres}
\alias{combinedPlateCenters}
\alias{combinedCentres,ddpcrPlate-method}
\title{Retrieve the cluster centres.}
\usage{
clusterCentres(theObject, cMethod)

\S4method{clusterCentres}{ddpcrWell}(theObject, cMethod)

\S4method{clusterCentres}{ddpcrPlate}(theObject, cMethod)

combinedCentres(theObject, cMethod)

\S4method{combinedCentres}{ddpcrPlate}(theObject, cMethod)
}
\arguments{
\item{theObject}{A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
object.}

\item{cMethod}{The classification method for which to obtain the centres.}
}
\value{
If a \code{ddpcrWell} object is given, \code{clusterCentres} returns
the cluster centres as a data frame.

If a \code{ddpcrPlate} object is given, \code{clusterCentres} return
a list of data frames, where each data frame corresponds to the cluster
centres of a well.

\code{combinedCentres} returns a data frame of the centres of all of
the wells combined.
}
\description{
\code{clusterCentres} retrieves the cluster centres for
a \code{\link{ddpcrWell}} object or the centres for each well in
a \code{\link{ddpcrPlate}} object.

\code{combinedCentres} retrieves the cluster centres for all of
the wells together.
}
\examples{
## Get the centres of a sample with 4 clusters.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
clusterCentres(aWell, "Cluster")

## Get the centres of a sample with 3 clusters.
aWell <- ddpcrWell(well=KRASdata[["H04"]])
clusterCentres(aWell, "Cluster")

## Retrieve the cluster centres of each of the wells in a \code{ddpcrPlate}
## object.
krasPlate <- ddpcrPlate(wells=KRASdata)
clusterCentres(krasPlate, cMethod="Cluster")

## Retrieve the cluster centres of all wells combined.
combinedCentres(krasPlate, cMethod="Cluster")

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kmeansClassify.R
\name{kmeansClassify}
\alias{kmeansClassify}
\alias{kmeansClassify,data.frame-method}
\alias{kmeansClassify,ddpcrWell-method}
\alias{kmeansClassify,ddpcrPlate-method}
\title{K-means classify the wells in a \code{ddpcrWell} or
\code{ddpcrPlate} object, or in a data frame.}
\usage{
kmeansClassify(
  droplets,
  centres = matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000), ncol = 2, byrow = TRUE),
  ...
)

\S4method{kmeansClassify}{data.frame}(
  droplets,
  centres = matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000), ncol = 2, byrow = TRUE),
  fullTable = TRUE
)

\S4method{kmeansClassify}{ddpcrWell}(
  droplets,
  centres = matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000), ncol = 2, byrow = TRUE)
)

\S4method{kmeansClassify}{ddpcrPlate}(
  droplets,
  centres = matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000), ncol = 2, byrow = TRUE)
)
}
\arguments{
\item{droplets}{A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
object, or a data frame with columns \code{Ch1.Amplitude} and
\code{Ch2.Amplitude}.}

\item{centres}{Either:
\itemize{
  \item A matrix corresponding to the initial centres to use for the k-means
  algorithm; or
  \item An integer corresponding to the number of clusters. If this is set,
  the initial centres are randomly set.
}
Defaults to \code{matrix(c(0, 0, 10000, 0, 0, 7000, 10000, 7000), ncol=2,
byrow=TRUE)}}

\item{...}{Other options depending on the type of \code{droplets}.}

\item{fullTable}{If \code{TRUE}, returns a full data frame of droplets and
their classification; if \code{FALSE}, simply returns a factor corresponding
to this classification. Defaults to \code{TRUE}.}
}
\value{
An object with the new classification.

If \code{droplets} is a data frame, a list is returned with the
following components:
  \item{data}{A data frame or vector corresponding to the classification.}
  \item{centres}{A data frame listing the final centre points from the
  k-means algorithm with the corresponding cluster labels.}
}
\description{
If \code{droplets} is a data frame, the droplets are classified
using the k-means clustering algorithm.

For \code{ddpcrWell}, the droplets are classified by using the
k-means clustering algorithm.

For \code{ddpcrPlate}, all of the wells are combined and
classified, with this new classification assigned to the
\code{ddpcrPlate} object.
}
\examples{
### Use the KRASdata dataset for all of these examples.

## Use K-means clustering to classify droplets into four (the default
## number) classes.
aWell <- kmeansClassify(KRASdata[["E03"]])

## We can look the the classification or the centres.
head(aWell$data)
aWell$centres

## Specify 3 centres for a different sample in KRASdata.
aWell <- kmeansClassify(KRASdata[["H04"]], centres=3)
head(aWell$data)

## We can be more specific with the choice of centres.
aWell <- kmeansClassify(KRASdata[["H04"]],
                       centres=matrix(c(5000, 1500, 5500, 7000, 10000,
                                        2000), ncol=2, byrow=TRUE))

## We can use \code{ddpcrWell} objects directly as a parameter.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
kmeansClassify(aWell)

## We can take multiple samples in a \code{ddpcrPlate} object and
## classify everything together.
krasPlate <- ddpcrPlate(wells=KRASdata)
kmeansClassify(krasPlate)

}
\seealso{
This method uses the \code{\link[stats]{kmeans}} function.

To manually set and retrieve classifications, use the
\code{\link{wellClassification}}, \code{\link{plateClassification}} and
\code{\link{plateClassificationMethod}} methods.

For a supervised classification approach, one may want to consider
\code{\link{knnClassify}}.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sdRain.R
\name{getCutOff}
\alias{getCutOff}
\title{Find the standard deviation of droplets (in a given class) multipied by
a given constant.}
\usage{
getCutOff(droplets, cl, level = 3, classCol = "class")
}
\arguments{
\item{droplets}{A data frame of droplets with "Ch1.Amplitude" and
"Ch2.Amplitude" columns, as well as a class column (see classCol).}

\item{cl}{The class to focus on. Typically one of "NN", "PN", "NP" and "PP".}

\item{level}{A constant by which we will multiply the standard deviation.
Defaults to 5.}

\item{classCol}{The column (name or number) from 'droplets' representing the
class.}
}
\value{
A list with named elements 'ch1' and 'ch2', each giving the error
bound for the corresponding channel. If the number of droplets is either
0 or 1, return list(ch1=0, ch2=0) to avoid any errors. Otherwise, return
level * (sd of the droplets in each channel).
}
\description{
For a specified class, take a data frame of droplet amplitudes and compute
the standard deviation multiplied by a level of accuracy.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusterStats.R
\name{.matrixInverse}
\alias{.matrixInverse}
\title{Get the inverse of a matrix}
\usage{
.matrixInverse(s)
}
\arguments{
\item{s}{A 2x2 matrix.}
}
\value{
The inverse of `s`, or NULL if the matrix is singular

Given a matrix, compute the inverse or return \code{NULL} if it is singular.
}
\description{
Get the inverse of a matrix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/KRASdata.R
\docType{data}
\name{KRASdata}
\alias{KRASdata}
\title{Droplet amplitude data for KRAS mutant and wild type molecules.}
\format{
A list of data frames, each of which has columns 
\code{Ch1.Amplitude}, \code{Ch2.Amplitude} and \code{Cluster}.
}
\usage{
data(KRASdata)
}
\value{
A data frame.
}
\description{
A data frame of ddPCR droplet amplitudes using KRAS cell lines 
and pre-defined mutant/wild type ratios. The existing classification under 
the column name \code{Cluster} was obtained from Bio-Rad's QuantaSoft by 
setting the \code{Ch1.Amplitude} threshold to \code{6789} and the 
\code{Ch2.Amplitude} threshold to \code{3000}.
}
\author{
From ddPCR experiments run by Mahmood Ayub, 
\email{mahmood.ayub@cruk.manchester.ac.uk}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gridClassify.R
\name{thresholdClassify}
\alias{thresholdClassify}
\alias{thresholdClassify,data.frame-method}
\alias{thresholdClassify,ddpcrWell-method}
\alias{thresholdClassify,ddpcrPlate-method}
\title{Set thresholds to classify droplets.}
\usage{
thresholdClassify(droplets, ch1Threshold = 6500, ch2Threshold = 2900, ...)

\S4method{thresholdClassify}{data.frame}(
  droplets,
  ch1Threshold = 6500,
  ch2Threshold = 2900,
  fullTable = TRUE
)

\S4method{thresholdClassify}{ddpcrWell}(
  droplets,
  ch1Threshold = 6500,
  ch2Threshold = 2900,
  classMethodLabel = "thresholds"
)

\S4method{thresholdClassify}{ddpcrPlate}(
  droplets,
  ch1Threshold = 6500,
  ch2Threshold = 2900,
  classMethodLabel = "thresholds"
)
}
\arguments{
\item{droplets}{A \code{\link{ddpcrWell}} object or a data frame of droplet
amplitudes with columns \code{Ch1.Amplitude} and \code{Ch2.Amplitude}.}

\item{ch1Threshold}{The channel 1 upper bound for the NN and NP classes.
Defaults to 8000}

\item{ch2Threshold}{The channel 2 upper bound for the NN and PN classes.
Defaults to 3000.}

\item{...}{Other options depending on the type of \code{droplets}.}

\item{fullTable}{Whether to return a data frame including amplitude figures.
If \code{TRUE}, a data frame with columns \code{Ch1.Amplitude},
\code{Ch1.Amplitude} and \code{class} is returned. If \code{FALSE}, a factor
with levels in \code{ddpcr$classesRain} is returned, where each entry
corresponds to each row in \code{droplets} (and \code{trainingData} is
automatically set to \code{FALSE}). Defaults to \code{TRUE}.}

\item{classMethodLabel}{A name (as a character string) of the classification
method. Defaults to "thresholds".}
}
\value{
If \code{droplets} is a data frame, return a data frame or factor
(depending on the \code{trainingData} and \code{fullTable} parameters) with
a classification for droplets in the chosen regions.

If \code{droplets} is a \code{ddpcrWell} object, return
a \code{ddpcrWell} object with the appropriate classification.

If \code{droplets} is a \code{ddpcrPlate} object, return
a \code{ddpcrPlate} object with the appropriate classification.
}
\description{
Classify droplets as "NN", "NP", "PN" or "PP" depending on
whether they lie above or below given thresholds. This is illustrated in the
details and parameters for more detail.
}
\details{
The \code{threshold} parameters correspond to those in the
following diagram:
\preformatted{Ch1 ^          |
    |          |
    |          |
    |    PN    |    PP
    |          |
    |          |
   a|__________|__________
    |          |
    |          |
    |    NN    |    NP
    |          |
    |          |
    --------------------->
               b      Ch2}
Specifically:
\describe{
  \item{a:}{\code{ch1Threshold},}
  \item{b:}{\code{ch2Threshold}.}
}
}
\examples{
## Use thresholds to set a classification for a data frame.
gCl <- thresholdClassify(KRASdata[["E03"]],
                         ch1Threshold=6789, ch2Threshold=3000)
str(gCl)

## The same works for ddpcrWell objects.
aWell <- ddpcrWell(well=KRASdata[["E03"]])
aWell <- thresholdClassify(aWell, ch1Threshold=6789, ch2Threshold=3000)
str(aWell)

## ddpcrPlate objects work in exactly the same way.
krasPlate <- ddpcrPlate(wells=KRASdata)
krasPlate <- thresholdClassify(krasPlate,
                               ch1Threshold=6789, ch2Threshold=3000)
lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)

## The default classification method (column name) is 'threshold'. It can be
## changed by providing a label.
krasPlate <- ddpcrPlate(wells=KRASdata)
krasPlate <- thresholdClassify(krasPlate,
                               ch1Threshold=6789, ch2Threshold=3000,
                               classMethodLabel="manual")
lapply(plateClassification(krasPlate, withAmplitudes=TRUE), head, n=1)

}
\seealso{
This function is a special case of \code{\link{gridClassify}}.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrWell.R, R/ddpcrPlate.R
\name{amplitudes}
\alias{amplitudes}
\alias{amplitudes,ddpcrWell-method}
\alias{amplitudes,ddpcrPlate-method}
\title{Retrieve droplet amplitudes.}
\usage{
amplitudes(theObject)

\S4method{amplitudes}{ddpcrWell}(theObject)

\S4method{amplitudes}{ddpcrPlate}(theObject)
}
\arguments{
\item{theObject}{A \code{\link{ddpcrWell}} or \code{\link{ddpcrPlate}}
object.}
}
\value{
If \code{theObject} is a \code{\link{ddpcrWell}} object, return
a data frame of droplet amplitudes with columns "Ch1.Amplitude" and
"Ch2.Amplitude". If \code{theObject} is a \code{\link{ddpcrPlate}} object,
return a list of data frames.
}
\description{
Retrieve the droplet amplitudes from an object.
}
\examples{
## Set a ddpcrWell object with no data.
aWell <- ddpcrWell(well=data.frame("Ch1.Amplitude"=double(),
                                   "Ch2.Amplitude"=double()))

## This can be checked to be empty.
amplitudes(aWell)

## Alternatively, load some data.
aWell <- ddpcrWell(well=KRASdata[["E03"]])

## We check again and see that it has been populated.
head(amplitudes(aWell))

# Get all of the KRASdata droplet amplitudes.
krasPlate <- ddpcrPlate(wells=KRASdata)
allDroplets <- amplitudes(krasPlate)
str(allDroplets)

}
\seealso{
\code{\link{wellClassification}} for the classification of the
droplets.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalise.R
\name{.classifyDfOnChannel}
\alias{.classifyDfOnChannel}
\title{K-means classify a data frame where the droplets are negative in the same
channels only.}
\usage{
.classifyDfOnChannel(
  df,
  channel,
  centres = NULL,
  minSeparation = 2000,
  fullTable = TRUE
)
}
\arguments{
\item{df}{A data frame corresponding to a well with droplets corresponding
only to "NN" and "NP" or "NN" and "PN".}

\item{channel}{The channel on which to classify (1 or 2).}

\item{centres}{A data frame of centres. The data frame should have columns
\code{Ch1.Amplitude} and \code{Ch2.Amplitude} and row names corresponding
the cluster label, e.g. "NN", "NP", "PN" or "PP".}

\item{minSeparation}{The minimum distance required between two cluster
centres in order for us to assume that k-means found two distinct clusters.
Defaults to 2000.}

\item{fullTable}{Whether to return a full table or just a vector. Defaults
to `TRUE`}
}
\value{
A classification for \code{df}.
}
\description{
K-means classify a data frame where the droplets are negative in the same
channels only.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseCounts.R
\name{.getWellNames}
\alias{.getWellNames}
\title{Extract the well names from a data frame.}
\usage{
.getWellNames(df)
}
\arguments{
\item{df}{A data frame.}
}
\value{
A factor of row names.
}
\description{
Get the well names from a data frame, checking if there is a \code{Well}
column or by using the row numbering.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalise.R
\name{.classifyOnChannel}
\alias{.classifyOnChannel}
\title{K-means classify a list of data frames individually, where each data frame
comprises droplets that are negative in the same channels only.}
\usage{
.classifyOnChannel(
  cl,
  channel,
  centres = NULL,
  minSeparation = 2000,
  fullTable = TRUE
)
}
\arguments{
\item{cl}{List of data frames, where each data frame corresponds to a well
with droplets corresponding only to "NN" and "NP" or "NN" and "PN".}

\item{channel}{The channel on which to classify (1 or 2).}

\item{centres}{A data frame of centres. The data frame should have columns
\code{Ch1.Amplitude} and \code{Ch2.Amplitude} and row names corresponding
the cluster label, e.g. "NN", "NP", "PN" or "PP".}

\item{minSeparation}{The minimum distance required between two cluster
centres in order for us to assume that k-means found two distinct clusters.
Defaults to 2000.}

\item{fullTable}{Whether to return a full table or just a vector. Defaults
to `TRUE`}
}
\value{
A classification for \code{cl}.
}
\description{
K-means classify a list of data frames individually, where each data frame
comprises droplets that are negative in the same channels only.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrPlate.R
\name{plateClassificationMethod}
\alias{plateClassificationMethod}
\alias{plateClassName}
\alias{plateClassificationName}
\alias{plateClassMethod}
\alias{plateClassificationMethod,ddpcrPlate-method}
\alias{plateClassificationMethod<-}
\alias{plateClassificationMethod<-,ddpcrPlate-method}
\alias{commonClassificationMethod}
\alias{commonClassificationMethod,ddpcrPlate-method}
\title{Set or retrieve the classification method strings for multiple wells.}
\usage{
plateClassificationMethod(theObject)

\S4method{plateClassificationMethod}{ddpcrPlate}(theObject)

plateClassificationMethod(theObject, cMethod) <- value

\S4method{plateClassificationMethod}{ddpcrPlate}(theObject, cMethod) <- value

commonClassificationMethod(theObject)

\S4method{commonClassificationMethod}{ddpcrPlate}(theObject)
}
\arguments{
\item{theObject}{A \code{\link{ddpcrPlate}} object.}

\item{cMethod}{This should represent existing classification method(s) for
all wells in \code{theObject}. It can be given in the form of a:
\itemize{
  \item Character vector. If this vector is shorter than the length of
  \code{wells}, this vector's elements will be repeated.
  \item List of character vectors.
}}

\item{value}{New classification method(s) in the same form as
\code{cMethod}.}
}
\value{
\code{plateClassificationMethod} returns a list of character strings
corresponding to the classification methods.

\code{commonClassificationMethod} returns a vector of character
strings indicating which classification methods appear in all wells.
}
\description{
\code{plateClassificationMethod} retrieves multiple classification methods
that have been assigned to a \code{ddpcrPlate} object.

\code{commonClassificationMethod} retrieves the classification
methods common to all the wells in the given \code{ddpcrPlate} object.
}
\examples{
## Get the classification methods for the KRASdata dataset.
krasPlate <- ddpcrPlate(wells=KRASdata)
plateClassificationMethod(krasPlate)

## Change the "Cluster" column to "QS".
plateClassificationMethod(krasPlate, "Cluster") <- "QS"
plateClassificationMethod(krasPlate)

## Usually, all of the classification names are the same for all wells. We
## use the \code{commonClassificationMethod} method to retrieve the ones
## common to all wells.
commonClassificationMethod(krasPlate)

}
\seealso{
\code{\link{plateClassification}} for the classifications.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/numDroplets.R
\name{isEmpty,ddpcrWell-method}
\alias{isEmpty,ddpcrWell-method}
\alias{isEmpty,ddpcrPlate-method}
\title{Is a \code{\link{ddpcrWell}} object empty?}
\usage{
\S4method{isEmpty}{ddpcrWell}(x)

\S4method{isEmpty}{ddpcrPlate}(x)
}
\arguments{
\item{x}{An object to test for emptiness.}
}
\value{
A logical value.
}
\description{
Returns a logical value as to whether the given object has no
droplets/wells.
}
\examples{
## Check that an empty ddpcrPlate object is in fact empty.
krasPlate <- ddpcrPlate(wells=list())
isEmpty(krasPlate)

## Now add some amplitude data and check that is not empty.
krasPlate <- ddpcrPlate(wells=KRASdata)
isEmpty(krasPlate)

}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaries.R
\name{.getMutCopies}
\alias{.getMutCopies}
\title{Get the mutant copies per 20ul of a data frame.}
\usage{
.getMutCopies(df)
}
\arguments{
\item{df}{A data frame generated by \code{\link{fullCountsSummary}}.}
}
\value{
A data frame with the basic columns and mutant copies per 20ul.
}
\description{
Returns a data frame with the number of mutant copies per 20ul.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddpcrPlate.R
\name{.slice}
\alias{.slice}
\title{Splits a long vector and according to a vector of sizes.}
\usage{
.slice(vec, wellSizes, wellNames)
}
\arguments{
\item{vec}{The vector to split.}

\item{wellSizes}{A numeric vector corresponding to sizes of the wells.}

\item{wellNames}{A character vector corresponding to the names of the wells.}
}
\value{
A list of vectors split into the given lengths.
}
\description{
Takes one long vector/factor and splits it into a list of vectors, where the
lengths are given by a vector of sizes. This may be the same as another
given list of vectors. Particularly useful if we want to combine a list of
data, do some analysis on the combined data, then split the analysis.
}
\author{
Anthony Chiu, \email{anthony.chiu@cruk.manchester.ac.uk}
}
